## Available Scripts

* extract_pyinv_examples (in crtomo_tests)
* pycrtomo_test (in crtomo_tests)
* CRMod (in crtomo_wrappers)
* CRTomo (in crtomo_wrappers)
* CutMcK (in crtomo_wrappers)

## Updating CRMod

    ./gen_pycrmod.sh
    cp -r output_pycrmod both_v1/pycrmod_vX
    # in meson.build:
        * remove virtualenv-specific python path
        * remove project(...) call, as we use this project as a subproject

subroutine randb(my_a,my_b)

!!!$     Unterprogramm modifiziert die Matrix 'a' (Bandbreite 'mb') und den
!!!$     Konstantenvektor 'b' gemaess homogener Dirichletscher Randbedingungen.

!!!$     ( Vgl. Subroutine 'RBSTBNDN' in Schwarz (1991) )

!!!$     Andreas Kemna                                            12-Feb-1993
!!!$     Letzte Aenderung   05-Nov-1997

!!!$.....................................................................

  USE elemmod , ONLY : sanz, mb, typanz, typ, selanz, nrel, nelanz

  IMPLICIT none

!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

  COMPLEX (KIND (0D0)),DIMENSION ((mb+1)*sanz) :: my_a
  COMPLEX (KIND (0D0)),DIMENSION (sanz)        :: my_b

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Aktuelle Elementnummer
  INTEGER(KIND = 4)  ::   iel

!!!$     Aktueller Elementtyp
  INTEGER(KIND = 4)  ::   ntyp

!!!$     Anzahl der Knoten im aktuellen Elementtyp
  INTEGER(KIND = 4)  ::   nkel

!!!$     Index-/Hilfsvariablen
  INTEGER(KIND = 4)  ::   m1,ir,i,j,k,ia,ki,i2,j2,idk,ji

!!!$.....................................................................

  m1  = mb+1
  iel = 0

  do i2=1,typanz
     ntyp = typ(i2)
     nkel = selanz(i2)

     do j2=1,nelanz(i2)
        iel = iel+1
        
        if (ntyp.ne.13) CYCLE ! next j2
        
        do ir=1,nkel
           k    = nrel(iel,ir)
           my_b(k) = dcmplx(0d0)

           idk    = k*m1
           my_a(idk) = dcmplx(1d0)

           if (k /= 1) THEN

              ia = max0(1,mb+2-k)

              do i=ia,mb
                 ki    = idk+i-m1
                 my_a(ki) = dcmplx(0d0)
              end do
           END IF
           if (k.eq.sanz) CYCLE ! next ir

           ia = max0(1,k-sanz+m1)

           do i=ia,mb
              j     = k-i+m1
              ji    = (j-1)*m1+i
              my_a(ji) = dcmplx(0d0)
           end do

        END do ! ir

     END do !j2

  END do !i2

end subroutine randb

SUBROUTINE bvariogram
!!$c     
!!$c     Unterprogramm zum Bestimmen von Experimentellen Variogrammen
!!$c     
!!$c     Copyright by Andreas Kemna
!!$c     
!!$c     Created by Roland Martin                             19-Mar-2010
!!$c     
!!$c     Letzte Aenderung                                     23-Mar-2010
!!$c     
!!$c.....................................................................

  USE invmod         ! fuer par
  USE variomodel
  USE sigmamod       ! fuer sigma
  USE modelmod       ! fuer manz
  USE elemmod        ! fuer grid_min,grid_max,etc
  USE errmod
  USE konvmod        ! fuer alfx/alfz

  IMPLICIT none


!!$c     PROGRAMMINTERNE PARAMETER:-------------------------------------------
!!$c     Indexvariablen
  INTEGER :: i,j,ik,ifp
!!$c     th = Tail - Head; hx,hy,h distances in each direction
  REAL(KIND(0D0)) :: th,tail,head,hx,hy,h,mid_par
!!$c     korrelation length for variogram models
  REAL(KIND(0D0)) :: Ix,Iy
!!$c     smallest variogram distance and tolerance
  REAL(KIND(0D0)) :: lag_unit,lag_tol
!!$c     smallest variogram distance and tolerance anisotrop
  REAL(KIND(0D0)) :: lag_unit_x,lag_tol_x
  REAL(KIND(0D0)) :: lag_unit_y,lag_tol_y
!!$c     number of equidistant lags (nlag) = INT(grid_max / grid_min)
  INTEGER :: nlag,nlag_x,nlag_y
!!$c     lag vector (nlag)
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: lag,lag_x,lag_y
!!$c     number of headtail pairs for each semivariogram N(lag)(nlag)
  INTEGER,DIMENSION(:),ALLOCATABLE :: ngam_x,ngam_y,ngam
!!$c     experimental semivariogram
!!$c     gam(lag)=1/N(lag)/2 * sum_k^N(lag) (tail - head)**2.
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: gam_x,gam_y,gam
!!$c     variogram model
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: mgam_x,mgam_y,mgam
  CHARACTER(80) :: tmgam,tmgam_x,tmgam_y,mti,tgam,tcov
!!$! mti stores a string for variogram statistics, like korrelation length
!!$! tgam stores the output string of get_vario
  CHARACTER (11) :: tg
!!$c-----------------------------------------------------------------------
  WRITE (*,'(/a)',ADVANCE='no')'Calculating VARIOGRAM'
  errnr = 4
!!
!!$c     define linear equidistant lag vector

  lag_unit = grid_min
  lag_unit_x = grid_minx
  lag_unit_y = grid_miny

  nlag = NINT(grid_max / lag_unit) / 2
  nlag_x = NINT(grid_maxx / lag_unit_x) / 2
  nlag_y = NINT(grid_maxy / lag_unit_y) / 2

  lag_tol = lag_unit * .5
  lag_tol_x = lag_unit_x * .5
  lag_tol_y = lag_unit_y * .5

!!$     get memory
  ALLOCATE (lag(nlag),gam(nlag),ngam(nlag),lag_x(nlag_x),gam_x(nlag_x),&
       ngam_x(nlag),lag_y(nlag_y),gam_y(nlag_y),ngam_y(nlag),mgam(nlag),&
       mgam_x(nlag_x),mgam_y(nlag_y),STAT=errnr)
  lag = 0D0
  ngam = 0
  ngam_x = 0
  ngam_y = 0
  mgam_x = 0D0
  mgam_y = 0D0
  lag_x = 0D0
  lag_y = 0D0
  gam = 0D0
  gam_x = 0D0
  gam_y = 0D0

  IF (errnr/=0) THEN
     fetxt = 'Allocation problem in bvariogram'
     WRITE (*,'(/a/)')TRIM(fetxt)
     errnr = 97
     RETURN
  END IF

  ngam_x = 0;ngam_y = 0;ngam = 0
  gam_x = 0.;gam_y = 0.;gam = 0.

!!$! gets the current variogram function parameters
  CALL get_vario(Ix,Iy,fetxt,0) 
!!$  ! now prepare title string of gnuplot plot
  WRITE (mti,'(2(a,F4.2))')'Correlation lengths ax=',Ix,', ay=',Iy
!!$     for postscript 
  tg = '{/Symbol g}'
  WRITE (tgam,'(a)')tg//'(h)='//TRIM(fetxt) 
  IF (ltri == 15) THEN ! only meaningful for stochastical regu..
     CALL get_vario(Ix,Iy,fetxt,1) ! gets teh 
!!$   for postscript
     WRITE (tcov,'(a)')'C(h)='//TRIM(fetxt)
  END IF
!!$  compute synthetic variogram model
  par_vari = 1.
  DO i=1,nlag
     lag(i) = i*lag_unit
     h = lag(i)
     WRITE (tmgam,'(a)')tg//'(h)'
     mgam(i) = mvario(h,h,par_vari)
  END DO
!!$  anisotrop
  DO i=1,nlag_x
     lag_x(i) = i*lag_unit_x
     h = lag_x(i)
     WRITE (tmgam_x,'(a)')tg//'(hx)'
     mgam_x(i) = mvario(h,0D0,par_vari)
  END DO
  DO i=1,nlag_y
     lag_y(i) = i*lag_unit_y
     h = lag_y(i)
     WRITE (tmgam_y,'(a)')tg//'(hy)'
     mgam_y(i) = mvario(0D0,h,par_vari)
  END DO

  mid_par = SUM(LOG10(DBLE(sigma))) / manz
  mid_par = SUM(LOG10(DBLE(sigma))) / manz

  par_vari=0.

!!$  Experimentelles semi-variogram
  DO i=1,elanz

     IF (lverb) WRITE (*,'(a,t70,F6.2,A)',ADVANCE='no')&
          ACHAR(13)//'Variogram/',REAL(i*(100./elanz)),'%'

     tail = LOG10(DBLE(sigma(i))) ! lin val

     par_vari = par_vari + (tail - mid_par)**2.

     DO j=1,elanz

        IF (i==j) CYCLE

        head = LOG10(DBLE(sigma(j)))

        hx = ABS(espx(i) - espx(j))
        hy = ABS(espy(i) - espy(j))

        h = SQRT(hx**2. + hy**2.)

        th = (tail - head)**2.

        DO ik = 1,nlag
!!$  lag - lag_tol < h < lag + lag_tol
           IF (ABS(lag(ik) - h) < lag_tol) THEN
              ngam(ik) = ngam(ik) + 1
              gam(ik) = gam(ik) + th
           END IF
        END DO
!!$  anisotrop lag vector y-dir
        IF (hx < lag_tol_x) THEN
           DO ik = 1,nlag_y
              IF (ABS(lag_y(ik) - hy) < lag_tol_y) THEN
                 ngam_y(ik) = ngam_y(ik) + 1
                 gam_y(ik) = gam_y(ik) + th
              END IF
           END DO
        END IF
!!$  anisotrop lag vec x-dir
        IF (hy < lag_tol_y) THEN
           DO ik = 1,nlag_x
              IF (ABS(lag_x(ik) - hx) < lag_tol_x) THEN
                 ngam_x(ik) = ngam_x(ik) + 1
                 gam_x(ik) = gam_x(ik) + th
              END IF
           END DO
        END IF

     END DO                 ! inner loop j=1,elanz
  END DO                    ! outer loop i=1,elanz

  DO i=1,nlag
     IF (ngam(i)>0) &
          gam(i) = gam(i) / ngam(i) / 2.
  END DO
  DO i=1,nlag_x
     IF (ngam_x(i)>0) &
          gam_x(i) = gam_x(i) / ngam_x(i) / 2.
  END DO
  DO i=1,nlag_y
     IF (ngam_y(i) > 0) &
          gam_y(i) = gam_y(i) / ngam_y(i) / 2.
  END DO

!!$   sets parameter variance..
  par_vari = MAX(par_vari / manz,1.d-5)
  WRITE (*,'(2(a,G10.3,1x))')ACHAR(13)//'Conductivity Mean=',mid_par,&
       'Variance=',par_vari
  WRITE (*,'(3(a,G10.3,1x))')'Min=',MINVAL(REAL(sigma)),'Max=',&
       MAXVAL(REAL(sigma)),'DLOG',LOG10(MAXVAL(REAL(sigma))/&
       MINVAL(REAL(sigma)))

  mgam = par_vari * mgam ! or we put it normalized to the sill ?
  mgam_x = par_vari * mgam_x
  mgam_y = par_vari * mgam_y

1 FORMAT(3(G10.3,3X),I10)
2 FORMAT(a,I10,a,F10.3)

  CALL get_unit(ifp)
  OPEN (ifp,FILE='inv.variogram_x',STATUS='replace',ERR=999)
  WRITE (ifp,2)'#   lag(x-dir)'//ACHAR(9)//&
       'anisotrop exp. semivariogram    model ##',nlag_x,&
       ' / parameter variance ',par_vari
  DO i=1,nlag_x
     WRITE (ifp,1,ERR=999)lag_x(i),gam_x(i),mgam_x(i),ngam_x(i)
  END DO
  CLOSE (ifp)
  OPEN (ifp,FILE='inv.variogram_y',STATUS='replace',ERR=999)
  WRITE (ifp,2)'#   lag(y-dir)'//ACHAR(9)//&
       'anisotrop exp. semivariogram   model ##',nlag_y,&
       ' / parameter variance ',par_vari
  DO i=1,nlag_y
     WRITE (ifp,1,ERR=999)lag_y(i),gam_y(i),mgam_y(i),ngam_y(i)
  END DO
  CLOSE (ifp)
  OPEN (ifp,FILE='inv.variogram',STATUS='replace',ERR=999)
  WRITE (ifp,2)'#   lag(h)'//ACHAR(9)//&
       'exp. semivariogram     model ## ',nlag,&
       ' / parameter variance ',par_vari
  DO i=1,nlag
     WRITE (ifp,1,ERR=999)lag(i),gam(i),mgam(i),ngam(i)
  END DO
  CLOSE (ifp)

  OPEN (ifp,FILE='variogram.gnu',STATUS='replace',ERR=999)
  WRITE (ifp,'(a)')'set st da l'
  WRITE (ifp,'(a)')'set grid'
  WRITE (ifp,'(a)')"set out 'variograms.ps'"
  WRITE (ifp,'(a)')'set term pos col enh 20'
  WRITE (ifp,'(a)')'set pointsize 1.2'
  WRITE (ifp,'(a)')'set key bot right Left samplen .3'
  IF (ltri == 15) THEN ! only meaningful for stochastical regu..
     WRITE (ifp,'(a)')'set tit "'//TRIM(mti)//'\n'//&
          TRIM(tgam)//'\n'//TRIM(tcov)//'"'
  ELSE
     WRITE (ifp,'(a)')'set tit "'//TRIM(mti)//'\n'//&
          TRIM(tgam)//'"'
  END IF
  WRITE (ifp,'(a)')"set xlab offset 0,0.5 'Lag [m]'"
  WRITE (ifp,'(a,2(F10.2,a))')'set xrange [',grid_min,':',&
       grid_max/2.,']'
  WRITE (ifp,'(a)')"set ylab offset 2,0 'sv(h)=1/2N(h)"//&
       " {/Symbol S}_i(Z(m_i)-Z(m_i+h))^2, {/Symbol g}(h) [1]'"
  WRITE (ifp,'(a,F10.3,a)')"plot"//&
       "'inv.variogram' u 1:2 w p lc 1 pt 7 ti 'sv(h)',"//&
       "'inv.variogram' u 1:3 w l lc 1 lw 4 ti '"//TRIM(tmgam)//&
       "','inv.variogram_x' u 1:2 w p lc 2 pt 7 ti 'sv(hx)',"//&
       "'inv.variogram_x' u 1:3 w l lc 2 lw 4 ti '"//TRIM(tmgam_x)//&
       "','inv.variogram_y' u 1:2 w p lc 3 pt 7 ti 'sv(hy)',"//&
       "'inv.variogram_y' u 1:3 w l lc 3 lw 4 ti '"//TRIM(tmgam_y)//&
       "',",par_vari," w l lc 0 lw 4 lt 2 ti 'Variance (va)'"
  CLOSE (ifp)
  
  par_vari = 10**par_vari

  fetxt = ''
!!$  CALL SYSTEM('which gnuplot > tmp.gnuplot')
!!$  OPEN (ifp,FILE='tmp.gnuplot',STATUS='old',ERR=999)
!!$  READ (ifp,'(a)',ERR=100)fetxt
!!$  CLOSE (ifp)
!!$  my_buff = TRIM(ADJUSTL(fetxt))//' < variogram.gnu >& /dev/null'
!!$  IF (fetxt /= '') CALL SYSTEM (TRIM(my_buff))
  
  DEALLOCATE (gam_x,gam_y,gam)
  DEALLOCATE (ngam_x,ngam_y,ngam)
  DEALLOCATE (lag,lag_x,lag_y)

  errnr = 0
999 RETURN

END SUBROUTINE bvariogram

module pyinv
    ! variable declarations here
    contains
        subroutine invertpy()
            ! Copyright © 1990-2020 Andreas Kemna <kemna@geo.uni-bonn.de>
            ! Copyright © 2008-2020 CRTomo development team (see AUTHORS file)
            !
            !
            ! Permission is hereby granted, free of charge, to any person obtaining a copy of
            ! this software and associated documentation files (the “Software”), to deal in
            ! the Software without restriction, including without limitation the rights to
            ! use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
            ! of the Software, and to permit persons to whom the Software is furnished to do
            ! so, subject to the following conditions:
            !
            ! The above copyright notice and this permission notice shall be included in all
            ! copies or substantial portions of the Software.
            !
            ! THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
            ! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
            ! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
            ! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
            ! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
            ! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
            ! SOFTWARE.

            !> \file inv.f90
            !! \brief Main inversion algorithm
            !> \author Andreas Kemna, Roland Martin, Johannes Kenkel
            !> \date 11/4/2014
            !> \date {original version} 1990
            !> @param aggr information

            !>   Hauptprogramm zur Complex-Resistivity-2.5D-Inversion.

            !!!$   Belegte Kanaele:
            !!!$   9 - error.dat   -> fperr
            !!!$   10 - run.ctr    -> fprun
            !!!$   11 - in-/output -> kanal
            !!!$   12 - crtomo.cfg -> fpcfg
            !!!$   13 - inv.ctr    -> fpinv
            !!!$   14 - cjg.ctr    -> fpcjg
            !!!$   15 - eps.ctr    -> fpeps
            !!!$
            !!!$   Andreas Kemna                                        02-May-1995
            !!!$   Letzte Aenderung                                     Jul-2010

            !!!$.....................................................................

            USE alloci
            USE tic_toc
            USE femmod
            USE datmod
            USE invmod
            USE cjgmod
            USE sigmamod
            USE electrmod
            USE modelmod
            USE elemmod
            USE wavenmod
            USE randbmod
            USE konvmod
            USE errmod
            USE pathmod
            USE bsmatm_mod
            USE bmcm_mod
            USE brough_mod
            USE invhpmod
            USE omp_lib
            USE ompmod
            USE get_ver
            !!!$   USE portlib

            IMPLICIT NONE

            CHARACTER(256)         :: ftext
            INTEGER                :: c1,i,count,mythreads,maxthreads
            REAL(KIND(0D0))        :: lamalt,bdalt
            LOGICAL                :: converged,l_bsmat
            INTEGER,PARAMETER      :: clrln_len=50
            CHARACTER(clrln_len)   :: clrln ! clear line

            INTEGER :: getpid,pid,myerr
            !!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

            !!!$   SETUP UND INPUT
            !!!$   'crtomo.cfg' oeffnen
            errnr = 1
            !!!$   Kanal nummern belegen.. die variablen sind global!
            fperr = 9
            fprun = 10
            kanal = 11
            fpcfg = 12
            fpinv = 13
            fpcjg = 14
            fpeps = 15

            DO i=1,clrln_len-1
                clrln(i:i+1) = ' ' ! fill clear line CHARACTER array
            END DO

            pid = getpid()
            fetxt = 'crtomo.pid'
            PRINT*,'######### CRTomo ############'
            WRITE(*,"(a)") 'Licence:', &
            'Copyright © 1990-2020 Andreas Kemna <kemna@geo.uni-bonn.de>', &
            'Copyright © 2008-2020 CRTomo development team (see AUTHORS file)',&
            'Permission is hereby granted, free of charge, to any person obtaining a copy of',&
            'this software and associated documentation files (the “Software”), to deal in',&
            'the Software without restriction, including without limitation the rights to',&
            'use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies',&
            'of the Software, and to permit persons to whom the Software is furnished to do',&
            'so, subject to the following conditions:',&
            '',&
            'The above copyright notice and this permission notice shall be included in all',&
            'copies or substantial portions of the Software.',&
            '',&
            'THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR',&
            'IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,',&
            'FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE',&
            'AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER',&
            'LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,',&
            'OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE',&
            'SOFTWARE.'

            PRINT*, ''
            PRINT*, ''

            PRINT*,'Process_ID ::',pid
            OPEN (fprun,FILE=TRIM(fetxt),STATUS='replace',err=999)
            WRITE (fprun,*)pid
            CLOSE (fprun)
            maxthreads = OMP_GET_MAX_THREADS()
            WRITE(6,"(a, i5)") " OpenMP max threads: ", maxthreads

            PRINT*,'Version control of binary:'
            CALL get_git_ver

            fetxt = 'crtomo.cfg'
            OPEN(fpcfg,file=TRIM(fetxt),status='old',err=999)

            lagain=.TRUE. ! is set afterwards by user input file to false

            !!!$   Allgemeine Parameter setzen
            DO WHILE (lagain) ! this loop exits after all files are processed
                errnr2 = 0
                !!!$   Benoetigte Variablen einlesen
                CALL rall(kanal,delem,delectr,dstrom,drandb,&
                    dsigma,dvolt,dsens,dstart,dd0,dm0,dfm0,lagain)
                !!!$   diff+<
                !!!$   diff-     1            dsigma,dvolt,dsens,dstart,lsens,lagain)
                !!!$   diff+>
                IF (errnr.NE.0) GOTO 999

                NTHREADS = maxthreads
                !!!$ now that we know nf and kwnanz, we can adjust the OMP environment..
                IF (maxthreads > 2) THEN ! single or double processor machines don't need scheduling..
                    mythreads = MAX(kwnanz,2)
                    PRINT*,'Rescheduling..'
                    IF (mythreads <= maxthreads) THEN ! best case,
                        !!!$ the number of processors is greater or equal the assumed
                        !!!$ workload
                        PRINT*,'perfect match'
                    ELSE
                        !!!$ is smaller than the minimum workload.. now we have to devide a bit..
                        PRINT*,'less nodes than wavenumbers'
                        DO i = 1, INT(kwnanz/2)
                            mythreads = INT(kwnanz / i) + 1
                            IF (mythreads < maxthreads) EXIT
                        END DO
                    END IF
                    NTHREADS = mythreads
                END IF
                CALL OMP_SET_NUM_THREADS ( NTHREADS )
                ! recheck ..
                i = OMP_GET_MAX_THREADS()
                WRITE(6,'(2(a, i3),a)') " OpenMP threads: ",i,'(',maxthreads,')'
                !!!$

                !!!$   Element- und Randelementbeitraege sowie ggf. Konfigurationsfaktoren
                !!!$   zur Berechnung der gemischten Randbedingung bestimmen
                CALL precal()

                IF (errnr.NE.0) GOTO 999

                IF (.NOT.lbeta) THEN
                    lsr = .FALSE.

                    !!!$   Ggf. Fehlermeldungen
                    IF (.NOT.lsink) THEN
                        fetxt = 'no mixed boundary specify sink node'
                        errnr = 102
                    END IF
                    !!!$ RM this is handeled in rall..
                    !!$        if (swrtr.eq.0.and..not.lrandb2) then
                    !!$           fetxt = ' '
                    !!$           errnr = 103
                    !!$        end if

                    IF (errnr.NE.0) GOTO 999
                ELSE

                    !!!$   Ggf. Fehlermeldungen
                    IF (swrtr.EQ.0) THEN
                        fetxt = ' '
                        errnr = 106
                    END IF
                END IF

                !!!$   getting dynamic memory
                errnr = 94
                !!!$ physical model
                fetxt = 'allocation problem sigma'
                ALLOCATE (sigma(elanz),STAT=myerr)
                IF (myerr /= 0) GOTO 999
                fetxt = 'allocation problem sigma2'
                ALLOCATE (sigma2(elanz),STAT=myerr)
                IF (myerr /= 0) GOTO 999
                !!!$  model parameters
                fetxt = 'allocation problem par'
                ALLOCATE (par(manz),STAT=myerr)
                IF (myerr /= 0) GOTO 999
                fetxt = 'allocation problem dpar'
                ALLOCATE (dpar(manz),STAT=myerr)
                IF (myerr /= 0) GOTO 999
                fetxt = 'allocation problem dpar2'
                ALLOCATE (dpar2(manz),STAT=myerr)
                IF (myerr /= 0) GOTO 999
                fetxt = 'allocation problem pot'
                ALLOCATE(pot(sanz),STAT=myerr)
                IF (myerr /= 0) GOTO 999
                fetxt = 'allocation problem pota'
                ALLOCATE (pota(sanz),STAT=myerr)
                IF (myerr /= 0) GOTO 999
                !!!$ now the big array are coming..
                fetxt = 'allocation problem fak'
                ALLOCATE (fak(sanz),STAT=myerr) ! fak for modeling
                IF (myerr /= 0) GOTO 999
                IF (ldc) THEN
                    fetxt = 'allocation problem sensdc'
                    ALLOCATE (sensdc(nanz,manz),STAT=myerr)
                    IF (myerr /= 0) GOTO 999
                    fetxt = 'allocation problem kpotdc'
                    ALLOCATE (kpotdc(sanz,eanz,kwnanz),STAT=myerr)
                ELSE
                    fetxt = 'allocation problem sens'
                    ALLOCATE (sens(nanz,manz),STAT=myerr)
                    IF (myerr /= 0) GOTO 999
                    fetxt = 'allocation problem kpot'
                    ALLOCATE (kpot(sanz,eanz,kwnanz),STAT=myerr)
                END IF
                IF (myerr /= 0) GOTO 999

                !!!$ get CG data storage of residuums and bvec, which is global
                CALL con_cjgmod (1,fetxt,myerr)
                IF (myerr /= 0) GOTO 999

                !!!$ >> RM ref model regu
                !!!$ assign memory to global variables
                fetxt = 'allocation problem reference model'
                ALLOCATE (w_ref_re(manz),w_ref_im(manz),m_ref(manz),STAT=myerr)
                w_ref_re = 0d0;m_ref = DCMPLX(0d0);w_ref_im = 0d0
                IF (myerr /= 0) GOTO 999
                !!!$ << RM ref model regu

                !!!!$ INITIALIZE
                !!!$   Startparameter setzen
                bdalt = 1d0
                it     = 0;itr    = 0
                rmsalt = 0d0; lamalt = 1d0; bdpar = 1d0
                !     IF (lamnull_cri > 0d0) llamalt = lamnull_cri
                IF (BTEST(llamf,0)) lamalt = lamfix
                betrms = 0d0; pharms = 0d0
                lsetup = .TRUE.; lsetip = .FALSE.; lfpi    = .FALSE.
                llam   = .FALSE.; ldlami = .TRUE.; lstep  = .FALSE.
                lfstep = .FALSE.; l_bsmat = .TRUE.
                step   = 1d0; stpalt = 1d0; alam   = 0d0

                !!!$   Kontrolldateien oeffnen
                errnr = 1
                !!!$ OPEN CONTRL FILES
                fetxt = ramd(1:lnramd)//slash(1:1)//'inv.ctr'
                OPEN(fpinv,file=TRIM(fetxt),status='replace',err=999)
                CLOSE(fpinv)
                fetxt = ramd(1:lnramd)//slash(1:1)//'run.ctr'
                OPEN(fprun,file=TRIM(fetxt),status='replace',err=999)
                !!!$  close(fprun) muss geoeffnet bleiben da sie staendig beschrieben wird
                fetxt = ramd(1:lnramd)//slash(1:1)//'cjg.ctr'
                OPEN(fpcjg,file=TRIM(fetxt),status='replace',err=999)
                CLOSE(fpcjg)
                fetxt = ramd(1:lnramd)//slash(1:1)//'eps.ctr'
                OPEN(fpeps,file=TRIM(fetxt),status='replace',err=999)

                !!!$  SET ERRORS for all measurements and write control to fpeps
                !!!$ >> RM
                IF (ldc) THEN
                    WRITE (fpeps,'(a)')'1/eps_r eps_r datum'
                    WRITE (fpeps,'(G12.3,2x,G12.3,2X,G14.5)')( &
                        SQRT(wmatdr(i)),&
                        1/SQRT(wmatdr(i)), &
                        REAL(dat(i)), i=1,nanz)
                ELSE
                    WRITE (fpeps,'(t5,a,t14,a,t27,a,t38,a,t50,a,t62,a,t71,a,t87,a)')'1/eps_r','1/eps_p',&
                        '1/eps','eps_r','eps_p','eps','-log(|R|)', '-Phase (rad)'
                    WRITE (fpeps,'(3F10.1,2x,3G12.3,2G15.7)')&
                        (SQRT(wmatdr(i)),SQRT(wmatdp(i)),SQRT(wmatd(i)),1/SQRT(wmatdr(i)),&
                        1/SQRT(wmatdp(i)),1/SQRT(wmatd(i)),REAL(dat(i)),AIMAG(dat(i)),i=1,nanz)
                END IF
                CLOSE(fpeps)
                errnr = 4

                !!!$ set starting model
                CALL bsigm0(kanal,dstart)
                IF (errnr.NE.0) GOTO 999

                !!!$   Kontrolldateien initialisieren
                !!!$   diff-        call kont1(delem,delectr,dstrom,drandb)
                !!!$   diff+<
                CALL kont1(delem,delectr,dstrom,drandb,dd0,dm0,dfm0,lagain)
                !!!$   diff+>
                IF (errnr.NE.0) GOTO 999

                !!$     write(6,"(a, i3)") " OpenMP max threads: ", OMP_GET_MAX_THREADS()
            !!$     !$OMP PARALLEL
            !!$     write(6,"(2(a,i3))") " OpenMP: N_threads = ",&
            !!$          OMP_GET_NUM_THREADS()," thread = ", OMP_GET_THREAD_NUM()
            !!$     !$OMP END PARALLEL

            !!!$-------------
            !!!$   get current time
             CALL tic(c1)
            !!!$.................................................
             converged = .FALSE.

             DO WHILE (.NOT.converged) ! optimization loop

            !!!$   Control output
                WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//clrln
                WRITE(*,'(a,i3,a,i3,a)',ADVANCE='no')ACHAR(13)//&
                     ' Iteration ',it,', ',itr,' : Calculating Potentials'
                WRITE(fprun,'(a,i3,a,i3,a)')' Iteration ',it,', ',itr,&
                     ' : Calculating Potentials'

            !!!$   MODELLING
                count = 0
                IF (ldc) THEN
                   fetxt = 'allocation problem adc'
                   ALLOCATE (adc((mb+1)*sanz),STAT=myerr)
                   IF (myerr /= 0) GOTO 999
                   fetxt = 'allocation problem hpotdc'
                   ALLOCATE (hpotdc(sanz,eanz),STAT=myerr)
                   IF (myerr /= 0) GOTO 999
                   ALLOCATE (bdc(sanz),STAT=myerr)
                   fetxt = 'allocation problem adc'
                   IF (myerr /= 0) GOTO 999

                   !$OMP PARALLEL DEFAULT (none) &
                   !$OMP FIRSTPRIVATE (pota,fak,pot,adc,bdc,fetxt) &
                   !$OMP PRIVATE (j,l) &
                   !$OMP SHARED (kwnanz,lverb,eanz,lsr,lbeta,lrandb,&
                   !$OMP  lrandb2,sanz,kpotdc,swrtr,hpotdc,elbg,count,mb)
                   !$OMP DO
            !!!$   DC CASE

                   DO k=1,kwnanz
                      !$OMP ATOMIC
                      count = count + 1
                      fetxt = 'DC-Calculation wavenumber'
            !!$              IF (lverb) WRITE (*,'(a,t35,I4,t100,a)',ADVANCE='no')&
            !!$                   ACHAR(13)//TRIM(fetxt),count,''
                      DO l=1,eanz
                         IF (lsr.OR.lbeta.OR.l.EQ.1) THEN
            !!!$   Evtl calculation of analytical potentials
                            IF (lsr) CALL potana(l,k,pota)

            !!!$   COMPilation of the linear system
                            fetxt = 'kompadc'
                            CALL kompadc(l,k,adc,bdc)
                            !                    if (errnr.ne.0) goto 999

            !!!$   Evtl take Dirichlet boundary values into account
                            IF (lrandb) CALL randdc(adc,bdc)
                            IF (lrandb2) CALL randbdc2(adc,bdc)

            !!!$   Scale the linear system (preconditioning stores fak)
                            fetxt = 'scaldc'
                            CALL scaldc(adc,bdc,fak)
                            !                    if (errnr.ne.0) goto 999
            !!!$   Cholesky-Factorization of the Matrix
                            fetxt = 'choldc'
                            CALL choldc(adc)
                            !                    if (errnr.ne.0) goto 999
                         ELSE
                            fetxt = 'kompbdc'
            !!!$   Modification of the current vector (Right Hand Side)
                            CALL kompbdc(l,bdc,fak)
                         END IF

            !!!$   Solve linear system
                         fetxt = 'vredc'

                         CALL vredc(adc,bdc,pot)

            !!!$   Scale back the potentials, save them and
            !!!$   eventually add the analytical response
                         DO j=1,sanz
                            kpotdc(j,l,k) = DBLE(pot(j)) * fak(j)
                            IF (lsr) kpotdc(j,l,k) = kpotdc(j,l,k) + &
                                 DBLE(pota(j))
                            IF (swrtr.EQ.0) hpotdc(j,l) = kpotdc(j,l,k)
                         END DO
                      END DO

                   END DO
                   !$OMP END DO
                   !$OMP END PARALLEL

                ELSE

                   fetxt = 'allocation problem a'
                   ALLOCATE (a((mb+1)*sanz),STAT=myerr)
                   IF (myerr /= 0) GOTO 999
                   fetxt = 'allocation problem hpot'
                   ALLOCATE (hpot(sanz,eanz),STAT=myerr)
                   IF (myerr /= 0) GOTO 999
                   fetxt = 'allocation problem b'
                   ALLOCATE (b(sanz),STAT=myerr)
                   IF (myerr /= 0) GOTO 999
                   !$OMP PARALLEL DEFAULT (none) &
                   !$OMP FIRSTPRIVATE (pota,fak,pot,a,b,fetxt) &
                   !$OMP PRIVATE (j,l,k) &
                   !$OMP SHARED (kwnanz,lverb,eanz,lsr,lbeta,lrandb,lrandb2,sanz,kpot,swrtr,hpot,count)
                   !$OMP DO
            !!!$   COMPLEX CASE
                   DO k=1,kwnanz
                      !$OMP ATOMIC
                      count = count + 1
                      fetxt = 'IP-Calculation wavenumber'
                      IF (lverb) WRITE (*,'(a,t35,I4,t100,a)',ADVANCE='no')&
                           ACHAR(13)//TRIM(fetxt),count,''
                      DO l=1,eanz
                         IF (lsr.OR.lbeta.OR.l.EQ.1) THEN

            !!!$   Ggf. Potentialwerte fuer homogenen Fall analytisch berechnen
                            IF (lsr) CALL potana(l,k,pota)

            !!!$   Kompilation des Gleichungssystems (fuer Einheitsstrom !)
                            fetxt = 'kompab'
                            CALL kompab(l,k,a,b)
                            !                    if (errnr.ne.0) goto 999

            !!!$   Ggf. Randbedingung beruecksichtigen
                            IF (lrandb) CALL randb(a,b)
                            IF (lrandb2) CALL randb2(a,b)

            !!!$   Gleichungssystem skalieren
                            fetxt = 'scalab'
                            CALL scalab(a,b,fak)
                            !                    if (errnr.ne.0) goto 999

            !!!$   Cholesky-Zerlegung der Matrix
                            fetxt = 'chol'
                            CALL chol(a)
                            !                    if (errnr.ne.0) goto 999
                         ELSE

            !!!$   Stromvektor modifizieren
                            fetxt = 'kompb'
                            CALL kompb(l,b,fak)

                         END IF

            !!!$   Gleichungssystem loesen
                         fetxt = 'vre'
                         CALL vre(a,b,pot)

            !!!$   Potentialwerte zurueckskalieren und umspeichern sowie ggf.
            !!!$   analytische Loesung addieren
                         DO j=1,sanz
                            kpot(j,l,k) = pot(j) * dcmplx(fak(j))
                            IF (lsr) kpot(j,l,k) = kpot(j,l,k) + pota(j)
                            IF (swrtr.EQ.0) hpot(j,l) = kpot(j,l,k)
                         END DO
                      END DO
                   END DO
                   !$OMP END DO
                   !$OMP END PARALLEL

                END IF


            !!!$   Ggf. Ruecktransformation der Potentialwerte
                IF (swrtr.EQ.1) THEN
                   CALL rtrafo(errnr)
                   IF (errnr.NE.0) GOTO 999
                END IF
            !!!$   Spannungswerte berechnen
                CALL bvolti()
                IF (errnr.NE.0) THEN
            !!!$   reset model and data
                   sigma = sigma2

                   sigmaa = sgmaa2

                   EXIT
                END IF
            !!$  free some memory..
                IF (ldc) THEN
                   DEALLOCATE(adc,hpotdc,bdc)
                ELSE
                   DEALLOCATE(a,hpot,b)
                END IF

                IF (lsetup.OR.lsetip) THEN
            !!!$   Ggf. background auf ratio-Daten "multiplizieren"
                   IF (lratio) THEN
                      DO j=1,nanz
                         dat(j) = dat(j) + sigmaa(j)
                      END DO
                   END IF

            !!!$   Polaritaeten checken
                   CALL chkpol(lsetup.OR.lsetip)
                END IF

            !!!$   Daten-CHI berechnen
                CALL dmisft(lsetup.OR.lsetip)
                !        print*,nrmsd,betrms,pharms,lrobust,l1rat
                IF (errnr.NE.0) GOTO 999

                IF ((llam.AND..NOT.lstep).OR.lsetup) THEN
                   IF (itmax == 0) THEN
                      WRITE (*,'(t20,a,G14.4/)')'++ Calculated Fit',nrmsd
                   ELSE
                      IF (it == 0)  THEN
                         WRITE (*,'(a,G14.4/)')'++ Starting Fit',nrmsd
                      ELSE
                         WRITE (*,'(t10,a,G14.4/)',ADVANCE='no')'++ Actual Fit',nrmsd
                      END IF
                   END IF
                ELSE
                   WRITE (*,'(t10,a,G14.4)',ADVANCE='no')'-- Update Fit',nrmsd
                END IF

            !!!$   'nrmsd=0' ausschliessen
                IF (nrmsd.LT.1d-12) nrmsd=nrmsdm*(1d0-mqrms)

            !!!$   tst
            !!!$   tst        if (lfphai) then
            !!!$   tst            llam = .true.
            !!!$   tst            if (.not.lfpi) nrmsd = 1d0
            !!!$   tst        end if

            !!!$.............................
                IF (it == 0) THEN
                   WRITE (*,'(/a,t100/)')ACHAR(13)//&
                        'WRITING STARTING MODEL'
                   CALL wout(kanal,dsigma,dvolt)
                END IF
            !!!$   Kontrollvariablen ausgeben
                CALL kont2(lsetup.OR.lsetip)
                IF (errnr.NE.0) GOTO 999

            !!!$   ABBRUCHBEDINGUNGEN
                IF (llam.AND..NOT.lstep) THEN

            !!!$   Polaritaeten checken
                   CALL chkpol(lsetup.OR.lsetip)

            !!!$   Wiederholt minimale step-length ?
                   IF (stpalt.EQ.0d0) THEN
                      errnr2 = 92
                      fetxt = 'repeated step length'
                   END IF
                   WRITE (*,'(/a,G12.4,a/)')'+++ Convergence check (CHI (old/new)) ',&
                        100.0*(1d0-rmsalt/nrmsd),' %'
            !!!$   Keine Verbesserung des Daten-CHI ?
                   IF (dabs(1d0-rmsalt/nrmsd).LE.mqrms) THEN
                      errnr2 = 81
                      WRITE (fetxt,*)'No further CHI approvement ',&
                           REAL(ABS(1d0-rmsalt/nrmsd))
                   END IF
            !!!$   Minimaler Daten-CHI erreicht ?
            !!!$   tst            if (dabs(1d0-nrmsd/nrmsdm).le.mqrms) errnr2=80
                   IF (dabs(1d0-nrmsd/nrmsdm).LE.mqrms.AND.ldlamf) THEN
                      errnr2 = 80
                      WRITE (fetxt,*)'Optimal RMS ',REAL(nrmsd),' reached'
                   END IF

            !           IF (llam) THEN
            !              WRITE (6,'(a)',ADVANCE='no')'convergence '
            !              IF (nrmsd < 1d0 ) errnr2 = 94
            !              IF (nrmsd > rmsalt) errnr2 = 95
            !              IF (dabs(1d0-nrmsd/rmsalt) < mqrms) errnr2 = 93
            !              PRINT*,errnr2
            !           END IF

            !!!$   Maximale Anzahl an Iterationen ?
                   IF (it.GE.itmax) THEN
                      errnr2 = 79
                      WRITE (fetxt,*)'Reached max number of iterations ',itmax
                   END IF
            !!!$   Minimal stepsize erreicht ?
                   IF (dabs(1d0-bdpar/bdalt) < bdmin) THEN
                      errnr2 = 109
                      WRITE (fetxt,*)' Min model update reached ',dabs(1d0-bdpar/bdalt)
                   END IF

            !!!$   Ggf. abbrechen oder "final phase improvement"
                   IF (errnr2.NE.0) THEN

                      IF (lfphai.AND.errnr2.NE.79) THEN
                         PRINT*,'CRI termination '//TRIM(fetxt),errnr2
            !!!$   ak
            !!!$   Widerstandsverteilung und modellierte Daten ausgeben
                         CALL wout(kanal,dsigma,dvolt)
                         IF (errnr.NE.0) GOTO 999

            !!!$   Kontrollausgaben
                         WRITE(*,'(/a/)')&
                              '**** Final phase improvement ****'

                         WRITE(fprun,'(a24)',err=999)&
                              ' Final phase improvement'

                         fetxt = ramd(1:lnramd)//slash(1:1)//'inv.ctr'
                         OPEN(fpinv,file=TRIM(fetxt),status='old',&
                              POSITION='append',err=999)
                         WRITE(fpinv,'(/a/)',err=999)&
                              '------------------------------------------------'//&
                              '------------------------------------------------'//&
                              '-----------------'
                         CLOSE(fpinv)

            !!!$   Wichtungsfeld umspeichern
                         wmatd = wmatdp
                         lam_cri = lamalt

                         WRITE (*,'(/a,g12.4/)')'++ (FPI) setting phase error '//&
                              'and saving lam_cri: ',REAL(lam_cri)
                         WRITE (fprun,'(/a,g12.4/)')'++ (FPI) setting phase error '//&
                              'and saving lam_cri: ',REAL(lam_cri)

                         lfpi    = .TRUE.
                         lsetip = .TRUE. !
                         lfphai = .FALSE.
                         llam   = .FALSE.
                         ldlami = .TRUE.
                         lfstep = .TRUE.
                         step   = 1d0
                         errnr2 = 0 ! reset convergence case "error"

            !!!$   ak
                         fetxt = 'cp -f inv.lastmod inv.lastmod_rho'
                         CALL SYSTEM (TRIM(fetxt))
                         IF (lffhom) THEN
                            WRITE(*,*)&
                                 ' ******* Restarting phase model ********'
                            WRITE(fprun,*)&
                                 ' ******* Restarting phase model ********'
                            fetxt = ramd(1:lnramd)//slash(1:1)//'inv.ctr'
                            OPEN (fpinv,file=TRIM(fetxt),status='old',err=999,&
                                 position='append')
                            WRITE (fpinv,*)&
                                 ' ******* Resetting phase model ********'
                            CLOSE (fpinv)
                            DO j=1,elanz
                               sigma(j) = dcmplx(&
                                    dcos(pha0/1d3)*cdabs(sigma(j)) ,&
                                    -dsin(pha0/1d3)*cdabs(sigma(j)) )
                            END DO
                            lsetup = .TRUE. ! ensure proper misfit and kont2 output
                            CYCLE       ! neues calc
                         ELSE
                            lsetup = .FALSE.
                         END IF
            !!!$   ak

            !!!$   Daten-CHI berechnen
                         CALL dmisft(lsetip)
                         IF (errnr.NE.0) GOTO 999
                         WRITE (*,'(a,t45,a,t78,F14.4)') &
                              ACHAR(13),'++ Phase data fit',nrmsd

            !!!$   Kontrollvariablen ausgeben
                         CALL kont2(lsetip)
                         IF (errnr.NE.0) GOTO 999
                      ELSE
                         EXIT
                      END IF
                   ELSE
            !!!$ >> RM
                      lamalt = lam ! save the lambda of the previous iteration
            !!!$ if, and only if the iterate was successful...
            !!!$ << RM
            !!!$   ak
            !!!$   Widerstandsverteilung und modellierte Daten ausgeben
            !!$              WRITE (*,'(a,t30,I4,t100,a)')ACHAR(13)//&
            !!$                   'WRITING MODEL ITERATE',it,''
                      CALL wout(kanal,dsigma,dvolt)
                      IF (errnr.NE.0) GOTO 999
                   END IF
                END IF

                IF ((llam.AND..NOT.lstep).OR.lsetup.OR.lsetip) THEN

            !!!$   Iterationsindex hochzaehlen
                   it = it+1

            !!!$   Parameter zuruecksetzen
                   itr    = 0
                   rmsreg = 0d0
                   dlam   = 1d0
                   dlalt  = 1d0
                   ldlamf = .FALSE.
                   bdpar = 1d0
                   bdalt = 1d0

            !!!$   Daten-CHI speichern
                   rmsalt = nrmsd

            !!!$   Lambda speichen
                   IF (it>1) lamalt = lam ! mindestens einmal konvergiert

            !!!$   Felder speichern
                   sigma2 = sigma

                   sgmaa2 = sigmaa

                   IF (lrobust) wmatd2 = wmatd

            !!!$   Kontrollausgaben
                   WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//clrln
                   WRITE (*,'(a,i3,a,i3,a)',ADVANCE='no') &
                        ACHAR(13)//' Iteration ',it,', ',itr,&
                        ' : Calculating Sensitivities'

                   WRITE(fprun,'(a,i3,a,i3,a)')' Iteration ',it,', ',itr,&
                        ' : Calculating Sensitivities'

            !!!$   SENSITIVITAETEN berechnen
                   IF (ldc) THEN
                      CALL bsendc((it==0))
                   ELSE
                      CALL bsensi((it==0))
                   END IF

            !!!$   evtl   Rauhigkeitsmatrix oder CmS-Matrix belegen
                   IF (l_bsmat) CALL bsmatm(it,l_bsmat)

                ELSE

                   IF (lverb) THEN
                      CALL wout_up(kanal,it,itr,.FALSE.)
                      IF (errnr.NE.0) GOTO 999
                   END IF

            !!!$   Felder zuruecksetzen
                   sigma = sigma2

                   sigmaa = sgmaa2

                   IF (lrobust) wmatd = wmatd2

                END IF
                IF (itmax == 0) THEN ! only precalcs..
                   errnr2 = 109
                   PRINT*,'Only precalcs'
                   EXIT
                END IF

                IF (BTEST(llamf,0)) THEN ! for fixed lambda we do not want any parabola fitting?
                   lam = lamfix
                   IF (BTEST(llamf,1).AND.it>1) lam = lamfix / (2d0 * DBLE(it - 1))
                   llam = .FALSE. ! in order to calculate any update this needs to be false
                   IF (lsetup.OR.lsetip) THEN
                      lsetup = .FALSE.
                      lsetip = .FALSE.
                   END IF

            !!!$   REGULARISIERUNG / STEP-LENGTH einstellen
                ELSE
                   IF (.NOT.lstep) THEN

                      IF (llam) THEN
            !!!$   "Regularisierungsschleife" initialisieren und step-length zuruecksetzen
                         llam = .FALSE.
                         step = 1d0
                      ELSE

            !!!$   Regularisierungsindex hochzaehlen
                         itr = itr+1
                         IF ((((nrmsd.LT.rmsreg.AND.itr.LE.nlam).OR. &
                              (dlam.GT.1d0.AND.itr.LE.nlam)).AND.&
                              (.NOT.ldlamf.OR.dlalt.LE.1d0).AND.&
                           (dabs(1d0-bdpar/bdalt) > bdmin).AND.&
                              (dabs(1d0-rmsreg/nrmsdm).GT.mqrms)).OR.&
                              (rmsreg.EQ.0d0)) THEN

                            IF (rmsreg > 0d0) THEN
                               WRITE (fprun,'(/a,G12.4,a)')'Chi increase:',&
                                    100.0*(1d0-rmsalt/nrmsd),' %'
                               WRITE (fprun,'(a,G12.4,a)')'Stepsize :',bdpar
                               WRITE (fprun,'(a,G12.4/)')'nrmsd/rmsreg :',nrmsd/rmsreg
                            END IF
            !!!$   Regularisierungsparameter bestimmen
                            IF (lsetup.OR.lsetip) THEN ! general initialization, lam0

            !!!$   Kontrollausgabe
                               WRITE(*,'(a,i3,a,i3,a,t100,a)',ADVANCE='no')&
                                    ACHAR(13)//' Iteration ',it,', ',itr,&
                                    ' : Calculating 1st regularization parameter',''
                               WRITE(fprun,'(a,i3,a,i3,a)',ADVANCE='no')&
                                    ' Iteration ',it,', ',itr,&
                                    ' : Calculating 1st regularization parameter'
                               CALL blam0()
                               WRITE (*,'(a,G10.2)',ADVANCE='no')'lam_0:: ',lammax
                               WRITE (fprun,'(a,G10.2)')'lam_0 ',lammax
                               lam = lammax
                               lamalt = lammax
            !!!$   ak Model EGS2003, ERT2003                        call blam0()
            !!!$   ak Model EGS2003, ERT2003                        lam = lammax
            !!!$   ak                        lam = 1d4
            !!!$
            !!!$ GENERAL REMARK ON OUR REGULARISATION PARAMETER
            !!!$ Standard normal equations are
            !!!$ (A^h * Cd^-1 A + Cm^-1) dm = A_q^h * C_d^-1 * (d - f(m_q)) + C_m^-1 * ({m_q,(m_q-m_0)})
            !!!$ Where we identify lam as inverse a-priori variance:
            !!!$ Cm^-1 = \lam R^T * R.
            !!!$ If we solve the normal equation
            !!!$  Cm * (A^h * Cd^-1 A + I) dm = Cm * (A_q^h * C_d^-1 * (d - f(m_q)) - ({m_q,(m_q-m_0)}))
            !!!$ instead, we use \lam as prior variance.
            !!!$ This also results in the fundamental problem on how to adjust the search direction which depends on the
            !!!$ CHI decrease and thus should also be reciprocal.
            !!!$
            !!!$ nrmsdm and mqrms, fstart and fstop are set in rall.f90.
            !!!$ Defaults are
            !!!$ nrmsdm := 1d0; mqrms := 2d-2; fstart := 0.5; fstop := 0.9
            !!!$
                            ELSE ! for lambda search we go here
                               dlalt = dlam
                               IF (ldlami) THEN ! initialize search
                                  ldlami = .FALSE.
                                  alam   = dmax1(dabs(dlog(nrmsd/nrmsdm)),&
                                       dlog(1d0+mqrms))
            !!!$ alam = MAX(log(actual chi),log(1+0.02))
                                  dlam   = fstart ! sets first dlam (0.5 default, which should be fine)
                               ELSE
                                  alam = dmax1(alam,dabs(dlog(nrmsd/nrmsdm)))
            !!!$ CHI dependend partial fraction of lam variation
            !!!$ alam = MAX(alam,log(actual chi))
                                  dlam = dlog(fstop)*&
                                       SIGN(1d0,dlog(nrmsd/nrmsdm))+&
                                       dlog(fstart/fstop)*&
                                       dlog(nrmsd/nrmsdm)/alam
            !!!$
            !!!$ dlam = ln(0.9) * sign(1,ln(act chi)) + (ln(0.5/0.9)) * ln(act chi)/alam
            !!!$ this makes mostly the same and dlam = exp(ln(0.9) + ln(0.5/0.9)) = 0.5
            !!!$ This holds until the act chi value drops below 1. Than sign gives -1 and
            !!!$ also alam is now not identical to log(act chi) but log(1.02), which results
            !!!$ (for example act chi = 0,98)
            !!!$ dlam = exp(-ln(0.9) + ln(0.5/0.9) * ln(0.98)/log(1.02)) = 2
            !!!$
                                  dlam = dexp(dlam)

                               END IF
                               lam = lam*dlam
                               IF (dlalt.GT.1d0.AND.dlam.LT.1d0) ldlamf=.TRUE.
            !!!$   tst                        if (dlam.gt.1d0) lfstep=.true.
            !!!$   ak Model EGS2003
                               IF (dlam.GT.1d0) lrobust=.FALSE.

                            END IF
                         ELSE

            !!!$   Regularisierungsparameter zuruecksetzen und step-length verkleinern
            !!!$ if no Chi decrease found
                            llam = .TRUE.
                            lam  = lam/dlam

                            IF (lfstep) THEN
                               lfstep = .FALSE.
                            ELSE
                               lstep = .TRUE.
                               step  = 5d-1
                            END IF
                         END IF

            !!!$   Ggf. Daten-CHI speichern
                         IF (lsetup.OR.lsetip) THEN
                            lsetup = .FALSE.
                            lsetip = .FALSE.
                         ELSE
                            IF (.NOT.lstep) rmsreg=nrmsd
                         END IF
                      END IF
                   ELSE
                      lstep = .FALSE.

            !!!$   Parabolische Interpolation zur Bestimmung der optimalen step-length
                      CALL parfit(rmsalt,nrmsd,rmsreg,nrmsdm,stpmin)

                      IF (step.EQ.stpmin.AND.stpalt.EQ.stpmin)THEN

            !!!$   Nach naechstem Modelling abbrechen
                         stpalt = 0d0
                      ELSE

            !!!$   Step-length speichern
                         stpalt = step
                      END IF

                   END IF

                END IF
            !!!$   Kontrollausgaben
                WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//clrln
                WRITE(*,'(a,i3,a,i3,a)',ADVANCE='no')&
                     ACHAR(13)//' Iteration ',it,', ',itr,&
                     ' : Updating'

                WRITE(fprun,*)' Iteration ',it,', ',itr,&
                     ' : Updating'

            !!!$ Modell parameter mit aktuellen Leitfaehigkeiten belegen

                CALL bpar
                IF (errnr.NE.0) GOTO 999

            !!!$   UPDATE anbringen
                bdalt = bdpar
                CALL update
                IF (errnr.NE.0) GOTO 999

            !!!$ Leitfaehigkeiten mit verbessertem Modell belegen
                CALL bsigma
                IF (errnr.NE.0) GOTO 999

                IF (lverb) THEN
                   CALL wout_up(kanal,it,itr,.TRUE.)
                   IF (errnr.NE.0) GOTO 999
                END IF
            !!!$   Roughness bestimmen
                CALL brough

            !!!$   Ggf. Referenzleitfaehigkeit bestimmen
            !!!$ >>> RM
                !! $THIS has now a general meaning with the
            !!!$ mixed boundary, since we like to set sigma0
            !!!$ as reference sigma as "mean" boundary value
            !!!$ <<< RM
                IF (lbeta) CALL refsig()

                IF (BTEST(llamf,0)) THEN
                   llam = .TRUE.
                END IF

            !!!$   Neues Modelling
             END DO ! DO WHILE (.not. converged)

            !!!$ RESET FPI status variable to proceed with full COMPLEX calculus
             ! lfpi = .FALSE.
            !!!$
            !!!$.................................................

            !!!$   OUTPUT
             WRITE (*,'(a,t25,I4,t35,a,t100,a)')ACHAR(13)//&
                  'MODEL ESTIMATE AFTER',it,'ITERATIONS',''


            !!!$   Kontrollausgaben
            !!!$ errnr2 is more a status variable than a pure error number
            !!!$ it shows which case was the reason for termination of the algorithm
             SELECT CASE (errnr2)
             CASE (95)

                WRITE(*,'(a22,a31)') ' Iteration terminated:',&
                     ' no CHI decrease'
                WRITE(fprun,'(a22,a31)',err=999) ' Iteration terminated:',&
                     ' no CHI decrease'
            !!!$ reset model to previous state
                IF (BTEST(llamf,0)) THEN
                   WRITE (*,'(a)',ADVANCE='no')'Taking model state of previous iteration... '
                   sigma = sigma2
                   sigmaa = sgmaa2
                   nrmsd = rmsalt
                   PRINT*,'CHI = ',REAL(nrmsd)
                END IF

             CASE (94)

                WRITE(*,'(a22,a31)') ' Iteration terminated:',&
                     ' CHI < 1'
                WRITE(fprun,'(a22,a31)',err=999) ' Iteration terminated:',&
                     ' CHI < 1'

             CASE (93)

                WRITE(*,'(a22,a31)') ' Iteration terminated:',&
                     ' CHI decrease sufficiently'
                WRITE(fprun,'(a22,a31)',err=999) ' Iteration terminated:',&
                     ' CHI decreasse sufficiently'

             CASE (92)

                WRITE(*,'(a22,a31)') ' Iteration terminated:',&
                     ' Min. step-length for 2nd time.'

                WRITE(fprun,'(a22,a31)',err=999) ' Iteration terminated:',&
                     ' Min. step-length for 2nd time.'
             CASE (80)
                WRITE(*,'(a22,a10)') ' Iteration terminated:', &
                     ' Min. CHI.'

                WRITE(fprun,'(a22,a10)',err=999) ' Iteration terminated:',&
                     ' Min. CHI.'
             CASE (81)
                WRITE(*,'(a22,a24)') ' Iteration terminated:',&
                     ' Min. rel. CHI decrease.'

                WRITE(fprun,'(a22,a24)',err=999) ' Iteration terminated:',&
                     ' Min. rel. CHI decrease.'
             CASE (79)
                WRITE(*,'(a22,a19)') ' Iteration terminated:',&
                     ' Max. # iterations.'

                WRITE(fprun,'(a22,a19)',err=999) ' Iteration terminated:',&
                     ' Max. # iterations.'

             CASE (109)
                WRITE(*,'(a)') ' Iteration terminated:'//&
                     ' Min. model changes reached'

                WRITE(fprun,'(a)',err=999) ' Iteration terminated:'//&
                     ' Min. model changes reached'

             END SELECT

             CALL wout(kanal,dsigma,dvolt)
             IF (errnr.NE.0 .AND..NOT. errnr == 82) GOTO 999

            !!!$   Kontrollausgaben

            !!!$   Run-time abfragen und ausgeben
             fetxt = ' CPU time: '
             CALL toc(c1,fetxt)
            !!$     PRINT*,''
            !!$     PRINT*,''
             WRITE(fprun,'(a)',err=999)TRIM(fetxt)

            !!!$   Kontrolldateien schliessen
             CLOSE(fpinv)
             CLOSE(fpcjg)
             CLOSE(fpeps)


            !!!$   Ggf. Summe der Sensitivitaeten aller Messungen ausgeben
             IF (lsens) THEN
                CALL BBSENS(kanal,dsens)
                IF (errnr.NE.0) GOTO 999
             END IF

             IF (lvario) THEN
                !        IF (lsens) CALL bvariogram_s ! calculate experimental variogram
                CALL bvariogram
             END IF

             IF (lcov1) CALL buncert (kanal,lamalt)

             CALL des_cjgmod(1,fetxt,myerr) ! call cjgmod destructor
             IF (myerr /= 0) GOTO 999

            !!!$   'sens' und 'pot' freigeben
             IF (ldc) THEN
                fetxt = 'allocation sensdc'
                DEALLOCATE (sensdc)
                fetxt = 'allocation koptdc'
                DEALLOCATE (kpotdc)
             ELSE
                DEALLOCATE(sens,kpot)
             END IF

             fetxt = 'allocation smatm'
             IF (ALLOCATED (smatm)) DEALLOCATE (smatm)

             fetxt = 'allocation pot,pota,fak'
             IF (ALLOCATED (pot)) DEALLOCATE (pot,pota,fak)

             fetxt = 'allocation snr,sx,sy'
             IF (ALLOCATED (snr)) DEALLOCATE (snr,sx,sy)

             fetxt = 'allocation typ'
             IF (ALLOCATED (typ)) DEALLOCATE (typ,nelanz,selanz)

             fetxt = 'allocation nrel'
             IF (ALLOCATED (nrel)) DEALLOCATE (nrel,rnr)

             fetxt = 'allocation esp'
             IF (ALLOCATED (espx)) DEALLOCATE (espx,espy)

             fetxt = 'allocation kwn'
             IF (ALLOCATED (kwn)) DEALLOCATE (kwn)

             fetxt = 'allocation kwni'
             IF (ALLOCATED (kwnwi)) DEALLOCATE (kwnwi)

             fetxt = 'allocation elbg'
             IF (ALLOCATED (elbg)) DEALLOCATE (elbg,relbg,kg)

             fetxt = 'allocation enr'
             IF (ALLOCATED (enr)) DEALLOCATE (enr)

             fetxt = 'allocation mnr'
             IF (ALLOCATED (mnr)) DEALLOCATE (mnr)

             fetxt = 'allocation strnr,strom,volt,etc'
             IF (ALLOCATED (strnr)) DEALLOCATE (strnr,strom,volt,sigmaa,&
                  kfak,wmatdr,wmatdp,vnr,dat,wmatd,wmatd2,sgmaa2,wdfak,&
                  wmatd_cri) !!! these are allocated in rdati!!!

             fetxt = 'allocation par,dpar,dpar2'

             IF (ALLOCATED (par)) DEALLOCATE (par,dpar,dpar2)

             fetxt = 'allocation sigma'

             IF (ALLOCATED (sigma)) DEALLOCATE (sigma,sigma2)

             IF (ALLOCATED (d0)) DEALLOCATE (d0,fm0)
             IF (ALLOCATED (m0)) DEALLOCATE (m0)

             IF (ALLOCATED (rwddc)) DEALLOCATE (rwddc)
             IF (ALLOCATED (rwndc)) DEALLOCATE (rwndc)
             IF (ALLOCATED (rwd)) DEALLOCATE (rwd)
             IF (ALLOCATED (rwn)) DEALLOCATE (rwn)
             IF (ALLOCATED (rwdnr)) DEALLOCATE (rwdnr)

             IF (ALLOCATED (w_ref_re)) DEALLOCATE (w_ref_re,w_ref_im,m_ref)

            !!! write final statement in run.ctr
             WRITE(fprun,'(a)') '***finished***'
             CLOSE(fprun)

            !!!$   Ggf. weiteren Datensatz invertieren
            END DO

            !!!$   'crtomo.cfg' schliessen
            CLOSE (fpcfg)

            !!!$ crtomo.pid löschen
            fetxt = 'crtomo.pid'
            OPEN (fprun,FILE=TRIM(fetxt),STATUS='old',err=999)
            CLOSE (fprun,STATUS='delete')

            !!!$ finished-string an inv.ctr anhängen
            fetxt = ramd(1:lnramd)//slash(1:1)//'inv.ctr'
            OPEN(fpinv,file=TRIM(fetxt),status='old',POSITION='append',err=999)
            WRITE (fpinv,'(a)')'***finished***'
            CLOSE(fpinv)

            !!! also write the final statement to STDOU
            WRITE(*,*) '***finished***'
            ! STOP '0'

            !!!$.....................................................................

            !!!$   Fehlermeldung
            999 OPEN(fperr,file='error.dat',status='replace')
            errflag = 2
            CALL get_error(ftext,errnr,errflag,fetxt)
            WRITE(fperr,*) 'CRTomo PID ',pid,' exited abnormally'
            WRITE(fperr,'(a80,i3,i1)') fetxt,errnr,errflag
            WRITE(fperr,*)ftext
            CLOSE(fperr)

            ! STOP '-1'

        end subroutine invertpy
end module pyinv

!> \file cg_mod.f90
!> \brief modules for solving the inversion update equation (<I>Normal equation</I>)
!> \details Collection of routines for computing the iterative model update as a solution of the <I>Normal equations</I> with the conjugate gradient (CG) method.
!> @author Andreas Kemna, Roland Martin
!> @date 07/30/2010

MODULE cg_mod
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This MODULE should deliver the interface for the Conjugate Gradient  
! Method routines which are utilized to solve the normal equations   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Copyright by Andreas Kemna 2010
!
! Edited by Roland Martin               30-Jul-2010
!
! Last changed       RM                  Feb-2011
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  USE alloci , ONLY : sens,sensdc,smatm
  USE femmod , ONLY : fak,ldc
  USE elemmod, ONLY : max_nr_element_nodes,nachbar
  USE invmod , ONLY : lfpi,wmatd,wdfak,dpar
  USE errmod , ONLY : errnr,fetxt
  USE konvmod , ONLY : ltri,lam,nx,nz,lverb,lw_ref, lam_ref, lam_ref_sw
  USE modelmod , ONLY : manz,w_ref_re,w_ref_im
  USE datmod , ONLY : nanz
  USE cjgmod

  IMPLICIT NONE

!> number of threads.
!! NOTE that we restrict the total thread numbers here to avoid atomization 
!! of the problem since we are dealing with pure matrix vector product
  INTEGER,PARAMETER,PRIVATE :: ntd=2 

!> controls whather we have REAL or COMPLEX case
  PUBLIC :: cjg
!> Subroutine calculates model update (DC)
!! with preconditioned conjugate gradient method
  PRIVATE :: cjggdc
!!  sub calculates A * p (skaliert)
  PRIVATE :: bapdc
!! calculates  A^h * R^d * A * p + l * R^m * p  (skaliert)
  PRIVATE :: bbdc
!! calculates b = B * p (RHS) smooth regularization
  PRIVATE :: bpdc
!! calculates b = B * p (RHS) same but for unstructured grids
  PRIVATE :: bpdctri
!! calculates b = B * p (RHS) for Levenberg and Levenberg-Marquardt damping
  PRIVATE :: bpdclma
!!$ calculates b = B * p (RHS) for stochastical regularization
  PRIVATE :: bpdcsto
!!$ adds additional parts to b = B * p (RHS) for reference model regularization
  PRIVATE :: bpdcref


!!$ IP subroutines
  PRIVATE :: cjggra
! Subroutine calculates model update for COMPLEX case
! with preconditioned conjugate gradient method

  PRIVATE :: bap
!  sub calculates A * p (skaliert)
  PRIVATE :: bp
!  subroutine calculates b = B * p (RHS) smooth regularization
  PRIVATE :: bptri
!!! same but for unstructured grids
  PRIVATE :: bplma
! for Levenberg and Levemnberg-Marquardt damping
  PRIVATE :: bpsto
!!$ for stochastical regularization, MATMUL is 
!!$ now explicitly formed because of conjugate complex
!!$ adds additional parts to b = B * p (RHS) for reference model regularization
  PRIVATE :: bpref
  PRIVATE :: bb
! calculates  A^h * R^d * A * p + l * R^m * p  (skaliert)


CONTAINS
!> cjg flow control subroutine is called from outside
!! and checks for the different cases (DC,IP,FPI)
  SUBROUTINE cjg
    IF (ldc.OR.lfpi) THEN
       CALL con_cjgmod (2,fetxt,errnr)
       IF (errnr /= 0) RETURN
       CALL cjggdc
       CALL des_cjgmod (2,fetxt,errnr)
       IF (errnr /= 0) RETURN
    ELSE
       CALL con_cjgmod (3,fetxt,errnr)
       IF (errnr /= 0) RETURN
       CALL cjggra
       CALL des_cjgmod (3,fetxt,errnr)
       IF (errnr /= 0) RETURN
    END IF

  END SUBROUTINE cjg


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                          DC_PART                               !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  SUBROUTINE cjggdc()
!    Unterprogramm berechnet Modellverbesserung mittels konjugierter
!    Gradienten.
!
!    Andreas Kemna                                        01-Mar-1996
!    Letzte Aenderung                                     29-Jul-2009
!....................................................................
!    PROGRAMMINTERNE PARAMETER:
!
!    Skalare
    REAL(KIND(0D0)) :: beta,alpha,dr,dr0,dr1
!
!    Hilfsvariablen
    INTEGER         :: k
!
!....................................................................

    IF (lfpi) THEN
       bvecdc = dimag(bvec)
    ELSE
       bvecdc = DBLE(bvec)
    END IF

    dpar = DCMPLX(0D0)
    rvecdc = bvecdc
    pvecdc = 0D0

    fetxt = 'CG iteration'

    DO k=1,ncgmax

       ncg = k-1

       dr = DOT_PRODUCT(rvecdc,rvecdc)

       IF (k.EQ.1) THEN
          dr0  = dr*eps
          beta = 0d0
       ELSE
          beta = dr/dr1
       END IF

       IF (lverb) WRITE (*,'(a,t40,I5,t55,G10.4,t70,G10.4)',&
            ADVANCE='no')ACHAR(13)//TRIM(fetxt),k,dr,dr0

       IF (dr.LE.dr0) GOTO 10

       pvecdc= rvecdc + beta * pvecdc
       CALL bapdc

       IF (ltri == 0) THEN
          CALL bpdc

       ELSE IF (ltri == 1.OR.ltri == 2.OR.&
            (ltri > 4 .AND. ltri < 15)) THEN
          CALL bpdctri

       ELSE IF (ltri == 3.OR.ltri == 4) THEN
          CALL bpdclma

       ELSE IF (ltri == 15) THEN
          CALL bpdcsto

       END IF
       
       IF (lw_ref) CALL bpdcref

       CALL bbdc

       dr1 = DOT_PRODUCT(pvecdc,bvecdc) ! this is ok for ERT

       alpha = dr/dr1

       dpar = dpar + DCMPLX(alpha) * DCMPLX(pvecdc)
       rvecdc= rvecdc - alpha * bvecdc

!rm update speichern
       dr1 = dr

!    Residuum speichern
       cgres(k+1) = REAL(eps*dr/dr0)

    END DO

    ncg = ncgmax

!    Anzahl an CG-steps speichern
10  cgres(1) = REAL(ncg)

    !    DEALLOCATE (pvecdc,rvecdc,apdc,bvecdc)

    RETURN

  END SUBROUTINE cjggdc

  SUBROUTINE bapdc
!!$
!    Unterprogramm berechnet Hilfsvektor A * p (skaliert).
!
!    Andreas Kemna                                      29-Feb-1996
!!$
!    Last changes   RM                                  Mar-2011
!!$
!...................................................................
!    PROGRAMMINTERNE PARAMETER:
!    Hilfsvariablen
    INTEGER         ::     i,j

!....................................................................

    

    apdc = 0D0

!    A * p  berechnen (skaliert)
    DO i=1,nanz
       IF (ldc) THEN
          DO j=1,manz
             apdc(i) = apdc(i) + pvecdc(j)*sensdc(i,j)*cgfac(j)
          END DO
       ELSE IF (lfpi) THEN
          DO j=1,manz
             apdc(i) = apdc(i) + pvecdc(j)*DBLE(sens(i,j))*cgfac(j)
          END DO
       END IF
    END DO
  END SUBROUTINE bapdc

  SUBROUTINE bpdc()
!!$
!    Unterprogramm berechnet b = B * p .
!
!    Andreas Kemna                                      29-Feb-1996
!!$
!    Last changes   RM                                  Jul-2010
!!$
!...................................................................
!    PROGRAMMINTERNE PARAMETER:
!    Hilfsvariablen
    REAL(KIND(0D0))    ::     dum
    INTEGER         ::     i

!....................................................................

!    R^m * p  berechnen (skaliert)
    DO i=1,manz
       dum = 0d0

       IF (i.GT.1) &
            dum = pvecdc(i-1)*smatm(i-1,2)*cgfac(i-1)
       IF (i.LT.manz) &
            dum = dum + pvecdc(i+1)*smatm(i,2)*cgfac(i+1)
       IF (i.GT.nx) &
            dum = dum + pvecdc(i-nx)*smatm(i-nx,3)*cgfac(i-nx)
       IF (i.LT.manz-nx+1) &
            dum = dum + pvecdc(i+nx)*smatm(i,3)*cgfac(i+nx)

       bvecdc(i) = dum + pvecdc(i)*smatm(i,1)*cgfac(i)
    END DO

  END SUBROUTINE bpdc

  SUBROUTINE bpdctri()
!    
!    Unterprogramm berechnet b = B * p .
!    Fuer beliebige Triangulierung
!    
!    Copyright by Andreas Kemna         2009
!
!    Created by Roland Martin                            29-Jul-2009
!     
!    Last changes      RM                                   Jul-2010
!    
!....................................................................
!.....................................................................
!
!!     PROGRAMMINTERNE PARAMETER:

!!     Hilfsvariablen
    REAL(KIND(0D0))    ::     dum
    INTEGER         ::     i,j
!!.....................................................................

    !     R^m * p  berechnen (skaliert)
    DO i=1,manz
       dum = 0d0
       DO j=1,max_nr_element_nodes
          IF (nachbar(i,j) /= 0) dum = dum + pvecdc(nachbar(i,j)) * & 
               smatm(i,j) * cgfac(nachbar(i,j)) ! off diagonals
       END DO
       !     main diagonal
       bvecdc(i) = dum + pvecdc(i) * smatm(i,max_nr_element_nodes+1) * cgfac(i) 
    END DO

  END SUBROUTINE bpdctri



  SUBROUTINE bpdclma()
!    
!    Unterprogramm berechnet b = B * p . 
!    Angepasst an Levenberg-Marquardt-Daempfung
!   
!    Copyright by Andreas Kemna 2010
!    
!    Created by Roland Martin                            24-Feb-2010
!    
!    Last changes        RM                                Jul-2010
!
!....................................................................
!    PROGRAMMINTERNE PARAMETER:

!    Hilfsvariablen
    INTEGER         ::     i

!....................................................................


!    R^m * p  berechnen (skaliert)
    DO i=1,manz
       bvecdc(i)=pvecdc(i)*cgfac(i)*smatm(i,1) ! damping stuff..
    END DO

  END SUBROUTINE bpdclma

  SUBROUTINE bpdcsto()
!
!    Unterprogramm berechnet b = B * p . 
!    Angepasst an die neue Regularisierungsmatrix
!    (stoch. Kovarianzmatrix)
!
!    Copyright by Andreas Kemna 2009
!    
!    Created by Roland Martin                             10-Jun-2009
!
!    Last changes        RM                                Jul-2010
!
!....................................................................

!    R^m * p  berechnen (skaliert)

    bvecdc = MATMUL(smatm,pvecdc)

    bvecdc = bvecdc * cgfac

  END SUBROUTINE bpdcsto

  SUBROUTINE bpdcref()
!    
!    additional entries due to b = B*p
!    for reference model regu
!   
!    Copyright by Andreas Kemna 2010
!    
!    Created by Roland Martin                            05-Sep-2012
!    
!    Last changes        RM                                Sep-2012
!
!....................................................................
!    PROGRAMMINTERNE PARAMETER:

!    Hilfsvariablen
    INTEGER         ::     i
    REAL (KIND(0D0)) :: rdum
!....................................................................


!    R^m * p  berechnen (skaliert)
    DO i=1,manz

       IF (w_ref_re(i) <= EPSILON(rdum)) CYCLE 

       rdum = pvecdc(i)*w_ref_re(i)

       bvecdc(i) = bvecdc(i) + rdum * lam_ref * cgfac(i)
!!! according to damping stuff..
    END DO

  END SUBROUTINE bpdcref

  SUBROUTINE bbdc
!!$
!    Unterprogramm berechnet A^h * R^d * A * p + l * R^m * p  berechnen (skaliert)
!
!    Andreas Kemna                                      29-Feb-1996
!!$
!    Last changes   RM                                  Mar-2011
!!$
!...................................................................
!    PROGRAMMINTERNE PARAMETER:
!    Hilfsvariablen
    REAL(KIND(0D0))    ::     dum
    INTEGER         ::     i,j

!....................................................................
    DO j=1,manz
       dum = 0d0
       IF (ldc) THEN
          DO i=1,nanz
             dum = dum + sensdc(i,j) * &
                  wmatd(i)*DBLE(wdfak(i))*apdc(i)
          END DO
       ELSE IF (lfpi) THEN
          DO i=1,nanz
             dum = dum + DBLE(sens(i,j)) * &
                  wmatd(i)*DBLE(wdfak(i))*apdc(i)
          END DO
       END IF

       bvecdc(j) = dum + lam*bvecdc(j)
       bvecdc(j) = bvecdc(j)*cgfac(j)
    END DO

  END SUBROUTINE bbdc


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!                         IP_PART                                !!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  SUBROUTINE cjggra()
!    Unterprogramm berechnet Modellverbesserung mittels konjugierter
!    Gradienten.
!
!    Andreas Kemna                                        01-Mar-1996
!    Last changes   RM                                    Jul-2010
!....................................................................
!    PROGRAMMINTERNE PARAMETER:
!    Skalare
!!$!!    COMPLEX(KIND(0D0)) :: beta
    REAL(KIND(0D0))    :: alpha,dr,dr0,dr1,beta
!!$
!    Hilfsvariablen
    INTEGER            :: k,j
!....................................................................


    dpar = dcmplx(0d0)
    rvec = bvec
    pvec = dcmplx(0d0)

    fetxt = 'CG iteration'

    DO k=1,ncgmax

       ncg = k-1

       dr = 0d0
       DO j=1,manz
          dr = dr + DBLE(DCONJG(rvec(j)) * rvec(j))
       END DO

       IF (k.EQ.1) THEN
          dr0  = dr*eps
          beta = 0d0
       ELSE
          IF (dr.LE.dr0) GOTO 10
!    Fletcher-Reeves-Version
          beta = dr/dr1
!    ak!Polak-Ribiere-Version
!!$          beta = 0d0
!!$          do j=1,manz
!!$             beta = beta + dconjg(bvec(j))*rvec(j)
!!$          end do
!!$          beta = beta * -alpha/dr1
       END IF

       IF (lverb) WRITE (*,'(a,t40,I5,t55,G10.4,t70,G10.4)',&
            ADVANCE='no')ACHAR(13)//TRIM(fetxt),k,dr,dr0

       pvec = rvec + DCMPLX(beta) * pvec

       CALL bap

       IF (ltri == 0) THEN
          CALL bp
       ELSE IF (ltri == 1.OR.ltri == 2.OR.&
            (ltri > 4 .AND. ltri < 15)) THEN
          CALL bptri
       ELSE IF (ltri == 3.OR.ltri == 4) THEN
          CALL bplma
       ELSE IF (ltri == 15) THEN
          CALL bpsto
       END IF

       IF (lw_ref) CALL bpref

       CALL bb

       dr1 = 0d0
       DO j=1,manz
          dr1 = dr1 + DBLE(DCONJG(pvec(j)) * bvec(j))
       END DO

       alpha = dr/dr1

       dpar = dpar + DCMPLX(alpha) * pvec
       rvec = rvec - DCMPLX(alpha) * bvec

       dr1 = dr

!    Residuum speichern
       cgres(k+1) = REAL(eps*dr/dr0)

    END DO

    ncg = ncgmax

!    Anzahl an CG-steps speichern
10  cgres(1) = REAL(ncg)


  END SUBROUTINE cjggra

  SUBROUTINE bap
!
!    Unterprogramm berechnet A * p  berechnen (skaliert)
!
!    Andreas Kemna                                        29-Feb-1996
!     
!    Last changes      RM                                   Mar-2011
!    
!....................................................................
!    PROGRAMMINTERNE PARAMETER:

!    Hilfsvariablen
    INTEGER         ::     i,j

!....................................................................

!    A * p  berechnen (skaliert)
    DO i=1,nanz
       ap(i) = dcmplx(0d0)

       DO j=1,manz
          ap(i) = ap(i) + pvec(j)*sens(i,j)*dcmplx(cgfac(j))
       END DO
    END DO

  END SUBROUTINE bap

  SUBROUTINE bp()
!
!    Unterprogramm berechnet b = B * p .
!
!    Andreas Kemna                                        29-Feb-1996
!     
!    Last changes      RM                                   Jul-2010
!    
!....................................................................
!    PROGRAMMINTERNE PARAMETER:

!    Hilfsvariablen
    COMPLEX(KIND(0D0)) ::    cdum
    INTEGER         ::     i

!....................................................................
!    R^m * p  berechnen (skaliert)
    DO i=1,manz
       cdum = dcmplx(0d0)

       IF (i.GT.1) &
            cdum = pvec(i-1)*dcmplx(smatm(i-1,2)*cgfac(i-1))
       IF (i.LT.manz) &
            cdum = cdum + pvec(i+1)*dcmplx(smatm(i,2)*cgfac(i+1))
       IF (i.GT.nx) &
            cdum = cdum + pvec(i-nx)*dcmplx(smatm(i-nx,3)*cgfac(i-nx))
       IF (i.LT.manz-nx+1) &
            cdum = cdum + pvec(i+nx)*dcmplx(smatm(i,3)*cgfac(i+nx))
       bvec(i) = cdum + pvec(i)*dcmplx(smatm(i,1)*cgfac(i))
    END DO
  END SUBROUTINE bp

  SUBROUTINE bptri()
!    
!    Unterprogramm berechnet b = B * p .
!    Fuer beliebige Triangulierung
!    
!    Copyright by Andreas Kemna         2009
!
!    Created by Roland Martin                           29-Jul-2009
!    
!    Last changes      RM                                  Jul-2010
!    
!..................................................................
!.....................................................................
!
!     PROGRAMMINTERNE PARAMETER:
!
!     Hilfsvariablen
    COMPLEX(KIND(0D0)) ::    cdum
    INTEGER         ::     i,j,idum
!!!.....................................................................
    !     R^m * p  berechnen (skaliert)
    DO i=1,manz
       cdum = dcmplx(0d0)
       DO j=1,max_nr_element_nodes
          idum=nachbar(i,j)
          IF (idum/=0) cdum = cdum + pvec(idum) * & 
               DCMPLX(smatm(i,j)) * cgfac(idum) ! off diagonals
       END DO

       bvec(i) = cdum + pvec(i) * DCMPLX(smatm(i,max_nr_element_nodes+1)) * &
            cgfac(i) ! + main diagonal

    END DO

  END SUBROUTINE bptri

  SUBROUTINE bplma()
!
!    Unterprogramm berechnet b = B * p . 
!    Angepasst an Levenberg-Marquardt-Daempfung
!
!    Copyright by Andreas Kemna       2010
!    
!    Created by Roland Martin                              24-Feb-2010
!
!    Last changes        RM                                Jul-2010
!
!....................................................................
!    PROGRAMMINTERNE PARAMETER:
!    Hilfsvariablen
    INTEGER         ::     i
!....................................................................
!    coaa R^m * p  berechnen (skaliert)

!     bvec = pvec * DCMPLX(cgfac * smatm(:,1))
    do i=1,manz
       bvec(i)=pvec(i)*dcmplx(cgfac(i))*DCMPLX(smatm(i,1))
    end do

  END SUBROUTINE bplma


  SUBROUTINE bpsto()
!
!    Unterprogramm berechnet b = B * p .
!    Angepasst an die neue Regularisierungsmatrix 
!    (stoch. Kovarianzmatrix) fuer komplexes Modell
!
!   TODO:
!      since smatm is symmetric, it would be good to 
!      exploit this..
!
!    Copyright by Andreas Kemna 2009
!    
!    Created by Roland Martin                              10-Jun-2009
!
!    Last changes   RM                                     Jul-2010
!
!....................................................................
!    R^m * p  berechnen (skaliert)
    bvec = MATMUL(DCMPLX(smatm),pvec)

    bvec = bvec * DCMPLX(cgfac)
  END SUBROUTINE bpsto

  SUBROUTINE bpref()
!    
!    additional entries due to b = B*p
!    for reference model regu
!   
!    Copyright by Andreas Kemna 2010
!    
!    Created by Roland Martin                            05-Sep-2012
!    
!    Last changes        RM                                Sep-2012
!
!....................................................................
!    PROGRAMMINTERNE PARAMETER:

!    Hilfsvariablen
    INTEGER         ::     i
    COMPLEX (KIND(0D0)) :: cdum
!....................................................................


!    R^m * p  berechnen (skaliert)
    DO i=1,manz

       IF (w_ref_re(i) <= EPSILON(w_ref_re(i)) .AND. &
            w_ref_im(i) <= EPSILON(w_ref_im(i))) CYCLE 
!!$ scaling for real and imaginary part separately       
       cdum = DCMPLX(DBLE(pvec(i))*w_ref_re(i), DIMAG(pvec(i))*w_ref_re(i))

       bvec(i) = bvec(i) + cdum * DCMPLX(lam_ref * cgfac(i))

!!! according to damping stuff..
    END DO

  END SUBROUTINE bpref

  SUBROUTINE bb
!
!    Unterprogramm berechnet A^h * R^d * A * p + l * R^m * p  berechnen (skaliert)
!
!    Andreas Kemna                                        29-Feb-1996
!     
!    Last changes      RM                                   Mar-2011
!    
!....................................................................
!    PROGRAMMINTERNE PARAMETER:

!    Hilfsvariablen
    COMPLEX(KIND(0D0)) ::    cdum
    INTEGER         ::     i,j

!....................................................................
    DO j=1,manz
       cdum = dcmplx(0d0)

       DO i=1,nanz
          cdum = cdum + dconjg(sens(i,j)) * &
               dcmplx(wmatd(i)*DBLE(wdfak(i)))*ap(i)
       END DO

       bvec(j) = cdum + dcmplx(lam)*bvec(j)
       bvec(j) = bvec(j)*dcmplx(cgfac(j))
    END DO
  END SUBROUTINE bb


END MODULE cg_mod

MODULE pathmod
!!$c 'path.fin'
!!$
!!$c Andreas Kemna                                            25-Jun-1996
!!$c                                       Letzte Aenderung   24-Oct-1996
!!$
!!$c.....................................................................

!!$c (Back-) Slash
  CHARACTER(1),PUBLIC :: slash

!!$c RAM-Disk-Pfad
  CHARACTER (60),PUBLIC ::    ramd

!!$c Laenge des RAM-Disk-Pfades
  INTEGER(KIND = 4),PUBLIC ::     lnramd

!!$c UNIX COMMANDS
  CHARACTER(6),PUBLIC,PARAMETER :: mkdir_cmd='mkdir '
  CHARACTER(6),PUBLIC,PARAMETER :: rmdir='rm -R '

  PUBLIC :: clear_string

CONTAINS

  SUBROUTINE clear_string (string)
!!!$ PURPOSE
!!!$ extract the first "part" of a string until the first blank and
!!!!$ remove the rest

    CHARACTER (*) :: string

    INTEGER ( KIND = 4 ) :: iblank

    string = ADJUSTL(string)

    iblank = INDEX(string,' ')

    IF (iblank ==  1) RETURN

    IF (iblank /= 0) string = string(:iblank - 1)

   END SUBROUTINE clear_string

END MODULE pathmod

SUBROUTINE bbsens(kanal,datei)
    !!!$     Unterprogramm zur Berechnung der Summe der Sensitivitaeten
    !!!$     aller Messungen (normiert)
    !!!$     Berechnet nun coverage als Summe der Absolutbetraege..
    !!!$     ('kpot' als Hilfsfeld benutzt).
    !!!$     Andreas Kemna 02-Mar-1995
    !!!$     Letzte Aenderung 31-Mar-2010
    !!!$....................................................................
    USE alloci , ONLY : sens,sensdc
    USE datmod , ONLY : nanz,wmatd_cri,wmatdr
    USE invmod , ONLY : lfpi,wmatd,wdfak
    USE modelmod , ONLY : manz
    USE elemmod , ONLY: espx,espy
    USE errmod , ONLY : errnr,fetxt
    USE femmod , ONLY : ldc
    USE konvmod, ONLY : lelerr
    USE ompmod
    IMPLICIT NONE

    ! input/output

    ! io-channel (Kanalnummer)
    INTEGER (KIND = 4)  ::     kanal

    !!!$     Datei
    CHARACTER (80)      ::  datei

    !!!$.....................................................................
    !!!$     PROGRAMMINTERNE PARAMETER:

    !!!$     Hilfsvariablen
    REAL (KIND(0D0)),ALLOCATABLE,DIMENSION(:) :: csens,csens_fpi
    REAL (KIND(0D0))                          :: csensmax
    REAL (KIND(0D0))                          :: dum,dum_fpi
    !!!$     Indexvariablen
    INTEGER (KIND = 4)  ::     i,j
    !!!$.....................................................................
    !!!$     'datei' oeffnen
    ALLOCATE (csens(manz),STAT=errnr)
    IF (errnr /= 0) RETURN
    !!!$     Werte berechnen
    csens = 0D0
    ALLOCATE (csens_fpi(manz),STAT=errnr)
    csens_fpi = 0D0

    DO j=1,manz
        DO i=1,nanz
            dum = SQRT(wmatd(i)) * DBLE(wdfak(i))
            !!!$ CR case:
            !!!$  wmatd = wmatdr without error ellipses
            !!!$  wmatd = wmatd_cri with error ellipses
            !!!$ DC case:
            !!!$  wmatd = wmatdr
            !!!$ FPI case:
            !!!$  wmatd = wmatdp

            ! RM: we modify this to make sure, that even for FPI (case lfpi=.T.)
            ! we can calculate a complex coverage as well as treating the error
            ! right
            IF (lfpi) THEN
                dum_fpi = SQRT(wmatd(i)) * DBLE(wdfak(i))
                IF (lelerr) THEN
                    dum = SQRT(wmatd_cri(i)) * DBLE(wdfak(i))
                ELSE
                    dum = SQRT(wmatdr(i)) * DBLE(wdfak(i))
                END IF
                !!!$ this sensitivity is the one which is used through the FPI
                csens_fpi(j) = csens_fpi(j) + ABS(DBLE(sens(i,j))) * dum_fpi

                !!!$ this one is the COMPLEX sensitivity of the final estimate
                csens(j) = csens(j) + ABS(sens(i,j)) * dum
            ELSE IF (ldc) THEN
                csens(j) = csens(j) + ABS(sensdc(i,j)) * dum
            ELSE
                ! complex inversion
                csens(j) = csens(j) + ABS(sens(i,j)) * dum
            ENDIF
         END DO
    END DO

    !!!$ for normalization
    csensmax = MAXVAL(csens)

    !!!$     'datei' oeffnen
    fetxt = datei
    errnr = 1
    OPEN(kanal,file=TRIM(fetxt),status='replace',err=999)
    errnr = 4
    ! write number of values and maximum sensitivity
    WRITE(kanal,*,err=1000) manz, csensmax

    !!!$     Koordinaten und Sensitivitaetsbetraege schreiben
    !!!$     (logarithmierter (Basis 10) normierter Betrag)
    DO i=1,manz
        WRITE (kanal,*,err=1000)espx(i),espy(i),LOG10(csens(i)/csensmax)
    END DO

    CLOSE (kanal)

    DEALLOCATE (csens)

    IF (lfpi) THEN
        !!!$ for normalization
        csensmax = MAXVAL(csens_fpi)

        !!!$     'datei' oeffnen
        fetxt = datei
        errnr = 1
        OPEN(kanal,file=TRIM(datei)//'_fpi',status='replace',err=999)
        errnr = 4
        WRITE(kanal,*,err=1000) manz

        !!!$     Koordinaten und Sensitivitaetsbetraege schreiben
        !!!$     (logarithmierter (Basis 10) normierter Betrag)
        DO i=1,manz
            WRITE (kanal,*,err=1000)espx(i),espy(i),LOG10(csens_fpi(i)/csensmax)
        END DO

        !!!$     Maximale Sensitivitaet schreiben
        WRITE(kanal,*,err=1000)'Max:',csensmax
        !!!$     'datei' schliessen
        CLOSE(kanal)
    END IF
    DEALLOCATE (csens_fpi)

    errnr = 0
    RETURN

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

999 RETURN

1000 CLOSE(kanal)
  RETURN

END SUBROUTINE bbsens

module fem_pyw

contains
    subroutine forward_calculation(return_value)

        USE alloci
        USE tic_toc
        USE femmod
        USE datmod
        USE sigmamod
        USE electrmod
        USE modelmod
        USE elemmod
        USE wavenmod
        USE randbmod
        USE errmod
        USE konvmod
        USE omp_lib
        USE ompmod
        USE get_ver

        IMPLICIT none
        !....................................................................
        INTEGER(KIND = 4), INTENT(OUT) :: return_value

        !   channel numbers
        integer ::  kanal

        !!!$   file names
        character       * 80    delem,delectr,dsigma,dstrom,&
            dkpot,dpot,dvolt,dsens,drandb
        ! character       * 80    delem,delectr,dsigma,dstrom,&
        !     dkpot,dpot,dvolt,dsens,drandb

        !!!$   Schalter ob transformierte Potentialwerte ausgegeben werden sollen
        ! switch that controls whether transformed potentials shall be returned
        logical         * 4     lkpot

        !!!$   Schalter ob Potentialwerte ausgegeben werden sollen
        logical         * 4     lpot

        !!!$   Schalter ob Spannungswerte ausgegeben werden sollen
        logical         * 4     lvolt

        !!!$   Schalter ob weiterer Datensatz modelliert werden soll
        logical         * 4     lagain

        !!!$   Schalter ob mit K-Faktor modelliert werden soll (default ohne)
        logical         * 4     wkfak

        !!!$   Schalter ob nur analytisch modelliert werden soll (default ohne)
        logical         * 4     lana

        !!!$   Indexvariablen
        integer         * 4     j,k,l,c1

        !!!$ counting wavenumbers
        INTEGER :: count

        character       *256    ftext
        INTEGER :: getpid,pid,maxthreads,mythreads

        !!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

        PRINT*,'######### CMod ############'
        WRITE(*,"(a)") 'Licence:', &
        'Copyright © 1990-2020 Andreas Kemna <kemna@geo.uni-bonn.de>', &
        'Copyright © 2008-2020 CRTomo development team (see AUTHORS file)',&
        'Permission is hereby granted, free of charge, to any person obtaining a copy of',&
        'this software and associated documentation files (the “Software”), to deal in',&
        'the Software without restriction, including without limitation the rights to',&
        'use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies',&
        'of the Software, and to permit persons to whom the Software is furnished to do',&
        'so, subject to the following conditions:',&
        '',&
        'The above copyright notice and this permission notice shall be included in all',&
        'copies or substantial portions of the Software.',&
        '',&
        'THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR',&
        'IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,',&
        'FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE',&
        'AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER',&
        'LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,',&
        'OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE',&
        'SOFTWARE.'

        PRINT*, ''
        PRINT*, ''

        ! TODO: export via input_fempy module
        kanal = 11
        pid = getpid()
        fetxt = 'crmod.pid'
        PRINT*,'CRMod Process_ID ::',pid
        OPEN (kanal,FILE=TRIM(fetxt),STATUS='replace',err=999)
        WRITE (kanal,*)pid
        CLOSE (kanal)

        maxthreads = OMP_GET_MAX_THREADS()
        WRITE(6,"(a, i3)") " OpenMP max threads: ", maxthreads

        CALL get_git_ver

        CALL tic(c1)

        ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        ! read in crmod.cfg start
        !!!$   'crmod.cfg' oeffnen
        fetxt = 'crmod.cfg'
        errnr = 1
        open(12,file=TRIM(fetxt),status='old',err=999)

        !!!$   Allgemeine Parameter setzen
        !!!$   "singularity removal" ?
        lsr = .false.

        !!!$   Art der Ruecktransformation
        !!!$   ak        swrtr = 1
        !!!$   ak        swrtr = 0

        !!!$   Sonstiges
        lkpot = .false.
        wkfak = .false.
        lana = .FALSE.
        lprior = .false. ! kann prior modell verrauschen
        ldc = .FALSE.
        lnsepri = .false.
        !!!$   ak        lkpot = .true.
        !!!$   ak        dkpot = '..\tmp\kpot.ctr'

        !!!$   Kontrollausgabe
5 write(*,*)
  write(*,'(a20)') ' Reading Input-Files'

        !!$   'crmod.cfg' einlesen
        fetxt = 'crmod.cfg'
        errnr = 3
        mswitch = 0
        read(12,*,end=1001,err=999)
        read(12,'(a80)',end=1001,err=999) delem
        read(12,'(a80)',end=1001,err=999) delectr
        read(12,'(a80)',end=1001,err=999) dsigma
        read(12,'(a80)',end=1001,err=999) dstrom
        read(12,*,end=1001,err=999) lpot
        read(12,'(a80)',end=1001,err=999) dpot
        read(12,*,end=1001,err=999) lvolt
        read(12,'(a80)',end=1001,err=999) dvolt
        read(12,*,end=1001,err=999) lsens
        read(12,'(a80)',end=1001,err=999) dsens
        read(12,*,end=1001,err=999) lagain
        read(12,*,end=1001,err=999) swrtr
        read(12,*,end=1001,err=999) lsink
        read(12,*,end=1001,err=999) nsink
        read(12,*,end=1001,err=999) lrandb2
        read(12,'(a80)',end=1001,err=999) drandb
        fetxt = 'reading mswitch'
        read(12,'(I4)',end=101,err=100) mswitch

        !GOTO 101

100 BACKSPACE (12)
    close(12)
    ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! read in crmod.cfg end

101 lana = BTEST(mswitch,0)
  wkfak = BTEST(mswitch,1)
  lsr = BTEST(mswitch,2)
  lverb = BTEST(mswitch,10)

  IF (lana) PRINT*,'ANALYTICAL SOLUTION'
  IF (wkfak) PRINT*,'WITH K-FAKTOR'
  IF (lsr) THEN
     PRINT*,'WITH SINGULARITY REMOVAL'
     lana = .FALSE. ! analytical for singularity
! is indeed controlled by lsr and not lana..
! lana is only true for analytical solution only
  END IF

  IF (lverb) PRINT*,'VERBOSE OUTPUT'

!!!$   Alles einlesen
  call relem(kanal,delem)
  if (errnr.ne.0) goto 999

  call relectr(kanal,delectr)
  if (errnr.ne.0) goto 999

  call rdatm(kanal,dstrom)
  if (errnr.ne.0) goto 999

  if (swrtr.eq.0) then
     lana = .FALSE.
     lsr = .FALSE.
     kwnanz = 1
     ALLOCATE (kwn(kwnanz),stat=errnr)
     IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation kwn'
        errnr = 94
        GOTO 999
     END IF
     kwn(1) = 0d0
  else
     call rwaven()
     if (errnr.ne.0) goto 999
  end if
  print*,''
  NTHREADS = maxthreads
!!!$ now that we know nf and kwnanz, we can adjust the OMP environment..
  IF (maxthreads > 2) THEN ! single or double processor machines don't need scheduling..
     mythreads = MAX(kwnanz,2)
     mythreads = kwnanz
     PRINT*,'Rescheduling..'
     IF ( mythreads <= maxthreads ) THEN ! best case,
!!!$ the number of processors is greater or equal the assumed
!!!$ workload
        PRINT*,'perfect match'
     ELSE
!!!$ is smaller than the minimum workload.. now we have to devide a bit..
        PRINT*,'less nodes than wavenumbers'
        DO k = 1, INT(kwnanz/2)
           mythreads = INT(kwnanz / k) + 1
           IF (mythreads < maxthreads) EXIT
        END DO
     END IF
     NTHREADS = mythreads
  END IF
  CALL OMP_SET_NUM_THREADS ( NTHREADS )
  ! recheck ..
  k = OMP_GET_MAX_THREADS()
  WRITE(6,'(2(a, i3),a)') " OpenMP threads: ",k,'(',maxthreads,')'
  print*
!!!$   Startmodell belegen
  ALLOCATE (sigma(elanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation fem sigma'
     errnr = 94
     goto 999
  END IF

!!$ manz = elanz
  manz =elanz

  call rsigma(kanal,dsigma)
  if (errnr.ne.0) goto 999

  if (lrandb2) then
     call rrandb(kanal,drandb)
     if (errnr.ne.0) goto 999
  end if

!!!$   Ggf. Referenzleitfaehigkeit bestimmen
  call refsig()

  IF (lsink) WRITE(6,'(/A,I5,2F12.3/)')&
       'Fictious sink @ node ',nsink,sx(snr(nsink)),sy(snr(nsink))
!!!$   Element- und Randelementbeitraege sowie Konfigurationsfaktoren zur
!!!$   Berechnung der gemischten Randbedingung bestimmen
  call precal()
  if (errnr.ne.0) goto 999

  if (.not.lbeta) lsr=.false.

    !!!$   'a', 'hpot' und 'kpot' zuweisen
    ALLOCATE(a((mb+1)*sanz),hpot(sanz,eanz),&
        kpot(sanz,eanz,kwnanz),b(sanz),stat=errnr)
  if (errnr.ne.0) then
     fetxt = 'allocation problem a and hpot'
     errnr = 97
     goto 999
  end if
  ALLOCATE(pot(sanz),pota(sanz),fak(sanz),stat=errnr)
  if (errnr.ne.0) then
     fetxt = 'allocation problem pot to fak'
     errnr = 97
     goto 999
  end if
  count = 0
  !$OMP PARALLEL DEFAULT (none) &
  !$OMP FIRSTPRIVATE (pota,fak,pot,a,b,fetxt) &
  !$OMP PRIVATE (j,l,k) &
  !$OMP SHARED (kwnanz,lverb,eanz,lsr,lbeta,lrandb,lrandb2,&
  !$OMP  sanz,kpot,swrtr,hpot,count,lana,kg,elbg,relanz,sigma)
  !$OMP DO
!!!$   POTENTIALWERTE BERECHNEN
  do k=1,kwnanz
!!!$   Kontrollausgabe
     !$OMP ATOMIC
     count = count + 1

     if (swrtr.eq.0) then
        write(*,'(a)')' Calculating Potentials'
     else
        WRITE (*,'(a,t45,I4,t100,a)',ADVANCE='no')&
             ACHAR(13)//' Calculating Potentials : Wavenumber ',count
     end if

     do l=1,eanz

!!!$   Ggf. Potentialwerte fuer homogenen Fall analytisch berechnen
        if (lsr.OR.lana) call potana(l,k,pota)
!!!$ is also needed by kompab for reference therfore it is placed here
!!!$

!!!$ for analytical only, the linear system is never solved
        if ((lbeta.or.l.eq.1.OR.lsr).AND..NOT.lana) then

!!!$   Kompilation des Gleichungssystems (fuer Einheitsstrom !)
           call kompab(l,k,a,b)
           !           if (errnr.ne.0) goto 999

!!!$   Ggf. Randbedingung beruecksichtigen
           if (lrandb) call randb(a,b)
           if (lrandb2) call randb2(a,b)

!!!$   Gleichungssystem skalieren
           call scalab(a,b,fak)
           !           if (errnr.ne.0) goto 999

!!!$   Cholesky-Zerlegung der Matrix
           call chol(a)
           !           if (errnr.ne.0) goto 999
        else if (.NOT. lana) THEN

!!!$   Stromvektor modifizieren
           call kompb(l,b,fak)
        end if

!!!$   Gleichungssystem loesen only for
!!!$ non analytical
        IF (.NOT. lana) call vre(a,b,pot)
!!!$   Potentialwerte zurueckskalieren und umspeichern sowie ggf.
!!!$   analytische Loesung addieren
        do j=1,sanz
           IF (lana) THEN

              kpot(j,l,k) = pota(j)
           ELSE
              kpot(j,l,k) = pot(j) * dcmplx(fak(j))
              if (lsr) kpot(j,l,k) = kpot(j,l,k) + pota(j)
           END IF
!!!$   ak (fuer Testzwecke)
!!!$   ak                    kpot(j,l,k) = pota(j)
           if (swrtr.eq.0) hpot(j,l) = kpot(j,l,k)
        end do
     end do
  end do
  !$OMP END PARALLEL
  print*,'done, now processing'
!!!$   Ggf. Ruecktransformation der Potentialwerte
  if (swrtr.eq.1) call rtrafo()

!!!$   Ggf. transformierte Potentialwerte ausgeben
  if (lkpot) then
     call wkpot(kanal,dkpot)
     if (errnr.ne.0) goto 999
  end if

!!!$   Ggf. Potentialwerte berechnen und ausgeben
  if (lpot) then
     call bpot(kanal,dpot)
     if (errnr.ne.0) goto 999
  end if

!!!$   Ggf. Spannungswerte berechnen und ausgeben
!!!$   (bzw. scheinbaren Widerstandswerte)
  if (lvolt) then
     IF (wkfak.AND.lbeta) then
        call bkfak()
        if (errnr.ne.0) goto 999
     else
!!!$   nur echte Spannungen ausgeben...
        kfak=1.0
     end if

     call bvolt()
     if (errnr.ne.0) goto 999

     call wdatm(kanal,dvolt)
     if (errnr.ne.0) goto 999
  end if

!!!$   'a' und 'hpot' freigeben
  DEALLOCATE(a,hpot,b)

!!!$   Ggf. Sensitivitaeten aller Messungen berechnen und ausgeben
  if (lsens) then

     if (manz.ne.elanz) then
        fetxt = 'manz /= elanz .. is not implemented yet'
        errnr = 50
        goto 999
     end if
     !     !$ get memory for mnr..
     ALLOCATE (mnr(elanz),stat=errnr)
     IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation mnr failed'
        errnr = 94
        goto 999
     END IF
!!!$   Modelleinteilung gemaess Elementeinteilung belegen

     do j=1,elanz
        mnr(j) = j
     end do

!!!$   'sens' zuweisen
     ALLOCATE(sens(nanz,manz),stat=errnr)
     if (errnr.ne.0) then
        errnr = 97
        goto 999
     end if

     call bsens()

     call wsens(kanal,dsens)
     if (errnr.ne.0) goto 999

!!!$   'sens' freigeben
     DEALLOCATE(sens)
  end if

!!!$   'kpot' freigeben
  DEALLOCATE(kpot,pot,pota,fak)

    !!!$   Ggf. weiteren Datensatz modellieren
    if (lagain) goto 5

    !!!$   Kontrollausgabe
    fetxt = 'solution time'
    CALL TOC(c1,fetxt)

    write(*,*)
    write(*,'(a)',ADVANCE='no')' Modelling completed'
    write(*,*)


  IF (ALLOCATED (snr)) DEALLOCATE (snr,sx,sy)
  IF (ALLOCATED (typ)) DEALLOCATE (typ,nelanz,selanz)
  IF (ALLOCATED (nrel)) DEALLOCATE (nrel,rnr)

  IF (ALLOCATED (strnr)) DEALLOCATE (strnr,strom,volt,sigmaa,&
       kfak,vnr)
    IF (ALLOCATED (sigma)) DEALLOCATE (sigma)
    IF (ALLOCATED (enr)) DEALLOCATE (enr)
    IF (ALLOCATED (mnr)) DEALLOCATE (mnr)
    IF (ALLOCATED (kwn)) DEALLOCATE (kwn)
    IF (ALLOCATED (kwnwi)) DEALLOCATE (kwnwi)

    IF (ALLOCATED (rwddc)) DEALLOCATE (rwddc)
    IF (ALLOCATED (rwndc)) DEALLOCATE (rwndc)
    IF (ALLOCATED (rwd)) DEALLOCATE (rwd)
    IF (ALLOCATED (rwn)) DEALLOCATE (rwn)
    IF (ALLOCATED (rwdnr)) DEALLOCATE (rwdnr)

    ! not sure when we actually want to deallocate this
    ! if (allocated(out_ab)) deallocate(out_ab)

    return_value = 25
    return

    ! various error states
!!!$   (Fehler-) Meldung schreiben
999 open(9,file='error.dat',status='replace')
    errflag = 2
    CALL get_error(ftext,errnr,errflag,fetxt)
    write(9,'(a80,i3,i1)') fetxt,errnr,errflag
    write(9,*) ftext
    close(9)
    return_value = -1
    return

1001 open(9,file='error.dat',status='replace')
        errnr   = 2
        errflag = 2
        CALL get_error(ftext,errnr,errflag,fetxt)
        write(9,'(a80,i3,i1)') fetxt,errnr,errflag
        write(9,*)ftext
        close(9)
        return_value = -2
        return

    end subroutine forward_calculation

end module fem_pyw

character (12) function intcha(idum,lidum)

!!!$ Die Function wandelt einen Integer 'idum' in einen String der
!!!$ Laenge 'lidum'.

!!!$ Andreas Kemna                                            22-Jan-1993
!!!$                                       Letzte Aenderung   24-Oct-1996

!!!$.....................................................................

  INTEGER (KIND = 4)  :: idum
  INTEGER (KIND = 4)  :: lidum
  INTEGER (KIND = 4)  :: i,ih1
  character (5)       :: form

!!!$.....................................................................

!!!$ Integer in String schreiben
  if (lidum.lt.10) then
     write(form,'(a2,i1,a1)') '(i',lidum,')'
  else
     write(form,'(a2,i2,a1)') '(i',lidum,')'
  end if

  write(intcha,form) idum

!!!$ Moegliche Blanks mit Nullen ueberschreiben
  do i=1,lidum
     ih1 = ichar(intcha(i:i))

     if (ih1.eq.32) then
        intcha(i:i) = '0'
     end if
  END DO

  return
end function intcha

MODULE modelmod
!!$c 'model.fin'
!!$       
!!$c Andreas Kemna                                            10-Jul-1993
!!$c                                       Letzte Aenderung   24-Oct-1996
!!$
!!$c.....................................................................
!!$c Anzahl der Modellparameter
  INTEGER(KIND = 4),PUBLIC                          :: manz
        
!!$c Zeiger auf Modellparameter
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE :: mnr

!!!$ >> RM ref model regu
!!!$ variance of magnitude (re) and phase (im) of the reference model
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE :: w_ref_re
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE :: w_ref_im
  INTEGER,PUBLIC,DIMENSION(:),ALLOCATABLE :: ind_ref_grad
!!!$ << RM ref model regu
  
END MODULE modelmod

subroutine wkpot(kanal,datei)

!!!$     Unterprogramm zur Ausgabe der transformierten Potentialwerte.

!!!$     Andreas Kemna                                            11-Oct-1993
!!!$     Letzte Aenderung   24-Jun-1997

!!!$.....................................................................

  USE alloci
  USE electrmod
  USE elemmod
  USE wavenmod
  USE errmod

  IMPLICIT none


!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Kanalnummer
  INTEGER (KIND=4) ::      kanal

!!!$     Datei
  CHARACTER (80)   ::      datei

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Elektrodennummer
  INTEGER (KIND=4) ::     nelec

!!!$     Anzahl der Knotenpunkte, an denen transformierte Potentialwerte
!!!$     ausgegeben werden sollen
  INTEGER (KIND=4) ::     kanz

!!!$     Nummern der Knotenpunkte, an denen transformierte Potentialwerte
!!!$     ausgegeben werden sollen
  INTEGER(KIND = 4),DIMENSION(:),ALLOCATABLE :: knr

!!!$     Indexvariablen
  INTEGER (KIND=4) ::     i,k

!!!$     Hilfsvariable
  COMPLEX(KIND(0D0)) ::    dum

!!!$.....................................................................

!!!$     'datei' oeffnen
  fetxt = datei
  errnr = 1
  open(kanal,file=TRIM(fetxt),status='old',err=999)
  errnr = 3

!!!$     Elektrodennummer einlesen
  read(kanal,*,end=1001,err=1000) nelec

!!!$     Ggf. Fehlermeldung
  if (nelec.gt.eanz) then
     fetxt = ' '
     errnr = 54
     goto 1000
  end if

!!!$     Anzahl der Knotenpunkte einlesen
  read(kanal,*,end=1001,err=1000) kanz

!!!$     Ggf. Fehlermeldung
  if (kanz.gt.sanz) then
     fetxt = ' '
     errnr = 52
     goto 1000
  end if
  ALLOCATE (knr(kanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation hsens'
     errnr = 94
     GOTO 1000
  END IF

!!!$     Knotennummern einlesen
  do i=1,kanz
     read(kanal,*,end=1001,err=1000) knr(i)

!!!$     Ggf. Fehlermeldung
     if (knr(i).gt.sanz) then
        fetxt = ' '
        errnr = 53
        goto 1000
     end if
  end do

  errnr = 4

!!!$     Entsprechenden transformierten Potentialwerte schreiben
!!!$     (Real- und Imaginaerteil)
  do i=1,kanz
     write(kanal,*,err=1000)
     write(kanal,*,err=1000) knr(i)

     do k=1,kwnanz
        dum = kpot(knr(i),nelec,k)
        write(kanal,*,err=1000) real(dble(dum)),real(dimag(dum))
     end do
  end do

!!!$     'datei' schliessen
  close(kanal)

  errnr = 0
  return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

999 return

1000 close(kanal)
  return

1001 close(kanal)
  errnr = 2
  return

end subroutine wkpot

subroutine wout(kanal,dsigma,dvolt)

!!!$     Unterprogramm zum Schreiben der Widerstandsverteilung und der
!!!$     modellierten Daten inkl. Elektrodenkennungen.

!!!$     Andreas Kemna                                            28-Sep-1994
!!!$     Letzte Aenderung   10-Mar-2007

!!!$.....................................................................

  USE datmod
  USE femmod
  USE invmod
  USE sigmamod
  USE modelmod
  USE elemmod
  USE errmod
  USE konvmod
  USE pathmod

  IMPLICIT none

!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Kanalnummer
  INTEGER (KIND=4) ::  kanal

!!!$     Dateinamen
  CHARACTER (80)   ::  dsigma,dvolt

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:
!!!$     Indexvariablen
  INTEGER (KIND=4) ::  i

!!!$     Hilfsvariablen
  INTEGER (KIND=4) ::  idum,idum2
  CHARACTER (80)   ::  htxt
  COMPLEX(KIND(0D0))  ::  dum

!!!$     Hilfsfunctions
  CHARACTER (80)   ::   filpat

!!!$     diff+<
  REAL(KIND(0D0))  ::   dum2,dum3
!!!$     diff+>
  CHARACTER (2)   ::   ci
!!!$.....................................................................

!!!$     'dsigma' modifizieren

  WRITE (ci,'(I2.2)')it
!!$  IF (it>9) THEN
!!$     WRITE (ci,'(I2)')it
!!$  ELSE 
!!$     WRITE (ci,'(a,I1)')'0',it
!!$  END IF
  htxt = filpat(dsigma,idum2,1,slash(1:1))
  idum = idum2+index(dsigma(idum2+1:80),'.')-1
  htxt  = dsigma(1:idum)//ci//dsigma(idum+1:idum+4)

!!!$     Betraege ausgeben
  idum  = index(htxt,' ')
  fetxt = htxt(1:idum-4)//'mag'
  OPEN (kanal,FILE='inv.lastmod',STATUS='replace')
  WRITE (kanal,*)TRIM(fetxt)
  CLOSE (kanal)
  errnr = 1
  open(kanal,file=TRIM(fetxt),status='replace',err=999)
  errnr = 4
  write(kanal,*,err=1000) elanz,ACHAR(9),betrms

  do i=1,elanz
!!!$     diff+<
     if (.not.ldiff.AND..NOT.lprior) then
!!!$  if (.not.ldiff) then
!!!$     diff+>
        dum = dcmplx(1d0)/sigma(i)
!!!$ak   write(kanal,*,err=1000) real(espx(i)),real(espy(i)),&
!!!$ak         real(cdabs(dum))
        write(kanal,*,err=1000) real(espx(i)),&
             real(espy(i)),real(dlog10(cdabs(dum)))
!!!$ro   write(kanal,*,err=1000) real(espy(i)),real(espx(i)),&
!!!$ro      real(cdabs(dum))
!!!$     diff+<
     ELSE IF (lprior) THEN
        dum3 = CDABS(dcmplx(1d0)/sigma(i))
        dum2 = CDABS(dcmplx(1d0)/cdexp(m0(mnr(i))))
        !     dum3 = REAL(CDLOG(sigma(i))/m0(mnr(i)))
        write(kanal,*,err=1000)REAL(espx(i)),&
             REAL(espy(i)),real(dlog10(dum3))
!!$        write(kanal,'(7(f10.4,2x))',err=1000)REAL(espx(i)),&
!!$             REAL(espy(i)),real(dlog10(dum3)),&
!!$             (DLOG10(dum3) - DLOG10(dum2)),&
!!$             real(dlog10(dum2)),real(1d2*(1d0-dum2/dum3)),&
!!$             real(1d2*(1d0-dum3/dum2))
     else
        ! model resistivity, linear
        dum3 = cdabs(dcmplx(1d0)/sigma(i))
        ! start model, linear, resistivity
        dum2 = cdabs(dcmplx(1d0)/cdexp(m0(mnr(i))))
        write(kanal,'(7(f10.4,2x))',err=1000)&
             real(espx(i)),real(espy(i)),&
             ! log10(rho)
             real(dlog10(dum3)),&
             ! log10(rho0)
             real(dlog10(dum2)),&
             ! log10(rho) - log10(rho0)
             real(dlog10(dum3) - dlog10(dum2)),&
             ! (rho - rho0) / rho0 * 100
             real(1d2*(dum3/dum2-1d0)),&
             ! (sigma - sigma0) / sigma0 * 100
             real(1d2*(dum2/dum3-1d0))
     end if
!!!$     diff+>
  end do
  close(kanal)
  fetxt = htxt(1:idum-4)//'modl'
  OPEN (kanal,file=TRIM(fetxt),status='replace')

  WRITE (kanal,'(I7)',err=1000) elanz
  IF (.NOT.lprior) then
     DO i=1,elanz
        dum = dcmplx(1d0)/sigma(i)
        dum2 = real(1d3*datan2(dimag(dum),dble(dum)))
        WRITE (kanal,'(2(1x,G12.4))')1./REAL(sigma(i)),dum2
     END DO
  ELSE
     DO i=1,elanz
        dum = dcmplx(1d0)/sigma(i) ! - DCMPLX(1d0)/CDEXP(m0(mnr(i)))
        dum2 = real(1d3*datan2(dimag(dum),dble(dum)))
        WRITE (kanal,'(2(1x,G12.4))')1./REAL(sigma(i)),dum2
     END DO
  END IF
  CLOSE (kanal)
!!!$     Ggf. Phasen ausgeben
  if (.not.ldc) then
     fetxt = htxt(1:idum-4)//'pha'
     errnr = 1
     open(kanal,file=TRIM(fetxt),status='replace',err=999)
     errnr = 4
     write(kanal,*,err=1000) elanz,ACHAR(9),pharms

     do i=1,elanz
        dum = dcmplx(1d0)/sigma(i)
        write(kanal,*,err=1000)&
!!!$     ak Default
             real(espx(i)),real(espy(i)),&
             real(1d3*datan2(dimag(dum),dble(dum)))
!!!$     ak MMAJ
!!!$     ak     1                      real(espx(i)),real(espy(i)),
!!!$     ak     1                      -real(1d3*datan2(dimag(dum),dble(dum)))
     end do
     close(kanal)

     fetxt = htxt(1:idum-4)//'sig'
     errnr = 1
     open(kanal,file=TRIM(fetxt),status='replace',err=999)
     errnr = 4
     write(kanal,*,err=1000) elanz,betrms,pharms
     do i=1,elanz
        write(kanal,*,err=1000)REAL(sigma(i)),IMAG(sigma(i))
     end do
     close(kanal)
  end if

!!!$     'dvolt' modifizieren
  htxt = filpat(dvolt,idum2,1,slash(1:1))
  idum = idum2+index(dvolt(idum2+1:80),'.')-1

  htxt  = dvolt(1:idum)//ci//dvolt(idum+1:idum+4)

  fetxt = htxt
  errnr = 1
  open(kanal,file=TRIM(fetxt),status='replace',err=999)

  errnr = 4
  write(kanal,*,err=1000) nanz

!!!$     Stromelektrodennummern, Spannungselektrodennummern und scheinbare
!!!$     Widerstandswerte (Betrag und Phase (in mrad)) schreiben
  if (ldc) then
     do i=1,nanz
        write(kanal,*,err=1000)strnr(i),vnr(i),&
!!!$     diff-     1                      real(1d0/dexp(dble(sigmaa(i))))
!!!$     diff+<
             real(1d0/dexp(dble(sigmaa(i)))),wdfak(i)
!!!$     diff+>
     end do
  else
     do i=1,nanz
        write(kanal,*,err=1000)strnr(i),vnr(i),&
             real(1d0/dexp(dble(sigmaa(i)))),&
!!!$     diff-     1                      real(-1d3*dimag(sigmaa(i)))
!!!$     diff+<
             real(-1d3*dimag(sigmaa(i))),wdfak(i)
!!!$     diff+>
     end do
  end if

  close(kanal)

  errnr = 0
  return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

999 return

1000 close(kanal)
  return

end subroutine wout

module relectrmod
    contains
      subroutine relectr(kanal,datei)

!     Unterprogramm zum Einlesen der Elektrodenverteilung aus 'datei'.

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   24-Oct-1996

! ....................................................................
      USE electrmod
      USE elemmod
      USE errmod

      IMPLICIT none

! ....................................................................

!     EIN-/AUSGABEPARAMETER:

!     Kanalnummer
      integer     ::   kanal

!     Datei
      character(80) :: datei

! ....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariable
      integer      ::   i

! ....................................................................

!     'datei' oeffnen
      fetxt = datei

      errnr = 1
      open(kanal,file=fetxt,status='old',err=999)

      errnr = 3

!     Anzahl der Elektroden einlesen
      read(kanal,*,end=1001,err=1000) eanz

!!!   $ memory allocation
      ALLOCATE (enr(eanz),stat=errnr)
      IF (errnr /= 0) THEN
         fetxt = 'Error memory allocation enr'
         errnr = 94
         goto 1000
      END IF

!     Knotennummern der Elektroden einlesen
      do i=1,eanz
         read(kanal,*,end=1001,err=1000) enr(i)

!     Ggf. Fehlermeldung
         if (enr(i).gt.sanz) then
            fetxt = ' '
            errnr = 29
            goto 1000
         end if
      end do

!     'datei' schliessen
      close(kanal)

      errnr = 0
      return

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

 999  return

 1000 close(kanal)
      return

 1001 close(kanal)
      errnr = 2
      return

      end subroutine relectr
end module relectrmod

SUBROUTINE bsendc(tictoc)

!!!$     Unterprogramm zur Berechnung der Sensitivitaeten.

!!!$     Andreas Kemna                                            09-Apr-1995
!!!$     Letzte Aenderung   07-Mar-2003

!!!$.....................................................................

  USE alloci
  USE femmod
  USE datmod
  USE sigmamod
  USE electrmod
  USE modelmod
  USE elemmod
  USE wavenmod
  USE errmod
  USE konvmod , ONLY : lverb
  USE ompmod
  USE tic_toc

  IMPLICIT NONE

!!!$.....................................................................

  LOGICAL  :: tictoc ! measure calculation time

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Aktuelle Elementnummer
  INTEGER (KIND = 4)  :: iel

!!!$     Aktueller Elementtyp
  INTEGER (KIND = 4)  :: ntyp

!!!$     Anzahl der Knoten im aktuellen Elementtyp
  INTEGER (KIND = 4)  :: nkel

!!!$     Elektrodennummern
  INTEGER (KIND = 4)  :: elec1,elec2,elec3,elec4

!!!$     Beitraege zur Superposition
  REAL (KIND(0D0))    ::    sup(4)

!!!$     Indexvariablen
  INTEGER (KIND = 4)  :: ityp,jnel,mi,mj,imn,imax,imin
  INTEGER (KIND = 4)  :: i,j,k,icount

!!!$     Hilfsfeld
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: hsens

!!!$     Hilfsvariablen
  INTEGER (KIND = 4)  :: nzp,nnp,c1
  REAL (KIND(0D0))    :: dum

!!!$     Pi
  REAL (KIND(0D0))    :: pi

!!!$.....................................................................

  pi = dacos(-1d0)

  !     get memory for hsens
  ALLOCATE (hsens(kwnanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation hsens'
     errnr = 94
     RETURN
  END IF

  IF (tictoc) CALL tic (c1)

!!!$     Sensitivitaetenfeld auf Null setzen
  sensdc = 0D0
  icount  = 0

!  !$OMP PARALLEL DEFAULT (none) &
!  !$OMP FIRSTPRIVATE (hsens) &
!  !$OMP SHARED (icount,strnr,vnr,typanz,typ,selanz,kwnanz,lverb,sigma,&
!  !$OMP nrel,kpotdc,elbg,strom,kwnwi,pi,mnr,nanz,swrtr,nelanz,sensdc,volt) &
!  !$OMP PRIVATE(iel,elec1,elec2,elec3,elec4,sup,imin,imn,&
!  !$OMP ntyp,jnel,nkel,nzp,nnp,imax,dum)
!  !$OMP DO SCHEDULE (GUIDED,CHUNK_0)
!!!$     Messwert hochzaehlen
  DO i=1,nanz

     iel = 0

!     !$OMP ATOMIC
     icount = icount + 1

     IF (lverb) WRITE(*,'(a,t50,F6.2,A)',advance='no')ACHAR(13)//&
          'Sensitivity/ ',REAL(icount)/REAL(nanz) * 100.,'%'

!!!$     Stromelektroden bestimmen
     elec1 = MOD(strnr(i),10000)
     elec2 = (strnr(i)-elec1)/10000

!!!$     Messelektroden bestimmen
     elec3 = MOD(vnr(i),10000)
     elec4 = (vnr(i)-elec3)/10000

!!!$     Beitraege zur Superposition auf Null setzen
     DO j=1,4
        sup(j) = 0d0
     END DO

     DO ityp=1,typanz
        ntyp = typ(ityp)
        nkel = selanz(ityp)

!!!$     Ggf. zu neuem Messwert springen
        IF (ntyp.GT.10) CYCLE

        DO jnel=1,nelanz(ityp)

!!!$     Elementnummer hochzaehlen
           iel = iel + 1

!!!$     SENSITIVITAETEN BERECHNEN
           DO k=1,kwnanz
              hsens(k) = 0d0

!!!$     Knoten des aktuellen Elements hochzaehlen
              DO mi=1,nkel
                 nzp = nrel(iel,mi)

                 DO mj=1,nkel
                    nnp  = nrel(iel,mj)
                    imax = max0(mi,mj)
                    imin = min0(mi,mj)
                    imn  = imax*(imax-1)/2+imin

!!!$     Beitraege nach "Reziprozitaetsmethode" gewichtet aufaddieren und
!!!$     superponieren
!!!$     (beachte: 'volt = pot(elec4) - pot(elec3)' ,
!!!$     '+I' bei 'elec2', '-I' bei 'elec1' )
                    IF (elec1.GT.0) sup(1) = kpotdc(nnp,elec1,k)
                    IF (elec2.GT.0) sup(2) = kpotdc(nnp,elec2,k)
                    IF (elec3.GT.0) sup(3) = kpotdc(nzp,elec3,k)
                    IF (elec4.GT.0) sup(4) = kpotdc(nzp,elec4,k)

!!!$     ACHTUNG: Bei grossen Quellabstaenden UNDERFLOW moeglich, da einzelnen
!!!$     Potentiale sehr klein (vor allem bei grossen Wellenzahlen)!
!!!$     -> mittels Compiler-Einstellung auf Null setzen!
!!!$     MsDev5.0: "/fpe:3 /check:underflow" -> "/fpe:0"
                    dum      = (sup(2)-sup(1)) * (sup(4)-sup(3))
                    hsens(k) = hsens(k) + elbg(iel,imn,k) * dum
                 END DO
              END DO
           END DO

!!!$     GGF. RUECKTRANSFORMATION
           IF (swrtr.EQ.0) THEN

              dum = hsens(1)

           ELSE

              dum = 0d0

              DO k=1,kwnanz
                 dum = dum + hsens(k)*kwnwi(k)
              END DO

              dum = dum / pi

           END IF

           sensdc(i,mnr(iel)) = sensdc(i,mnr(iel)) + dum * &
                DBLE(sigma(iel)/volt(i))

!!!$     ak BAW-Tank
!!!$     ak                if (mnr(iel).le.14*58) sensdc(i,mnr(iel))=0d0

        END DO ! jnel=1,nelanz(i)
     END DO ! ityp=1,typanz
  END DO ! i=1,nanz
!  !$OMP END PARALLEL

  fetxt = 'bsendc::'
  IF (tictoc) CALL toc(c1,fetxt)

  DEALLOCATE (hsens)
  
END SUBROUTINE bsendc

!> \file dmisfit.f90
!> \brief compute data misfit
!> \details Kemna (2000) Section 1.3.2: It seems obvious to formulate the complex resistivity inverse problem directly for complex
!parameters and data, i.e., to jointly invert for resistivity magnitude and phase as a complex number. An inherent advantage of such
!a formulation is that the inverse solution can be obtained in an elegant way using complex calculus. By the following definitions
!and considerations, it is shown that the inversion approach outlined in the previous section can be applied to the complex-valued
!problem in a straightforward manner.
!>
!> Within the complex resistivity inversion, log transformed parameters and data shall be used to account for the wide dynamic range
!of resistivity magnitude encountered in earth materials. In terms of conductivity, the model vector \f$ m \f$ and the data vector
!\f$ d \f$ of the inverse problem may thus be defined as
!> \f[ m_j = \ln \sigma_j  d_i = \ln \sigma_{a_i} \f]
!> @author Andreas Kemna
!> @date 10/11/1993


SUBROUTINE dmisft(lsetup)
    !     Unterprogramm zum Bestimmen des Misfits der Daten.
    !     Andreas Kemna                                            01-Mar-1995
    !     Letzte Aenderung   15-Jan-2001
    !.....................................................................

    USE invmod
    USE datmod
    USE errmod
    USE konvmod
    USE pathmod

    IMPLICIT NONE

    !.....................................................................

    !     EIN-/AUSGABEPARAMETER:

    !     Hilfsschalter
    LOGICAL ::     lsetup
    !.....................................................................

    ! PROGRAMMINTERNE PARAMETER:

    ! Hilfsfelder
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE   :: psi,eps2
    INTEGER(KIND = 4),DIMENSION(:),ALLOCATABLE :: wdlok

    ! Hilfsvariablen
    INTEGER (KIND = 4)  ::     i,idum
    COMPLEX (KIND(0D0)) ::    cdum,cdat,csig
    REAL(KIND(0D0))     ::     dum,norm,norm2
    !.....................................................................

    ! einfach mal oeffnen falls Ausgabe
    errnr = 1
    fetxt = ramd(1:lnramd)//slash(1:1)//'eps.ctr'
    OPEN(fpeps,file=TRIM(fetxt),STATUS='old',POSITION='append',ERR=1000)
    fetxt = ramd(1:lnramd)//slash(1:1)//'run.ctr'
    OPEN(fprun,file=TRIM(fetxt),STATUS='old',POSITION='append',ERR=1000)
    errnr = 4

    11 FORMAT (I6,G12.3,1x,F10.6,2x,I3,2X,4(1X,G15.7))

    IF ((llam.AND..NOT.lstep).OR.lsetup) THEN
        IF (lfpi) THEN
            WRITE(fpeps,'(/a,t7,I4)',err=1000)'PIT#',it
        ELSE
            WRITE(fpeps,'(/a,t7,I4)',err=1000)'IT#',it
        END IF
        WRITE(fpeps,'(a)',err=1000)'Datum'//ACHAR(9)//'eps'//ACHAR(9)//&
            'psi'//ACHAR(9)//'pol'//ACHAR(9)//'Re(d)'//ACHAR(9)//'Re(f(m))'&
            //ACHAR(9)//'Im(d)'//ACHAR(9)//'Im(f(m))'
    END IF

    !     RMS-WERTE BERECHNEN
    nrmsd  = 0d0
    betrms = 0d0
    pharms = 0d0
    idum   = 0
    !     get memory for wdlok and psi
    ALLOCATE (wdlok(nanz),psi(nanz),stat=errnr)
    IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation psi'
        errnr = 94
        RETURN
    END IF

    DO i=1,nanz
        wdlok(i) = 1

        !     Phasen lokal korrigieren
        CALL chkpo2(dat(i),sigmaa(i),cdat,csig,wdlok(i),lpol)

        !     ak Ggf. Daten mit Phase betraglich groesser 200 mrad nicht beruecksichtigen
        !     ak (Standardabweichung auf 1d4 hochsetzen)
        !     ak           if (dabs(1d3*dimag(csig)).gt.200d0) wmatd(i)=1d-8

        !     diff-            cdum = cdat - csig
        !     diff+<
        IF (.NOT.ldiff) THEN
            cdum = cdat - csig
        ELSE
            cdum = cdat - csig - (d0(i) - fm0(i))
        END IF
        !     diff+>

        IF (lfpi) THEN
            psi(i) = dsqrt(wmatd(i))*dabs(dimag(cdum))
        ELSE
            psi(i) = dsqrt(wmatd(i))*cdabs(cdum)
        END IF

        !     Ggf. 'eps_i', 'psi_i' und Hilfsfeld ausgeben
        IF ((llam.AND..NOT.lstep).OR.lsetup) WRITE(fpeps,11,err=1000) &
            i, REAL(1d0/dsqrt(wmatd(i))),REAL(psi(i)),wdlok(i),&
            REAL(csig),REAL(cdat),AIMAG(cdat),AIMAG(csig)

            idum   = idum   + wdlok(i)
            nrmsd  = nrmsd  + psi(i)*psi(i)*DBLE(wdlok(i))

            betrms = betrms + wmatdr(i)*DBLE(wdlok(i)) * &
                DBLE(cdum)*DBLE(cdum)

            pharms = pharms + wmatdp(i)*DBLE(wdlok(i)) * &
                dimag(cdum)*dimag(cdum)

    END DO

    !     Ggf. Fehlermeldung
    IF (idum.EQ.0) THEN
        fetxt = ' '
        errnr = 99
        GOTO 1000
    END IF

    npol   = nanz-idum
    rmssum = nrmsd
    nrmsd  = dsqrt(nrmsd /DBLE(idum))
    betrms = dsqrt(betrms/DBLE(idum))
    pharms = dsqrt(pharms/DBLE(idum))

    !     Ggf. ROBUST INVERSION (nach Doug' LaBrecque)
    IF (lrobust) THEN

        !     get memory for wdlok
        ALLOCATE (eps2(nanz),stat=errnr)
        IF (errnr /= 0) THEN
            fetxt = 'Error memory allocation eps2'
            errnr = 94
            RETURN
        END IF
        !     'estimated weights' und 1-Normen berechnen
        norm  = 0d0
        norm2 = 0d0

        DO i=1,nanz
            dum     = 1d0/SQRT(wmatd(i))
            eps2(i) = dum*SQRT(psi(i))
            norm    = norm  + psi(i)*(wdlok(i))
            norm2   = norm2 + psi(i)*(wdlok(i))*dum/eps2(i)
        END DO

        !     'estimated weights' normieren
        DO i=1,nanz
            eps2(i) = eps2(i) * norm2/norm
        END DO

        ! Kleinere Standardabweichung ausschliessen und neue 1-Norm berechnen
        norm2 = 0d0

        DO i=1,nanz
            dum     = 1d0/SQRT(wmatd(i))
            eps2(i) = MAX(dum,eps2(i))
            norm2   = norm2 + (psi(i))*(wdlok(i))*dum/eps2(i)
        END DO

        l1rat = norm/norm2

        !     Ggf. neue Wichtungsfaktoren belegen
        IF (l1rat.GT.l1min) THEN
            DO i=1,nanz
                dum = 1./(eps2(i) * eps2(i))

                !     Ausgabe, falls 'eps_neu' > 1.1 * 'eps_alt'
                IF (dum.LT.0.83d0*wmatd(i).AND. &
                    ((llam.AND..NOT.lstep).OR.lsetup)) THEN

                    WRITE(fprun,*)i,&
                        ' : increase standard deviation *', &
                        REAL(eps2(i)*SQRT(wmatd(i))),dum,psi(i)
                END IF

                wmatd(i) = dum
            END DO
        END IF
        IF (ALLOCATED(eps2)) DEALLOCATE (eps2)
    END IF

    IF (ALLOCATED(wdlok)) DEALLOCATE (wdlok,psi)

    errnr = 0
    RETURN

    !:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    !     Fehlermeldungen
    1000 CLOSE(fpeps)
    CLOSE(fprun)
RETURN

END SUBROUTINE dmisft


!*********************************************************************

SUBROUTINE chkpo2(dati,sigi,cdat,csig,wdlok,ldum)

!.....................................................................

!     EIN-/AUSGABEPARAMETER:

!     Eingabe
  COMPLEX (KIND(0D0)) ::    dati,sigi

!     Ausgabe
  COMPLEX (KIND(0D0)) ::    cdat,csig

!     Schalter
  INTEGER (KIND = 4)  ::     wdlok
  LOGICAL ::     ldum

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Hilfsvariablen
  INTEGER (KIND = 4)  ::     idat,isig

!     Real-, Imaginaerteile
  REAL (KIND(0D0))    ::     redat,imdat,resig,imsig

!     Pi
  REAL (KIND(0D0))    ::     pi

!.....................................................................

  pi = dacos(-1d0)

!     Logarithmierte Betraege in den Realteilen,
!     Phasen (in rad) in den Imaginaerteilen
  redat = DBLE(dati)
  imdat = dimag(dati)
  resig = DBLE(sigi)
  imsig = dimag(sigi)

!     Phasenbereich checken
  IF (imdat.GT.pi/2d0) THEN
     idat = -1
  ELSE IF (imdat.LE.-pi/2d0) THEN
     idat = 1
  ELSE
     idat = 0
  END IF

  IF (imsig.GT.pi/2d0) THEN
     isig = -1
  ELSE IF (imsig.LE.-pi/2d0) THEN
     isig = 1
  ELSE
     isig = 0
  END IF

  IF (idat.EQ.0.AND.isig.NE.0) THEN

!     Falls ldum=.true., angenommene Polaritaet des Messdatums falsch,
!     ggf. Korrektur; auf jeden Fall Polaritaetswechsel
     imsig = imsig + DBLE(isig)*pi
     IF (.NOT.ldum) imdat=imdat-dsign(pi,imdat)

     wdlok = 0

  ELSE IF (idat.NE.0.AND.isig.EQ.0) THEN

!     Falls ldum=.true., angenommene Polaritaet des Messdatums falsch,
!     ggf. Korrektur
     IF (ldum) imdat=imdat+DBLE(idat)*pi

     wdlok = 0

  ELSE IF (idat.NE.0.AND.isig.NE.0) THEN

!     Polaritaetswechsel
     imsig = imsig + DBLE(isig)*pi
     imdat = imdat + DBLE(idat)*pi

  END IF

!     'cdat' und 'csig' speichern
  cdat = dcmplx(redat,imdat)
  csig = dcmplx(resig,imsig)

  RETURN
END SUBROUTINE chkpo2

!> \file elem1.f90
!> \brief form functions of linear boundary elements
!> \details Kemna (1995): The potential function \f$ \tilde \phi (s)\f$ is approximated with a linear function of the boundary \f$ C \f$:
!> \f[ \tilde \phi (s) \approx c_1^{(j)}+c_2^{(j)}s \f]
!> with \f$ s \in C^{(j)} \ \ (j=1,...,n_r) \f$. The constants \f$ c_1^{(j)}, c_2^{(j)}\f$ can be determined by the corresponding node values \f$ \tilde \phi_{i_1 (j)}, \tilde \phi_{i_1 (j)} \ \ i_1 (j),i_2(j) \in \{1,...,n_k\}) \f$ (see figure below).
!> \image html elem1_sketch.png "Boundary element with linear approach"
!> The approach yields (Schwarz 1991)
!> \f[ \int_{C^{(j)}}{\tilde \phi ^2} ds = \tilde \phi ^{(j)^T} S_3^{'(j)} \tilde \phi ^{(j)} \ \ with S_3^{'(j)} = \frac{L^{(j)}}{6} \left( \begin{array}{cc} 2 & 1 \\ 1 & 2 \end{array} \right), \f]
!> requiring \f$ \tilde \phi^{(j)} = \left( \tilde \phi_{i_1(j)}, \tilde \phi_{i_1(j)} \right)^T \f$ and the length \f$ L^{(j)} \f$ of the \f$ j\f$-th boundary element.
!> The \f$ 2\times 2\f$ matrix \f$ S_3^{'(j)} \f$ can be regarded as \f$n_k \times n_k \f$ matrix \f$ S_3^{(j)}\f$, if it is filled with zeros according to the contributing indices \f$ i_1(j), i_2(j) \f$. The resulting matrix element \f$ (s_3^{(j)})_{mn} \ \ (m,n \in \{ 1,..., n_k \})\f$ is
!> \f[ (s_3^{(j)})_{mn} = \left\{ \begin{array}{cc} (s_3^{'(j)})_{\kappa\lambda}, & if \kappa,\lambda \in \{ 1,2 \}\  with \  m=i_\kappa (j) \ and \ n= i_\lambda(j) \\ 0, & else. \end{array} \right. \f]
!> where \f$ (s_3^{'(j)})_{\kappa\lambda} \f$ is an element of \f$ S_3^{'(j)}\f$. It follows that
!> \f[ \tilde\phi^{(j)^T} S_3^{'(j)}\tilde\phi^{(j)} = \tilde\phi^{T} S_3^{(j)}\tilde\phi  \f]
!> @author Andreas Kemna
!> @date 10/11/1993, last change 11/05/1997

subroutine elem1()

!     Unterprogramm liefert die Elementmatrix 'elmam(2,2)' und den Element-
!     vektor 'elve(2)' fuer ein Randelement mit linearem Ansatz ( Element-
!     typ Nr.1 ).

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   22-Sep-1998

!.....................................................................

  USE elemmod,only:xk,yk,elmam,elve

  IMPLICIT none

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Grundelementmatrix
  INTEGER (KIND = 4)  ::     s4(2,2)

!     Grundelementvektor
  INTEGER (KIND = 4)  ::     sb(2)

!     Hilfsvariablen
  REAL (KIND(0D0))    ::     x21,y21,l

!     Indexvariablen
  INTEGER (KIND = 4)  ::     i,j

!.....................................................................

  data sb/1,1/
  data s4/2,1,1,2/

  x21 = xk(2) - xk(1)
  y21 = yk(2) - yk(1)

  l = dsqrt(x21*x21 + y21*y21)

  do i=1,2
     elve(i) = l * dble(sb(i)) / 2d0

     do j=1,2
        elmam(i,j) = l * dble(s4(i,j)) / 6d0
     end do
  end do

  return
end subroutine elem1

!> \file bvolt.f90
!> \brief compute measured voltages and apparent resistivities.

!> @author Andreas Kemna
!> @date 11/06/1997

subroutine bvolt()

!     Unterprogramm zur Berechnung der Spannungs- und scheinbaren
!     Widerstandswerte (beachte: Potentialwerte wurden fuer Einheitsstrom
!     berechnet).

!     Andreas Kemna                                            03-Sep-1994
!     Letzte Aenderung   06-Nov-1997

!.....................................................................

  USE alloci
  USE datmod
  USE electrmod
  USE errmod

  IMPLICIT none


!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariable
  INTEGER (KIND = 4)  ::     i,j

!     Elektrodennummern
  INTEGER (KIND = 4)  ::     elec1,elec2,elec3,elec4

!     Hilfsvariablen
  COMPLEX (KIND(0D0)) ::    dum1,dum2,dum3,dum4

!.....................................................................
  j=0
  do i=1,nanz

!     Stromelektroden bestimmen
     elec1 = mod(strnr(i),10000)
     elec2 = (strnr(i)-elec1)/10000

!     Messelektroden bestimmen
     elec3 = mod(vnr(i),10000)
     elec4 = (vnr(i)-elec3)/10000

!     Spannungswert berechnen (Superposition)
!     (beachte: Faktoren '.../2d0' (-> Potentialwerte fuer Einheitsstrom)
!     und '...*2d0' (-> Ruecktransformation) kuerzen sich weg !)
     dum1 = dcmplx(min0(elec4,1)*min0(elec2,1)) &
          *hpot(enr(max0(elec4,1)),max0(elec2,1))
     dum2 = dcmplx(min0(elec4,1)*min0(elec1,1)) &
          *hpot(enr(max0(elec4,1)),max0(elec1,1))
     dum3 = dcmplx(min0(elec3,1)*min0(elec2,1)) &
          *hpot(enr(max0(elec3,1)),max0(elec2,1))
     dum4 = dcmplx(min0(elec3,1)*min0(elec1,1)) &
          *hpot(enr(max0(elec3,1)),max0(elec1,1))

     volt(i) = (dum1-dum2) - (dum3-dum4)

     if (cdabs(volt(i)).eq.0d0) then
        j=j+1
!     ak
        write(*,'(A,I8,A,I8)',ADVANCE='no')ACHAR(13)// &
             ' --- Messpannung',i,' ist null ',j
!     RM               fetxt = ' '
!     RM               errnr = 82
!     RM               goto 1000
     end if

!     Scheinbaren Widerstandswert berechnen
!     ak            sigmaa(i) = dcmplx(kfak(i)) * volt(i)
     sigmaa(i) = volt(i)
     sigmaa(i) = dcmplx(kfak(i)) * volt(i)
  end do
  IF (j/=0) WRITE (*,'(/A,I8,A)')' Vorsicht es wurde',j,&
       'mal keine Messpannung gemessen'
  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

end subroutine bvolt

subroutine kont2(lsetup)
    !     Unterprogramm zur Ausgabe der Kontrollvariablen.
    !     Andreas Kemna 16-Apr-1996
    !     Letzte Aenderung 11-Nov-1997
    ! ....................................................................

    USE datmod
    !     mw
    USE invmod
    USE cjgmod,ONLY:cgres,ncg
    USE errmod
    USE konvmod
    USE pathmod

    IMPLICIT none

    !.....................................................................
    !     EIN-/AUSGABEPARAMETER:

    !     Hilfsschalter
    LOGICAL  ::  lsetup

    !.....................................................................

    !     PROGRAMMINTERNE PARAMETER:

    !     Indexvariable
    INTEGER (KIND=4)  ::  i,k
    !!!$     Platzhalter
    INTEGER,PARAMETER :: ncdump=110
    CHARACTER(ncdump) :: cdump
    !!!$.....................................................................
    ! first iteration, robust
    100 FORMAT (t1,a3,t5,i3,t11,g10.4,t69,g10.4,t81,g10.4,t93,i4,t105,g9.3)
    ! first iteration, non-robust
    101 FORMAT (t1,a3,t5,i3,t11,g10.4,t69,g10.4,t81,g10.4,t93,i4)

    ! other iterations, robust
    110 FORMAT (t1,a3,t5,i3,t11,g10.4,t23,g10.4,t34,g10.4,t46,g10.4,t58,&
        i6,t69,g10.4,t81,g10.4,t93,i4,t105,g9.3,t117,f5.3)
    ! other iterations, non-robust
    111 FORMAT (t1,a3,t5,i3,t11,g10.4,t23,g10.4,t34,g10.4,t46,g10.4,t58,&
        i6,t69,g10.4,t81,g10.4,t93,i4,t105,f5.3)

    ! update iterations, non-robust
    105 FORMAT (t1,a3,t5,i3,t11,g10.4,t23,g9.3,t34,g10.4,t46,g10.4,t58,&
        i6,t105,f5.3)
    ! update iterations, robust
    106 FORMAT (t1,a3,t5,i3,t11,g10.4,t23,g9.3,t34,g10.4,t46,g10.4,t58,&
        i6,t105,g9.3,t117,f5.3)

    !!!$     'inv.ctr' oeffnen
    DO i=1,ncdump-1
        cdump(i:i+1)='*'
    END DO
    errnr = 1
    fetxt = ramd(1:lnramd)//slash(1:1)//'inv.ctr'
    open(fpinv,file=TRIM(fetxt),status='old',err=1000,position='append')
    fetxt = ramd(1:lnramd)//slash(1:1)//'cjg.ctr'
    open(fpcjg,file=TRIM(fetxt),status='old',err=1000,position='append')
    errnr = 4
    ncg = INT(cgres(1))
    !!!$     Erste Iteration (?)
    if (lsetup) then
        IF (lfpi) THEN          ! FPI?
            write(fpinv,'(a)',err=1000)cdump
            !!!$     Robuste Inversion
            if (lrobust) then
                write(fpinv,100,err=1000)'PIT',it,nrmsd,betrms,pharms,npol,l1rat
            else
            write(fpinv,101,err=1000)'PIT',it,nrmsd,betrms,pharms,npol
            end if
            write(fpinv,'(a)',err=1000)cdump
        ELSE
            write(fpinv,'(a)',err=1000)cdump
            !!!$     Robuste Inversion
            if (lrobust) then
                write(fpinv,100,err=1000)'IT',it,nrmsd,betrms,pharms,npol,l1rat
            else
                write(fpinv,101,err=1000)'IT',it,nrmsd,betrms,pharms,npol
            end if
            write(fpinv,'(a)',err=1000)cdump
        END IF
    else
        !!!$
        !!!$     Hauptiterationen
     if (llam.and..not.lstep) then
        write(fpinv,'(a)',err=1000)cdump
        if (lfpi) then
           if (lrobust) then
              write(fpinv,110,err=1000)'PIT',it,nrmsd,bdpar,lam,rough,&
                   ncg,betrms,pharms,npol,l1rat,step
           else
              write(fpinv,111,err=1000)'PIT',it,nrmsd,bdpar,lam,rough,&
                   ncg,betrms,pharms,npol,step
           end if
        else
!!!$     kein FPI
           if (lrobust) then
              write(fpinv,110,err=1000)'IT',it,nrmsd,bdpar,lam,rough,&
                   ncg,betrms,pharms,npol,l1rat,step
           else
              write(fpinv,111,err=1000)'IT',it,nrmsd,bdpar,lam,rough,&
                   ncg,betrms,pharms,npol,step
           end if

        end if

        write(fpinv,'(a)',err=1000)cdump

        write(fpcjg,*,err=1000)
        write(fpcjg,*,err=1000) it
        do k=1,ncg
           write(fpcjg,*,err=1000) cgres(k+1)
        end do
!!!$     lambda search and steplength search
     else
        IF (lfpi) THEN
           if (lrobust) then
              write(fpinv,106,err=1000)'PUP',itr,nrmsd,bdpar,lam,rough,ncg,l1rat,step
           ELSE
              write(fpinv,105,err=1000)'PUP',itr,nrmsd,bdpar,lam,rough,ncg,step
           END if
        ELSE
           if (lrobust) then
              write(fpinv,106,err=1000)'UP',itr,nrmsd,bdpar,lam,rough,ncg,l1rat,step
           ELSE
              write(fpinv,105,err=1000)'UP',itr,nrmsd,bdpar,lam,rough,ncg,step
           END if
        END IF
     end if
  end if

!!!$     'inv.ctr' schliessen
  close(fpinv)
  close(fpcjg)

  errnr = 0
  return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

1000 return

end subroutine kont2

module relem_mod
      contains
      subroutine relem(kanal,io,datei)

!     Unterprogramm zum Einlesen der FEM-Parameter aus 'datei'.

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   24-Oct-1996

! ....................................................................

      USE elemmod
      USE errmod

      IMPLICIT none

      ! INCLUDE 'err.fin'
! ....................................................................

!     EIN-/AUSGABEPARAMETER:

!     Kanalnummer
      integer :: kanal,io

!     Datei
      character(80) :: datei

! ....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariablen
      integer :: i,j,k

!     Hilfsvariable
      integer :: idum

! ....................................................................

!     'datei' oeffnen
      fetxt = datei

      errnr = 1
      open(kanal,file=fetxt,status='old',err=999)
      OPEN(io,file='ctmck.info',STATUS='replace')
      errnr = 3

!     Anzahl der Knoten (bzw. Knotenvariablen), Anzahl der Elementtypen
!     sowie Bandbreite der Gesamtsteifigkeitsmatrix einlesen
      read(kanal,*,end=1001,err=1000) sanz,typanz,mb
!     !$ now get some memory for the fields..
!     !$ first the sanz fields
      ALLOCATE (sx(sanz),sy(sanz),snr(sanz),stat=errnr)
      IF (errnr /= 0) THEN
         fetxt = 'Error memory allocation sx failed'
         errnr = 94
         GOTO 999
      END IF

      ALLOCATE (typ(typanz),nelanz(typanz),selanz(typanz),stat=errnr)
      IF (errnr /= 0) THEN
         fetxt = 'Error memory allocation selanz failed'
         errnr = 94
         GOTO 999
      END IF

!     Elementtypen, Anzahl der Elemente eines bestimmten Typs sowie
!     Anzahl der Knoten in einem Elementtyp einlesen
      read(kanal,*,end=1001,err=1000) (typ(i),nelanz(i),selanz(i),i=1,typanz)

!     !$ set number of node points for regular elements
      smaxs = MAXVAL(selanz)

!     Anzahl der Elemente (ohne Randelemente) und Anzahl der Randelemente
!     bestimmen
      relanz = 0
      elanz  = 0
      do i=1,typanz
         if (typ(i).gt.10) then
            relanz = relanz + nelanz(i)
         else
            elanz  = elanz  + nelanz(i)
         end if
      end do
!     !$ get memory for the element integer field
      ALLOCATE (nrel(elanz+relanz,smaxs),rnr(relanz),stat=errnr)
      IF (errnr /= 0) THEN
         fetxt = 'Error memory allocation nrel failed'
         errnr = 94
         GOTO 999
      END IF

      PRINT*,'check dis out ',4+sanz+elanz+relanz*2

!     Zeiger auf Koordinaten, x-Koordinaten sowie y-Koordinaten der Knoten
!     einlesen
      print*,'knoten::',sanz
      read(kanal,*,end=1001,err=1000) (snr(i),sx(i),sy(i),i=1,sanz)
      i = 0;j = 0
      DO k=1,sanz
         IF (sx(snr(k))==sx(snr(1))) j = j+1 !counts vertical grid nodes
         IF (sy(snr(k))==sy(snr(1))) i = i+1 !counts horizontal grid nodes
      END DO
      IF ((i-1) == 0 .OR. (j-1) == 0) THEN
         PRINT*,ACHAR(9)//'## GRID not regular ##'
         WRITE (io,'(a)')'## Grid not regular'
      ELSE
         WRITE (*,*)'Regular grid info NX=',i-1, '  NY=',j-1,'  NXY=',(i-1)*(j-1)
         WRITE (*,*)'x0=',MINVAL(sx(1:sanz)),'y0=', MINVAL(ABS(sy(1:sanz)))
         WRITE (*,'(2(a,2x,F10.4))')'Linear dx',sx((2))-sx((1)), 'dy',sy((i+1))-sy((1))
         WRITE (io,'(a)')'## Regular grid'
         WRITE (io,'(A,2X,I4)')'NX',i-1
         WRITE (io,'(a,2x,F10.3)')'X0',MINVAL(sx(1:sanz))
         WRITE (io,'(a,2x,F10.3)')'DX',sx((2))-sx((1))
         WRITE (io,'(A,2X,I4)')'NY',j-1
         WRITE (io,'(a,2x,F10.3)')'Y0',MINVAL(ABS(sy(1:sanz)))
         WRITE (io,'(a,2x,F10.3)')'DY',sy((i+1))-sy((1))
         WRITE (io,'(A,2X,I4)')'NXY',(i-1)*(j-1)
      END IF
!     Knotennummern der Elemente einlesen
      print*,'post knoten position',4+sanz
      idum = 0
      print*,'elemente::',elanz,relanz
      do i=1,typanz
         do j=1,nelanz(i)
            read(kanal,*,end=1001,err=1000) (nrel(idum+j,k),k=1,selanz(i))
         end do
         idum = idum + nelanz(i)
      end do
      print*,'post elemente position',4+sanz+elanz+relanz
      print*,'randpunkte::',relanz
!     Zeiger auf Werte der Randelemente einlesen
      read(kanal,*,end=1001,err=1000) (rnr(i),i=1,relanz)
      print*,'post randpunkte position',4+sanz+elanz+relanz*2
!     'datei' schliessen
      close(kanal)
      CLOSE(io)
      errnr = 0
      return

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

 999  return

 1000 close(kanal)
      return

 1001 close(kanal)
      errnr = 2
      return

      end subroutine relem
end module relem_mod

!> \file bsens.f90
!> \brief forward modelling sensitivity calculation
!> \details Kemna (2000): An elegant way of deriving an appropriate sensitivity expression via reciprocity starts directly from the linear FE equations (e.g., Rodi, 1976; Oristaglio and Worthington, 1980). Substituting 
!> \f[ S = \sum_{j=1}^{N_e}{\sigma_j \left( S_{1j}+ k^2 S{2j} \right)} + \sum_{j=1}^{N_b}{\beta_j S_{3j}} \f]
!> and 
!> \f[ b = - \left[ \sum_{j=1}^{N_e}{\Delta \sigma_j \left( S_{1j} + k^2 S_{2j} \right)} + \sum_{j=1}^{N_e}{\Delta \beta_j S_{3j}} \right] \tilde \phi_p \f]
!> into the matrix equation
!> \f[ S\tilde \phi_s = b \f]
!>  and subsequently taking the derivative with respect to the complex conductivity of the j-th domain element, it is easily shown that
!> \f[ S \frac{\partial \tilde \phi}{\partial \sigma_j} = -\left( S_{1j} + k^2 S_{2j} \right) \tilde\phi \f]
!> Note that although the boundary-element parameters \f$ \beta_j \f$ in the first expression may be determined with the help of the conductivity values of the respective adjacent cells, virtually, they must not be considered as domain-element parameters. Therefore, the derivative within the right-hand side of the above equation includes no contribution on this account.
!> 
!> A further remark on the general complex differentiability of the discrete complex potential values in \f$ \tilde \phi \f$ may be added. Obviously, from the first equation it is  \f$ \partial S / \partial \sigma_j = \i \partial S / \partial \Re (\sigma_j) \f$. Hence, from the above equation, it is readily seen that each function \f$\tilde\phi_i (\sigma_j) \f$ fulfills the Cauchy-Riemann conditions
!> \f[ \frac{\partial \Re \tilde\phi_i}{\partial\Re \sigma_j} = \frac{\partial \Im \tilde\phi_i}{\partial\Im \sigma_j}, \ \frac{\partial \Im \tilde\phi_i}{\partial\Re \sigma_j} = -\frac{\partial \Re \tilde\phi_i}{\partial\Im \sigma_j} \f]
!> and, thus, is actually analytic (i.e., complex differentiable).
!> From the analogy with the original FE matrix equation for the (total) potential, the sensitivity \f$ \partial \tilde \phi_{i,l} / \partial \sigma_j \f$, corresponding to a potential \f$ \tilde \phi_{i,l} \f$ at node \f$ i \f$ due to a source at node \f$ l \f$, can be represented as a superposition of potentials \f$ \tilde \phi_{i,m} \f$ originated from ‘fictitious’ sources at the nodes  of the j-th domain element (e.g., Sasaki, 1989). By the principle of reciprocity, the values \f$ \tilde \phi_{i,m} \f$ can be expressed via potentials \f$ \tilde \phi_{m,i} \f$ at the nodes  due to a current \f$ I_i \f$ at node \f$ i \f$. Analogous to the DC resistivity problem (e.g., Kemna  1995), for the complex sensitivity the expression ultimately results in:
!> \f[ S \frac{\partial \tilde \phi}{\partial \sigma_j} = -\frac{1}{I_i} \sum_m{\sum_n{a_{j_{mn}} \tilde \phi_{{m,i}}} \tilde \phi_{n,l} }\f]
!> where the double sum is made over all nodes \f$ m,n \f$ of the respective element, and \f$ a_{j_{mn}}\f$ is the \f$ m,n\f$-th element of the matrix \f$ S_{1j} + k^2 S_{2j} \f$. From the last equation, the sensitivities are simply obtained by a weighted sum of complex potential products.

!> @author Andreas Kemna
!> @date 10/11/1993, last change 1/26/1998

subroutine bsens()

!     Unterprogramm zur Berechnung der Sensitivitaeten.

!     Andreas Kemna                                            09-Apr-1995
!     Letzte Aenderung   04-Dez-1998

!.....................................................................

  USE alloci
  USE femmod
  USE datmod
  USE electrmod
  USE modelmod
  USE elemmod
  USE wavenmod
  USE errmod
  USE konvmod , ONLY : lverb
  USE ompmod
  IMPLICIT none

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Aktuelle Elementnummer
  INTEGER (KIND = 4)  ::     iel

!     Aktueller Elementtyp
  INTEGER (KIND = 4)  ::     ntyp

!     Anzahl der Knoten im aktuellen Elementtyp
  INTEGER (KIND = 4)  ::     nkel

!     Elektrodennummern
  INTEGER (KIND = 4)  ::     elec1,elec2,elec3,elec4

!     Beitraege zur Superposition
  COMPLEX (KIND(0D0)) ::     sup(4)

!     Indexvariablen
  INTEGER (KIND = 4)  ::     ityp,jnel,mi,mj,imn,imax,imin
  INTEGER (KIND = 4)  ::     i,k

!     Hilfsfeld
  COMPLEX(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: hsens

!     Hilfsvariablen
  INTEGER (KIND = 4)  ::     nzp,nnp
  COMPLEX (KIND(0D0)) ::     dum

!     Pi
  REAL (KIND(0D0))    ::  pi

! OMP zaehler
  INTEGER (KIND = 4) ::  icount

!.....................................................................

  pi = dacos(-1d0)
  !     get memory for hsens
  ALLOCATE (hsens(kwnanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation hsens'
     errnr = 94
     RETURN
  END IF
!     Sensitivitaetenfeld auf Null setzen
  sens = 0d0
  icount = 0

  !$OMP PARALLEL DEFAULT(none) &
  !$OMP FIRSTPRIVATE(hsens) &
  !$OMP SHARED (icount,strnr,vnr,typanz,typ,selanz,kwnanz,lverb,&
  !$OMP nrel,kpot,elbg,strom,kwnwi,pi,mnr,nanz,swrtr,nelanz,sens) &
  !$OMP PRIVATE(iel,elec1,elec2,elec3,elec4,sup,imin,imn,&
  !$OMP ntyp,jnel,nkel,nzp,nnp,imax,dum)
  !$OMP DO SCHEDULE (GUIDED,CHUNK_0)

!     Messwert hochzaehlen
  do i=1,nanz
     iel = 0
     
     !OMP CRITICAL
     icount = icount + 1

!     Kontrollausgabe
     IF (lverb) write(*,'(a,t70,F10.2,A)',advance='no')ACHAR(13)//&
          'Sensitivity/ ',REAL(icount)/REAL(nanz) * 100. ,' %'

!     Stromelektroden bestimmen
     elec1 = mod(strnr(i),10000)
     elec2 = (strnr(i)-elec1)/10000

!     Messelektroden bestimmen
     elec3 = mod(vnr(i),10000)
     elec4 = (vnr(i)-elec3)/10000

!     Beitraege zur Superposition auf Null setzen
     sup = DCMPLX(0d0)

     do ityp=1,typanz
        ntyp = typ(ityp)
        nkel = selanz(ityp)

!     Ggf. zu neuem Messwert springen
        if (ntyp.gt.10) CYCLE

        do jnel=1,nelanz(ityp)

!     Elementnummer hochzaehlen
           iel = iel + 1

!     SENSITIVITAETEN BERECHNEN
           do k=1,kwnanz
              hsens(k) = dcmplx(0d0)

!     Knoten des aktuellen Elements hochzaehlen
              do mi=1,nkel
                 nzp = nrel(iel,mi)

                 do mj=1,nkel
                    nnp  = nrel(iel,mj)
                    imax = max0(mi,mj)
                    imin = min0(mi,mj)
                    imn  = imax*(imax-1)/2+imin

!     Beitraege nach "Reziprozitaetsmethode" gewichtet aufaddieren und
!     superponieren
!     (beachte: 'volt = pot(elec4) - pot(elec3)' ,
!     '+I' bei 'elec2', '-I' bei 'elec1' )
                    if (elec1.gt.0) sup(1) = kpot(nnp,elec1,k)
                    if (elec2.gt.0) sup(2) = kpot(nnp,elec2,k)
                    if (elec3.gt.0) sup(3) = kpot(nzp,elec3,k)
                    if (elec4.gt.0) sup(4) = kpot(nzp,elec4,k)

!     ACHTUNG: Bei grossen Quellabstaenden UNDERFLOW moeglich, da einzelnen
!     Potentiale sehr klein (vor allem bei grossen Wellenzahlen)!
!     -> mittels Compiler-Einstellung auf Null setzen!
!     MsDev5.0: "/fpe:3 /check:underflow" -> "/fpe:0"
                    dum      = (sup(2)-sup(1)) * (sup(4)-sup(3))
                    hsens(k) = hsens(k) + dcmplx(elbg(iel,imn,k)) * dum
                 end do
              end do
           end do

!     GGF. RUECKTRANSFORMATION
           if (swrtr.eq.0) then

              dum = hsens(1) * dcmplx(strom(i))

           else

              dum = dcmplx(0d0)

              do k=1,kwnanz
                 dum = dum + hsens(k)*dcmplx(kwnwi(k))
              end do

              dum = dum * dcmplx(strom(i)/pi)

           end if

!     Sensitivitaeten aufaddieren
           sens(i,mnr(iel)) = sens(i,mnr(iel)) - dum

        end do ! jnel=1,nelanz(i)
     end do ! ityp=1,typanz
  end do ! i=1,nanz
  !$OMP END DO
  !$OMP END PARALLEL
  
  DEALLOCATE (hsens)

end subroutine bsens

module welemmod
    contains
      subroutine welem(kanal,datei)

!     Unterprogramm zum Schreiben der FEM-Parameter in 'datei'.

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   21-Jan-2003

! ....................................................................

      USE elemmod
      USE errmod

      IMPLICIT none
! ....................................................................

!     EIN-/AUSGABEPARAMETER:

!     Kanalnummer
      integer :: kanal

!     Datei
      character(80) :: datei

! ....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariablen
      integer        ::     i,j,k

!     Hilfsvariable
      integer         ::    idum

! ....................................................................

!     'datei' oeffnen
      fetxt = datei

      errnr = 1
      open(kanal,file=fetxt,status='replace',err=999)

      errnr = 4

!     Anzahl der Knoten (bzw. Knotenvariablen), Anzahl der Elementtypen
!     sowie Bandbreite der Gesamtsteifigkeitsmatrix schreiben
      write(kanal,*,err=1000) sanz,typanz,mb

!     Elementtypen, Anzahl der Elemente eines bestimmten Typs sowie
!     Anzahl der Knoten in einem Elementtyp schreiben
      do i=1,typanz
         write(kanal,*,err=1000) typ(i),nelanz(i),selanz(i)
      end do

!     Zeiger auf Koordinaten, x-Koordinaten sowie y-Koordinaten der Knoten
!     schreiben
      do i=1,sanz
         write(kanal,'(I8,2F12.3)',err=1000) snr(i),real(sx(i)),real(sy(i))
      end do

!     Knotennummern der Elemente schreiben
      idum = 0
      do i=1,typanz
         do j=1,nelanz(i)
            write(kanal,*,err=1000) (nrel(idum+j,k),k=1,selanz(i))
         end do
         idum = idum + nelanz(i)
      end do

!     Zeiger auf Werte der Randelemente schreiben
      do i=1,relanz
         write(kanal,*,err=1000) rnr(i)
      end do

!     'datei' schliessen
      close(kanal)

      fetxt='ctm_triangles.txt'
      OPEN (kanal,FILE=fetxt,STATUS='replace',ACCESS='sequential')
      do j=1,nelanz(1)
         write(kanal,*,err=1000) (nrel(j,k),k=1,selanz(1))
      end do
      CLOSE (kanal)

      errnr = 0
      return

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

 999  return

 1000 close(kanal)
      return

      end subroutine welem
end module welemmod

!> \file ompmod.f90
!> \brief variable declarations for OpenMP
!> @author Roland Martin 

MODULE ompmod

  IMPLICIT none

  INTEGER,PUBLIC :: TID ! Thread ID
  INTEGER,PUBLIC :: NTHREADS ! Total number of threads
  INTEGER,PUBLIC,PARAMETER :: CHUNK_0=256
  INTEGER,PUBLIC,PARAMETER :: CHUNK_1=2*CHUNK_0
  INTEGER,PUBLIC,PARAMETER :: CHUNK_2=2*CHUNK_1
  INTEGER,PUBLIC,PARAMETER :: CHUNK_3=2*CHUNK_2

  ! chunk pieces for guided scheduling of do loops
  
!!$  !$OMP PARALLEL SHARED(a,b,CHUNK) PRIVATE (i)
!!$  a = 1.
!!$  !$OMP DO SCHEDULE(STATIC, chunk)

!!$  DO i = 1, n
!!$    a(i) = a(i) + b(i)
!!$  END DO

!!$  !$OMP END PARALLEL

END MODULE ompmod

!> \file blam0.f90
!> \brief compute the starting regularizazion parameter
!> \details The starting regularization parameter  \f$ \lambda_0 \f$ is determined from
!> - <I>lamnull_cri </I>file in the current directory if llamf <I> modulo </I> 2 = 1 and \f$ nz \neq -1\f$ in <I>crmod.cfg</I> 
!> - \f$\max(nanz,manz) \f$ the maximum of either the nr of model parameters and the number of measurements if llamf <I> modulo </I> 2 = 1 and \f$ nz = -1 \f$
!> - else (the common way): Kemna (2000): Following the suggestion of Newman and Alumbaugh (1997), an adequate starting value \f$ \lambda_0 \f$ at the first inverse iteration step may be estimated from the row sums of the matrix product \f$ A^H W_d^H W_d A \f$. Such a choice properly scales the regularizing term \f$ \lambda W_m^T W_m \f$ at the beginning of the inversion process. However, whereas Newman and Alumbaugh (1997) use the maximum absolute row value which occurs, for the problem considered herein five times the corresponding mean value has been found to be sufficiently large. Taking in addition the smoothing parameters \f$ \alpha_x \f$ and \f$ \alpha_z \f$ into account, it is
!> \f[ \lambda_0 = \frac{2}{\alpha_x + \alpha_z} \frac{5}{M} \sum_{m=1}^M {\left| 4 \sum_{j=1}^M {\sum_{i=1}^N {\frac{\bar a _{im} a_{ij}}{\bar \epsilon_i \epsilon_i}}}\right|}, \f]
!> where \f$ \bar {} \f$ denotes complex conjugation.
!> @author Andreas Kemna
!> @date 02/20/1997, last change 03/07/2003
SUBROUTINE blam0()

!     Unterprogramm zum Bestimmen des Start-Regularisierungsparameters.

!     Andreas Kemna                                            20-Feb-1997
!     Letzte Aenderung   07-Mar-2003

!.....................................................................

  USE alloci
  USE femmod
  USE datmod
  USE invmod
  USE modelmod
  USE konvmod

  IMPLICIT NONE


!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Hilfsvariablen
  COMPLEX (KIND(0D0)) ::  cdum
  REAL (KIND(0D0))    ::  dum

  REAL (KIND(0D0)),ALLOCATABLE , DIMENSION(:) :: jtj

!     Indexvariablen
  INTEGER (KIND = 4)  ::  i,j,k,ic

!.....................................................................

!     Start-Regularisierungsparameter bestimmen

! for fixed lambda set the values according to preset fixed lamfix
  IF (( BTEST(llamf,0) .OR. (lamnull_cri > EPSILON(lamnull_cri)) ) .AND..NOT. &
       lfpi ) THEN
     IF (nz==-1) THEN ! this is a special switch, but only taken for 
!! CRI/DC
        lammax = MAX(REAL(manz),REAL(nanz))
        WRITE (*,'(a,t5,a,G12.4)')ACHAR(13),'taking easy lam_0 ',lammax
     ELSE
        lammax = DBLE(lamnull_cri)
        WRITE (*,'(a,t5,a,G12.4)')ACHAR(13),'-> presetting lam0 CRI',lammax
     END IF
     RETURN
  ELSE IF ( BTEST(llamf,0) .OR. (lamnull_fpi > EPSILON(lamnull_fpi)) ) THEN
     lammax = DBLE(lamnull_fpi)
     WRITE (*,'(a,t5,a,G12.4)')ACHAR(13),'-> presetting lam0 FPI',lammax
     RETURN
  END IF


  ALLOCATE (jtj(manz))

  jtj = 0d0;ic = 0

  
  IF (ldc) THEN

     !$OMP PARALLEL DEFAULT(none) PRIVATE (dum) &
     !$OMP SHARED (manz,nanz,sensdc,wmatd,wdfak,jtj,lverb,ic)
     !$OMP DO SCHEDULE (GUIDED)

     DO j=1,manz
        IF (lverb) THEN
           !$OMP ATOMIC
           ic = ic + 1
           
           WRITE(*,'(a,t70,F6.2,A)',advance='no')ACHAR(13)//&
                'blam0/ ',REAL( ic * (100./manz)),'%'
        END IF
        dum = 0d0

        DO i=1,nanz
           DO k=1,manz
              dum = dum + sensdc(i,j) * sensdc(i,k) * &
                   wmatd(i)*DBLE(wdfak(i))
           END DO

        END DO

        jtj(j) = DABS(dum)
        
     END DO

     !$OMP END PARALLEL

  ELSE IF (lfpi) THEN

     !$OMP PARALLEL DEFAULT(none) PRIVATE (dum) &
     !$OMP SHARED (manz,nanz,sens,wmatd,wdfak,jtj,lverb,ic)
     !$OMP DO SCHEDULE (GUIDED)
     DO j=1,manz
        IF (lverb) THEN
           !$OMP ATOMIC
           ic = ic + 1
           
           WRITE(*,'(a,t70,F6.2,A)',advance='no')ACHAR(13)//&
                'blam0/ ',REAL( ic * (100./manz)),'%'
        END IF

        dum = 0d0

        DO i=1,nanz
           DO k=1,manz
              dum = dum + DBLE(sens(i,j)) * DBLE(sens(i,k)) * &
                   wmatd(i)*DBLE(wdfak(i))
           END DO
        END DO

        jtj(j) = DABS(dum)

     END DO
     !$OMP END PARALLEL

  ELSE

     !$OMP PARALLEL DEFAULT(none) PRIVATE (cdum) &
     !$OMP SHARED (manz,nanz,sens,wmatd,wdfak,jtj,lverb,ic)
     !$OMP DO SCHEDULE (GUIDED)
     DO j=1,manz

        
        IF (lverb) THEN
           !$OMP ATOMIC
           ic = ic + 1
           
           WRITE(*,'(a,t70,F6.2,A)',advance='no')ACHAR(13)//&
                'blam0/ ',REAL( ic * (100./manz)),'%'
        END IF

        cdum = dcmplx(0d0)

        DO i=1,nanz
           DO k=1,manz
              cdum = cdum + dconjg(sens(i,j)) * sens(i,k) * &
                   dcmplx(wmatd(i)*DBLE(wdfak(i)))
           END DO
        END DO
        
        jtj(j) = cdabs(cdum)

     END DO
     !$OMP END PARALLEL

  END IF

  lammax = SUM(jtj)/DBLE(manz)

  DEALLOCATE (jtj)

  lammax = lammax * 2d0/(alfx+alfz)
!     ak Default
  lammax = lammax * 5d0
  WRITE (*,'(a,t5,a,G12.4,t60)')ACHAR(13),'found lam_0 ',lammax

!     ak Synthetic Example (JoH)
!     ak        lammax = lammax * 1d1

!     ak MinFrac
!     ak        lammax = lammax * 5d1

!     ak Test
!     ak        lammax = lammax * 1d1

!     ak AAC
!     ak        lammax = lammax * 5d0
  RETURN
END SUBROUTINE blam0

SUBROUTINE Gauss_cmplx (a,n,e_flag)    ! Invert matrix by Gauss method

  IMPLICIT NONE
  INTEGER(KIND(4))                                :: n
  COMPLEX(KIND(0D0)),DIMENSION(n,n),INTENT(INOUT) :: a
  COMPLEX(KIND(0D0)),DIMENSION(:), ALLOCATABLE    :: temp
  COMPLEX(KIND(0D0))                              :: c,d 
  INTEGER(KIND(4))                                :: i,j,e_flag
  

  ALLOCATE (temp(n),STAT=e_flag)
  IF (e_flag/=0) THEN
     print*,'error alllocating temp(',n,')=',n*16/(1024**3),' GB'
     RETURN
  END IF
  
  DO i = 1,n
     WRITE (*,'(A,1X,F6.2,A)',ADVANCE='no')ACHAR(13)//ACHAR(9)//ACHAR(9)//&
          'gauss/ ',REAL( i * (100./n)),'%'

     e_flag = -i

     IF (ABS(a(i,i)) < EPSILON(DBLE(d))) RETURN

     d = DCMPLX(1.)/a(i,i)
     temp = a(:,i)
     DO j = 1, n
        c = a(i,j) * d
        a(:,j) = a(:,j) - temp * c
        a(i,j) = c
     END DO
     a(:,i) = temp * (-d)
     a(i,i) = d
  END DO

  e_flag=0
  
END SUBROUTINE Gauss_cmplx

!> \file cjgmod.f90
!> \brief variable delarations for the conjugate gradient (CG) solver in <I>cg_mod</I>
!> @author Roland Martin
!> @date 07/27/2010

MODULE cjgmod
!! ------------------------------------------------------------------
! Module for the data of Conjugate gradient to solve Linear systems
! Copyright by Andreas Kemna   2010
! Edited first by Roland Martin                          27-07-2010
! -------------------------------------------------------------------
  USE datmod,ONLY:nanz
  USE modelmod,ONLY:manz

  IMPLICIT none
!!! COMPLEX CASE
!! auxiliary vector stores product of A*(Ap)
  COMPLEX(KIND(0D0)),ALLOCATABLE,DIMENSION(:),PUBLIC  :: ap
! Right hand side (RHS) vector
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE  :: bvec
! residual vector
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE  :: rvec
! intermediate vector (stores Ap)
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE  :: pvec

!!! DC CASE
!c assist vectors
  REAL(KIND(0D0)),ALLOCATABLE,DIMENSION(:),PUBLIC     :: apdc
! dc real valued version ov RHS
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: bvecdc
! residual vector dc
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: rvecdc
! intermediate vector (stores Ap) dc
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: pvecdc

!! variables for every case
! CG residuals
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: cgres
! storage
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: cgres2
! preconditioning factors
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: cgfac
! CG Epsilon
  REAL(KIND(0D0)),PUBLIC                              :: eps
! maximum number of CG steps
  INTEGER (KIND = 4),PUBLIC                           :: ncgmax
! actual number of CG steps..
  INTEGER (KIND = 4),PUBLIC                           :: ncg

  PUBLIC :: con_cjgmod ! constructor
  PUBLIC :: des_cjgmod ! destructor

CONTAINS 


  SUBROUTINE con_cjgmod (mycase,errtxt,errnr) ! constructor of cjgmod
    INTEGER (KIND=4),INTENT (IN) :: mycase ! mycase can have 3 values
!! 0:  allocate global cgres and bvec which should be called from update
    CHARACTER (*),INTENT(INOUT)  :: errtxt
    INTEGER (KIND=4),INTENT(OUT) :: errnr

    SELECT CASE (mycase)
    CASE (1) !global variables
       errtxt = 'allocation problem cgres'
       ALLOCATE (cgres(ncgmax+1),STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'allocation problem cgres2'
       ALLOCATE (cgres2(ncgmax+1),STAT=errnr)
       IF (errnr /= 0) RETURN
!!  CJG aux vectors and update
       errtxt = 'allocation problem bvec'
       ALLOCATE (bvec(manz),STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'allocation problem cgfac'
       ALLOCATE (cgfac(manz),STAT=errnr)
       IF (errnr /= 0) RETURN
    CASE (2)! ERT or FPI
! getting further CJG variables
       errtxt = 'allocation problem pvecdc'
       ALLOCATE (pvecdc(manz),STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'allocation problem bvecdc'
       ALLOCATE (bvecdc(manz),STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'allocation problem rvecdc'
       ALLOCATE (rvecdc(manz),STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'allocation problem apdc'
       ALLOCATE (apdc(nanz),STAT=errnr)
    CASE(3) ! COMPLEX _only_
       errtxt = 'allocation problem rvec'
       ALLOCATE (rvec(manz),STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'allocation problem pvec'
       ALLOCATE (pvec(manz),STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'allocation problem ap'
       ALLOCATE (ap(nanz),STAT=errnr)
    END SELECT

  END SUBROUTINE con_cjgmod

  SUBROUTINE des_cjgmod (mycase,errtxt,errnr) ! destructor of cjgmod
    INTEGER (KIND=4),INTENT (IN) :: mycase
    CHARACTER (*),INTENT(INOUT)  :: errtxt
    INTEGER (KIND=4),INTENT(OUT) :: errnr

    SELECT CASE (mycase)
    CASE (1) !global variables
       errtxt = 'deallocation problem cgres'
       DEALLOCATE (cgres,STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'deallocation problem cgres2'
       DEALLOCATE (cgres2,STAT=errnr)
       IF (errnr /= 0) RETURN
!!  CJG aux vectors and update
       errtxt = 'deallocation problem bvec'
       DEALLOCATE (bvec,STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'deallocation problem bvec'
       DEALLOCATE (cgfac,STAT=errnr)
       IF (errnr /= 0) RETURN
    CASE (2)! ERT or FPI
! getting further CJG variables
       errtxt = 'deallocation problem pvecdc'
       DEALLOCATE (pvecdc,STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'deallocation problem bvecdc'
       DEALLOCATE (bvecdc,STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'deallocation problem rvecdc'
       DEALLOCATE (rvecdc,STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'deallocation problem apdc'
       DEALLOCATE (apdc,STAT=errnr)
    CASE(3) ! COMPLEX _only_
       errtxt = 'deallocation problem rvec'
       DEALLOCATE (rvec,STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'deallocation problem pvec'
       DEALLOCATE (pvec,STAT=errnr)
       IF (errnr /= 0) RETURN
       errtxt = 'deallocation problem ap'
       DEALLOCATE (ap,STAT=errnr)
    END SELECT

  END SUBROUTINE des_cjgmod

END MODULE cjgmod

!> \file gaulag.f90
!> \brief Gauss-Laguerre integration
!> \details Gauss-Laguerre integration: Computation of abcissas and weights for the numerical integration of the k integral for the backward transformation to the y space. Details can be found in Press et al. <I> Numerical Resipes in Fortran 77 and 90 (second edition) </I> (2001), pp. 146
!> @author William H. Press, Saul A. Teukolsky, William T. Vetterling, Brian P. Flannery
!> @date 2001
SUBROUTINE gaulag(x,w,n,alf)
  IMPLICIT none
  INTEGER (KIND = 4) ::n,MAXIT
  REAL (KIND(0D0)) :: alf,w(n),x(n)
  REAL (KIND(0D0)) :: EPS
  PARAMETER (EPS=3.D-14,MAXIT=10)
!!$CU    USES gammln
  INTEGER (KIND = 4) :: i,its,j
  REAL (KIND(0D0)) :: ai,gammln
  REAL (KIND(0D0)) :: p1,p2,p3,pp,z,z1
  do i=1,n
     if(i.eq.1)then
        z=(1.d0+alf)*(3.d0+.92d0*alf)/(1.d0+2.4d0*n+1.8d0*alf)
     else if(i.eq.2)then
        z=z+(15.d0+6.25d0*alf)/(1.d0+.9d0*alf+2.5d0*n)
     else
        ai=dble(i-2)
        z=z+((1.d0+2.55d0*ai)/(1.9d0*ai)+1.26d0*ai*alf/ &
             (1.d0+3.5d0*ai))*(z-x(i-2))/(1.d0+.3d0*alf)
     endif
     do its=1,MAXIT
        p1=1.d0
        p2=0.d0
        do j=1,n
           p3=p2
           p2=p1
           p1=((dble(2*j-1)+alf-z)*p2-(dble(j-1)+alf)*p3)/dble(j)
        END do
        pp=(dble(n)*p1-(dble(n)+alf)*p2)/z
        z1=z
        z=z1-p1/pp
        if(dabs(z-z1).le.EPS)goto 1
     END do
     print*,'too many iterations in gaulag'
1    x(i)=z
     w(i)=-dexp(gammln(alf+dble(n))-gammln(dble(n)))/(pp*dble(n)*p2)
  END do
  return
END SUBROUTINE gaulag

!> \file alloci.f90
!> \brief Memory allocation module
!> @author Andreas Kemna
!> @date 01/24/1997, last change 11/13/1997

MODULE alloci
!!$Andreas Kemna                                            24-Jan-1997
!!$                                      Letzte Aenderung   13-Nov-1997
!!$COMPLEX CASE
!> FE stiffness matrix
  COMPLEX (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC     :: a
!> potential values of all electrode locations in wave number space
  COMPLEX (KIND(0D0)), DIMENSION(:,:,:), ALLOCATABLE, PUBLIC :: kpot
!> potential values of alle electrodes in real space
  COMPLEX (KIND(0D0)), DIMENSION(:,:), ALLOCATABLE, PUBLIC   :: hpot
!> sensitivities
  COMPLEX (KIND(0D0)), DIMENSION(:,:), ALLOCATABLE, PUBLIC   :: sens
!> coverages
  REAL (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC   :: csens
!!$DC-CASE
!> FE stiffness matrix, DC case
  REAL (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC        :: adc
!> potential values of all electrode locations in wave number space, DC case
  REAL (KIND(0D0)), DIMENSION(:,:,:),ALLOCATABLE, PUBLIC     :: kpotdc
!> potential values of alle electrodes in real space, DC case
  REAL (KIND(0D0)), DIMENSION(:,:),ALLOCATABLE, PUBLIC       :: hpotdc
!> sensitivities
  REAL (KIND(0D0)), DIMENSION(:,:),ALLOCATABLE, PUBLIC       :: sensdc
!> real symmetric data covariance
  REAL (KIND(0D0)), DIMENSION(:,:), ALLOCATABLE, PUBLIC      :: cov_d
!> regularization matrix
  REAL (KIND(0D0)), DIMENSION(:,:),ALLOCATABLE, PUBLIC       :: smatm
!> PSR fields
  REAL (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC        :: rnd_r,rnd_p
!> real symmetric matrix to compute general inverses
  REAL (KIND(0D0)), DIMENSION(:,:), ALLOCATABLE, PUBLIC   :: ata
!> general symmetric transpose matrix (regularized) to compute general inverses
  REAL (KIND(0D0)), DIMENSION(:,:), ALLOCATABLE, PUBLIC   :: ata_reg
!> inverse matrix (may be resolution matrix or the MCM)
  REAL (KIND(0D0)), DIMENSION(:,:), ALLOCATABLE, PUBLIC   :: cov_m
END MODULE alloci

!> \file datmod.f90
!> \brief variable delarations for the <I> data</I> part of the inversion
!> @author Roland Martin
!> @date 07/27/2010

MODULE datmod
! 'dat.fin'
!
! Original version by 
! Andreas Kemna                                            07-Oct-1993
!
! Modified F90 module by Roland Martin
!                                       Letzte Aenderung   27-07-2010
!.....................................................................
! Anzahl der Messwerte
  INTEGER (KIND = 4),PUBLIC                             :: nanz
! Nummern der Stromelektroden
  INTEGER (KIND = 4), DIMENSION(:),ALLOCATABLE, PUBLIC  :: strnr
! Stromwerte
  REAL (KIND(0D0)), DIMENSION(:),ALLOCATABLE, PUBLIC    :: strom
! Nummern der Spannungselektroden
  INTEGER (KIND = 4), DIMENSION(:),ALLOCATABLE, PUBLIC  :: vnr
! Spannungswerte
  COMPLEX (KIND(0D0)), DIMENSION(:),ALLOCATABLE, PUBLIC :: volt
! Scheinbare Leitfaehigkeiten
  COMPLEX (KIND(0D0)), DIMENSION(:),ALLOCATABLE, PUBLIC :: sigmaa
! storage
  COMPLEX (KIND(0D0)), DIMENSION(:),ALLOCATABLE, PUBLIC :: sgmaa2
! Konfigurationsfaktoren
  REAL (KIND(0D0)), DIMENSION(:),ALLOCATABLE, PUBLIC    :: kfak
! Wichtungsvektor der Phasen
  REAL (KIND(0D0)), DIMENSION(:),ALLOCATABLE, PUBLIC    :: wmatdp
! Wichtungsvektor der Widerstaende
  REAL (KIND(0D0)), DIMENSION(:),ALLOCATABLE, PUBLIC    :: wmatdr
! Wichtungsvektor der Komplexen Fehlerellipsen
  REAL (KIND(0D0)), DIMENSION(:),ALLOCATABLE, PUBLIC    :: wmatd_cri
! parameters of resistance error model (dR=stabw0*R+stabm0)
  REAL (KIND(0D0)), PUBLIC                              :: stabw0,stabm0
! parameters of phase error model
! (dp=stabA1*R^stabpB+stabpA2*|P|+stabpA3)
  REAL (KIND(0D0)), PUBLIC                              :: stabp0,stabpA1
  REAL (KIND(0D0)), PUBLIC                              :: stabpB,stabpA2
! Schalter ob 'individual error' (.true.) oder 'uniform weighting'
! (.false.)
  LOGICAL, PUBLIC                                       :: lindiv
! Schalter ob ratio-dataset (.true.)
  LOGICAL, PUBLIC                                       :: lratio
! Schalter ob Polaritaeten gecheckt werden sollen (.true.)
  LOGICAL, PUBLIC                                       :: lpol
! Daten Verrauschen? lnse2 entkoppelt Rauschen und Fehlermodell
  LOGICAL, PUBLIC                                       :: lnse,lnse2
! Initialer Seed der Pseudo Random Sequence (PRS)
  INTEGER (KIND = 4), PUBLIC                            :: iseed
! Noise error model ...
! ... of resistance error model (dnR=nstabw0*nR+nstabm0)
  REAL (KIND(0D0)), PUBLIC                              :: nstabw0,nstabm0
! ... of phase error model 
! (dnp=nstabA1*dnR^nstabpB+nstabpA2*nP+nstabp0)
  REAL (KIND(0D0)), PUBLIC                              :: nstabpB,nstabpA1
  REAL (KIND(0D0)), PUBLIC                              :: nstabpA2,nstabp0
! Anzahl der nicht beruecksichtigten Messwerte
  INTEGER (KIND = 4), PUBLIC                            :: npol

END MODULE datmod

!> \file kompab.f90
!> \brief compilation of the stiffness matrix S and the right-hand-side source vector b
!> \details The stiffness matrix S is compiled from the form functions (see <I>elem1, elem3, elem8</I>) and the conductivity of the individual cells according to (Kemna, 2000, pp. 52):
!> \f[ S = \sum_{j=1}^{N_e} \sigma_j \left( S_{1j}+ k^2 S_{2j} \right) + \sum_{j=1}^{N_b} \beta_j S_{3j} \f]
!> The matrix is stored in band format, the matrix elements \f$ S_{mn} \f$ are assigned to the band matrix (a vector of length ((bandwidth+1)*nr_nodes)) via
!> \f[ S_{mn} \rightarrow S_{band}(max(m,n)*bandwidth + min(m,n)) \f]

!> @author Andreas Kemna
!> @date 10/11/1993, last change 11/05/1997

subroutine kompab(nelec,ki,my_a,my_b)

    !     Unterprogramm zur Kompilation der FE-Matrix 'a' in Bandform
    !     (vorgegebene Bandbreite 'mb') und des Konstantenvektors 'b'
    !     ( A * x + b = 0 ).

    !     Andreas Kemna                                            17-Dec-1993
    !     Letzte Aenderung   15-Jul-2007

    !.....................................................................

    USE alloci
    USE femmod
    USE sigmamod
    USE electrmod
    USE elemmod
    USE wavenmod
    USE errmod

    IMPLICIT none


    !.....................................................................

    !     EIN-/AUSGABEPARAMETER:
    !> (OpenMP thread safe) stiffness matrix
    COMPLEX (KIND (0D0)),DIMENSION((mb+1)*sanz) ::     my_a
    !> (OpenMP thread safe) right-hand-side (source) vector
    COMPLEX (KIND (0D0)),DIMENSION(sanz) ::     my_b

    !> current electrode number
    INTEGER (KIND = 4) ::     nelec

    !> current wave number
    INTEGER (KIND = 4) ::     ki

    !.....................................................................

    !     PROGRAMMINTERNE PARAMETER:

    !     Aktuelle Elementnummer
    INTEGER (KIND = 4) ::     iel

    !     Aktuelle Randelementnummer
    INTEGER (KIND = 4) ::     rel

    !     Aktueller Elementtyp
    INTEGER (KIND = 4) ::     ntyp

    !     Anzahl der Knoten im aktuellen Elementtyp
    INTEGER (KIND = 4) ::     nkel

    !     Hilfsvariablen
    REAL (KIND(0D0))   ::     dum
    COMPLEX(KIND(0D0)) ::     dum2
    INTEGER (KIND = 4) ::     im,imax,imin
    INTEGER (KIND = 4) ::     nzp,nnp,idif,ikl

    !     Indexvariablen
    INTEGER (KIND = 4) ::     i,j,k,l

    !.....................................................................

    !     Gesamtsteifigkeitsmatrix und Konstantenvektor auf Null setzen
    my_a = DCMPLX(0D0)
    my_b = DCMPLX(0D0)

    iel = 0

    do i=1,typanz
        ntyp = typ(i)
        nkel = selanz(i)

        do j=1,nelanz(i)
            iel = iel + 1
            ikl = 0

            if (ntyp.gt.11) CYCLE

            do k=1,nkel
                nzp = nrel(iel,k)

                do l=1,k
                    nnp  = nrel(iel,l)
                    idif = iabs(nzp-nnp)

                    !     Ggf. Fehlermeldung
                    if (idif.gt.mb) then
                        WRITE (fetxt,*)'kompab idif',idif,' iel ',iel
                        fetxt = ' '
                        errnr = 19
                        goto 1000
                    else

                        ! Aufbau der Gesamtsteifigkeitsmatrix und ggf. des Konstantenvektors
                        ikl = ikl + 1

                        imax = max0(nzp,nnp)
                        imin = min0(nzp,nnp)
                        im   = imax*mb + imin

                        ! mixed boundary
                        if (ntyp.eq.11) then
                            rel  = iel - elanz
                            dum  = relbg(rel,ikl) * kg(rel,nelec,ki)
                            ! >> RM
                            dum2 = sigma(rnr(rel))
                        else
                            dum  = elbg(iel,ikl,ki)
                            dum2 = sigma(iel)
                        end if
                        ! GRIDBUG was causing some problems here
                        ! sigma index can be overaccessed due to some segementation
                        ! issue which will cause undefined sigma access..
                        ! FIXED this with grid consisitency check during read in

                        my_a(im) = my_a(im) + dcmplx(dum) * dum2
                        ! << RM
                        if (lsr) then
                            dum2   = dcmplx(dum) * (dum2 - sigma0)
                            my_b(nzp) = my_b(nzp) + dum2 * pota(nnp)
                            if (nnp.ne.nzp) my_b(nnp) = my_b(nnp) + dum2 * pota(nzp)
                        end if
                    end if
                end do
            end do
        END do
    end do

    ! electrode capacitances: start
    if (nr_elec_capacitances.gt.0) then
        write (*,*) ''
        write (*,*) 'Electrode capacitances'
        write (*,*) eanz
        write (*,*) nr_elec_capacitances
        write (*,*) 'sanz', sanz, mb
        write(*,*) 'Applying electrode capacitances'
        do i=1,eanz
            im = j*mb + imin
            write (*,*) 'electrode node', i, snr(enr(i))
            ! see Schwartz, eq. 3.3 (page 142)
            ! compute index of diagonal element (i, i) in my_a
            write(*, *) 'index', (mb * sanz) + i
            my_a((mb * sanz) + i)  = my_a((mb * sanz) + i) + dcmplx(0, electrode_capacitances(i))
            !
        end do
    end if
    ! electrode capacitances: end


    !     Ggf. Konstantenvektor belegen
    if (.not.lsr) my_b(enr(nelec)) = dcmplx(-1d0)

        !     akc BAW-Tank
        !     ak        my_b(211) = dcmplx(1d0)
        !     akc Model EGS2003
        !     ak        my_b(1683) = dcmplx(1d0)
        !     akc Lysimeter hor_elem\normal
        !     ak        my_b(129) = dcmplx(1d0)
        !     akc Lysimeter hor_elem\fine
        !     ak        my_b(497) = dcmplx(1d0)
        !     akc Simple Tucson Model
        !     ak        my_b(431) = dcmplx(1d0)
        !     akc TU Berlin Mesokosmos
        !     ak        my_b(201) = dcmplx(1d0)
        !     akc Andy
        !     ak        my_b(2508) = dcmplx(1d0)
        !     akc Sandra (ele?_anom)
        !     ak        my_b(497) = dcmplx(1d0)
        !     akc Adrian (Tank)
        !     ak        my_b(1660) = dcmplx(1d0)

    if (lsink) my_b(nsink) = dcmplx(1d0)

    errnr = 0
    return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 return

end subroutine kompab

!> \file bsytop.f90
!> \brief compute the average element height for von-Neumann boundary elements (mirror sources)

!> @author Roland Martin
!> @date 11/20/2010

SUBROUTINE bsytop
!     
!     Unterprogramm zum Bestimmen der Mittleren Elementhoehe
!     aller "no-flow" Elemente (Halbraumgrenze) sytop
!     
!     Copyright by Andreas Kemna
!     
!     Erste Version von Roland Martin                          20-Nov-2009
!     
!     Letzte Aenderung                                         20-Nov-2009
!     
!.....................................................................

  USE elemmod               ! fuer sytop und den ganzen rest 

  IMPLICIT none

!     PROGRAMMINTERNE PARAMETER:-------------------------------------------
!     Indexvariablen
  INTEGER :: i,j,ik
!     Elementnummer
  INTEGER :: iel
!     Knotenanzahl der no flow elemente 
  INTEGER :: nkel
!     Schwerpunktskoordinaten des randelements
  REAL(KIND(0D0)) :: sp
!-----------------------------------------------------------------------

  sytop = 0.
  iel = 0
  DO i=1,typanz

     IF (typ(i) == 12) THEN ! search for "no flow" boundary

        nkel = selanz(i)
        sytop = 0.

        DO j=1,nelanz(i) ! check all electrode y-positions

           iel = iel + 1

           sp=0
           DO ik=1,nkel
              sp = sp + sy(snr(nrel(iel,ik)))
           END DO
           sp = sp/DBLE(nkel)


           IF (j == 1) THEN 
              sytop = sp
           ELSE             !caculate arithmetic mean (direct)
              sytop = (sytop*dble(j-1)+sp)/dble(j)
           END IF

        END DO
     ELSE

        iel = iel + nelanz(i)

     END IF
  END DO

  IF (sytop /= 0.) PRINT*,'SYTOP::',sytop

END SUBROUTINE bsytop

SUBROUTINE bvariogram_s
!!$c     
!!$c     Unterprogramm zum Bestimmen von Experimentellen Variogrammen
!!$c     
!!$c     Copyright by Andreas Kemna
!!$c     
!!$c     Created by Roland Martin                             19-Mar-2010
!!$c     
!!$c     Letzte Aenderung                                     23-Mar-2010
!!$c     
!!$c.....................................................................

  USE invmod         ! fuer par
  USE variomodel
  USE sigmamod       ! fuer sigma
  USE modelmod       ! fuer manz
  USE elemmod        ! fuer grid_min,grid_max,etc
  USE errmod
  USE konvmod        ! fuer alfx/alfz
  USE alloci, only:csens

  IMPLICIT none


!!$c     PROGRAMMINTERNE PARAMETER:-------------------------------------------
!!$c     Indexvariablen
  INTEGER :: i,j,ik,ifp
!!$c     th = Tail - Head; hx,hy,h distances in each direction
  REAL(KIND(0D0)) :: th,tail,head,hx,hy,h,mid_par
!!$c     korrelation length for variogram models
  REAL(KIND(0D0)) :: Ix,Iy
!!$c     smallest variogram distance and tolerance
  REAL(KIND(0D0)) :: lag_unit,lag_tol
!!$c     smallest variogram distance and tolerance anisotrop
  REAL(KIND(0D0)) :: lag_unit_x,lag_tol_x
  REAL(KIND(0D0)) :: lag_unit_y,lag_tol_y
!!$c     number of equidistant lags (nlag) = INT(grid_max / grid_min)
  INTEGER :: nlag,nlag_x,nlag_y
!!$c     lag vector (nlag)
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: lag,lag_x,lag_y
!!$c     number of headtail pairs for each semivariogram N(lag)(nlag)
  INTEGER,DIMENSION(:),ALLOCATABLE :: ngam_x,ngam_y,ngam
!!$c     experimental semivariogram
!!$c     gam(lag)=1/N(lag)/2 * sum_k^N(lag) (tail - head)**2.
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: gam_x,gam_y,gam
!!$c     variogram model
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: mgam_x,mgam_y,mgam
  CHARACTER(80) :: tmgam,tmgam_x,tmgam_y,mti,tgam,tcov
!!$! mti stores a string for variogram statistics, like korrelation length
!!$! tgam stores the output string of get_vario
!!$c     variogram model
  REAL(KIND(0D0)) :: csensmax
  CHARACTER (11) :: tg
!!$c-----------------------------------------------------------------------
  WRITE (*,'(/a)',ADVANCE='no')'Calculating VARIOGRAM'
  errnr = 4
!!$
!!$c     define linear equidistant lag vector

  lag_unit = grid_min
  lag_unit_x = grid_minx
  lag_unit_y = grid_miny

  nlag = NINT(grid_max / lag_unit) / 2
  nlag_x = NINT(grid_maxx / lag_unit_x) / 2
  nlag_y = NINT(grid_maxy / lag_unit_y) / 2

  lag_tol = lag_unit * .5
  lag_tol_x = lag_unit_x * .5
  lag_tol_y = lag_unit_y * .5

!!$     get memory
  ALLOCATE (lag(nlag),gam(nlag),ngam(nlag),lag_x(nlag_x),gam_x(nlag_x),&
       ngam_x(nlag),lag_y(nlag_y),gam_y(nlag_y),ngam_y(nlag),mgam(nlag),&
       mgam_x(nlag_x),mgam_y(nlag_y),STAT=errnr)
  lag = 0D0
  ngam = 0
  ngam_x = 0
  ngam_y = 0
  mgam_x = 0D0
  mgam_y = 0D0
  lag_x = 0D0
  lag_y = 0D0
  gam = 0D0
  gam_x = 0D0
  gam_y = 0D0
  IF (errnr/=0) THEN
     fetxt = 'Allocation problem in bvariogram'
     WRITE (*,'(/a/)')TRIM(fetxt)
     errnr = 97
     RETURN
  END IF

  ngam_x = 0;ngam_y = 0;ngam = 0
  gam_x = 0.;gam_y = 0.;gam = 0.

!!$! gets the current variogram function parameters
  CALL get_vario(Ix,Iy,fetxt,0) 
!!$  ! now prepare title string of gnuplot plot
  WRITE (mti,'(2(a,F3.1))')'Correlation lengths ax=',Ix,', ay=',Iy
!!$     for postscript 
  tg = '{/Symbol g}'
  WRITE (tgam,'(a)')tg//'(h)='//TRIM(fetxt) 
  IF (ltri == 15) THEN ! only meaningful for stochastical regu..
     CALL get_vario(Ix,Iy,fetxt,1) ! gets teh 
!!$   for postscript
     WRITE (tcov,'(a)')'C(h)='//TRIM(fetxt)
  END IF
!!$  compute synthetic variogram model
  par_vari = 1.
  DO i=1,nlag
     lag(i) = i*lag_unit
     h = lag(i)
     WRITE (tmgam,'(a)')tg//'(h)'
     mgam(i) = mvario(h,h,par_vari)
  END DO
!!$  anisotrop
  DO i=1,nlag_x
     lag_x(i) = i*lag_unit_x
     h = lag_x(i)
     WRITE (tmgam_x,'(a)')tg//'(hx)'
     mgam_x(i) = mvario(h,0D0,par_vari)
  END DO
  DO i=1,nlag_y
     lag_y(i) = i*lag_unit_y
     h = lag_y(i)
     WRITE (tmgam_y,'(a)')tg//'(hy)'
     mgam_y(i) = mvario(0D0,h,par_vari)
  END DO

  mid_par = SUM(LOG10(DBLE(sigma))) / manz
  mid_par = SUM(LOG10(DBLE(sigma))) / manz

  par_vari=0d0
  csensmax = MAXVAL(csens)

!!$  Experimentelles semi-variogram
  DO i=1,elanz

     IF (lverb) WRITE (*,'(a,t70,F6.2,A)',ADVANCE='no')&
          ACHAR(13)//'Variogram/',REAL(i*(100./elanz)),'%'

     tail = LOG10(DBLE(sigma(i))) ! lin val

     par_vari = par_vari + (tail - mid_par)**2d0


     DO j=1,elanz

        IF (i==j) CYCLE
        
        tail = tail / csens(j) / csensmax

        head = LOG10(DBLE(sigma(j))) / csens(j) / csensmax

        hx = ABS(espx(i) - espx(j))
!!!$ direction ?
        hy = ABS(espy(i) - espy(j))

        h = SQRT(hx**2d0 + hy**2d0)

        th = (tail - head)**2d0

        DO ik = 1,nlag
!!$  lag - lag_tol < h < lag + lag_tol
           IF (ABS(lag(ik) - h) < lag_tol) THEN
              ngam(ik) = ngam(ik) + 1
              gam(ik) = gam(ik) + th
           END IF
        END DO
!!$  anisotrop lag vector y-dir
        IF (hx < lag_tol_x) THEN
           DO ik = 1,nlag_y
              IF (ABS(lag_y(ik) - hy) < lag_tol_y) THEN
                 ngam_y(ik) = ngam_y(ik) + 1
                 gam_y(ik) = gam_y(ik) + th
              END IF
           END DO
        END IF
!!$  anisotrop lag vec x-dir
        IF (hy < lag_tol_y) THEN
           DO ik = 1,nlag_x
              IF (ABS(lag_x(ik) - hx) < lag_tol_x) THEN
                 ngam_x(ik) = ngam_x(ik) + 1
                 gam_x(ik) = gam_x(ik) + th
              END IF
           END DO
        END IF

     END DO                 ! inner loop j=1,elanz
  END DO                    ! outer loop i=1,elanz

  DO i=1,nlag
     IF (ngam(i)>0) &
          gam(i) = gam(i) / ngam(i) / 2d0
  END DO
  DO i=1,nlag_x
     IF (ngam_x(i)>0) &
          gam_x(i) = gam_x(i) / ngam_x(i) / 2d0
  END DO
  DO i=1,nlag_y
     IF (ngam_y(i) > 0) &
          gam_y(i) = gam_y(i) / ngam_y(i) / 2d0
  END DO

!!$   sets parameter variance..
  par_vari = MAX(par_vari / manz,1.d-5)
  WRITE (*,'(2(a,G10.3,1x))')ACHAR(13)//'Conductivity Mean=',mid_par,&
       'Variance=',par_vari
  WRITE (*,'(3(a,G10.3,1x))')'Min=',MINVAL(REAL(sigma)),'Max=',&
       MAXVAL(REAL(sigma)),'DLOG',LOG10(MAXVAL(REAL(sigma))/&
       MINVAL(REAL(sigma)))

  mgam = par_vari * mgam ! or we put it normalized to the sill ?
  mgam_x = par_vari * mgam_x
  mgam_y = par_vari * mgam_y

1 FORMAT(3(G10.3,3X),I10)
2 FORMAT(a,I10,a,F10.3)

  CALL get_unit(ifp)
  OPEN (ifp,FILE='inv.variogram_s_x',STATUS='replace',ERR=999)
  WRITE (ifp,2)'#   lag(x-dir)'//ACHAR(9)//&
       'anisotrop exp. semivariogram    model ##',nlag_x,&
       ' / parameter variance ',par_vari
  DO i=1,nlag_x
     WRITE (ifp,1,ERR=999)lag_x(i),gam_x(i),mgam_x(i),ngam_x(i)
  END DO
  CLOSE (ifp)
  OPEN (ifp,FILE='inv.variogram_s_y',STATUS='replace',ERR=999)
  WRITE (ifp,2)'#   lag(y-dir)'//ACHAR(9)//&
       'anisotrop exp. semivariogram   model ##',nlag_y,&
       ' / parameter variance ',par_vari
  DO i=1,nlag_y
     WRITE (ifp,1,ERR=999)lag_y(i),gam_y(i),mgam_y(i),ngam_y(i)
  END DO
  CLOSE (ifp)
  OPEN (ifp,FILE='inv.variogram_s',STATUS='replace',ERR=999)
  WRITE (ifp,2)'#   lag(h)'//ACHAR(9)//&
       'exp. semivariogram     model ## ',nlag,&
       ' / parameter variance ',par_vari
  DO i=1,nlag
     WRITE (ifp,1,ERR=999)lag(i),gam(i),mgam(i),ngam(i)
  END DO
  CLOSE (ifp)

  OPEN (ifp,FILE='variogram_s.gnu',STATUS='replace',ERR=999)
  WRITE (ifp,'(a)')'set st da l'
  WRITE (ifp,'(a)')'set grid'
  WRITE (ifp,'(a)')"set out 'variogram_ss.ps'"
  WRITE (ifp,'(a)')'set term pos col enh 20'
  WRITE (ifp,'(a)')'set pointsize 1.2'
  WRITE (ifp,'(a)')'set key bot right Left samplen .3'
  IF (ltri == 15) THEN ! only meaningful for stochastical regu..
     WRITE (ifp,'(a)')'set tit "'//TRIM(mti)//'\n'//&
          TRIM(tgam)//'\n'//TRIM(tcov)//'"'
  ELSE
     WRITE (ifp,'(a)')'set tit "'//TRIM(mti)//'\n'//&
          TRIM(tgam)//'"'
  END IF
  WRITE (ifp,'(a)')"set xlab offset 0,0.5 'Lag h/[m]'"
  WRITE (ifp,'(a,2(F10.2,a))')'set xrange [',grid_min,':',&
       grid_max/2.,']'
  WRITE (ifp,'(a)')"set ylab offset 2,0 'sv(h)=1/2N(h)"//&
       " {/Symbol S}_i(Z(m_i)-Z(m_i+h))^2, {/Symbol g}(h) /[SI]'"
  WRITE (ifp,'(a,F10.3,a)')"plot"//&
       "'inv.variogram_s' u 1:2 w p lc 1 pt 7 ti 'sv(h)',"//&
       "'inv.variogram_s' u 1:3 w l lc 1 lw 4 ti '"//TRIM(tmgam)//&
       "','inv.variogram_s_x' u 1:2 w p lc 2 pt 7 ti 'sv(hx)',"//&
       "'inv.variogram_s_x' u 1:3 w l lc 2 lw 4 ti '"//TRIM(tmgam_x)//&
       "','inv.variogram_s_y' u 1:2 w p lc 3 pt 7 ti 'sv(hy)',"//&
       "'inv.variogram_s_y' u 1:3 w l lc 3 lw 4 ti '"//TRIM(tmgam_y)//&
       "',",par_vari," w l lc 0 lw 4 lt 2 ti 'Variance (va)'"
  CLOSE (ifp)
  
  par_vari = 10**par_vari

  fetxt = ''
!!$  CALL SYSTEM('which gnuplot > tmp.gnuplot')
!!$  OPEN (ifp,FILE='tmp.gnuplot',STATUS='old',ERR=999)
!!$  READ (ifp,'(a)',ERR=100)fetxt
!!$  CLOSE (ifp)
!!$  my_buff = TRIM(ADJUSTL(fetxt))//' < variogram_s.gnu >& /dev/null'
!!$  IF (fetxt /= '') CALL SYSTEM (TRIM(my_buff))
  
  DEALLOCATE (gam_x,gam_y,gam)
  DEALLOCATE (ngam_x,ngam_y,ngam)
  DEALLOCATE (lag,lag_x,lag_y)

  errnr = 0
999 RETURN

END SUBROUTINE bvariogram_s

subroutine wdatm(kanal,datei)

!!!$     Unterprogramm zum Schreiben der Strom- und Spannungs- bzw.
!!!$     scheinbaren Widerstandswerte sowie der Elektrodenkennungen
!!!$     in 'datei'.

!!!$     Andreas Kemna                                            22-Oct-1993
!!!$     Letzte Aenderung   10-Mar-2007

!!!$.....................................................................

  USE datmod
  USE errmod

  IMPLICIT none


!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Kanalnummer
  INTEGER (KIND=4) ::   kanal

!!!$     Datei
  CHARACTER (80)   ::  datei

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Indexvariable
  INTEGER (KIND=4) ::    i

!!!$     Pi
  REAL(KIND(0D0))  ::    pi

!!!$     Hilfsvariablen
  REAL(KIND(0D0))  ::   bet,pha,npi
  INTEGER (KIND=4) ::    ie1,ie2
!!!$     Standartabweichung.-..
  REAL(KIND(0D0))  ::    stab
!!!$.....................................................................

!100 FORMAT(2(4X,I8),2(1x,G14.7))
  pi = dacos(-1d0)

!!!$     'datei' oeffnen
  fetxt = datei
  errnr = 1
  open(kanal,file=TRIM(fetxt),status='replace',err=999)
  errnr = 4

!!!$     Anzahl der Messwerte schreiben
  write(kanal,*,err=1000) nanz

!!!$     Stromelektrodennummern, Spannungselektrodennummern und scheinbare
!!!$     Widerstandswerte (Betrag und Phase (in mrad)) schreiben
  stab=5.0
  do i=1,nanz
     bet = cdabs(sigmaa(i))
     pha = datan2(dimag(sigmaa(i)),dble(sigmaa(i)))

!!!$     ak
!!!$     Ggf. Polaritaet vertauschen
     npi = dnint(pha/pi)*pi
     if (dabs(npi).gt.1d-12) then
        pha    = pha-npi
        ie1    = mod(vnr(i),10000)
        ie2    = (vnr(i)-ie1)/10000
        vnr(i) = ie1*10000+ie2
     end if

!!!$  write(kanal,*,err=1000)
!!!$  1                  strnr(i),vnr(i),real(bet),real(1d3*pha)
     write(kanal,*,err=1000)strnr(i),vnr(i),real(bet),real(1d3*pha)
!!!$     1                  strnr(i),vnr(i),real(bet),real(1d3*pha),
!!!$     1                  real(kfak(i))
  end do

!!!$     'datei' schliessen
  close(kanal)

  errnr = 0
  return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

999 return

1000 close(kanal)
  return

end subroutine wdatm

!!$ $Id: make_noise.f90 1.4 2008/07/29 14:05:36 Roland Martin Exp $
MODULE Make_noise
!!$---------------------------------------------------------------------
!!$  make_noise.f90
!!$
!!$  Contains subroutines and functions to generate ensembles of
!!$  random numbers which should be portable (e.g. Press, et al. 1998)
!!$  the distributions are of popular algorithms
!!$
!!$---------------------------------------------------------------------
  IMPLICIT none

  ! PRIVATE
  ! SAVE

  PUBLIC :: get_noisemodel
  PUBLIC :: write_noisemodel
  PUBLIC :: Random_Init
  PUBLIC :: Random_Gauss
  PUBLIC :: Random_Exponential
  PUBLIC :: Random_Breitwigner
  PRIVATE :: Random_Draw
  PRIVATE :: Random_Double
  PRIVATE :: Random_Int

  INTEGER(KIND = 4),public :: f2py_fix
!!$ now the most important variables..
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: N_RND=97
  ! number of pseudo random numbers
  REAL(KIND(0D0)),SAVE,DIMENSION(N_RND),PRIVATE :: Rnd
  !  pseudo random ensemble
  INTEGER(KIND = 4),SAVE,PRIVATE :: ix1,ix2,ix3
  ! huge numbers which are stored and altered thoroughly
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: M1=259200
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: M2=134456
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: M3=243000
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: IA1=7141
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: IA2=8121
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: IA3=4561
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: IC1=54773
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: IC2=28441
  INTEGER(KIND = 4),PARAMETER,PRIVATE:: IC3=51349
  ! a bunch of magic numbers...
  REAL(KIND(0D0)),PARAMETER,PRIVATE:: RM1=1./M1
  REAL(KIND(0D0)),PARAMETER,PRIVATE:: RM2=1./M2
!!!$ character container..
  CHARACTER (128),PRIVATE :: csz
  CONTAINS
!!$---------------------------------------------------------------------
!!$ Try to get a noise model from the File crt.noisemod
!!$ and fills the parameters for the noise model
!!$---------------------------------------------------------------------

    SUBROUTINE get_noisemodel(iseed,wa,w0,pa1,pb,pa2,p0,ierr)
!!!$ Integer seed
      INTEGER ( KIND = 4 ),INTENT(INOUT) :: iseed
!!!$ widerstand noise model output parameters
      REAL(KIND(0D0)),INTENT(INOUT)      :: wa,w0
!!!$ phase noise model: dp=pa1*R^pb+pa2*p+p0'
      REAL(KIND(0D0)),INTENT(INOUT)      :: pa1,pb,pa2,p0
      CHARACTER (80) :: buff
      INTEGER        :: ifp,ierr,myseed
      LOGICAL        :: exi
      ierr = 1
      CALL get_unit(ifp)
      buff = 'crt.noisemod'
      INQUIRE (FILE=TRIM(buff),EXIST=exi)

      IF (exi) THEN
         PRINT*,'reading NOISE model '//TRIM(buff)
         CALL get_unit(ifp)
         OPEN(ifp,FILE=TRIM(buff),STATUS='old')
         csz = 'Seed ('//TRIM(buff)//')'
         READ (ifp,*,ERR=99) myseed
         iseed = myseed
         GOTO 100
99       WRITE (*,*)'old crt.noisemode, assuming iseed=',iseed
         BACKSPACE(ifp)
100      csz = 'Relative error resistance [%]('//TRIM(buff)//')'
         READ (ifp,*) wa
         WRITE (*,*)TRIM(csz)//':',wa
         csz = 'Absolute errior resistance [Ohm m] ('//TRIM(buff)//')'
         READ (ifp,*) w0
         WRITE (*,*)TRIM(csz)//':',w0
         csz = 'Phase error parameter A1 [mRad/Ohm/m]('//TRIM(buff)//')'
         READ (ifp,*) pa1
         WRITE (*,*)TRIM(csz)//':',pa1
         csz = 'Phase error parameter B1 []('//TRIM(buff)//')'
         READ (ifp,*) pb
         WRITE (*,*)TRIM(csz)//':',pb
         csz = 'Relative phase error A2 [%]('//TRIM(buff)//')'
         READ (ifp,*) pa2
         WRITE (*,*)TRIM(csz)//':',pa2
         csz = 'Absolute phase error p0 [mRad] ('//TRIM(buff)//')'
         READ (ifp,*) p0
         WRITE (*,*)TRIM(csz)//':',p0
         CLOSE (ifp)
      ELSE
         pb = wa ; iseed = 1 ! defaults
         PRINT*,'Taking standard deviation',wa
         w0 = 0.;pb = 0.; pa2 = 0.;p0 = 0.
      END IF
      IF (iseed < 0 ) THEN
         PRINT*,'seed < 0!!'
         RETURN
      ELSE IF (wa < 0.) THEN
         PRINT*,'A < 0!!'
         RETURN
      ELSE IF (w0 < 0.) THEN
         PRINT*,'B < 0!!'
         RETURN
      ELSE IF (pa1 < 0.) THEN
         PRINT*,'A1 < 0!!'
         RETURN
      ELSE IF (pb < 0.) THEN
         PRINT*,'B1 < 0!!'
         RETURN
      ELSE IF (pa2 < 0.) THEN
         PRINT*,'A2 < 0!!'
         RETURN
      ELSE IF (p0 < 0.) THEN
         PRINT*,'p0 < 0!!'
         RETURN
      END IF

      ierr = 0

    END SUBROUTINE get_noisemodel
!!!$--------------------------------------------------------------------
!!!$ write out the current noise model into crt.noisemod
!!!$ old data would be overwritten, but with the old data
!!!$--------------------------------------------------------------------

    SUBROUTINE write_noisemodel(iseed,wa,w0,pa1,pb,pa2,p0,ierr)
!!!$ Ensemble seed
      INTEGER ( KIND = 4 ),INTENT(IN) :: iseed
!!!$ widerstand noise model output parameters
      REAL(KIND(0D0)),INTENT(IN)   :: wa,w0
!!!$ phase noise model: dp=pa1*R^pb+pa2*p+p0'
      REAL(KIND(0D0)),INTENT(IN)   :: pa1,pb,pa2,p0
      INTEGER        :: ifp,ierr
3     FORMAT(G10.3,t15,'#',1X,A)
4     FORMAT(I7,t15,'#',1X,A)


      ierr = 1

      CALL get_unit(ifp)

      csz = 'crt.noisemod'
      OPEN(ifp,FILE=TRIM(csz),STATUS='replace')
      csz = 'Ensemble seed'
      WRITE (ifp,4) iseed,TRIM(csz)
      csz = 'Relative error resistance A (noise) [%] von dR=AR+B'
      WRITE (ifp,3) wa,TRIM(csz)
      csz = 'Absolute errior resistance B (noise) [Ohm m]'
      WRITE (ifp,3) w0,TRIM(csz)
      csz = 'Phase error parameter A1 (noise) [mRad/Ohm/m] von'//&
           ' dp=A1*R^B1+A2*p+p0'
      WRITE (ifp,3) pa1,TRIM(csz)
      csz = 'Phase error parameter B1 (noise) []'
      WRITE (ifp,3) pb,TRIM(csz)
      csz = 'Relative phase error A2 (noise) [%]'
      WRITE (ifp,3) pa2,TRIM(csz)
      csz = 'Absolute phase error p0 (noise) [mRad]'
      WRITE (ifp,3) p0,TRIM(csz)
      CLOSE (ifp)

      ierr = 0
    END SUBROUTINE write_noisemodel
!!$---------------------------------------------------------------------
!!$ initialize portable pseudo random numbers
!!$ (set the pseudo random numbers)
!!$
    SUBROUTINE Random_Init(iseed)
      INTEGER ( KIND = 4 ),OPTIONAL :: iseed
      INTEGER ( KIND = 4 ) :: i

      IF (.NOT.PRESENT(iseed)) iseed = 1 !default seed

      ix1=MOD(IC1+iseed,M1)
      ix1=MOD(IA1*ix1+IC1,M1)
      ix2=MOD(ix1,M2)
      ix1=MOD(IA1*ix1+ic1,M1)
      ix3=MOD(ix1,M3)
      DO i=1,N_RND
         ix1=MOD(IA1*ix1+IC1,M1)
         ix2=MOD(IA2*ix2+IC2,M2)
         Rnd(i)=(DBLE(ix1)+DBLE(ix2)*RM2)*RM1
      END DO
    END SUBROUTINE Random_Init
!!$---------------------------------------------------------------------
!!$ Draw a random number from the pseudo random sequence
!!$
    REAL (KIND(0D0)) FUNCTION Random_Draw()
      INTEGER ( KIND = 4 ) :: i

      DO
         ix1=MOD(IA1*ix1+IC1,M1)
         ix2=MOD(IA2*ix2+IC2,M2)
         ix3=MOD(IA3*ix3+IC3,M3)
         i=1+(N_RND*ix3)/M3
         IF (i>N_RND.OR.i<1) CYCLE
         Random_Draw=Rnd(i)
         Rnd(i)=(DBLE(ix1)+DBLE(ix2)*RM2)*RM1
         EXIT
      END DO
    END FUNCTION Random_Draw
!!$---------------------------------------------------------------------
!!$ Flat (uniform) distribution
!!$ Returns a uniformly distributed random real number between
!!$ [min,max]
    REAL (KIND (0D0)) FUNCTION Random_Double(min, max)
      REAL (KIND (0D0)), INTENT(IN), OPTIONAL :: min, max
      REAL (KIND (0D0)) :: x

      x = Random_Draw()

      IF(PRESENT(min) .AND. PRESENT(max)) THEN
         Random_Double = min + ABS(max-min)*x
      ELSE
         Random_Double = x
     END IF

   END FUNCTION Random_Double
!!$---------------------------------------------------------------------
!!$ Integer (uniform) distribution
!!$ Returns a uniformly distributed random integer number between
!!$ [min,max]
   INTEGER FUNCTION Random_Int(min, max)
   INTEGER, INTENT(IN), OPTIONAL :: min, max
   REAL (KIND (0D0)) :: x

     x = Random_Draw()

     IF(PRESENT(min) .AND. PRESENT(max)) THEN
        Random_Int = min + INT(max*x)
     ELSE
        Random_Int = INT(100*x)
     END IF

   END FUNCTION Random_Int
!!$---------------------------------------------------------------------
!!$ Gaussian Distribution
!!$ Returns a normally distributed deviate with mean and sigma
!!$ The routine uses the Box-Muller transformation of uniform
!!$ deviates.
   REAL (KIND (0D0)) FUNCTION Random_Gauss(mean, sigma)
   INTEGER, INTENT(IN), OPTIONAL :: mean, sigma
   REAL (KIND (0D0)) :: x, y, z

     DO
        x = 2.0 * Random_Double() - 1.0
        y = 2.0 * Random_Double() - 1.0
        z = x * x + y * y
        if( z <= 1.0 ) exit
     END DO

     IF(PRESENT(mean) .AND. PRESENT(sigma)) THEN
        Random_Gauss = mean + sigma * x * sqrt(-2.0 * log(z) / z)
     ELSE
        Random_Gauss = x * sqrt(-2.0 * log(z) / z)
     END IF

   END FUNCTION Random_Gauss
!!$---------------------------------------------------------------------
!!$ Exponential (decay) distribution
!!$ Returns a random number between times t1 and t2
!!$ according to f(t) = exp (-t/tau)
   REAL (KIND (0D0)) FUNCTION Random_Exponential(tau, tmin, tmax)
   REAL (KIND (0D0)), INTENT(IN) :: tau
   REAL (KIND (0D0)), INTENT(IN), OPTIONAL :: tmin, tmax
   REAL (KIND (0D0)) :: r1, r2

     IF(PRESENT(tmin) .AND. PRESENT(tmax)) THEN
        r1 =  exp(-tmin/tau)
        r2 =  exp(-tmax/tau)
     ELSE
        r1 = 1.0
        r2 = 0.0
     END IF

     Random_Exponential = -tau*log(r2 + Random_Double() * (r1-r2) )

   END FUNCTION Random_Exponential
!!$---------------------------------------------------------------------
!!$ Breit-Wigner Distribution
!!$ Returns a random number from a Breit-Wigner distribution
!!$ for center mean Full Width Half Maximum fwhm
!!$
   REAL (KIND (0D0)) FUNCTION Random_BreitWigner(mean, fwhm)
   REAL (KIND (0D0)), INTENT(IN), OPTIONAL :: mean, fwhm
   REAL (KIND (0D0)) :: x, y, z

     DO
        x = 2.0 * Random_Double() - 1.0
        y = 2.0 * Random_Double() - 1.0
        z = x*x + y*y
        if( z <= 1.0 ) exit
     END DO

     IF(PRESENT(mean) .AND. PRESENT(fwhm)) THEN
        Random_BreitWigner = mean + 0.5*fwhm*x/y
     ELSE
        Random_BreitWigner = 0.5*x/y
     END IF

   END FUNCTION Random_BreitWigner

 END MODULE Make_noise

SUBROUTINE get_error(ftext,errnr,errflag,intext)

  INTEGER,INTENT (IN) :: errnr,errflag
  CHARACTER(80),INTENT (IN) :: intext
  CHARACTER(256),INTENT (OUT) :: ftext

  INCLUDE 'crerror.h'
  
  ftext=TRIM(ADJUSTL(fetxt(errnr)))//' '//TRIM(intext)
  
  
END SUBROUTINE get_error

!> \file kompadc.f90
!> \brief compilation of the stiffness matrix S and the right-hand-side source vector b in DC case
!> \details The stiffness matrix S is compiled from the form functions (see <I>elem1, elem3, elem8</I>) and the conductivity of the individual cells according to (Kemna, 2000, pp. 52):
!> \f[ S = \sum_{j=1}^{N_e} \sigma_j \left( S_{1j}+ k^2 S_{2j} \right) + \sum_{j=1}^{N_b} \beta_j S_{3j} \f]
!> The matrix is stored in band format, the matrix elements \f$ S_{mn} \f$ are assigned to the band matrix (a vector of length ((bandwidth+1)*nr_nodes)) via
!> \f[ S_{mn} \rightarrow S_{band}(max(m,n)*bandwidth + min(m,n)) \f]

subroutine kompadc(nelec,ki,a_komp,b_komp)

!     Unterprogramm zur Kompilation der FE-Matrix 'adc' in Bandform
!     (vorgegebene Bandbreite 'mb') und des Konstantenvektors 'bdc'
!     ( A * x + b = 0 ).

!     Andreas Kemna                                            17-Dec-1993
!     Letzte Aenderung   16-Jul-2007

!.....................................................................

  USE alloci
  USE femmod
  USE sigmamod
  USE electrmod
  USE elemmod
  USE wavenmod
  USE errmod

  IMPLICIT none


!.....................................................................

!     EIN-/AUSGABEPARAMETER:
  REAL (KIND (0D0)),DIMENSION((mb + 1)*sanz) ::     a_komp
  REAL (KIND (0D0)),DIMENSION(sanz) ::     b_komp

!     Aktuelle Elektrodennummer
  INTEGER (KIND = 4) ::     nelec

!     Aktueller Wellenzahlindex
  INTEGER (KIND = 4) ::     ki

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Aktuelle Elementnummer
  INTEGER (KIND = 4) ::     iel

!     Aktuelle Randelementnummer
  INTEGER (KIND = 4) ::     rel

!     Aktueller Elementtyp
  INTEGER (KIND = 4) ::     ntyp

!     Anzahl der Knoten im aktuellen Elementtyp
  INTEGER (KIND = 4) ::     nkel

!     Hilfsvariablen
  REAL (KIND (0D0)) ::     dum
  REAL (KIND (0D0)) ::     dum2
  INTEGER (KIND = 4) ::     im,imax,imin
  INTEGER (KIND = 4) ::     nzp,nnp,idif,ikl

!     Indexvariablen
  INTEGER (KIND = 4) ::     i,j,k,l

!.....................................................................

!     Gesamtsteifigkeitsmatrix und Konstantenvektor auf Null setzen
  im = (mb+1)*sanz

  a_komp = 0D0
  b_komp = 0D0

  iel = 0

  do i=1,typanz
     ntyp = typ(i)
     nkel = selanz(i)

     do j=1,nelanz(i)
        iel = iel + 1
        ikl = 0

        if (ntyp.gt.11) CYCLE

        do k=1,nkel
           nzp = nrel(iel,k)

           do l=1,k
              nnp  = nrel(iel,l)
              idif = iabs(nzp-nnp)

!     Ggf. Fehlermeldung
              if (idif.gt.mb) then

                 fetxt = ' '
                 errnr = 19
                 goto 1000

              else

!     Aufbau der Gesamtsteifigkeitsmatrix und ggf. des Konstantenvektors
                 ikl = ikl + 1

                 imax = max0(nzp,nnp)
                 imin = min0(nzp,nnp)
                 im   = imax*mb + imin

                 if (ntyp.eq.11) then
                    rel  = iel - elanz
                    dum  = relbg(rel,ikl) * kg(rel,nelec,ki)
! << RM
                    dum2 = DBLE(sigma(rnr(rel)))
!!$                    dum2 = DBLE(sigma0)
!!$                    dum2 = 0d0 ! which removes the influence
                 else
                    dum  = elbg(iel,ikl,ki)
                    dum2 = DBLE(sigma(iel))
                 end if

! GRIDBUG was causing some problems here
! sigma index can be overaccessed due to some segementation
! issue which will cause undefined sigma access..
! FIXED this with grid consisitency check during read in

                 a_komp(im) = a_komp(im) + dum * dum2

! << RM

                 if (lsr) then
                    dum2   = dum * DBLE(dum2 - sigma0)
                    b_komp(nzp) = b_komp(nzp) + dum2 * dble(pota(nnp))
                    if (nnp.ne.nzp) b_komp(nnp) = b_komp(nnp) + dum2 * &
                         dble(pota(nzp))
                 end if

              end if

           end do ! l=1,k
        end do ! k=1,nkel
     END do ! j=1,nelanz(i)
  end do ! i=1,typanz
  
!     Ggf. Konstantenvektor belegen
  if (.not.lsr) b_komp(enr(nelec)) = -1d0

!     akc BAW-Tank
!     ak        b_komp(211) = 1d0
!     akc Model EGS2003
!     ak        b_komp(1683) = 1d0
!     akc Lysimeter hor_elem\normal
!     ak        b_komp(129) = 1d0
!     akc Lysimeter hor_elem\fine
!     ak        b_komp(497) = 1d0
!     akc Simple Tucson Model
!     ak        b_komp(431) = 1d0
!     akc TU Berlin Mesokosmos
!     ak        b_komp(201) = 1d0
!     akc Andy
!     ak        b_komp(2508) = 1d0
!     akc Sandra (ele?_anom)
!     ak        b_komp(497) = 1d0

  if (lsink) b_komp(nsink) = 1d0

  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 return

end subroutine kompadc

!> \file rwaven.f90
!> \brief determine wave numbers
!> \details Kemna (2000) Appendix C: The procedure used to evaluate the inverse Fourier integral \f[ \phi_i = \frac{1}{\pi} \int_0^\infty \tilde \phi_i(k)dk. \f] is based on the approach of LaBreque et al. (1996a). Since the asymptotic behavior of the transformed potential \f$\tilde \phi (k)\f$ for small and large arguments is different, the integral is split into two parts to which, respectively, adequate numerical integration techniques are then applied, i.e.,
!> \f[\int_0^\infty \tilde \phi_i(k)dk = \int_0^{k_0} \tilde \phi_i(k)dk + \int_{k_0}^\infty \tilde \phi_i(k)dk, \f]
!> with some characteristic wavenumber \f$ k_0 \f$.
!> According to the analytic solution of the 2D Helmholtz equation,
!> \f[ \tilde \phi_p = \frac{I}{2 \pi \sigma_0} \left( K-= (kr_-) + K_0 (kr_+) \right) ,\f] 
!> the (primary) transformed potential is proportional to the modified Bessel function \f$ K_0(u) \f$, with \f$ u= kr\f$. Here, \f$ r\f$ denotes the representative radial distance from the (image) source. The corresponding asymptotic behavior is given by (Abramowitz and Stegun, 1984)
!> \f[\begin{array}{cc} u \rightarrow 0 : & K_0(u) \propto -\ln u, \\ u \rightarrow \infty : & K_0 \propto e^{-u} / \sqrt{u}  \end{array}\f]
!> To overcome the singularity in the integrand at zero, the change of variable \f$ k' = (k/k_0)^{1/2}\f$ is made in the first integral of the right-hand side of the first equation. The resulting nonsingular integral, with integrand \f$ g(k') = 2 k_0 k' \tilde \phi (k) \f$, is evaluated by conventional \f$N_g-\f$point Gaussian quadrature (Press et al., 1992), yielding appropriate abscissa \f$k'_n\f$ with corresponding weights \f$ w'_n \f$. Summing up both steps, it is
!> \f[ \int_0^{k_0} \tilde \phi_i(k)dk = \int_0^1 g(k')dk' = \sum_{n=1}^{N_G} w'_n g(k'_n) = \pi \sum_{n=1}^{N_G} w_n \tilde \phi (k_n)\f]
!> where \f$ k_n = k_0 k^{'2}_0 \f$ and \f$ w_n = 2 k_0 k'_n w'_n / \pi \f$.
!> From the relations in the 3rd equation, it is seen that the behavior of \f$ \tilde\phi(k) \f$ for large arguments is characterized by an exponential decrease. Therefore, the upper integration in the 2nd equation is performed using a \f$N_L-\f$point Laguerre-type formula (Press et al., 1992). Analogous to the 4th equation, one finds
!> \f[ \int_{k_0}^\infty \tilde \phi(k) dk = \int_0^\infty e^{-k'} g(k') dk' = \sum_{n=1}^{N_L} w'_n g(k'_n) = \pi \sum_{n=1}^{N_L} w_n \tilde \phi (k_n) \f]
!> with the rescaled abscissa and weights, respectively, \f$ k_n = k_0 (k'_n +1) \f$ and \f$ w_n = k_0 e^{k'_n} w'_n /\pi \f$. Note that in the last equation, after substitution of \f$ k' = k/k_0 -1 \f$, the new function \f$ g(k') = k_0 e^{k'} \tilde \phi (k) \f$ is temporarily defined.
!> The integration bound \f$ k_0 \f$ has to be specified in relation to the spatial scale of the considered problem. A characteristic quantity in this regard is given by the minimum distance between corresponding transmitting and receiving electrodes within the underlying set of measurement configurations, denoted by \f$ r_{min} \f$. The number of employed abscissa in the integration formulas determines the valid range of the integration in terms of the distance from the source. From a numerical analysis for a homogeneous half-space, it was found that the variable choice
!> \f[ N_G = \int \left( 6 \log (r_{max}/r_{min}) \right) \f]
!> together with \f$ N_L = 4 \f$ and \f$ k_0 = 1/(2r_{min}) \f$, guarantees an error of less than 0.5 % in the inverse Fourier integration for distances ranging from \f$ r_{min}\f$ to \f$r_{max}\f$ (see Figure C.1). Herein,  denotes the maximum distance between source and receiver electrodes as being of interest within the survey.
!> @author Andreas Kemna 
!> @date 10/11/1993

subroutine rwaven()
    ! Unterprogramm zur Berechnung der Wellenzahlwerte.

    USE datmod
    USE electrmod
    USE elemmod
    USE wavenmod
    USE errmod

    IMPLICIT none


    ! PROGRAMMINTERNE PARAMETER:

    ! Indexvariablen
    INTEGER (KIND=4) ::  i,j

    ! Elektrodennummern
    INTEGER (KIND=4) ::     elec(4)

    ! Hilfsvariablen
    INTEGER (KIND=4) ::     ganz,lanz
    REAL (KIND(0D0)) ::    kwn0,dum,xke(4),yke(4),x21,y21

    !.....................................................................

    ! 'amin', 'amax' bestimmen
    amin = 1d9
    amax = 0d0

    do i=1,nanz

        ! Stromelektroden bestimmen
        elec(1) = mod(strnr(i),10000)
        elec(2) = (strnr(i)-elec(1))/10000

        ! Messelektroden bestimmen
        elec(3) = mod(vnr(i),10000)
        elec(4) = (vnr(i)-elec(3))/10000

        ! Abstaende bestimmen
        do j=1,4
            if (elec(j).gt.0) xke(j) = sx(snr(enr(elec(j))))
            if (elec(j).gt.0) yke(j) = sy(snr(enr(elec(j))))
        end do

        if (elec(3).gt.0) then
            do j=1,2
                if (elec(j).gt.0) then
                    x21  = xke(3)-xke(j)
                    y21  = yke(3)-yke(j)
                    dum  = dsqrt(x21*x21+y21*y21)
                    amin = dmin1(dum,amin)
                    amax = dmax1(dum,amax)
                end if
            end do
        end if

        if (elec(4).gt.0) then
            do j=1,2
                if (elec(j).gt.0) then
                    x21  = xke(4)-xke(j)
                    y21  = yke(4)-yke(j)
                    dum  = dsqrt(x21*x21+y21*y21)
                    amin = dmin1(dum,amin)
                    amax = dmax1(dum,amax)
                end if
            end do
        end if
    end do

    ! Ggf. Fehlermeldung
    if (amin.lt.1d-12.or.amax.lt.1d-12) then
        WRITE (fetxt,*)'check for duplicate electrodes'
        errnr = 73
        goto 1000
    end if

    ! Wellenzahlen bestimmen
    ! AK Diss p. 163
    lanz   = 4
    ! ak  ganz   = int(real(6d0*dlog10(amax)))
    ! Number of abcissas for Gauss-Legende-Integration (AK Diss p. 163)
    ganz   = int(real(6d0*dlog10(amax/amin)))
    ! Need at least 2 abcissas
    ganz   = max0(ganz,2)
    ganz   = min0(ganz,30 - lanz)
    ! Overall k number
    kwnanz = ganz+lanz
    ! k_0, AK Diss p. 163
    kwn0   = 1d0/(2d0*amin)

    ALLOCATE (kwn(kwnanz),kwnwi(kwnanz),stat=errnr)
    IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation kwn'
        errnr = 94
        RETURN
    END IF

    ! REMEMBER: We only compute the k values and the weighting factors
    ! here. No actual integration is done here as we still need to caluclate 
    ! the potentials for the k-values.

    ! Gauss-Integeration
    ! Variable substitution in order to overcome the singularity at zero
    ! k' = (k / k_0)^{1/2}
    ! Integration range changes from (0, k_0) to (0, 1)
    call gauleg(0d0,1d0,kwn(1),kwnwi(1),ganz)

    ! See Ak-Diss(2000), p. 161
    ! weighting factor also needs substitution: w_n = 2 k_0 k'_n w'_n / pi
    ! The pi vanishes when evaluating the whole integral -> no need to use it
    ! anywhere.
    ! k_n = k_0 k'_n^2
    do i=1,ganz
        kwnwi(i) = 2d0*kwn0*kwnwi(i)*kwn(i)
        kwn(i)   = kwn0*kwn(i)*kwn(i)
    end do

    ! Laguerre-Integration
    ! Compute abcissas and weights for the numerical integration
    ! of the upper integral (see AK Diss, p. 161ff.)
    ! the alpha = 0d0 value removes the exp function in the
    ! Gauss-Laguere formula (Numerical recipies, p. 144, 1992)
    call gaulag(kwn(ganz+1),kwnwi(ganz+1),lanz,0d0)

    do i=ganz+1,ganz+lanz
        kwnwi(i) = kwn0*kwnwi(i)*dexp(kwn(i))
        kwn(i)   = kwn0*(kwn(i)+1d0)
    end do

    ! debug output: wavenumbers
    ! print *, ""
    ! print *, "amin/amax", amin, amax
    ! print*, "Number of wavenumbers", kwnanz
    ! print *, "wavenumber    weight"
    ! do i=1,kwnanz
    !     PRINT*, kwn(i), kwnwi(i)
    ! end do

    errnr = 0
    return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 return

end subroutine rwaven

!> \file precal.f90
!> \brief pre-compute element contributions
!>
!> \details This module computes the element contributions of all element types in a <I> bare </I> structure. When used to compile the FE stiffness matrix, the corresponding conductivities and wavenumbers are applied. When referring to Schwarz (1991) or Kemna (1995, 2000), these bare contributions are named form functions. More information on form functions of specific element types can be found in:
!> - elem3.f90:  triangular area element 
!> - elem8.f90:  quadrilateral (rectangle) area element
!> - elem11.f90: mixed boundary element 
!> - elem12 doesn't exist because von Neumann boundary conditions don't contribute anything
!>
!> @author Andreas Kemna
!> @date 12/21/1995, last change 11/22/1998

subroutine precal()

    !!!$     Unterprogramm zur Berechnung der Element- und Randelementbeitraege
    !!!$     sowie der Konfigurationsfaktoren zur Berechnung der gemischten
    !!!$     Randbedingung.

    !!!$     Andreas Kemna                                            21-Dec-1995
    !!!$     Letzte Aenderung   22-Sep-1998

    !!!$.....................................................................

    USE femmod
    USE electrmod
    USE elemmod
    USE wavenmod
    USE errmod
    USE konvmod, ONLY : lsytop
    IMPLICIT none


    !!!$.....................................................................

    !!!$     PROGRAMMINTERNE PARAMETER:

    !!!$     Hilfsfunction
    REAL (KIND(0D0))  ::   beta

    !!!$     Aktuelle Elementnummer
    INTEGER (KIND=4)  ::    iel

    !!!$     Aktuelle Randelementnummer
    INTEGER (KIND=4)  ::     rel

    !!!$     Aktueller Elementtyp
    INTEGER (KIND=4)  ::     ntyp

    !!!$     Anzahl der Knoten im aktuellen Elementtyp
    INTEGER (KIND=4)  ::      nkel

    !!!$     Indexvariablen
    INTEGER (KIND=4)  ::  i,j,imn,m,n,l,k

    !!!$.....................................................................

    lbeta  = .false.
    lrandb = .false.
    iel    = 0

    ALLOCATE (xk(max_nr_element_nodes),yk(max_nr_element_nodes),elmas(max_nr_element_nodes,max_nr_element_nodes),&
        elmam(max_nr_element_nodes,max_nr_element_nodes),elve(max_nr_element_nodes),stat=errnr)
    IF (errnr /= 0) then
        fetxt = 'allocation problem elbg elmam'
        errnr = 97 
        GOTO 1000
    END IF
    ALLOCATE (elbg(elanz,(max_nr_element_nodes*(max_nr_element_nodes+1))/2,kwnanz),stat=errnr)
    IF (errnr /= 0) then
        fetxt = 'allocation problem elbg elbg'
        errnr = 97 
        GOTO 1000
    END IF
    ALLOCATE (relbg(relanz,(max_nr_element_nodes*(max_nr_element_nodes+1))/2),stat=errnr)
    ALLOCATE (kg(relanz,eanz,kwnanz),stat=errnr)
    IF (errnr /= 0) then
        fetxt = 'allocation problem elbg relbg or kg'
        errnr = 97 
        GOTO 1000
    END IF

    IF (lsytop) THEN
        CALL bsytop
    ELSE
        sytop = 0d0
    END IF

    ! loop over all element types
    do i=1,typanz
        ntyp = typ(i)
        nkel = selanz(i)

        ! loop over all elements of this type
        do j=1,nelanz(i)
            iel = iel + 1
            ! loop over each node of this element
            do m=1,nkel
                xk(m) = sx(snr(nrel(iel,m)))
                yk(m) = sy(snr(nrel(iel,m)))
            end do
            WRITE (fetxt,'(a,I7,2F10.2)')'Elementnr',iel
            !!!$     Randelement, linearer Ansatz
            ! Mixed boundaries
            if (ntyp.eq.11) then
                !!!$ Ggf. Fehlermeldung
                    if (lrandb) then
                        fetxt = ' '
                        errnr = 101
                        goto 1000
                    end if

                lbeta = .true.
                call elem1

                !!!$     Randelementbeitraege berechnen
                imn = 0
                rel = iel - elanz

                !!!$     Ggf. Fehlermeldung
                if (rel.le.0) then
                    fetxt = ' '
                    errnr = 36
                    goto 1000
                end if

                ! loop over each node in this element
                do m=1,nkel
                    do n=1,m
                        imn = imn + 1
                        relbg(rel,imn) = elmam(m,n)
                    end do
                end do

                !!!$     Konfigurationsfaktoren zur Berechnung der gemischten Randbedingung
                !!!$     berechnen
                ! loop over electrodes
                do l=1,eanz
                    ! loop over all wavenumbers
                    do k=1,kwnanz
                        kg(rel,l,k) = beta(l,k)
                        if (errnr.ne.0) goto 1000
                    end do
                end do

            else if (ntyp.eq.12) then
                ! Neumann no-flow boundary
                CYCLE

            else if (ntyp.eq.13) then
                ! Ggf. Fehlermeldung
                if (lbeta) then
                    fetxt = ' '
                    errnr = 101
                    goto 1000
                end if

                lrandb = .true.
                CYCLE

                !!!$     Zusammengesetztes Viereckelement
                !!!$     (vier Teildreiecke mit linearem Ansatz)
            else if (ntyp.eq.8) then

                do k=1,kwnanz
                    call elem8(elmas,elve,kwn(k),max_nr_element_nodes)
                    if (errnr.ne.0) goto 1000

                    !!!$     Elementbeitraege berechnen
                    imn = 0

                    do m=1,nkel
                        do n=1,m
                            imn = imn + 1
                            elbg(iel,imn,k) = elmas(m,n)
                        end do
                    end do
                end do
            else
                !!!$ Dreieckelement, linearer Ansatz
                if (ntyp.eq.3) then
                    call elem3
                    if (errnr.ne.0) goto 1000
                    !!!$     Parallelogrammelement, bilinearer Ansatz
                else if (ntyp.eq.5) then

                    call elem5
                    if (errnr.ne.0) goto 1000
                    !!!$  Fehlermeldung
                else
                    fetxt = ' '
                    errnr = 18
                    goto 1000
                end if

                !!!$ Elementbeitraege berechnen
                do k=1,kwnanz
                    imn = 0

                    do m=1,nkel
                        do n=1,m
                            imn = imn + 1
                            elbg(iel,imn,k) = elmas(m,n) + elmam(m,n)*kwn(k)*kwn(k)
                        end do
                    end do
                end do
            end if
        end do
    end do

    IF (ALLOCATED (xk)) DEALLOCATE (xk,yk,elmas,elmam,elve)

    errnr = 0

    return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

1000 return

end subroutine precal

!> \file relem.f90
!> \brief read model grid file
!> \details Read model grid file from filename. Involves node numbering information computed with the Cuthill-McKee algorithm.
!> @author Andreas Kemna 
!> @date 10/11/1993

SUBROUTINE relem(kanal,datei)

!     Unterprogramm zum Einlesen der FEM-Parameter aus 'datei'.

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   24-Oct-1996

!.....................................................................

  USE elemmod
  USE errmod
  USE konvmod

  IMPLICIT NONE


!.....................................................................

!     EIN-/AUSGABEPARAMETER:

!> unit number
  INTEGER (KIND = 4) ::    kanal

!> filename
  CHARACTER (80)     ::    datei

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariablen
  INTEGER (KIND =4)  ::    i,j,k

!     Hilfsvariable
  INTEGER (KIND =4)  ::    idum,ifln,iflnr
  LOGICAL            ::    my_check, failed(2)

! To check for border to element connection (rnr)
  INTEGER            :: ik1,ik2,jk1,jk2,ic,l

! NEW rnr
  INTEGER (KIND = 4),ALLOCATABLE,DIMENSION(:,:) :: my_nrel

!.....................................................................

!     'datei' oeffnen
  fetxt = datei

  errnr = 1
  OPEN(kanal,file=TRIM(fetxt),status='old',err=999)

  errnr = 3

!     Anzahl der Knoten (bzw. Knotenvariablen), Anzahl der Elementtypen
!     sowie Bandbreite der Gesamtsteifigkeitsmatrix einlesen
  READ(kanal,*,END=1001,err=1000) sanz,typanz,mb

!!$ now get some memory for the fields..
!!$ first the sanz fields
  ALLOCATE (sx(sanz),sy(sanz),snr(sanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation sx failed'
     errnr = 94
     GOTO 999
  END IF

  ALLOCATE (typ(typanz),nelanz(typanz),selanz(typanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation selanz failed'
     errnr = 94
     GOTO 999
  END IF

!     Elementtypen, Anzahl der Elemente eines bestimmten Typs sowie
!     Anzahl der Knoten in einem Elementtyp einlesen
  READ(kanal,*,END=1001,err=1000)(typ(i),nelanz(i),selanz(i),i=1,typanz)

!!$ set number of node points for regular elements
  max_nr_element_nodes = MAXVAL(selanz)

!     Anzahl der Elemente (ohne Randelemente) und Anzahl der Randelemente
!     bestimmen
  relanz = 0
  elanz  = 0

  my_check = .FALSE.

  DO i=1,typanz
     IF (typ(i).GT.10) THEN
        relanz = relanz + nelanz(i)
     ELSE
        elanz  = elanz  + nelanz(i)
     END IF
     my_check = my_check .OR. (typ(i) == 11)
  END DO

! if all no flow boundaries, we do not have to search for a 
! average sy top...
!!$  lsytop = .NOT. my_check

!!$ get memory for the element integer field      
  ALLOCATE (nrel(elanz+relanz,max_nr_element_nodes),my_nrel(elanz+relanz,max_nr_element_nodes),rnr(relanz),&
       stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation nrel,rnr failed'
     errnr = 94
     GOTO 999
  END IF
!!$ get memory for the regular element midpoint coordinates
  ALLOCATE (espx(elanz),espy(elanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation espx failed'
     errnr = 94
     GOTO 999
  END IF
  espx = 0.;espy = 0.
!     Zeiger auf Koordinaten, x-Koordinaten sowie y-Koordinaten der Knoten
!     einlesen
  READ(kanal,*,END=1001,err=1000) (snr(i),sx(i),sy(i),i=1,sanz)
!     Knotennummern der Elemente einlesen
  idum = 0;ifln = 0;iflnr = 0
  DO i=1,typanz
     DO j=1,nelanz(i)
        READ(kanal,*,END=1001,err=1000)(nrel(idum+j,k),k=1,selanz(i))

        IF (typ(i) < 10) THEN ! set midpoints of the parameters
! in correct numbering of j = 1, .... m

           ifln = ifln + 1

           DO k = 1,selanz(i)
              espx(ifln) = espx(ifln) + sx(snr(nrel(idum+j,k)))
              espy(ifln) = espy(ifln) + sy(snr(nrel(idum+j,k)))
           END DO

           espx(ifln) = espx(ifln) / selanz(i)
           espy(ifln) = espy(ifln) / selanz(i)

        END IF
     END DO
     idum = idum + nelanz(i)

  END DO
!     Zeiger auf Werte der Randelemente einlesen
  READ(kanal,*,END=1001,err=1000) (rnr(i),i=1,relanz)

! >> RM
! border lines have to be clock wise oriented to let the normal vector point
! outwards

! internal copy of element numberings
  my_nrel = nrel

  failed = .FALSE.

  WRITE (*,'(a)',ADVANCE='no')'++ check 1'
  ik1 = nrel(elanz + 1,1)
  ik2 = nrel(elanz + 1,2)
  ic = 1
  DO i=2,relanz
! consistency check of node ordering, assume ascending?

     jk1 = nrel(elanz + i,1)
     jk2 = nrel(elanz + i,2)
     IF (ik2 /= jk1) THEN
        failed(1) = .TRUE.
        ic = ic + 1
     END IF

     ik1 = jk1
     ik2 = jk2

  END DO

  IF (ic == relanz) THEN

     ! if consisntency check fails, reorder the stuff

     WRITE(*,'(/a/a/)',ADVANCE='no')'+++ WARNING: consistency check of border numbering failed ',&
          '-> swapping border-line-elements and writing it to '//TRIM(datei)//'_new'

     DO i=1,relanz
        
        my_nrel(elanz + i,1) = nrel(elanz + i,2)
        my_nrel(elanz + i,2) = nrel(elanz + i,1)
        
     END DO
  END IF
! << RM
  IF (failed(1)) print*,'-- failed'

! >> RM
! IF THIS IS NOT a pointer to the
! REGULAR ELEMENT adjacent to the border line
! THIS MAY CAUSE THE MIXED BOUNDARY TO BLOW UP

! TODO: 
! - independent of numbering order (plane b4 line elements)
! - CHECK where the BORDER ELE begin in nrel

  WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//'++ check 2'
  ic = 0
  DO i=1,relanz
! define the node points of the border-line
     ik1 = nrel(elanz + i,1)
     ik2 = nrel(elanz + i,2)

! now search for the corresponding element
! how to do so?
! suppose we have a ordered input file, where the
! big elements come first, than we might have something like
     DO k = 1,elanz
        jk1 = 0;jk2 = 0
        DO  l = 1, selanz(1) ! TODO : fix this for multi FE
! so, we set jk1 if the node of the element coincides
           IF (nrel(k,l) == ik1) jk1 = 1
! so, we set jk2 if the node of the lement coincides
           IF (nrel(k,l) == ik2) jk2 = 1
        END DO
! if both nodes are found, k is the only element possible
        IF (jk1 == 1 .AND. jk2 == 1.AND.rnr(i) /= k) THEN
           ic = ic + 1
           WRITE (*,'(a,I7,1x,a,I7)',ADVANCE='no')ACHAR(13)//&
                'wrong element to border connection: ',ic,'/',&
                relanz
           rnr(i) = k
           failed(2) = .TRUE.
        END IF
     END DO

  END DO
  IF (failed(2)) print*,'-- failed'

  ic = 0
  DO i=1,relanz
     IF (rnr(i) > elanz.OR.rnr(i) < 1) ic = ic + 1
  END DO

  IF (ic > 0) THEN
     PRINT*,'Kann nich sein'
     fetxt = 'border to element context is wrong'
     errnr = 111
     RETURN
  ELSE
     PRINT*,'done!'
  END IF

! << RM
!     'datei' schliessen
  CLOSE(kanal)

! >> RM
! write new grid if one of the checks failed
  IF (ANY(failed)) THEN

101  FORMAT (I9)
102  FORMAT (2(I9,1X))
103  FORMAT (3(I9,1X))
104  FORMAT (4(I9,1X))
105  FORMAT (I9,2(1X,G12.4))

     fetxt = TRIM(datei)//'_new'
     PRINT*,'+++ WRITING OUT IMPROVED GRID --> Writing',TRIM(fetxt)
     errnr = 1
     OPEN(kanal,file=TRIM(fetxt),status='replace')
     
     errnr = 3

!     Anzahl der Knoten (bzw. Knotenvariablen), Anzahl der Elementtypen
!     sowie Bandbreite der Gesamtsteifigkeitsmatrix einlesen
     WRITE(kanal,103) sanz,typanz,mb
     WRITE(kanal,103) (typ(i),nelanz(i),selanz(i),i=1,typanz)
     DO i=1,sanz
        WRITE(kanal,105) snr(i),sx(i),sy(i)
     END DO
!     STOP
!     Knotennummern der Elemente einlesen
     idum = 0;ifln = 0;iflnr = 0
     DO i=1,typanz
        DO j=1,nelanz(i)
           IF (typ(i) == 8)  THEN
              WRITE(kanal,104)(my_nrel(idum+j,k),k=1,selanz(i))
           ELSE IF (typ(i) == 4)  THEN
              WRITE(kanal,103)(my_nrel(idum+j,k),k=1,selanz(i))
           ELSE
              WRITE(kanal,102)(my_nrel(idum+j,k),k=1,selanz(i))
           END IF
        END DO

        idum = idum + nelanz(i)
        
     END DO
     
     WRITE(kanal,101) (rnr(i),i=1,relanz)

     CLOSE (kanal)

  END IF

  DEALLOCATE (my_nrel)
! << RM


  errnr = 0
  RETURN

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

999 RETURN

1000 CLOSE(kanal)
  RETURN

1001 CLOSE(kanal)
  errnr = 2
  RETURN

END SUBROUTINE relem

subroutine wsens(kanal,datei)

!!!$     Unterprogramm zum Schreiben der Sensitivitaeten aller Messungen.

!!!$     Andreas Kemna                                            20-Apr-1995
!!!$     Letzte Aenderung   10-Mar-2007

!!!$.....................................................................

  USE datmod
  USE alloci
  USE modelmod
  USE elemmod
  USE errmod

  IMPLICIT none


!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Kanalnummer
  INTEGER (KIND=4) ::       kanal

!!!$     Datei
  CHARACTER (80)   ::     datei

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Hilfsfunctions
  CHARACTER (12)   ::    intcha
  CHARACTER (80)   ::    filpat

!!!$     Hilfsvariablen
  INTEGER (KIND=4) ::     idum,idum2,lnanz
  CHARACTER (80)   ::    htxt
  CHARACTER (12)   ::    htxt2

  COMPLEX(KIND(0D0)) ::    summe
!!!$     Indexvariablen
  INTEGER (KIND=4) ::     i,j

!!!$     (Back-) Slash
  CHARACTER (1)   ::     slash

!!!$.....................................................................

!!!$     Slash
  slash = '/'

!!!$     'datei' modifizieren
  lnanz = int(log10(real(nanz)))+1
  htxt  = filpat(datei,idum2,1,slash(1:1))
  idum  = idum2+index(datei(idum2+1:80),'.')-1

!!!$     Ausgabeschleife
  do i=1,nanz

!!!$     'datei' bestimmen
     htxt2 = intcha(i,lnanz)
     htxt  = datei(1:idum)//htxt2(1:lnanz)//datei(idum+1:idum+4)

!!!$     'datei' oeffnen
     fetxt = htxt
     errnr = 1
     open(kanal,file=TRIM(fetxt),status='replace',err=999)
     errnr = 4

!!!$     Summe der Sensitivitaeten berechnen und ausgeben
!!!$     (Betrag und Phase (in mrad))
!!!$     ak            sensmax = 0d0
     summe   = dcmplx(0d0)

     do j=1,manz
!!!$     ak                sensmax = dmax1(sensmax,cdabs(sens(i,j)))
        summe   = summe + sens(i,j)
     end do

     if (cdabs(summe).gt.0d0) then
        write(kanal,*,err=1000) real(cdabs(summe)),&
             real(1d3*datan2(dimag(summe),dble(summe)))
     else
        write(kanal,*,err=1000) 0.,0.
     end if

!!!$     Koordinaten und Sensitivitaeten schreiben
!!!$     (Real- und Imaginaerteil)
     do j=1,manz
        write(kanal,*,err=1000)real(espx(j)),real(espy(j)),&
             real(dble(sens(i,j))),real(dimag(sens(i,j)))
     end do

!!!$     'datei' schliessen
     close(kanal)
  end do

  errnr = 0
  return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

999 return

1000 close(kanal)
  return

end subroutine wsens

!> \file beta.f90
!> \brief Mixed boundary element contributions
!>
!> \details Compute mixed boundary element contributions \f$ \beta \f$ to be used inside \n
!> \f[ \partial_x \left( \sigma \partial_x \tilde\phi \right) + 
!> \partial_z \left( \sigma \partial_z \tilde\phi \right) 
!> \sigma k^2 \tilde \phi + I \delta (x-x_s)\delta(z-zs) = 0 \f]
!> \f[ \sigma \partial_n \tilde \phi + \beta \tilde \phi =0 \f]
!> Kemna (2000): ERT surveys are generally conducted from both the earth`s surface and boreholes, defining a vertical 2D plane. The
!corresponding model geometry is characterized by homogeneous Neumann boundary conditions, i.e. \f$ \beta =0 \f$, at the surface (no
!current flow in the normal direction) and mixed boundary conditions, i.e. \f$ \beta \neq 0 \f$, at those boundaries confining the
!considered region within the half-space. In the following, these two types are referred to as <I>surface</I> and <I>half-space</I>
!boundaries, respectively.
!> 
!> Due to their much easier implementation, most early resistivity modeling algorithms impose homogeneous Dirichlet conditions in
!the half-space boundaries, i.e. \f$ \tilde \phi = 0 \f$ (corresponding to \f$ \beta =\inf \f$). This consequently requires the
!usage of large modeling grids, extending far to sides and depth from the actual region of interest, in order to keep related
!modeling errors at an acceptable level. However, here an approach first suggested by Dey and Morrison (1979) is used instead, where
!an adequate, finite value for  on the half-space boundaries is determined via the asymptotic behavior of the potential for a
!homogeneous half-space. Such a mixed (or asymptotic) boundary condition enables the usage of comparatively small grids and, thus,
!reduces the overall computational requirements for the modeling.
!> 
!> For a point source in a homogeneous half-space with complex conductivity \f$\sigma_0\f$, the analytic solution of the 2D Helmholtz equation (see above) in the source-free region is
!> \f[ \tilde \phi _p = \frac{I}{2\pi \sigma_0} \left( K_0 (kr_-) + K_0 (kr_+) \right) \f]
!> where \f$ K_0 \f$ denotes the modified Bessel function of order zero. The radial distances \f$ r_- \f$ and \f$r_+ \f$ from any point to the source and its image (in the case\f$ z_s \neq 0 \f$), respectively, are given by
!> \f[ r_- = \sqrt{(x-x_s)^2 + (z-z_s)^2}, r_+ = \sqrt{(x-x_s)^2 + (z+z_s)^2} \f]
!> Assuming now, in a first approximation, also for the inhomogeneous case \f$ \sigma(x,z) \f$ an asymptotic behavior of the transformed potential on the half-space boundaries according to
!> \f[ \| \tilde \phi \| \propto \left( K_0 (kr_-) + K_0 (kr_+) \right) \f],
!> an expression for the boundary parameter \f$ \beta \f$ can be easily derived using the derivative property of the modified Bessel function. It results
!> \f[ \beta = \sigma k g \f]
!> with the real factor
!> \f[ g = \frac{K_1 (kr_-) \partial_n r_- + K_1 (kr_+) \partial_n r_+ }{K_0 (kr_-) + K_0 (kr_+)} \f]
!> Here, \f$ K_1 \f$ is the modified Bessel function of first order.
!>
!> @author Andreas Kemna
!> @date 12/20/1993, last change 11/20/2009

REAL (KIND(0D0)) function beta(nelec,k)

    USE electrmod
    USE elemmod
    USE wavenmod
    USE errmod

    IMPLICIT none

    !> current electrode
    INTEGER (KIND = 4)  ::     nelec
    !> current wavenumber
    INTEGER (KIND = 4)  ::     k

    !!> internal parameters

    !!> radial distance source / mirror source
    REAL (KIND(0D0))    ::     r1m, r1p
    !!> Bessel function of 0th order
    REAL (KIND(0D0))    ::     bessk0
    !!> Bessel function of 1st order
    REAL (KIND(0D0))    ::     bessk1

    !!> helper variables
    REAL (KIND(0D0))    ::     cthetm,cthetp
    REAL (KIND(0D0))    ::     xs,ys,xr,yr,x3,y3m,y3p,&
        x4,y4,r2,bk0m,bk0p,bk1m,bk1p

    ! print *, 'xk', xk
    ! print *, 'yk', yk
    !!!$.....................................................................
    beta = 0D0
    !!!$ Koordinaten der Stromelektrode bestimmen
    xs = sx(snr(enr(nelec)))
    ys = sy(snr(enr(nelec)))
    ! print *, 'Stromelektrode'
    ! print *, xs
    ! print *, ys

    !!!$ Koordinaten des aktuellen Randelements bestimmen
    xr = (xk(1)+xk(2)) / 2d0
    yr = (yk(1)+yk(2)) / 2d0
    ! print *, 'xr', xr
    ! print *, 'yr', yr

    !!!$ Abstand Randelement - Quelle/Spiegelquelle bestimmen
    x3  = xr - xs
    y3m = (yr - sytop) - (ys - sytop)
    y3p = (yr - sytop) + (ys - sytop)

    r1m = dsqrt(x3*x3 + y3m*y3m)
    r1p = dsqrt(x3*x3 + y3p*y3p)

    !!!$     Hilfsvektor bestimmen
    x4 = yk(1) - yk(2)
    y4 = xk(2) - xk(1)

    r2 = dsqrt(x4*x4 + y4*y4)

    !!!$     Ggf. Fehlermeldung
    if (r1m.lt.1d-12.or.r1p.lt.1d-12.or.r2.lt.1d-12) then
        fetxt = ' '
        errnr = 35
        goto 1000
    end if

    !!!$ Kosinus von Theta bestimmen
    cthetm = (x3*x4 + y3m*y4) / r1m / r2
    cthetp = (x3*x4 + y3p*y4) / r1p / r2

    !!!$     'beta' bestimmen
    bk0m = bessk0(r1m*kwn(k))
    bk0p = bessk0(r1p*kwn(k))

    bk1m = bessk1(r1m*kwn(k))
    bk1p = bessk1(r1p*kwn(k))

    if (bk0m+bk0p.eq.0d0) then
        beta = (cthetm+cthetp) / 2d0
    else
        beta = (cthetm*bk1m+cthetp*bk1p) / (bk0m+bk0p)
    end if

    beta = kwn(k) * beta

    ! print *, "beta", beta
    ! stop

    errnr = 0
    return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

1000 return

end function beta

!> \file bsigm0.f90
!> \brief Set starting model \f$ \sigma_0 \f$
!> \details Set starting model for the inversion algorithm from
!> - \f$ m_0 \f$ if ldiff (absolute difference inversion)
!> - <I>rho.dat</I> (forward model file) if lstart 
!> - <I>bet0</I> and <I>pha0</I> if they were set in <I> rall </I> and lrho is true
!> - measured data via weighted sum of apparent conductivities if lbeta is true. lbeta can only be set to true in case of measurements with a horizontal surface; electrodes may nonetheless be placed below the surface. 
!> <I> bsigm0 </I> also computes the reference conductivity for the mixed boundaries in <I> refsig </I> (if lbeta is true).
!> @author Andreas Kemna
!> @date 05/02/1995, last change 01/15/2001

subroutine bsigm0(kanal,dstart)

!     Unterprogramm zum Belegen des Startmodells.

!     Andreas Kemna                                            02-May-1995
!     Letzte Aenderung   15-Jan-2001

!.....................................................................

  USE femmod
  USE datmod
  USE invmod
  USE sigmamod
  USE modelmod
  USE elemmod
  USE errmod
  USE konvmod

  IMPLICIT none


!.....................................................................

!     EIN-/AUSGABEPARAMETER:

!> file id
  INTEGER (KIND = 4)  ::  kanal

!> filename
  CHARACTER (80) ::   dstart

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariable
  INTEGER (KIND = 4)  ::   i

!     Hilfsvariablen
  INTEGER (KIND = 4)  ::   idat
  REAL (KIND(0D0))    ::   dum,dum2

!     Real-, Imaginaerteil
  REAL (KIND(0D0))    ::   redat,imdat

!     Pi
  REAL (KIND(0D0))    ::   pi

!.....................................................................

  pi = dacos(-1d0)

!     diff-        if (lstart) then
!     diff+<
  if (ldiff) then ! m0 was set within rall for this case 
!! (absolute difference inversion)
     do i=1,elanz
        sigma(i) = cdexp(m0(mnr(i)))
     end do
  else if (lstart) then
!     diff+>
!     'sigma' aus 'dstart' einlesen
     call rsigma(kanal,dstart)
     if (errnr.ne.0) goto 999

  else if (lrho0) then

!     'sigma' gemaess 'bet0', 'pha0' belegen
     do i=1,elanz
        sigma(i) = dcmplx( dcos(pha0/1d3)/bet0 , -dsin(pha0/1d3)/bet0 )
     end do

  else if (lbeta) then

!     Geometriefaktoren der Messungen bestimmen ("Standard-Geometrie")
     call bkfak()
     if (errnr.ne.0) goto 999

     sigma0 = dcmplx(0d0)
     dum    = 0d0

     do i=1,nanz
!     Phase lokal korrigieren
!     (entspricht hier "lpol=.true.", aber anders nicht moeglich)
        imdat = dimag(dat(i))

        if (imdat.gt.pi/2d0) then
           idat = -1
        else if (imdat.le.-pi/2d0) then
           idat = 1
        else
           idat = 0
        end if

        if (idat.ne.0) THEN
           imdat=imdat+dble(idat)*pi
           PRINT*,'swapping line',idat,i
        END if
        
!     Von "transfer resistance" auf scheinbaren Widerstand umrechnen
        redat = dble(dat(i))-dlog(dabs(kfak(i)))

!     Werte gewichtet mitteln
        dum2   = dsqrt(wmatd(i))*dble(wdfak(i))
        sigma0 = sigma0 + dcmplx(redat,imdat)*dcmplx(dum2)
        dum    = dum + dum2
!        print*,'Write:',REAL(DBLE(sigma0)),REAL(DBLE(dat(i))),REAL(redat),REAL(dum2)


     end do

!     Ggf. Fehlermeldung
     if (dabs(dum).eq.0d0) then
        fetxt = 'unable to find starting value sigma0'
        errnr = 99
        goto 999
     end if

!     'sigma' belegen
!     print*,'Write:',sigma0
     do i=1,elanz
        sigma(i) = cdexp(sigma0/dcmplx(dum))
     end do

  else

!     Fehlermeldung
     fetxt = ' '
     errnr = 100
     goto 999

  end if


!!$     Referenzleitfaehigkeit 'sigma0' bestimmen

! >> RM This is now a must have for mixed boundaries
  IF (lbeta) call refsig()
!! << RM because the sigma0 is needed
  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

999 return

end subroutine bsigm0

!> \file get_unit.f90
!> \brief returns a free <I>FORTRAN</I> unit number
!> @author John Burkhardt, Roland Martin
SUBROUTINE get_unit ( iunit )

  !     !$*****************************************************************************
  !
  ! GET_UNIT returns a free FORTRAN unit number.
  !
  !  Discussion:
  !
  !    A "free" FORTRAN unit number is an integer between 0 and 119 
  !    (on INTEL processors, 0 - 119 is a valid I/O number and 
  !    0 - 2**31-1 on ALPHA processors)
  !    which is not currently associated with an I/O device.  A free FORTRAN unit
  !    number is needed in order to open a file with the OPEN command.
  !
  !    If IUNIT = 0, then no free FORTRAN unit could be found, although
  !    all 99 units were checked (except for units 5, 6 and 9, which
  !    are commonly reserved for console I/O).
  !
  !    Otherwise, IUNIT is an integer between 0 and 119, representing a
  !    free FORTRAN unit.  Note that GET_UNIT assumes that units 5 and 6
  !    are special, and will never return those values.
  !
  !  Licensing:
  !
  !    This code is distributed under the GNU LGPL license. 
  !
  !  Modified:
  !
  !    06 December 2010
  !
  !  Author:
  !
  !    John Burkardt
  !
  !  Modifications (set I/O range to 0 - 119):
  !    Roland Martin
  !
  !  Parameters:
  !
  !    Output, integer ( kind = 4 ) IUNIT, the free unit number.
  !
  IMPLICIT NONE

  INTEGER ( kind = 4 ) :: i
  INTEGER ( kind = 4 ) :: ios
  INTEGER ( kind = 4 ) :: iunit
  LOGICAL              :: lopen

  iunit = 0

  DO i = 0, 119

     IF ( i /= 5 .AND. i /= 6 .AND. i /= 9 ) THEN

        INQUIRE ( unit = i, opened = lopen, iostat = ios )

        IF ( ios == 0 ) THEN
           IF ( .NOT. lopen ) THEN
              iunit = i
              RETURN
           END IF
        END IF

     END IF

  END DO

END SUBROUTINE get_unit

SUBROUTINE read_comments (unit)
  INTEGER,INTENT (IN)   :: unit
  INTEGER               :: ios
  CHARACTER (256)       :: buff

  READ ( unit , '(a)' , ERR = 11 , END = 10 , IOSTAT = ios ) buff
  
!  PRINT * , TRIM( buff), ios
  buff = ADJUSTL(buff) ! remove leading spaces

  IF ( buff (1:1) /= '#' .OR. buff == '' .OR. ios /= 0 ) THEN
! The case ios /= 0 was the solution to buffer underrun errors
! This lead to curious line readings..
     BACKSPACE ( unit )

  ELSE

     DO WHILE ( buff (1:1) == '#' .AND..NOT. ios /= 0 ) ! lines with comment 
        
        READ ( unit , '(a)' , ERR = 11 , END = 10 , IOSTAT = ios ) buff

!        PRINT * , TRIM ( buff )

     END DO

     BACKSPACE ( unit )

  END IF

10 RETURN

11 PRINT * , 'read_comment error::' , buff

END SUBROUTINE read_comments

!> \file get_git_ver.f90
!> \brief get the <I>git </I> version info from the file <I>my_git_version.h</I> 
!> \details the file is automatically created at the first compile time.
!> @author Roland Martin
!> @date <I> unknown </I>

MODULE get_ver

  IMPLICIT none

  CHARACTER (256),PUBLIC  ::   version(5)

  PUBLIC :: get_git_ver
  
CONTAINS

  SUBROUTINE get_git_ver

  INCLUDE 'my_git_version.h'
  
  version(1)=TRIM(ADJUSTL(my_git_version(1)))
  version(2)=TRIM(ADJUSTL(my_git_version(2)))
  version(3)=TRIM(ADJUSTL(my_git_version(3)))
  version(4)=TRIM(ADJUSTL(my_git_version(4)))
  version(5)=TRIM(ADJUSTL(my_git_version(5)))
  
  PRINT*,'Git-Branch  ',TRIM(version(1))
  PRINT*,'Commit-ID   ',TRIM(version(2))
  PRINT*,'Created     ',TRIM(version(3))
  PRINT*,'Compiler    ',TRIM(version(4))
  PRINT*,'OS          ',TRIM(version(5))
  
END SUBROUTINE get_git_ver
END MODULE get_ver

SUBROUTINE SORT(N,RA)
  IMPLICIT none
  INTEGER :: L,N,IR,J,I
  REAL(KIND(0D0)),DIMENSION(N) :: RA
  REAL(KIND(0D0)) :: RRA
  L=N/2+1
  IR=N
10 CONTINUE
  IF(L.GT.1)THEN
     L=L-1
     RRA=RA(L)
  ELSE
     RRA=RA(IR)
     RA(IR)=RA(1)
     IR=IR-1
     IF(IR.EQ.1)THEN
        RA(1)=RRA
        RETURN
     ENDIF
  ENDIF
  I=L
  J=L+L
20 IF(J.LE.IR)THEN
     IF(J.LT.IR)THEN
        IF(RA(J).LT.RA(J+1))J=J+1
     ENDIF
     IF(RRA.LT.RA(J))THEN
        RA(I)=RA(J)
        I=J
        J=J+J
     ELSE
        J=IR+1
     ENDIF
     GO TO 20
  ENDIF
  RA(I)=RRA
  GO TO 10
END SUBROUTINE SORT

SUBROUTINE vredc(a_vre,b_vre,pot_vre)

!!!$     Fuehrt das Vorwaerts- und Rueckwaertseinsetzen mit der Cholesky-Links-
!!!$     dreiecksmatrix aus;
!!!$     'bdc' bleibt unveraendert, 'pot' ist Loesungsvektor.

!!!$     ( Vgl. Subroutine 'VRBNDN' in Schwarz (1991) )

!!!$     Andreas Kemna                                            11-Oct-1993
!!!$     Letzte Aenderung   14-Nov-1997

!!!$.....................................................................

  USE alloci
  USE femmod
  USE elemmod
  USE errmod

  IMPLICIT NONE


!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:
  REAL(KIND(0D0)),DIMENSION((mb+1)*sanz) :: a_vre
  REAL(KIND(0D0)),DIMENSION(sanz) :: b_vre
  COMPLEX(KIND(0D0)),DIMENSION(sanz) :: pot_vre

!!!$     Hilfsvariablen
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: potdc
  INTEGER (KIND=4)  :: idi,i0
  INTEGER (KIND=4)  :: m1,jlow
  REAL(KIND(0D0))   ::   s

!!!$     Indexvariablen
  INTEGER (KIND=4)  ::  i,j

!!!$.....................................................................

  ALLOCATE (potdc(sanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation potdc failed'
     errnr = 94
     RETURN
  END IF

  potdc = 0d0

  m1 = mb+1

  DO i=1,sanz
     idi  = i*m1
     s    = b_vre(i)
     i0   = idi-i
     jlow = max0(1,i-mb)

     DO j=jlow,i-1
        s = s - a_vre(i0+j)*potdc(j)
     END DO

     potdc(i) = s / a_vre(idi)
  END DO

  DO i=sanz,1,-1
     potdc(i) = - potdc(i) / a_vre(idi)

     jlow = max0(1,i - mb)
     i0   = idi - i

     DO j=jlow,i - 1
        potdc(j) = potdc(j) + a_vre(i0 + j) * potdc(i)
     END DO

     idi = idi - m1
  END DO

  pot_vre = dcmplx(potdc)

!!$  do i=1,sanz
!!$     pot_vre(i) = dcmplx(potdc(i))
!!$  end do

  DEALLOCATE (potdc)
END SUBROUTINE vredc

MODULE elemmod
!!$c 'elem.fin'
!!$
!!$c Andreas Kemna                                            24-Nov-1993
!!$c                                       Letzte Aenderung   20-Nov-2009
!!$         
!!$c.....................................................................

!!!$Anzahl der Knoten (bzw. Knotenvariablen)
  INTEGER(KIND = 4),PUBLIC                            :: sanz
!!!$Anzahl der Elementtypen
  INTEGER(KIND = 4),PUBLIC                            :: typanz
!!!$Bandbreite der Gesamtsteifigkeitsmatrix 'a'
  INTEGER(KIND = 4),PUBLIC                            ::  mb

!!!$Elementtypen
!!!$(Randelemente (ntyp > 10) am Schluss !)
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: typ

!!!$Anzahl der Elemente eines bestimmten Typs
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: nelanz

!!!$Anzahl der Knoten (bzw. Knotenvariablen) in einem Elementtyp
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: selanz

!!!$Zeiger auf Koordinaten der Knoten
!!!$(Inverser Permutationsvektor der Umnumerierung)
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: snr

!!!$x-Koordinaten der Knoten
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: sx

!!!$y-Koordinaten der Knoten
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: sy

!!!$ Elementschwerpunktkoordinaten (ESP) der Flaechenelemente
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: spx,spy

!!!$Knotennummern der Elemente (Reihenfolge !)
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:,:),ALLOCATABLE :: nrel

!!!$Anzahl der Elemente (ohne Randelemente)
  INTEGER(KIND = 4),PUBLIC                            :: elanz

!!!$Anzahl der Randelemente
  INTEGER(KIND = 4),PUBLIC                            :: relanz

!!!$Zeiger auf Werte der Randelemente
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: rnr

!!!$ Groeste Anzahl der Knoten der Flaechenelemente
  INTEGER(KIND = 4),PUBLIC                            :: smaxs

END MODULE elemmod

!> \file rall.f90
!> \brief Read all parameters for the inversion.
!> \details The file formats are as follows (comments after the vertical bar):
!>      - grid file (delem):
!>          \verbatim
!>      1209           3          49  | nr of nodes, nr of element types, bandwidth of FE matrix)
!>         8        1140           4  | element type description, nr of elements, nr of nodes per element:)
!>        12          30           2  | ... element 5: triangles, 8: quadrilaterals (e.g., rectangles!))
!>        11         106           2  | ...        11: mixed boundary, 12: von Neumann boundary )
!>         1      -5.000       0.000  | node nr, x value, z value
!>         2      -3.596       0.000  | ...
!>         3      -2.465       0.000  | ...
!>         :           :           :  | ... 1206 more
!>        50   51    2    1           | edge node numbers of first element of type 8 (rectangle)
!>        51   52    3    2           | counter-clockwise notation starting at bottom left
!>         :    :    :    :           | ... 1138 more
!>         2    1                     | edge node numbers of first element of type 12 (line boundary)
!>         :    :                     | ... 29 more
!>         1   50                     | edge node numbers of first element of type 11 (line boundary)
!>         :    :                     | ... 105 more
!>         1                          | boundary element numbers to build a closed surface
!>         :                          | ... 135 more
!>          \endverbatim
!>      - electrode file (delectr):
!>          \verbatim
!>         31    | total number of electrodes
!>        564    | node number of 1st electrodes
!>          :    | ... 30 more
!>          \endverbatim
!>       These are the nicely ordered version of the grid and electrode file. They can be transformed into the corresponding high speed versions with the <I> CutMcK </I> command.
!>      - measurement file (dstrom):
!>          \verbatim
!>          812                       | nr of measurements
!>        10002 40003   283.1  0.00   | encoded current electr, encoded volt electr,...
!>        10002 50004   61.42  0.00   | recorded voltages and phase.
!>        10002 60005   6.364  0.00   | encoding: C1*10000+C2 same with P1 P2
!>          \endverbatim
!>
!> @author Andreas Kemna
!> @date 03/01/1995, last change 08/20/2007

SUBROUTINE rall(kanal,delem,delectr,dstrom,drandb,&
     dsigma,dvolt,dsens,dstart,dd0,dm0,dfm0,lagain)

    !    Unterprogramm zum Einlesen der benoetigten Variablen.
    !    Andreas Kemna 01-Mar-1995
    !    Letzte Aenderung 20-Aug-2007
    !....................................................................

    USE make_noise
    USE variomodel
    USE femmod
    USE datmod
    USE invmod
    USE cjgmod
    USE sigmamod
    USE electrmod
    USE modelmod
    USE elemmod
    USE wavenmod
    USE randbmod
    USE errmod
    USE konvmod
    USE pathmod
    USE get_ver, ONLY:version

    IMPLICIT NONE

    ! EIN-/AUSGABEPARAMETER:

    !> FID number
    INTEGER (KIND = 4) ::     kanal

    !> grid file
    CHARACTER (80) :: delem

    !> electrodes file
    CHARACTER (80) :: delectr

    !> configurations file
    CHARACTER (80) :: dstrom

    !> complex resistivity model file
    CHARACTER (80) :: dsigma

    !> measurements file
    CHARACTER (80) :: dvolt

    !> sensitivities file
    CHARACTER (80) :: dsens

    !> starting model file
    CHARACTER (80) :: dstart
    CHARACTER (80) :: dd0
    CHARACTER (80) :: dm0
    CHARACTER (80) :: dfm0
    CHARACTER (80) :: drandb

    !> run another inversion?
    LOGICAL ::     lagain
    LOGICAL ::     lsto

    ! check whether the file format is crtomo konform or not..
    LOGICAL ::    crtf

    ! check whether a file exists..
    LOGICAL ::    exi

    ! decoupling.dat exists?
    ! LOGICAL ::    decexi
    !!! INTEGER(KIND = 4), DIMENSION(:, :),ALLOCATABLE :: edecoup
    !!! REAL(KIND(0D0)), DIMENSION(:),ALLOCATABLE :: edecstr
    !!! INTEGER (KIND = 4) ::  decanz

    !!!$.....................................................................

    !!!$     PROGRAMMINTERNE PARAMETER:

    !!!$     Indexvariable
    INTEGER (KIND = 4) ::     i

    !!!$     Pi
    REAL(KIND(0D0))   ::     pi

    !!!$     diff+<
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE   :: dum,dum2
    REAL(KIND(0D0))                            :: dum3
    INTEGER(KIND = 4),DIMENSION(:),ALLOCATABLE :: idum,ic,ip
    INTEGER (KIND = 4) ::  nanz0,j,j0
    !!!$     diff+>

    !!!$     ak Inga
    INTEGER (KIND = 4) ::  elec1,elec2,elec3,elec4
    !!!$.....................................................................

    pi = dacos(-1d0)

    !!!$     'crtomo.cfg' EINLESEN
    fetxt = 'crtomo.cfg'
    errnr = 3
    !!!$#################DEFAULTS ########################
    !!!$###  switches
    !!!$     ro        lsr    = .false.
    !!!$     ro        lpol   = .true.
    !!!$     ro        lfphai = .true.
    !!!$     ro        lrho0  = .false.
    !!!$     akERT2003
    !!!$     ak        ld!!!$    = .true.
    !!!$     ak        lsr    = .false.
    !!!$     ak        lpol   = .false.
    !!!$     Sonstiges
    !!!$     diff+<
    lsr    = .FALSE.
    lpol   = .FALSE.
    lindiv = .FALSE.
    !!!$     ak
    !!!$     'dstart'
    lstart = .FALSE.
    dstart = ' '
    !!!$     ak        lstart = .true.
    !!!$     ak        dstart = '..\..\strasbrg\9610\plane45\mod\rho0.dat'
    ltri   = 0
    lsto = .FALSE.            !default--
    !!!$     "Force negative phase" ?
    !!!$     sandra        lphi0 = .true.
    lphi0 = .FALSE.
    !!!$     ak        lphi0 = .false.
    !!!$     "ratio-dataset" ?
    lratio = .FALSE.
    !!!$     ak        lratio = .true.
    !!!$     final phase improvement setzt phase zueruck auf homogenes modell
    lffhom = .FALSE.
    !!!$     Daten Rauschen vom Fehlermodell entkoppeln ?
    lnse2 = .FALSE.
    !!!$     Regularisierung mit prior modell?
    lprior = .FALSE.
    !!!$######values..
    !!!$     FIXED PARAMETER
    !!!$     Slash

    !!!$ BETA MGS
    betamgs = 1d0
    WRITE (*,'(/a)',ADVANCE='no')'OS identification:'
    IF (INDEX ( version(5), 'Msys') /= 0) THEN
        PRINT*,' MS-OS'
        slash = '\'  !' \ is escape char for syntax highlights
    ELSE
        PRINT*,' Linux-OS'
        slash = '/'
    END IF

    !  CALL CALL get_environment_variable('DELIMITER',slash) ! seems a special C extension
    !!!$     Minimale "L1-ratio" (Grenze der "robust inversion")
    l1min = 1d0
    !!!$     ak        l1min = 1.2d0
    nrmsdm = 1d0
    !!!$     Art der Ruecktransformation
    !!!$     ak        swrtr = 1
    !!!$     Minimaler Quotient zweier aufeinanderfolgender Daten-RMS-Werte
    !!!$     ak Default
    !!!$     ak        mqrms = 1d-2
    !!!$     ak ERT 2002-2003 synth
    mqrms = 2d-2
    !!!$     ak        mqrms = 2d-2
    !!!$     ak Tank
    !!!$     ak        mqrms = 2d-2
    !!!$     ak MMAJ
    !!!$     ak        mqrms = 5d-2
    !!!$     CG-Epsilon
    eps = 1d-4
    !!!$     Mindest-step-length
    stpmin = 1d-3
    !!!$     Minimale stepsize (bdpar)
    bdmin = 1d-3
    !!!$     Regularisierungsparameter
    !!!$     ak Default
    nlam   = 30
    !!!$     ak Default
    fstart = 0.5d0
    fstop  = 0.9d0
    lamfix = 0.0D0
    llamf = 0
    !!!$     ak MMAJ
    !!!$     ak        fstart = 0.2d0
    !!!$     ak        fstop  = 0.8d0
    !!!$     ak Strasbrg/Werne/Grimberg
    !!!$     ak        fstart = 0.5d0
    !!!$     ak        fstop  = 0.8d0
    iseedpri = 0; modl_stdn = 0.; iseed = 1
    mswitch = 0
    !!!$#########################################################
    !!!$     Read in input values..

    fetxt = 'rall -> mswitch'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=98) mswitch

    98 fetxt = 'rall -> grid file'
    CALL read_comments(fpcfg)
    READ (fpcfg,'(a)',END=1001,err=999) delem
    CALL clear_string (delem)

    fetxt = 'rall -> electrode file'
    CALL read_comments(fpcfg)
    READ (fpcfg,'(a)',END=1001,err=999) delectr
    CALL clear_string (delectr)

    fetxt = 'rall -> meaurement file'
    CALL read_comments(fpcfg)
    READ (fpcfg,'(a)',END=1001,err=999) dstrom
    CALL clear_string (dstrom)

    fetxt = 'rall -> directory for inversion results'
    CALL read_comments(fpcfg)
    READ (fpcfg,'(a)',END=1001,err=999) ramd
    CALL clear_string (ramd)

    !!$! checks if dir exists and if not, create it
    !#if defined (__INTEL_COMPILER)
    !!$! check for the intel compiler..
    !#define macro_1  INQUIRE ( DIRECTORY=TRIM(ramd),EXIST= crtf)
    !#else
    !!$! other compilers go here
    !!$! here we may put #elif defined (__GFORTRAN__) as well
    !#define macro_1  INQUIRE ( FILE=TRIM(ramd),EXIST= crtf)
    !#endif
    ! ifort uses DIRECTORY for folders, so this is to be used than..
    ! INQUIRE ( DIRECTORY=TRIM(ramd),EXIST= crtf)

    !!$! workaround for compability issues with ifort..
    fetxt = TRIM(ramd)//slash//'tmp.check'
    crtf = .FALSE.
    !!$ test if you can open a file in the directory..
    OPEN (fprun,FILE=TRIM(fetxt),STATUS='replace',ERR=97)
    !!$ if you can, the directory exits and you can remove it safely
    CLOSE(fprun,STATUS='delete')
    !!$ set this switch to circumvent mkdir
    PRINT*,'writing inversion results into '//TRIM(ramd)
    crtf = .TRUE.
    97 IF (.NOT.crtf) THEN
        PRINT*,'Creating inversion directory '//TRIM(ramd)
        CALL SYSTEM ('mkdir "'//TRIM(ramd)//'"')
    END IF
    fetxt = 'rall -> Difference inversion ?'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) ldiff

    fetxt = 'rall -> Diff. measurements'
    CALL read_comments(fpcfg)
    ! read measurement data for time 0
    READ (fpcfg,'(a)',END=1001,err=999) dd0
    CALL clear_string (dd0)

    fetxt = 'rall -> Diff. model (prior)'
    CALL read_comments(fpcfg)
    ! read model time 0
    READ (fpcfg,'(a)',END=1001,err=999) dm0
    CALL clear_string (dm0)

    fetxt = 'rall -> Diff. model response of prior'
    CALL read_comments(fpcfg)
    ! read forward response of model
    READ (fpcfg,'(a)',END=1001,err=999) dfm0
    CALL clear_string (dfm0)

    IF (dm0 /= '') THEN
        INQUIRE(FILE=TRIM(dm0),EXIST=lstart) ! prior model ?
        IF (lstart) THEN       ! set the starting model
            dstart = dm0
            PRINT*,'+ read prior:',ACHAR(9)//TRIM(dm0)
        ELSE
            PRINT*,'- omit prior (NO FILE):',ACHAR(9)//TRIM(dm0)
            dm0 = ''
        END IF
    END IF
    IF (lstart.AND.ldiff.AND.((dd0 == ''.AND.dfm0 == ''))) THEN
        PRINT*,'Prior model regularization !'
        lprior = .TRUE.        ! reference model regu only if there is no
        ldiff = .FALSE.        ! time difference inversion
    END IF
    !!!$     diff+>
    fetxt = 'trying noise model seed'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=99) iseedpri,modl_stdn
    !     hier landet man nur, wenn man iseed und modl_stdn angenommen hat
    !      lnse2 = .NOT.lprior       ! kein prior?
    !     Daten Rauschen unabhängig vom Fehlermodell?
    lnsepri = lstart          ! if we have seed and std we assume to add noise to prior
    PRINT*,'Prior model noise !'
    99 fetxt = 'rall -> Gitter nx'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) nx
    fetxt = 'rall -> (lamfix) Gitter nz'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) nz
    fetxt = 'rall -> Anisotropie /x'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) alfx
    fetxt = 'rall -> Anistotropie /y'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) alfz

    fetxt = 'rall -> Maximale Iterationen'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) itmax
    !!!$     ak        READ (fpcfg,*,end=1001,err=999) nrmsdm

    fetxt = 'rall -> DC/IP Inversion'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) ldc
    !!!$     ak        READ (fpcfg,*,end=1001,err=999) lsr

    fetxt = 'rall -> Robuste Inversion'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) lrobust
    IF (lrobust) PRINT*,'## Robust inversion ##'
    !!!$     ak        READ (fpcfg,*,end=1001,err=999) lpol

    fetxt = 'rall -> Finale Phasen Inversion'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) lfphai
    !!!$     ak        READ (fpcfg,*,end=1001,err=999) lindiv

    fetxt = 'rall -> Relativer Fehler Widerstand'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) stabw0

    fetxt = 'rall -> Absoluter Fehler Widerstand'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) stabm0

    fetxt = 'rall -> Phasenfehlerparameter A1'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) stabpA1

    fetxt = 'rall -> Phasenfehlerparameter B'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) stabpB

    fetxt = 'rall -> Relative Fehler Phasen'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) stabpA2

    fetxt = 'rall -> Absoluter Fehler Phasen (mRad)'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) stabp0

    fetxt = 'rall -> Homogenes Startmodell?'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) lrho0

    fetxt = 'rall -> rho_0'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) bet0

    fetxt = 'rall -> phase_0'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) pha0

    fetxt = 'rall -> Noch eine Inversion'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) lagain

    fetxt = 'rall -> 2D oder 2.5D ?'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) swrtr

    fetxt = 'rall -> weitere Quelle?'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) lsink

    fetxt = 'rall -> Nummer der Quelle'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) nsink

    fetxt = 'rall -> Randbedingungen ?'
    CALL read_comments(fpcfg)
    READ (fpcfg,*,END=1001,err=999) lrandb2

    fetxt = 'rall -> Datei mit Randwerten'
    CALL read_comments(fpcfg)
    READ (fpcfg,'(a80)',END=1001,err=999) drandb

    fetxt = 'triangularization switch'
    CALL read_comments(fpcfg)
    READ (fpcfg,'(I2)',END=100,err=100) ltri

    IF (BTEST(ltri,5)) THEN
        llamf = 1
        fetxt = 'rall -> fixed lam value'
        CALL read_comments(fpcfg)
        READ (fpcfg,*,END=104,err=104) lamfix
        GOTO 105
        104  lamfix = 1.0           ! default value for MGS
        BACKSPACE(fpcfg)

        105  PRINT*,'Fixing Lambda =', lamfix
        ltri = ltri - 2**5

        IF (BTEST(ltri,6)) THEN
            llamf = llamf + 2
            PRINT*,'NEW:: COOLING lambdas during inv'
            ltri = ltri - 2**6
        END IF
    END IF

    IF (ltri > 15) THEN ! exception for wrong ltri switch
        PRINT*,'WARNING, fix lambda switch has changed'
        PRINT*,'check ltri value (>15):',ltri
        STOP
    END IF

    lsto = (ltri == 15)

    GOTO 101

    100 BACKSPACE (fpcfg)

    101 IF (lsto) THEN
        PRINT*,'Stochastische Regularisierung'
        !     eps = eps*1d-2
    END IF
    IF (ltri > 4 .AND. ltri < 15) THEN
        fetxt = 'rall -> beta value'
        CALL read_comments(fpcfg)
        READ (fpcfg,*,END=102,err=102) betamgs
        GOTO 103
        102  betamgs = 0.1          ! default value for MGS
        BACKSPACE (fpcfg)

        103  PRINT*,'Regularisation with support stabilizer beta =',betamgs
    END IF

    IF (itmax == 0) PRINT*,' ####### Only precalcs, itmax==0 ###########'

    !!!$     check if the final phase should start with homogenous model
    lffhom = (stabp0 < 0)
    IF (lffhom) stabp0 = -stabp0

    !!!$ check if there is crt.noisemod containig noise info
    fetxt = 'crt.noisemod'
    INQUIRE(FILE=TRIM(fetxt),EXIST=lnse2)

    lnse = ( stabw0 < 0 )     ! couple error and noise model
    IF (lnse) THEN
        stabw0 = -stabw0 ! reset standard deviation to positive val
        IF (lnse2) PRINT*,'overriding seperate noise model'
        lnse2 = .FALSE.        ! overrides the lnse2 switch
        !!!$     copy error model into noise model
        nstabw0 = stabw0
        nstabm0 = stabm0
        nstabpA1 = stabpA1
        nstabpA2 = stabpA2
        nstabp0 = stabp0

        fetxt = 'rall -> seed'

        CALL read_comments(fpcfg)
        READ (fpcfg,*,END=106,err=106) iseed
        GOTO 107
        106  iseed = 1              ! default value for PRS
        BACKSPACE(fpcfg)
        WRITE (*,'(a)')' Rauschen Gekoppelt an Fehlermodell '
    END IF

    107 IF (lnse2) THEN
        fetxt = 'get noise model from crt.noisemod'
        CALL get_noisemodel(iseed,nstabw0,nstabm0,nstabpA1,&
             nstabpB,nstabpA2,nstabp0,errnr)

        IF (errnr /= 0) GOTO 999

        WRITE (*,'(a,I7)',ADVANCE='no')&
              'Entkoppeltes Daten Rauschen:: seed:',iseed

        lnse = .TRUE.          ! add noise
    END IF

    IF (lnse) THEN
        fetxt = 'write out noise model'
        CALL write_noisemodel(iseed,nstabw0,nstabm0,&
            nstabpA1,nstabpB,nstabpA2,nstabp0,errnr)
        IF (errnr /= 0) GOTO 999
    END IF


    IF ((nx<=0.OR.nz<=0).AND.ltri==0) ltri=1 ! at least L1-smoothness

    !!!$     Ggf. Fehlermeldungen
    IF (ltri==0.AND.(nx.LT.2.OR.nz.LT.2)) THEN
        fetxt = ' '
        errnr = 89
        GOTO 999
        !!!$  else if (alfx.le.0d0.or.alfz.le.0d0) then
        !!!$  fetxt = ' '
    !!!$  errnr = 96
    !!!$  goto 999
    ELSE IF (itmax<0.OR.itmax.GE.100) THEN
        fetxt = ' '
        errnr = 61
        GOTO 999
    ELSE IF (nrmsdm.LT.1d-12) THEN
        fetxt = ' '
        errnr = 62
        GOTO 999
        !!!$     else if (nlam.lt.0) then
        !!!$     fetxt = ' '
        !!!$     errnr = 83
        !!!$     goto 999
        !!!$     else if (fstart.gt.1d0.or.fstop.gt.1d0.or.
        !!!$     1           fstart.le.0d0.or.fstop.le.0d0.or.
        !!!$     1           fstart.gt.fstop) then
        !!!$     fetxt = ' '
        !!!$     errnr = 98
        !!!$     goto 999
    ELSE IF (stabw0.LE.0d0.OR.stabm0.LT.0d0) THEN
        fetxt = ' '
        errnr = 104
        GOTO 999
    ELSE IF (.NOT.ldc.AND.lfphai.AND.&
        ((stabp0.LT.0d0.OR.stabpA2.LT.0d0).OR. &
        ((stabp0 == 0d0).AND.(stabpA2 == 0d0).AND.(stabpA1 == 0d0)))) THEN
        fetxt = ' '
        errnr = 105
        GOTO 999
    ELSE IF (lrho0.AND.(bet0.LE.0d0.OR.&
        (.NOT.ldc.AND.dabs(pha0).GT.1d3*pi))) THEN
        fetxt = ' '
        errnr = 91
        GOTO 999
        !!!$     else if (mqrms.lt.0d0.or.mqrms.ge.1d0) then
        !!!$     fetxt = ' '
        !!!$     errnr = 64
        !!!$     goto 999
        !!!$     else if (lrobust.and.l1min.lt.1d0) then
        !!!$     fetxt = ' '
        !!!$     errnr = 90
        !!!$     goto 999
    END IF

!!$ RM >>
!!!$ assign all the logical switches and settings for the inversion
  lelerr = .NOT.lfphai.AND..NOT.ldc ! complex inversion only

!!!$     (mswitch) Mega switch testing..
  lsens = BTEST(mswitch,0)  ! +1 ueberdeckung schreiben
  lcov1 = BTEST(mswitch,1)  ! +2 posterior modell covariance matrix 1
  lres  = BTEST(mswitch,2)  ! +4 rsolution matrix berechnen
  lcov2 = BTEST(mswitch,3)  ! +8 posterior modell covariance matrix 2

  lgauss = BTEST (mswitch,4) ! +16 solve ols with Gauss elemination

  lelerr = BTEST (mswitch,5).OR.lelerr ! +32 overwrites previous lelerr

  IF (lelerr) PRINT*,'## using complex error ellipses ##'

  lphi0 = BTEST (mswitch,7) ! +128 forcing negative phase

  lsytop = BTEST (mswitch,8) ! +256 disables sy top check of
  !     no flow boundary electrodes for enhanced beta calculation (bsytop).
  !     This is useful for including topographical effects and should be used

  lvario = BTEST (mswitch,9) ! +512 calculate variogram

  lverb = BTEST (mswitch,10) ! +1024 Verbose output CG, daten, bnchbar..

  lverb_dat = BTEST (mswitch,11) ! +2048 writing out full resolution, covariance and cm0

  IF (lverb) WRITE(*,'(/a/)')' #  ## VERBOSE ## #'

  lres = (lres.OR.lcov2)    ! compute mcm2 on top of resolution
  lcov1 = (lres.OR.lcov1)   ! compute resolution by taking mcm1
!!!$
  lsens = .TRUE.            ! default immer coverages schreiben..
!!!$
  IF (lratio) THEN
     lrho0  = .TRUE.
     lstart = .FALSE.
     lphi0  = .FALSE.
     lpol   = .FALSE.
  END IF
!!!$     diff-        if (lstart) lrho0=.false.

  IF (lstart.OR.ldiff) lrho0=.FALSE.
!!!$     ak
  IF (ldiff) THEN
     ldc  = .TRUE.
     lpol = .FALSE.
  END IF
!!!$     diff+>
!!!$     ak        if (ldc.or.stabp0.ge.stabw0) lfphai=.false.
  IF (ldc) lfphai=.FALSE.
!!!$ << RM

!!!$ append path string (saved in ramd) and prepare
!!!$ output file names
  lnramd = INDEX(ramd,' ')-1
  dsigma = ramd(1:lnramd)//slash(1:1)//'rho.dat'
  dvolt  = ramd(1:lnramd)//slash(1:1)//'volt.dat'
  dsens  = ramd(1:lnramd)//slash(1:1)//'coverage.mag'

!!!$     Elementeinteilung einlesen
  IF (lverb) WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//'reading grid'
  CALL relem(kanal,delem)
  IF (errnr.NE.0) GOTO 999

    !!! MW: read in decoupling
    INQUIRE(FILE=TRIM("decouplings.dat"),EXIST=decexi)
    IF (decexi) THEN
        WRITE(*,*) "Found decoupling file"

        OPEN(kanal, file=TRIM('decouplings.dat'),status='old')
        READ(kanal,*) decanz
        WRITE(*,*) "number of decouplings: ", decanz
        ALLOCATE (edecoup(decanz, 2),stat=errnr)
        ALLOCATE (edecstr(decanz),stat=errnr)
        DO j=1,decanz
            READ(kanal, *) edecoup(j, 1), edecoup(j, 2), edecstr(j)
            WRITE(*,*) "Input: ", edecoup(j, 1), edecoup(j, 2), edecstr(j)
        END DO

        CLOSE(kanal)
    ELSE
        decanz = 0
    END IF
    !!! decoupling end

    !!! MW: electrode capacitances
    INQUIRE(FILE=TRIM("electrode_capacitances.dat"), EXIST=elec_caps_file_exists)
    IF (elec_caps_file_exists) THEN
        WRITE(*,*) "Found electrode capacitances file"
        OPEN(kanal, file=TRIM('electrode_capacitances.dat'), status='old')
        READ(kanal,*) nr_elec_capacitances
        WRITE(*,*) "number of electrode capacitances: ", nr_elec_capacitances
        ALLOCATE (electrode_capacitances(nr_elec_capacitances), stat=errnr)
        DO j=1,nr_elec_capacitances
            READ(kanal, *) electrode_capacitances(j)
            WRITE(*,*) "Capacitance: ", j, electrode_capacitances(j)
        END DO
        CLOSE(kanal)
    ELSE
        nr_elec_capacitances = 0
    END IF
    !!! electrode capacitances end

  IF (ltri/=0) THEN
     manz = elanz           ! wichtig an dieser stelle..
     lvario = lvario.OR.lsto
  ELSE
!!!$     Modelleinteilung gemaess Elementeinteilung belegen
     manz = nx*nz           ! nur für strukturierte gitter
  END IF


  CALL bnachbar          ! blegt nachbar
  CALL besp_elem


  IF (lstart .OR. ldiff .OR. lprior) THEN
     ALLOCATE (m0(manz),stat=errnr)
     IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation m0'
        errnr = 94
        GOTO 999
     END IF
  END IF
!!$  lvario = lvario.OR. &       ! if already set or
!!$       (itmax == 0).AND.(lstart.OR.lprior) ! analyse any prior

  IF (lvario) CALL set_vario (nx,alfx,alfz,esp_mit,esp_med) ! nx is than
  !     the variogram and covariance function type, see variomodel.f90

  IF (manz.NE.elanz) THEN
     fetxt = 'manz /= elanz .. is not implemented yet'
     errnr = 50
     GOTO 999
  END IF
  !     !$ get memory for mnr..
  ALLOCATE (mnr(elanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation mnr failed'
     errnr = 94
     GOTO 999
  END IF
  !     !$ set mnr.. this may be altered if we have zonal approach..
  DO i=1,elanz
     mnr(i) = i
  END DO
  !     !$ all the model mapping is than beased on a new numbering..
  !     !$ zonal approach ?

!!!$     Maximale Anzahl an CG-steps setzen
!!!$     ak        ncgmax = manz
!!!$  ncgmax = manz / 2         ! useful for small scale model variations
  ncgmax = manz         ! useful for small scale model variations
  !     for normal smooth and damping we usually need fewer CG iterations;
  !     because the model variations are of bigger scale size
  IF (ltri < 5) ncgmax = ncgmax / 10
!!!$     Elektrodenverteilung und Daten einlesen sowie Wellenzahlwerte
!!!$     bestimmen

  CALL relectr(kanal,delectr)
  IF (errnr.NE.0) GOTO 999

  IF (lsink) THEN
     IF (nsink > sanz) THEN
        PRINT*,'Sink node > grid nodes'
        errnr = 3
        GOTO 999
     END IF
     WRITE(*,'(/A,I5,2F12.3/)')'Fictious sink @ node ',&
          nsink,sx(snr(nsink)),sy(snr(nsink))
!!!$         WRITE(fpinv,'(A,I5,2F12.3)')'Fictious sink @ node ',
!!!$     1        nsink,sx(snr(nsink)),sy(snr(nsink))
  END IF

  CALL rdati (kanal,dstrom)
  IF (errnr.NE.0) GOTO 999



!!$>> RM
  fetxt = 'crt.lamnull'
  INQUIRE(FILE=TRIM(fetxt),EXIST=exi)
  IF (exi) THEN
!!!$ Overwriting lamfix with crt.lamnull content
     WRITE (*,'(/a)')'overwriting lamfix with content of '//TRIM(fetxt)
     OPEN(kanal,FILE=TRIM(fetxt),ACCESS='sequential',STATUS='old')
     READ(kanal,*,END=1001,ERR=999)lamnull_cri
     PRINT*,'++ Lambda_0(CRI) = ',REAL(lamnull_cri)
     READ(kanal,*,END=30,ERR=30)lamnull_fpi
     PRINT*,'++ Lambda_0(FPI) = ',REAL(lamnull_fpi)
     GOTO 31
30   lamnull_fpi = 0d0
     IF (BTEST(llamf,0)) lamnull_fpi = lamfix ! in case of llamf we possibly
!!!$ do not want lam0 search at the beginning of FPI
31   CLOSE(kanal)
     PRINT*
  ELSE IF (BTEST(llamf,0)) THEN
     WRITE (*,'(/a,G12.4/)')'Presetting lamnull with lamfix ',REAL(lamfix)
     lamnull_cri = lamfix
     lamnull_fpi = lamfix
  ELSE IF (nz == -1) THEN
     lamnull_cri = DBLE(MAX(manz,nanz))
     WRITE (*,'(/a,G12.4/)')'+++ Lambda_0(CRI) =',REAL(lamnull_cri)
     lamnull_fpi = 0d0
  ELSE IF (nz < 0) THEN
     lamnull_cri = ABS(DBLE(nz))
     WRITE (*,'(/a,G12.4/)')'+++ Lambda_0(CRI) =',REAL(lamnull_cri)
     lamnull_fpi = 0d0
  ELSE
     WRITE (*,'(/a/)')'+++ Found no presettings for lambda_0 (default)'
     lamnull_cri = 0d0
     lamnull_fpi = 0d0
  END IF
  PRINT*,'Saving lamba presettings -> '//TRIM(fetxt)
  OPEN (kanal,FILE=TRIM(fetxt),ACCESS='sequential',STATUS='replace')
  WRITE (kanal,*)lamnull_cri
  WRITE (kanal,*)lamnull_fpi
  CLOSE (kanal)

!!$<< RM


  IF (ldc) THEN
     WRITE (*,'(/a/)')'++ (DC) Setting magnitude error'
     wmatd = wmatdr
  ELSE

     IF (lelerr) THEN
        WRITE (*,'(/a/)')'++ (CRI) Setting complex error ellipse'
        wmatd = wmatd_cri
     ELSE
        WRITE (*,'(/a/)')'++ (CRI) Setting complex error of magnitude'
        wmatd = wmatdr
     END IF
  END IF

  IF (swrtr.EQ.0) THEN
     lsr    = .FALSE.
     kwnanz = 1
     ALLOCATE (kwn(kwnanz),kwnwi(kwnanz),stat=errnr)
     IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation kwn'
        errnr = 94
        GOTO 999
     END IF
     kwn = 0d0; kwnwi = 0D0
     DO i=1,typanz
        IF (typ(i) == 11) THEN
           fetxt = 'in 2D keine gemischten RB'
           PRINT*,TRIM(fetxt)
           errnr = 110
           GOTO 999
        END IF
     END DO
     IF (.NOT.lrandb2) THEN
        WRITE (*,'(//a,t33,a)')'2D without Dirichlet nodes','setting k=1e-6'
        kwn = 1d-6  ! make sure A is still pos definite
     END IF
  ELSE
     CALL rwaven()
     IF (errnr.NE.0) GOTO 999
  END IF

!!!$     read boundary values
  IF (lrandb2) THEN
     CALL rrandb(kanal,drandb)
     IF (errnr.NE.0) GOTO 999
  END IF

    !!!$     diff+<
    IF (ldiff) THEN
        ALLOCATE (d0(nanz),fm0(nanz),stat=errnr)
        IF (errnr /= 0) THEN
            fetxt = 'Error memory allocation diff data '
            errnr = 94
            GOTO 999
        END IF
        OPEN(kanal,file=TRIM(dd0),status='old')
        READ(kanal,*) nanz0
        READ(kanal,*,err=999) elec1
        BACKSPACE(kanal)

        elec3=elec1-10000      ! are we still positive?
        ! testen, welches Format benutzt wird
        ! crtf == True  - benutze 10002 40003 Format für Elektrodenkennungen
        crtf=(elec3 > 0)       ! crtomo konform?

        ALLOCATE (dum(nanz0),dum2(nanz0),idum(nanz0),&
            ic(nanz0),ip(nanz0),stat=errnr)
        IF (errnr /= 0) THEN
            fetxt = 'Error memory allocation dum'
            errnr = 94
            GOTO 999
        END IF

        ! read time 0 data
        DO j=1,nanz0
            IF (crtf) THEN
                READ(kanal,*) ic(j),ip(j),dum(j)
            ELSE
                READ(kanal,*) elec1,elec2,elec3,elec4,dum(j)
                ic(j) = elec1*10000 + elec2
                ip(j) = elec3*10000 + elec4
            END IF
        END DO
        CLOSE(kanal)

        ! read forward response of time-0 model
        OPEN(kanal,file=TRIM(dfm0),status='old')
        READ(kanal,*)
        DO j=1,nanz0
            ! read current and voltage electrodes (ignored later on) as i,i
            ! read dum2 == magnitudes
            ! read idum == bool switch indicating invalid forward responses
            !      i.e. because of sign problems with R (remember: we do not
            !      switch any electrodes to correct signs)
            READ(kanal,*) i,i,dum2(j),idum(j)
        END DO
        CLOSE(kanal)

        !
        j0 = 0
        i  = 0
        10   i  = i+1
        j = j0
        20   j = j+1
        !
        IF (strnr(i).EQ.ic(j).AND.vnr(i).EQ.ip(j).AND.idum(j).EQ.1) THEN
            !!!$     nur falls jede Messkonfiguration nur einmal!
            !!!$     j0     = j
            d0(i)  = dcmplx(-dlog(dum(j)),0d0)
            fm0(i) = dcmplx(-dlog(dum2(j)),0d0)
        ELSE IF (j.LT.nanz0) THEN
            GOTO 20
        ELSE
            WRITE(fprun,'(i7,1x,i7,a12)',err=999)strnr(i),vnr(i),' : discarded'

            nanz = nanz-1
            DO j=i,nanz
                strnr(j) = strnr(j+1)
                vnr(j)   = vnr(j+1)
                dat(j)   = dat(j+1)
                wmatd(j) = wmatd(j+1)
                IF (lfphai) wmatdp(j)=wmatdp(j+1)
                !!!$     nicht notwendig, da Werte eh alle 1
                !!!$     wdfak(j) = wdfak(j+1)
            END DO
            i = i-1
        END IF
        IF (i.LT.nanz) GOTO 10

        ! read start model
        OPEN(kanal,file=TRIM(dm0),status='old')
        READ(kanal,*)
        DO j=1,elanz
            READ(kanal,*) dum3,dum3,dum3
            m0(mnr(j)) = dcmplx(-dlog(1d1)*dum3,0d0)
        END DO
        CLOSE(kanal)
        DEALLOCATE (dum,dum2,idum,ic,ip)
    END IF ! ldiff
    !!!$     diff+>

    errnr = 0

    RETURN

    !!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    !!!$     Fehlermeldungen

    999 RETURN

    1001 errnr = 2
        RETURN

END SUBROUTINE rall

subroutine wpot(datei,np,mypot)

!!!$     Unterprogramm zum Schreiben der Potentialwerte.

!!!$     Andreas Kemna                                            17-Dec-1993
!!!$     Letzte Aenderung   10-Mar-2007

!!!$.....................................................................

  USE femmod
  USE datmod
  USE elemmod
  USE errmod

  IMPLICIT none


!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Kanalnummer
  INTEGER (KIND=4) ::   kanal

!!!$     Datei
  CHARACTER (80)   ::    datei

!!!$     Nummer der Projektion
  INTEGER (KIND=4) ::     np

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Indexvariable
  INTEGER (KIND=4) ::      i

!!!$     Hilfsvariablen
  INTEGER (KIND=4) ::     idum,idum2,lnanz
  CHARACTER (80)   ::    htxt
  CHARACTER (12)   ::     htxt2

!!!$     Hilfsfunctions
  CHARACTER (12)   ::    intcha
  CHARACTER (80)   ::    filpat

!!!$     (Back-) Slash
  CHARACTER (1)   ::     slash
  COMPLEX (KIND(0D0)), DIMENSION(sanz)  :: mypot

!!!$     tst        real            * 8     dum_re,dum_im,dum_mag,dum_pha

!!!$.....................................................................

  CALL get_unit(kanal)

!!!$     Slash
  slash = '/'

!!!$     'datei' modifizieren
  lnanz = int(log10(real(nanz)))+1
  htxt  = filpat(datei,idum2,1,slash(1:1))
  idum  = idum2+index(datei(idum2+1:80),'.')-1

  if ((idum-idum2-1).gt.(8-lnanz)) then
     fetxt = datei
     errnr = 15
     goto 999
  end if

  htxt2 = intcha(np,lnanz)
  htxt  = datei(1:idum)//htxt2(1:lnanz)//datei(idum+1:idum+4)

!!!$     'datei' oeffnen
  fetxt = htxt
  errnr = 1
  open(kanal,file=TRIM(fetxt),status='replace',err=999)
  errnr = 4

!!!$     Koordinaten und Potentialwerte (Real- und Imaginaerteil) der
!!!$     Knotenpunkte schreiben (in Reihenfolge der urspruenglichen
!!!$     Numerierung)
  do i=1,sanz
     write(kanal,*,err=1000)real(sx(snr(i))),real(sy(snr(i))),&
          real(dble(mypot(i))),real(dimag(mypot(i)))
!!!$     ak     1                real(cdabs(mypot(i))),
!!!$     ak     1                real(1d3*datan2(dimag(mypot(i)),dble(mypot(i))))
  end do

!!!$     'datei' schliessen
  close(kanal)

  errnr = 0
  return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

999 return

1000 close(kanal)
  return

end subroutine wpot

!> \file chol.f90
!> \brief Cholesky decomposition of the stiffness matrix A
!> \details Cholesky decomposition of the stiffness matrix A on the allocated memory of A. The algorithm closely follows <I>CHOBNDN</I> in Schwarz (1991).
!> @author Andreas Kemna
!> @date 10/11/1993

subroutine chol(a_chol)

!     Cholesky-Zerlegung der positiv definiten Matrix 'a'; erfolgt auf dem
!     Platz von 'a', d.h. bei Auftreten eines Fehlers ist gegebene Matrix
!     'a' zerstoert.

!     ( Vgl. Subroutine 'CHOBNDN' in Schwarz (1991) )

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   07-Mar-2003

!.....................................................................

  USE alloci
  USE elemmod
  USE errmod
  USE ompmod

  IMPLICIT none


!.....................................................................

!     PROGRAMMINTERNE PARAMETER:
!> stiffness matrix A
  COMPLEX (KIND(0D0)),DIMENSION(*) :: a_chol
  
!     Hilfsvariablen
  INTEGER (KIND = 4)  ::     idi,i0,ij,j0
  INTEGER (KIND = 4)  ::     m1,fi
  COMPLEX (KIND(0D0)) ::  s

!     Indexvariablen
  INTEGER (KIND = 4)  ::     i,j,k

!.....................................................................

  m1 = mb+1

  do i=1,sanz
     idi = i*m1
     fi  = max0(1,i-mb)
     i0  = idi-i
     
     do j=fi,i
        
        ij = i0+j
        j0 = j*mb
        s  = a_chol(ij)

        do k=fi,j-1
           s = s - a_chol(i0+k)*a_chol(j0+k)
        END do

        if (j.lt.i) then

           a_chol(ij) = s / a_chol(j*m1)

        else

           if (cdabs(s).le.0d0) then
              fetxt = ' '
              errnr = 28
              GOTO 1000
           end if

           a_chol(idi) = cdsqrt(s)

        end if

     END do
  END do
  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 return

end subroutine chol

!> \file bessk0.f90
!> \brief compute modified Bessel function \f$ K_0 \f$
!> \details Details can be found in Press et al. <I> Numerical Resipes in Fortran 77 and 90 (second edition) </I> (2001), pp. 231
!> @author William H. Press, Saul A. Teukolsky, William T. Vetterling, Brian P. Flannery
!> @date 2001
REAL (KIND(0D0))  FUNCTION BESSK0(X)
!> input value x
  REAL (KIND(0D0)) :: x,bessi0
  REAL (KIND(0D0)) :: Y,P1,P2,P3,P4,P5,P6,P7,&
       Q1,Q2,Q3,Q4,Q5,Q6,Q7
  DATA P1,P2,P3,P4,P5,P6,P7/-0.57721566D0,0.42278420D0,0.23069756D0,&
       0.3488590D-1,0.262698D-2,0.10750D-3,0.74D-5/
  DATA Q1,Q2,Q3,Q4,Q5,Q6,Q7/1.25331414D0,-0.7832358D-1,0.2189568D-1,&
       -0.1062446D-1,0.587872D-2,-0.251540D-2,0.53208D-3/
  IF (X.le.2d0) THEN
     Y=X*X/4d0
     BESSK0=(-dlog(X/2d0)*BESSI0(X))+(P1+Y*(P2+Y*(P3+&
          Y*(P4+Y*(P5+Y*(P6+Y*P7))))))
  else if (x.gt.5d2) then
     bessk0=0d0
  ELSE
     Y=(2d0/X)
     BESSK0=(dexp(-X)/dsqrt(X))*(Q1+Y*(Q2+Y*(Q3+&
          Y*(Q4+Y*(Q5+Y*(Q6+Y*Q7))))))
  ENDIF

END FUNCTION BESSK0

SUBROUTINE MDIAN1(X2,N,XMED)
  IMPLICIT none
  INTEGER :: N,N2
  REAL(KIND(0D0)),DIMENSION(N) :: X,X2
  REAL(KIND(0D0)) :: XMED

  X = X2 ! save a copy
  CALL SORT(N,X)
  N2=N/2
  IF(2*N2.EQ.N)THEN
     XMED=0.5*(X(N2)+X(N2+1))
  ELSE
     XMED=X(N2+1)
  ENDIF

END SUBROUTINE MDIAN1

!> \file femmod.f90
!> \brief variable delarations for <I>fem</I>
!> \details Replacement of former 'fem.fin' 
!> @author Andreas Kemna, Roland Martin
!> @date <I>unknown</I>

! $Id: fem.f90 1.4 2010/07/19 14:05:36 Roland Martin Exp $
MODULE femmod
! ---------------------------------------------------------
! this module contains some bigger arrays from fem.fin and should 
! replace fem.fin   -.-
! Copyright and written by Andreas Kemna
! Edited by R. Martin 2010
!
! included from FEM.FIN!!! COMPLEXs
!
! Berechnete Potentialwerte (bzw. Loesungsvektor)
  COMPLEX (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC     :: pot
! Analytische berechnete Potentialwerte 
  COMPLEX (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC     :: pota
! Konstanten-(bzw. Strom-) Vektor
  COMPLEX (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC     :: b
! included from FEM.FIN!!! REALs
  REAL (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC        :: bdc
! Skalierungsfaktor
  REAL (KIND(0D0)), DIMENSION(:), ALLOCATABLE, PUBLIC        :: fak
! Elementbeitraege
  REAL (KIND(0D0)), DIMENSION(:,:,:),ALLOCATABLE, PUBLIC     :: elbg
! Randelementbeitraege
  REAL (KIND(0D0)), DIMENSION(:,:),ALLOCATABLE, PUBLIC       :: relbg
! Konfigurationsfaktoren zur Berechnung der gemischten RB
  REAL (KIND(0D0)), DIMENSION(:,:,:),ALLOCATABLE, PUBLIC     :: kg
! Schalter ob "Gemischte Randbedingung" - Geometrie
  LOGICAL, PUBLIC                                            :: lbeta
! Schalter ob Dirichletsche Randbedingung vorkommt
  LOGICAL, PUBLIC                                            :: lrandb
! Schalter ob "singularity removal" durchgefuehrt werden soll
  LOGICAL, PUBLIC                                            :: lsr
! Schalter ob reine Betragsinversion ("DC") durchgefuehrt werden soll
  LOGICAL, PUBLIC                                            :: ldc
END MODULE femmod

!> \file choldc.f90
!> \brief Cholesky decomposition of the stiffness matrix A for the DC case
!> \details Cholesky decomposition of the stiffness matrix A on the allocated memory of A. The algorithm closely follows <I>CHOBNDN</I> in Schwarz (1991).
!> @author Andreas Kemna
!> @date 10/11/1993

SUBROUTINE choldc(a_chol)

!!!$  Cholesky-Zerlegung der positiv definiten Matrix 'adc'; erfolgt auf dem
!!!$  Platz von 'adc', d.h. bei Auftreten eines Fehlers ist gegebene Matrix
!!!$    'adc' zerstoert.

!!!$   ( Vgl. Subroutine 'CHOBNDN' in Schwarz (1991) )

!!!$   Andreas Kemna                                            11-Oct-1993
!!!$   Letzte Aenderung   07-Mar-2003

!!!$.....................................................................

  USE alloci
  USE elemmod
  USE errmod

  IMPLICIT NONE


!!!$.....................................................................
  REAL (KIND(0D0)),DIMENSION(*)    ::  a_chol

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Hilfsvariablen
  INTEGER (KIND = 4)  ::     idi,i0,ij,j0
  INTEGER (KIND = 4)  ::     m1,fi
  REAL (KIND(0D0))    ::     s

!!!$     Indexvariablen
  INTEGER (KIND = 4)  ::     i,j,k

!!!$.....................................................................

  m1 = mb+1

  DO i=1,sanz

     idi = i*m1
     fi  = max0(1,i-mb)
     i0  = idi-i

     DO j=fi,i

        ij = i0+j
        j0 = j*mb
        s  = a_chol(ij)

        DO k=fi,j-1
           s = s - a_chol(i0+k)*a_chol(j0+k)
        END DO

        IF (j.LT.i) THEN

           a_chol(ij) = s / a_chol(j*m1)

        ELSE

           IF (s.LE.0d0) THEN
              fetxt = ' '
              errnr = 28
              RETURN
           END IF

           a_chol(idi) = dsqrt(s)

        END IF

     END DO

  END DO

  errnr = 0

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

END SUBROUTINE choldc

!> \file invhpmod.f90
!> \brief variable delarations
!> \details Replacement of former 'invhp.fin' 
!> @author Andreas Kemna
!> @date 04/16/1996, last change 07/16/2007
MODULE invhpmod
!!$c 'invhp.fin'
!!$
!!$c Andreas Kemna                                            16-Apr-1996
!!$c                                       Letzte Aenderung   16-Jul-2007
!!$
!!$c.....................................................................
!!$
!!$c Kanalnummer
  INTEGER (KIND=4) ::     kanal

!!!$c Dateinamen
  CHARACTER (128) ::   delem,delectr,dstrom,&
       dsigma,dvolt,dsens,dstart,&
!!$cdiff+<
       dd0,dm0,dfm0,&
!!$cdiff+>
       drandb

!!$c Schalter ob allererste Iteration (Initialisierung)
  LOGICAL ::      lsetup

!!$c Schalter ob "final phase improvement" initialisiert werden soll
  LOGICAL ::      lsetip

!!$c Schalter ob weiterer Datensatz invertiert werden soll
  LOGICAL ::      lagain

!!$c Indexvariablen
  INTEGER (KIND=4) ::  j,k,l

!!$c Zeitvariablen
  REAL             ::     izeit,tazeit(2)

!!$c Zusaetzliche Fehlervariable
  INTEGER (KIND=4) ::     errnr2

END MODULE invhpmod

!> \file elem3.f90
!> \brief form functions of triangular area elements
!> \details Kemna (1995): A two-dimensional base element \f$ G^{(j)}\f$ can be formed out of a unity triangle. The function \f$ \tilde \phi (x,z) \f$ can be described via a linear approach
!> \f[ \tilde \phi (x,z) \approx c_1^{(j)} + c_2^{(j)} x + c_3^{(j)} z \f]
!> with \f$ (x,z) \in G^{(j)}  \ \ \ (j=1,...,n_e) \f$. It is uniquely determined by the potential values at the three nodes, \f$ \tilde \phi _{i_1 (j)} , \tilde \phi _{i_2 (j)} , \tilde \phi _{i_3 (j)} \f$ (see figure below).
!> \image html elem3_sketch.png "Triangle with linear approach"
!> The approach yields (Schwarz 1991)
!> \f[ \int \int_{G^{(j)}} {\left[ \left( \frac{\partial \tilde \phi}{\partial x} \right)^2 +\left( \frac{\partial \tilde \phi}{\partial z } \right)^2 \right] } dx dz = \tilde {\phi}^{(j)^T} S_1^{'(j)} \tilde \phi^{(j)} \f]
!> \f[ \int \int_{G^{(j)}} \tilde \phi ^2 dx dz = \tilde {\phi}^{(j)^T} S_2^{'(j)} \tilde \phi^{(j)} \f]
!> with \f$ \tilde \phi^{(j)} = \left( \tilde \phi_{i_1 (j)}, \tilde \phi_{i_2 (j)},\tilde \phi_{i_3 (j)} \right)\f$ being the vector of the values of the triangle nodes. The element matrices are 
!> \f[ S_1^{'(j)} = u_1 * U_1 + u_2 * U_2 + u_3 * U_3, \f]
!> \f[ S_2^{'(j)} = u_4 * U_4\f]
!> with 
!> \f[ u_1 = \left[ (x_3 - x_1)^2 + (z_3 - z_1)^2 \right] / u_4, \f]
!> \f[ u_2 = -\left[ (x_3 - x_1)(x_2-x_1) + (z_3-z_1)(z_2 - z_1) \right] / u_4, \f]
!> \f[ u_2 = \left[ (x_2 - x_1)^2+(z_2-z_1)^2 \right] / u_4, \f]
!> \f[ u_2 = (x_2 - x_1)(z_3-z_1) - (x_3-x_1)(z_2 - z_1)  \f]
!> and
!> \f[ U_1 = \frac{1}{2} \left( \begin{array}{ccc} 1 & -1 & 0 \\ -1 & 1 & 0 \\ 0 & 0 & 0  \end{array} \right), \ \ \ U_2 = \frac{1}{2} \left( \begin{array}{ccc} 2 & -1 & -1 \\ -1 & 0 & 1 \\ -1 & 1 & 0  \end{array} \right) \f]
!> \f[ U_3 = \frac{1}{2} \left( \begin{array}{ccc} 1 & 0 & -1 \\ 0 & 0 & 0 \\ -1 & 0 & 1  \end{array} \right), \ \ \ U_4 = \frac{1}{24} \left( \begin{array}{ccc} 2 & 1 & -1 \\ 1 & 2 & 1 \\ 1 & 1 & 2  \end{array} \right) \f]
!> Note that the above core element matrices \f$ U_1,...,U_4 \f$ are independent of the element's geometry. Therefore they can be applied universally.
!> The 3x3 matrices \f$ S_1^{'(j)} \f$ and \f$ S_2^{'(j)} \f$ can be transformed into the global \f$ n_k \times n_k \f$ stiffness matrices \f$ S_1 \f$ and \f$ S_2 \f$: a specific element \f$ (s_3^{(j)})_{mn} \ \ \ (m,n \in \{ 1,...,n_k \}) \f$ is set to
!> \f[ (s_3^{(j)})_{mn} = \left\{ \begin{array}{cc} (s_3^{'(j)})_{\kappa \lambda} & if\ \kappa,\lambda \in \{ 1,2 \}\  with \ m=i_k(j) \ and \ n=i_\lambda (j)   \\  0 & else \end{array} \right. \f]
!> with \f$ (s_3^{'(j)})_{\kappa \lambda} \f$ being an part of \f$  \f$
!> @author Andreas Kemna
!> @date 10/11/1993, last change 11/05/1997
subroutine elem3()

!!!$     Unterprogramm liefert die Elementmatrizen 'elmas(3,3)' und 'elmam(3,3)'
!!!$     sowie den Elementvektor 'elve(3)' fuer ein Dreieckelement mit linearem
!!!$     Ansatz ( Elementtyp Nr.3 ).

!!!$     Andreas Kemna                                            11-Oct-1993
!!!$     Letzte Aenderung   05-Nov-1997

!!!$.....................................................................

  USE elemmod,only:xk,yk,elmam,elmas,elve
  USE errmod

  IMPLICIT none


!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Grundelementmatrizen
  INTEGER (KIND = 4)  ::     s1(3,3),s2(3,3),s3(3,3),s4(3,3)

!!!$     Grundelementvektor
  INTEGER (KIND = 4)  ::     sb(3)

!!!$     Hilfsvariablen
  REAL (KIND(0D0))    ::     x21,x31,y21,y31,det,a,b,c

!!!$     Indexvariablen
  INTEGER (KIND = 4)  ::     i,j

!!!$.....................................................................

  data s1/1,-1,0,-1,1,0,0,0,0/
  data s2/2,-1,-1,-1,0,1,-1,1,0/
  data s3/1,0,-1,0,0,0,-1,0,1/
  data s4/2,1,1,1,2,1,1,1,2/
  data sb/1,1,1/

  x21 = xk(2) - xk(1)
  x31 = xk(3) - xk(1)
  y21 = yk(2) - yk(1)
  y31 = yk(3) - yk(1)
  det = x21*y31 - x31*y21

!!!$     Ggf. Fehlermeldung
  if (det.le.0d0) then
     fetxt = TRIM(fetxt)//' hat evtl falsche Kontennummerierung'
     print*,'det,x21,y31,x31,y21',det,x21,y31,x31,y21
     errnr = 26
     return
  end if

  a =   (x31*x31 + y31*y31) / det
  b = - (x31*x21 + y31*y21) / det
  c =   (x21*x21 + y21*y21) / det

  do i=1,3
     elve(i) = det * dble(sb(i)) / 6d0

     do j=1,3
        elmas(i,j) = (a*dble(s1(i,j)) + &
             b*dble(s2(i,j)) + c*dble(s3(i,j))) / 2d0
        elmam(i,j) = det * dble(s4(i,j)) / 2.4d1
     end do
  end do

  errnr = 0

  return
end subroutine elem3

MODULE bmcm_mod
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!$ Collection of subroutines to calculate linearized model
!!!$ uncertainty and resolution matrices for ERT (DC) and EIT (IP)
!!!$
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!$ Copyright by Andreas Kemna 2010
!!!$
!!!$ Created by Roland Martin               30-Jul-2010
!!!$
!!!$ Last changed       RM                  Jul-2010
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  USE tic_toc ! counts calculation time
  USE alloci , ONLY : sens,sensdc,smatm,ata,ata_reg,cov_m
  USE femmod , ONLY : ldc
  USE elemmod, ONLY : max_nr_element_nodes,espx,espy,nachbar
  USE invmod , ONLY : lfpi,wmatd,wdfak,par
  USE errmod , ONLY : errnr,fetxt
  USE konvmod , ONLY : ltri,lgauss,lam,nx,nz,mswitch,lcov2,lres,lverb,&
       lverb_dat,lelerr,lam_cri
  USE modelmod , ONLY : manz
  USE datmod , ONLY : nanz,wmatdr,wmatd_cri,wmatdp
  USE errmod, ONLY : errnr,fetxt,fprun
  USE sigmamod , ONLY : sigma
  USE pathmod
  USE ompmod, ONLY : CHUNK_0

  IMPLICIT none

  PUBLIC :: buncert
!!!$ this sub controls uncertainty caculation

  PRIVATE :: bata
!!!$ A^HC_d^-1A  -> ata
  PRIVATE :: bata_reg
!!!$ ata + lam*C_m^-1 -> ata_reg
  PRIVATE :: bmcm ! inversion
!!!$ ata_reg^-1   -> cov_m
  PRIVATE :: bres ! MATMUL
!!!$ cov_m * ata -> ata_reg
  PRIVATE :: bmcm2 ! MATMUL
!!!$ ata_reg * cov_m -> ata

CONTAINS

  SUBROUTINE buncert (kanal,lamalt)

!!!$
!!!$ This sub is the control unit of the smatm calculation
!!!$
    INTEGER (KIND = 4 ),INTENT(IN) :: kanal ! kanal is the io unit number
    REAL (KIND(0D0)),INTENT(IN)    :: lamalt ! lambda of the last iteration
!!! for tic_toc
    INTEGER (KIND = 4 )            :: c1

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!$    get time
    CALL TIC(c1)

    WRITE(*,'(a)')'Calculating model uncertainty..'
    WRITE (fprun,'(a)')'Calculating model uncertainty..'
    IF (lfpi) THEN
       WRITE(*,'(a)')' --> resetting lambda of FPI to CRI value'
       WRITE(fprun,'(a)')' --> resetting lambda of FPI to CRI value'
       lam = lam_cri
    ELSE
       WRITE(*,'(a)')' --> taking last good lambda'
       WRITE(fprun,'(a)')' --> taking last good lambda'
       lam = lamalt
    END IF

    WRITE (*,'(/a,G10.3,a/)')'take current lambda ?',lam,&
         ACHAR(9)//':'//ACHAR(9)

    IF (BTEST(mswitch,6)) THEN
       READ (*,*)fetxt
       IF (fetxt/='')READ(fetxt,*)lam
       WRITE (*,*)'No, set lambda to ',lam
    ELSE
       WRITE (*,*)' Yes'
    END IF

    WRITE (fprun,*)'----> taking lam=',lam

    WRITE(*,'(a)')ACHAR(13)//&
         'calculating MCM_1 = (A^TC_d^-1A + C_m^-1)^-1'
    WRITE(fprun,'(a)')'MCM_1 = (A^TC_d^-1A + C_m^-1)^-1'

    IF (lelerr) THEN
       WRITE (*,'(/a/a/)')'++ Resetting error weighting for uncertainty',&
            '  --> Complex error ellipses of CRI'
       wmatd = wmatd_cri
    ELSE IF (lfpi) THEN
       WRITE (*,'(/a/a/)')'++ Resetting error weighting for uncertainty',&
            '  --> Magnitude error of CRI'
       wmatd = wmatdr
    END IF

    ALLOCATE (ata(manz,manz),STAT=errnr)
    IF (errnr /= 0) THEN
       errnr = 97
       RETURN
    END IF
    ata = 0D0

    fetxt = ramd(1:lnramd)//slash(1:1)//'ata.diag'
    CALL bata(kanal) ! A^TC_d^-1A -> ata
    if (errnr.ne.0) RETURN

    ALLOCATE (ata_reg(manz,manz),STAT=errnr)
    IF (errnr /= 0) THEN
       errnr = 97
       RETURN
    END IF
    ata_reg = 0D0

    fetxt = ramd(1:lnramd)//slash(1:1)//'ata_reg.diag'
    CALL bata_reg(kanal) !ata + C_m^-1(lam) -> ata_reg_dc
    if (errnr.ne.0) RETURN

    ALLOCATE (cov_m(manz,manz))
    IF (errnr/=0) THEN
       WRITE (*,'(/a/)')'Allocation problem MCM_1 in bmcmdc'
       errnr = 97
       RETURN
    END IF
    cov_m = 0D0

    CALL bpar

    fetxt = ramd(1:lnramd)//slash(1:1)//'cov1_m.diag'
    CALL bmcm(kanal,lgauss) ! (A^TC_d^-1A + C_m^-1)^-1   -> cov_m_dc
    if (errnr.ne.0) RETURN


    IF (lres) THEN

       fetxt = ramd(1:lnramd)//slash(1:1)//'res_m.diag'

       WRITE(*,'(a)')ACHAR(13)//'calculating RES = '//&
            '(A^TC_d^-1A + C_m^-1)^-1A^TC_d^-1A'
       WRITE(fprun,'(a)')'RES = (A^TC_d^-1A + C_m^-1)^-1A^TC_d^-1A'

       CALL bres(kanal)
       if (errnr.ne.0) RETURN

       IF (lcov2) THEN

          fetxt = ramd(1:lnramd)//slash(1:1)//'cov2_m.diag'

          WRITE(*,'(a)')ACHAR(13)//'calculating MCM_2 = '//&
               '(A^TC_d^-1A + C_m^-1)^-1 A^TC_d^-1A (A^TC_d^-1A + C_m^-1)^-1'
          WRITE(fprun,'(a)')'MCM_2 = (A^TC_d^-1A + C_m^-1)'//&
               '^-1 A^TC_d^-1A (A^TC_d^-1A + C_m^-1)^-1'

          CALL bmcm2(kanal)
          if (errnr.ne.0) RETURN

       END IF              ! lcov2
    END IF                 ! lres

!!! $ may be we ant to write out not only main diagonals before freeing

    IF (ALLOCATED (ata)) DEALLOCATE (ata)
    IF (ALLOCATED (ata_reg)) DEALLOCATE (ata_reg)
    IF (ALLOCATED (cov_m)) DEALLOCATE (cov_m)

    fetxt = 'uncertainty calculation time'
    CALL TOC(c1,fetxt)

  END SUBROUTINE buncert

  SUBROUTINE bata(kanal)
!!!$
!!!$    Unterprogramm berechnet A^HC_d^-1A
!!!$
!!!$    Copyright Andreas Kemna 2009
!!!$    Created by  Roland Martin                            02-Nov-2009
!!!$
!!!$    Last changed      RM                                   20-Feb-2011
!!!$
!!!$.....................................................................
!!!$   PROGRAMMINTERNE PARAMETER:
!!!$   Hilfsvariablen
    INTEGER                                  :: kanal
    INTEGER                                  :: i,j,k
    COMPLEX (KIND(0D0))                      :: cdum
    REAL (KIND(0D0))                         :: dum = 0D0
    REAL(KIND(0d0)),DIMENSION(:),ALLOCATABLE :: dig,dig_fpi    ! contains diagonal of ATA
    REAL (KIND(0D0))                         :: dig_min,dig_max ! MINMAX(diag{ATA})
    INTEGER                                  :: c1
    CHARACTER(80)                            :: csz
    CHARACTER(256)                           :: fname

!!!$....................................................................

!!!$  A^TC_d^-1A

    errnr = 4
    fname = TRIM(fetxt) ! reassign

    fetxt = 'allocating digs'
    ALLOCATE(dig(manz),dig_fpi(manz),STAT=errnr)
    IF (errnr /= 0) THEN
       errnr = 97
       RETURN
    END IF

    ata = 0d0

    CALL TIC(c1)

    IF (ldc) THEN

       DO k=1,manz
          DO j=k,manz ! fills upper triangle (k,j)
             DO i=1,nanz
                ata(k,j) = ata(k,j) + sensdc(i,k) * &
                     sensdc(i,j) * wmatd(i) * DBLE(wdfak(i))
             END DO
             ata(j,k) = ata(k,j) ! fills lower triangle (k,j)
          END DO
          dig(k) = ata(k,k)
       END DO
    ELSE
       DO k=1,manz
          DO j=k,manz ! upper triangle
             cdum = DCMPLX(0d0)
             IF (j==k) dum = 0d0
             DO i=1,nanz
                cdum = cdum + DCONJG(sens(i,k)) * &
                     sens(i,j) * wmatd(i) * DBLE(wdfak(i))

                IF (j==k) dum = dum + DBLE(sens(i,k)) * DBLE(sens(i,j)) * &
                     wmatdp(i)*DBLE(wdfak(i))

             END DO
             ata(k,j) = real(cdum) ! fills upper triangle (k,j)
             ata(j,k) = real(cdum) ! fills lower triangle (j,k)
          END DO
          dig(k) = ata(k,k)
          dig_fpi(k) = dum
       END DO
    END IF

    csz = 'ATA time'
    CALL TOC(c1,csz)

!!!$    get min/max
    dig_min = MINVAL(dig)
    dig_max = MAXVAL(dig)
!!!$    write out
    errnr = 1
    OPEN (kanal,file=TRIM(fname),status='replace',err=999)
    errnr = 4

    WRITE (kanal,*)manz,dig_min,dig_max
    DO i=1,manz
       WRITE (kanal,*)dig(i),LOG10(dig(i))-LOG10(dig_max)
    END DO

    WRITE (*,*)'Max/Min:',dig_max,'/',dig_min
    CLOSE(kanal)

    IF (lfpi) THEN
       WRITE (*,'(/a/)')'Writing out:: '//TRIM(fname)//'_fpi'
       dig_min = MINVAL(dig_fpi)
       dig_max = MAXVAL(dig_fpi)
       errnr = 1
       OPEN (kanal,file=TRIM(fname)//'_fpi',status='replace',err=999)
       errnr = 4

       WRITE (kanal,*)manz
       DO i=1,manz
          WRITE (kanal,*)dig_fpi(i),LOG10(dig_fpi(i))-LOG10(dig_max)
       END DO
       WRITE (kanal,*)'Max/Min:',dig_max,'/',dig_min
       WRITE (*,*)'Max/Min:',dig_max,'/',dig_min
       CLOSE(kanal)
    END IF
    DEALLOCATE (dig,dig_fpi)

    errnr = 0
999 RETURN

  END SUBROUTINE bata

  SUBROUTINE bata_reg(kanal)
!!!$
!!!$    Unterprogramm berechnet A^HC_d^-1A+lam*C_m
!!!$    Fuer beliebige Triangulierung
!!!$
!!!$    Copyright Andreas Kemna
!!!$    Erstellt von Roland Martin                           02-Nov-2009
!!!$
!!!$    Last changed      RM                               31-Mar-2010
!!!$
!!!$.....................................................................
!!!$   PROGRAMMINTERNE PARAMETER:
    INTEGER                        :: kanal ! io number
!!!$   Hilfsvariablen
    INTEGER                        :: i,j,k,ik
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE  :: dig
    REAL(KIND(0D0))                           :: dig_min,dig_max
    INTEGER                                      :: c1
    CHARACTER(80)                                :: csz
!!!$.....................................................................

!!!$  A^TC_d^-1A+lamC_m

    errnr = 1
    open(kanal,file=TRIM(fetxt),status='replace',err=999)
    errnr = 4

    ALLOCATE(dig(manz))

    CALL TIC (c1)

    IF (ltri == 0) THEN

       ata_reg = ata
       DO j=1,manz
        DO i=1,manz

          write(*,'(a,1X,F6.2,A)',advance='no')ACHAR(13)// &
               'ATC_d^-1A+reg/ ',REAL( j * (100./manz)),'%'

          ata_reg(j,j) =  ata(j,j) + lam * smatm(i,1) ! main diagonal

          IF (i+1 < manz) THEN
             ata_reg(i+1,j) = ata(i+1,j) + lam * smatm(i+1,2) ! nebendiagonale in x richtung
             ata_reg(j,i+1) = ata_reg(i+1,j) ! lower triangle
          END IF
          IF (i+nx < manz) THEN
             ata_reg(i+nx,j) = ata(i+nx,j) + lam * smatm(i+nx,3) ! nebendiagonale in z richtung
             ata_reg(j,i+nx) = ata_reg(i+nx,j) ! lower triangle
          END IF
        END DO
          dig(j) = ata_reg(j,j)

       END DO

    ELSE IF (ltri == 3.OR.ltri == 4) THEN

       ata_reg = ata

       DO i=1,manz
          dig (i) = ata(i,i) + lam * smatm(i,1)
          ata_reg(i,i) = dig(i)
       END DO

    ELSE IF (ltri == 1.OR.ltri == 2.OR.(ltri > 4 .AND. ltri < 15)) THEN

       ata_reg = ata ! just copy and fill the other information afterwards

       DO j=1,manz

          write(*,'(a,1X,F6.2,A)',advance='no')ACHAR(13)// &
               'ATC_d^-1A+reg/ ',REAL( j * (100./manz)),'%'

          ata_reg(j,j) = ata(j,j) + lam * smatm(j,max_nr_element_nodes+1) ! main diagonal

          DO k=1,nachbar(j,max_nr_element_nodes+1) ! off diagonal

             ik = nachbar(j,k)

             IF (ik == 0) CYCLE ! check if there actually is a neighbor

             ata_reg(ik,j) = ata(ik,j) + lam * smatm(j,k) ! upper triangle

             ata_reg(j,ik) = ata_reg(ik,j) ! lower triangle

          END DO

          dig(j) = ata_reg(j,j)

       END DO

    ELSE IF (ltri == 15) THEN

       ata_reg= ata + lam * smatm ! for full C_m..w

       DO j=1,manz
          dig(j) = ata_reg(j,j)
       END DO

    END IF

    csz = 'ATA+RTR time'
    CALL TOC(c1,csz)

    dig_min = MINVAL(dig)
    dig_max = MAXVAL(dig)

    WRITE (kanal,*)manz,lam
    DO i=1,manz
       WRITE (kanal,*)dig(i),LOG10(dig(i))
    END DO

    WRITE (kanal,*)'Max/Min:',dig_max,'/',dig_min
    WRITE (*,*)'Max/Min:',dig_max,'/',dig_min

    CLOSE(kanal)

    DEALLOCATE (dig)

    errnr = 0
999 RETURN

  END SUBROUTINE bata_reg

  SUBROUTINE bmcm(kanal,ols)
!!!$
!!!$    Unterprogramm berechnet (einfache) Modell Kovarianz Matrix
!!!$    (A^TC_d^-1A + C_m^-1)^-1
!!!$    Fuer beliebige Triangulierung
!!!$
!!!$    Copyright Andreas Kemna 2009
!!!$    Created by  Roland Martin                            02-Nov-2009
!!!$
!!!$    Last changed      RM                                   20-Feb-2010
!!!$
!!!$.....................................................................
!!!$   PROGRAMMINTERNE PARAMETER:
!!!$   Hilfsvariablen
    INTEGER                                    :: i,kanal,j,c1
    REAL(KIND(0D0)),DIMENSION(:,:),ALLOCATABLE :: work
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE   :: dig
    REAL(KIND(0D0))                            :: dig_min,dig_max
    REAL (KIND(0D0))                           :: dre,dim
    COMPLEX(KIND(0D0))                         :: dsi
    LOGICAL,INTENT(IN),OPTIONAL                :: ols
    CHARACTER(80)                              :: csz
!!!$....................................................................

!!!$  invert (A^TC_d^-1A + C_m^-1)

    errnr = 1

    ALLOCATE (dig(manz)) !dig is a working array and contains main diagonal


!!!$    get time
    CALL TIC(c1)

    cov_m = ata_reg

    IF (.NOT.PRESENT(ols).OR..NOT.ols) THEN !default

       WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//'Factorization...'

       CALL CHOLD(cov_m,dig,manz,errnr,lverb)
       IF (errnr /= 0) THEN
          fetxt='CHOLD mcm :: matrix not pos definite..'
          PRINT*,'Zeile(',abs(errnr),')'
          errnr = 108
          RETURN
       END IF

       csz = 'Factorization time'
       CALL TOC(c1,csz)


       CALL TIC(c1)
       WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//'Inverting...'

       CALL LINVD(cov_m,dig,manz,lverb)

       WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//'Filling lower Cov...'

!!$       !$OMP PARALLEL DEFAULT (none) &
!!$       !$OMP SHARED (cov_m,manz,lverb) &
!!$       !$OMP PRIVATE (i,j)
!!$       !$OMP DO SCHEDULE (GUIDED,CHUNK_0)

       DO i= 1 , manz

          IF (lverb) WRITE (*,'(A,t45,F6.2,A)',ADVANCE='no')&
               ACHAR(13)//'Filling lower/',REAL( i * (100./manz)),'%'

          DO j = 1 , i - 1

             cov_m(i,j) = cov_m(j,i)

          END DO

       END DO

!!$       !$OMP END PARALLEL

       csz = 'Inversion time'
       CALL TOC(c1,csz)


    ELSE
       WRITE (*,'(a)',ADVANCE='no')'Inverting Matrix (Gauss elemination)'

       CALL gauss_dble(cov_m,manz,errnr)

       IF (errnr /= 0) THEN
          fetxt = 'error matrix inverse not found'
          PRINT*,'Zeile::',cov_m(abs(errnr),:)
          PRINT*,'Spalte::',cov_m(:,abs(errnr))
          errnr = 108
          RETURN
       END IF

       csz = 'Inversion time'
       CALL TOC(c1,csz)

    END IF

    IF (lverb) THEN

       ALLOCATE (work(manz,manz),STAT=errnr)
       IF (errnr/=0) THEN
          fetxt = 'Allocation problem WORK in bmcm'
          errnr = 97
          RETURN
       END IF

       !$OMP WORKSHARE
       work = MATMUL(cov_m,ata_reg)
       !$OMP END WORKSHARE

       DO i=1,manz
          IF (ABS(work(i,i) - 1d0) > 0.1) PRINT*,'bad approximation at parameter'&
               ,i,work(i,i)
       END DO
       DEALLOCATE (work)

    END IF

    DO i=1,manz
       dig(i) = cov_m(i,i)
    END DO

    dig_min = MINVAL(dig)
    dig_max = MAXVAL(dig)

!!$In order to find subsequent error expressions for our displayed model parameters, we identify the standard deviation as first order finite difference
!!$\begin{equation}
!!$\Delta:=\sqrt{diag\left\lbrace \MAT{C}_{m^*}^m\left( \lambda \right) \right\rbrace}
!!$\end{equation}
!!$and equate the model parameter within it's error bars:
!!$\begin{equation}
!!$m^*=m(1\pm\Delta)= (\ln{|\sigma|}+i\phi)(1+\Delta)
!!$\end{equation}
!!$From Equation \ref{eq:err_m} we see, that our real-valued covariance matrix error quantities are the same for real and imaginary part of the parameters:
!!$\begin{equation}
!!$\Delta m=\Delta \ln{|\rho|}+i\Delta \phi =\Delta \ln{|\sigma|}+i\Delta \phi\;. \label{eq:d_logm}
!!$\end{equation}
!!$If we now like to equate the errors for real and imaginary part of our complex conductivities, we have to reconsider their definitions.
!!$\begin{align}
!!$\sigma'&=|\sigma|\cos{\phi}\\
!!$\sigma'&=|\sigma|\sin{\phi}\;,
!!$\end{align}
!!$and build the total differential for the real part:
!!$\begin{align}
!!$\MMF{d} \sigma'&=\frac{\partial \sigma'}{\partial |\sigma|}\MMF{d}|\sigma| + \frac{\partial \sigma'}{\partial\phi}\MMF{d}\phi \\
!!$&=\frac{\partial \sigma'}{\partial |\sigma|}\frac{\partial |\sigma|}{\partial \ln{|\sigma|}}\MMF{d}\ln{|\sigma|} +
!!$|\sigma|\sin{\phi}\MMF{d}\phi \\
!!$&= \cos{\phi}|\sigma|\MMF{d}\ln{|\sigma|}+\sin{\phi}|\sigma|\MMF{d}\phi\;.
!!$\end{align}
!!$\begin{equation}
!!$\Delta \sigma'=\Delta |\sigma|\left(\cos{\phi}+\sin{\phi}\right)
!!$\end{equation}
!!$For the imaginary part we find
!!$\begin{align}
!!$\MMF{d} \sigma''&=\frac{\partial \sigma''}{\partial |\sigma|}\MMF{d}|\sigma| + \frac{\partial \sigma''}{\partial\phi}\MMF{d}\phi \\
!!$%&=\frac{\partial \sigma''}{\partial |\sigma|}|\sigma|\Delta\ln{|\sigma|} - |\sigma|\cos{\phi}\Delta\phi \\
!!$&= \sin{\phi}|\sigma|\Delta\ln{|\sigma|}-\cos{\phi}|\sigma|\Delta\phi \\
!!$&=\Delta |\sigma|\left(\sin{\phi}-\cos{\phi}\right)\;.
!!$\end{align}

    errnr = 1
    OPEN (kanal,file=TRIM(fetxt),status='replace',err=999)
    errnr = 4
    WRITE (kanal,*)manz,lam
    DO i=1,manz

       dsi = sigma(i) * SQRT(dig(i))

       dre = DBLE(sigma(i)) * SQRT(dig(i))
       dim = AIMAG(sigma(i)) * SQRT(dig(i))

       WRITE (kanal,*)SQRT(dig(i))*1e2,dre,dim !ABS(REAL(dsi)),ABS(AIMAG(dsi)),dre,dim
    END DO

    WRITE (kanal,*)'Max/Min:',dig_max,'/',dig_min
    WRITE (*,*)'Max/Min:',dig_max,'/',dig_min

    CLOSE(kanal)

    IF (lverb_dat) THEN

       errnr = 1
       open(kanal,file=TRIM(fetxt)//'_full',status='replace',err=999)
       errnr = 4
       DO i = 1, manz
          WRITE (kanal,*)espx(i),espy(i),(cov_m(i,j),j=i,manz)
       END DO

       CLOSE (kanal)
    END IF

    DEALLOCATE (dig)

    errnr = 0
999 RETURN

  END SUBROUTINE bmcm

  SUBROUTINE bres(kanal)
!!!$
!!!$    Unterprogramm berechnet Aufloesungsmatrix
!!!$    Fuer beliebige Triangulierung
!!!$    RES = (A^HC_d^-1A + C_m^-1)^-1 A^HC_d^-1A
!!!$    wobei (A^HC_d^-1A + C_m^-1) bereits invertiert wurde (cov_m)
!!!$
!!!$    Copyright Andreas Kemna 2009
!!!$
!!!$    Created by Roland Martin                            02-Nov-2009
!!!$
!!!$    Last changed      RM                             20-Feb-2010
!!!$.....................................................................
!!!$   PROGRAMMINTERNE PARAMETER:
!!!$   Hilfsvariablen
    INTEGER                                      :: i,j,kanal
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE     :: dig
    REAL(KIND(0D0))                              :: dig_min,dig_max
    INTEGER                                      :: c1
    CHARACTER(80)                                :: csz
!!!$.....................................................................

!!!$  cal!!!$RES = (A^TC_d^-1A + C_m^-1)^-1 A^TC_d^-1A

    errnr = 1
    open(kanal,file=TRIM(fetxt),status='replace',err=999)
    errnr = 4
!!!$    get time
    CALL TIC(c1)

!    !$OMP WORKSHARE
    ata_reg = MATMUL(cov_m,ata) ! that's it...
!    !$OMP END WORKSHARE

    csz = 'MATMUL time'
    CALL TOC(c1,csz)

    ALLOCATE (dig(manz)) !prepare to write out main diagonal

    DO i=1,manz
       dig(i) = ata_reg(i,i)
    END DO

    dig_min = MINVAL(dig)
    dig_max = MAXVAL(dig)

    WRITE (kanal,*) manz, lam, dig_min, dig_max
    DO i=1,manz
       WRITE (kanal,*)abs(dig(i)),LOG10(abs(dig(i)))-LOG10(dig_max)
    END DO

    WRITE (*,*)'Max/Min:',dig_max,'/',dig_min

    CLOSE(kanal)

    IF (lverb_dat) THEN
       errnr = 1
       open(kanal,file=TRIM(fetxt)//'_full',status='replace',err=999)
       errnr = 4
       DO i = 1, manz
          WRITE (kanal,*)espx(i),espy(i),(abs(ata_reg(i,j)),j=i,manz)
       END DO

       CLOSE (kanal)
    END IF

    DEALLOCATE (dig)

    errnr = 0
999 RETURN

  END SUBROUTINE bres

  SUBROUTINE bmcm2(kanal)
!!!$
!!!$    Unterprogramm berechnet Modellkovarianz nach Fehlerfortpflanzung
!!!$    MCM = (A^HC_d^-1A + C_m^-1)^-1 A^HC_d^-1A (A^HC_d^-1A + C_m^-1)^-1
!!!$    Fuer beliebige Triangulierung
!!!$!!!$    Copyright Andreas Kemna/Roland Martin 2009
!!!$    erstellt von Roland Martin                               02-Nov-2009
!!!$
!!!$    Last changed      RM                                   23-Nov-2009
!!!$
    !!!$.........................................................................
    USE alloci
    USE datmod
    USE invmod
    USE modelmod
    USE errmod

    IMPLICIT none

!!!$.....................................................................
!!!$   PROGRAMMINTERNE PARAMETER:
!!!$   Hilfsvariablen
    INTEGER                                      :: kanal
    INTEGER                                      :: i
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE     :: dig
    REAL(KIND(0D0))                              :: dig_min,dig_max
    COMPLEX(KIND(0D0))                           :: dsig
    INTEGER                                      :: c1
    CHARACTER(80)                                :: csz
!!!$.....................................................................
!!!$   vorher wurde schon
!!!$   ata_reg_dc= (A^TC_d^-1A + C_m^-1)^-1 A^TC_d^-1A berechnet
!!!$   cov_m_dc= (A^TC_d^-1A + C_m^-1)^-1


    errnr = 1
    open(kanal,file=TRIM(fetxt),status='replace',err=999)
    errnr = 4

!!!$    get time
    CALL TIC(c1)

!    !$OMP WORKSHARE
    ata = MATMUL (ata_reg,cov_m)
!    !$OMP END WORKSHARE

    csz = 'MATMUL time'
    CALL TOC(c1,csz)

    ALLOCATE (dig(manz))

    DO i=1,manz
       dig(i) = ata(i,i)
    END DO

    dig_min = MINVAL(dig)
    dig_max = MAXVAL(dig)

    WRITE (kanal,*)manz,lam
    DO i=1,manz
       dsig = sigma(i) * SQRT(dig(i))
       WRITE (kanal,*)SQRT(dig(i))*1d2, REAL(dsig), AIMAG(dsig)
    END DO

    WRITE (kanal,*)'Max/Min:',dig_max,'/',dig_min
    WRITE (*,*)'Max/Min:',dig_max,'/',dig_min

    CLOSE(kanal)

    DEALLOCATE (dig)

    errnr = 0

999 RETURN

  END SUBROUTINE bmcm2
END MODULE bmcm_mod

module errmod
! 'err.fin'

! Andreas Kemna                                            06-Feb-1993
!                                       Letzte Aenderung   24-Oct-1996

!.....................................................................

! COMMON

! Fehlernummer
        integer :: errnr

! Fehlerart
! 0 : GKS - nicht aktiv, Programm nicht verlassen
! 1 : GKS - nicht aktiv, Programm verlassen
! 2 : GKS - aktiv      , Programm nicht verlassen
! 3 : GKS - aktiv      , Programm verlassen und GKS schlieáen
         integer :: errflag

! Fehlertext
        character(80), public :: fetxt

!.....................................................................

        ! common/cerr/    errnr,
     ! 1                  errflag,
     ! 1                  fetxt
end module errmod

MODULE wavenmod
!
! 'waven.fin'
!
! Andreas Kemna                                            07-Oct-1993
!                                       Letzte Aenderung   07-Nov-1997
!
!.....................................................................

!Anzahl der Wellenzahlwerte
    INTEGER(KIND = 4),PUBLIC                        :: kwnanz

!Schalter steuert Art der Ruecktransformation
!( = 0 : keine Trafo (2D Fall),
!  = 1 : Gauss/Laguerre-Integration )
    INTEGER(KIND = 4),PUBLIC                        :: swrtr

!Wellenzahlwerte
    REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE :: kwn

!Wichtungsfaktoren fuer Ruecktransformation
    REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE :: kwnwi

!Fuer Ruecktransformation relevanter Abstandsbereich
    REAL(KIND(0D0)),PUBLIC                          :: amin,amax

END MODULE wavenmod

MODULE brough_mod
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!$ Collection of subroutines calculate model roughness term
!!!$ for different regularizations
!!!$ 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!$ Copyright by Andreas Kemna 2010
!!!$
!!!$ Created by Roland Martin               30-Jul-2010
!!!$
!!!$ Last changed       RM                  Jul-2010
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  USE alloci , ONLY : smatm
  USE invmod , ONLY : lfpi,par,m0
  USE konvmod , ONLY : ltri,nx,nz,lprior,rough
  USE modelmod , ONLY : manz
  USE elemmod, ONLY : max_nr_element_nodes,nachbar
  USE errmod , ONLY : errnr,fetxt
  USE datmod , ONLY : nanz

  IMPLICIT none

  PUBLIC :: brough
!!!$ controls which smatm to use

PRIVATE :: broughreg
!!!$ uses smatm of smooth regularization for regular grids (sparse smatm)
PRIVATE :: broughtri
!!!$ uses smatm for unstructured grids (recommended). this is (sparse smatm)
!!!$ used for MGS/TV regu as well..
PRIVATE :: broughlma
!!!$ smatm for Levenberg or Levenberg-Marquardt (diagonal smatm)
PRIVATE :: broughsto
!!!$ smatm for stochastical regu (full M^2 matrix)

CONTAINS

  SUBROUTINE brough

!!!$   Roughness bestimmen
      IF (ltri == 0) THEN
         CALL broughreg()
      ELSE IF (ltri == 1.OR.ltri == 2.OR.&
           (ltri > 4 .AND. ltri < 15)) THEN
         CALL broughtri
      ELSE IF (ltri == 3.OR.ltri == 4) THEN
         CALL broughlma
      ELSE IF (ltri == 15) THEN
         CALL broughsto
      END IF

  END SUBROUTINE brough

  subroutine broughreg()

!!!$   Unterprogramm zum Belegen der Leitfaehigkeit und zum Bestimmen der
!!!$   Rauhigkeit.
!!!$
!!!$   Andreas Kemna                                            12-Apr-1996
!!!$   Letzte Aenderung   15-Jan-2001
!!!$
!!!$.....................................................................
!!!$   PROGRAMMINTERNE PARAMETER:

!!!$   Hilfsvariablen
    INTEGER ::     i
    COMPLEX(KIND(0D0)) ::    cdum
!!!$   cdum describes (R^TR)m
!!!$.....................................................................

!!!$   Roughness bestimmen
    rough = 0d0

    do i=1,manz
       cdum = dcmplx(0d0)

!!!$   diff+<
       if (.not.lprior) then
!!!$   diff+>
          if (i.gt.1) &
         cdum = dcmplx(smatm(i-1,2))*par(i-1)
          if (i.lt.manz) &
         cdum = cdum + dcmplx(smatm(i,2))*par(i+1)
          if (i.gt.nx) &
               cdum = cdum + dcmplx(smatm(i-nx,3))*par(i-nx)
          if (i.lt.manz-nx+1) &
         cdum = cdum + dcmplx(smatm(i,3))*par(i+nx)

          cdum = cdum + dcmplx(smatm(i,1))*par(i)

          if (lfpi) then
             rough = rough + dimag(cdum)*dimag(par(i))
          else
             rough = rough + dble(cdum*dconjg(par(i)))
          end if
!!!$   diff+<
       else
          if (i.gt.1) &
               cdum = dcmplx(smatm(i-1,2)) * (par(i-1) - m0(i-1))
          if (i.lt.manz) &
               cdum = cdum + dcmplx(smatm(i,2)) * (par(i+1) - m0(i+1))
          if (i.gt.nx) &
               cdum = cdum + dcmplx(smatm(i-nx,3)) * (par(i-nx) - m0(i-nx))
          if (i.lt.manz-nx+1) &
               cdum = cdum + dcmplx(smatm(i,3)) * (par(i+nx) - m0(i+nx))
          
          cdum = cdum + dcmplx(smatm(i,1))*(par(i)-m0(i))
          
          if (lfpi) then
             rough = rough + dimag(cdum) * dimag(par(i) - m0(i))
          else
             rough = rough + dble(cdum*dconjg(par(i) - m0(i)))
          end if
       end if
!!!$   diff+>
    end do

  END subroutine broughreg

  SUBROUTINE broughtri()
!!!$
!!!$   Belegen der Leitfaehigkeit und zum Bestimmen der Rauhigkeit...
!!!$   Fuer beliebige Triangulierung
!!!$
!!!$   Andreas Kemna                                            12-Apr-1996
!!!$
!!!$   Letzte Aenderung                                         29-Jul-2009
!!!$
!!!$.....................................................................
!!!$  PROGRAMMINTERNE PARAMETER:
!!!$  Hilfsvariablen
    INTEGER ::     i,j
    COMPLEX(KIND(0D0)) ::    cdum
!!!$ cdum describes (R^TR)m
!!!$.....................................................................
!!!$  Roughness bestimmen
    rough = 0d0
    IF (.NOT. lprior) THEN
       DO i=1,manz
          cdum = dcmplx(0d0)
          DO j=1,max_nr_element_nodes
             IF (nachbar(i,j) /= 0) cdum = cdum + &
                  DCMPLX(smatm(i,j)) * par(nachbar(i,j))
          END DO
          cdum = cdum + dcmplx(smatm(i,max_nr_element_nodes+1)) * par(i)
          IF (lfpi) THEN
             rough = rough + dimag(cdum) * dimag(par(i))
          ELSE
             rough = rough + dble(cdum * dconjg(par(i)))
          END IF
       END DO
    ELSE 
       DO i=1,manz
          cdum = dcmplx(0d0)
          DO j=1,max_nr_element_nodes
             IF (nachbar(i,j) /= 0) cdum = cdum + &
                  DCMPLX(smatm(i,j)) * &
                  (par(nachbar(i,j)) - m0(nachbar(i,j)))
          END DO
          cdum = cdum + dcmplx(smatm(i,max_nr_element_nodes+1)) * (par(i) - m0(i))
          IF (lfpi) THEN
             rough = rough + dimag(cdum) * dimag(par(i) - m0(i))
          ELSE
             rough = rough + dble(cdum * dconjg(par(i) - m0(i)))
          END IF
       END DO
    END IF

  END SUBROUTINE broughtri

  SUBROUTINE broughlma
!!!$
!!!$   Unterprogramm zum Belegen der Leitfaehigkeit und zum Bestimmen der
!!!$   Rauhigkeit fuer Levenberg-Marquardt 
!!!$
!!!$   Copyright by Andreas Kemna 2010
!!!$   
!!!$   Andreas Kemna / Roland Martin                            24-Feb-2010
!!!$
!!!$   Letzte Aenderung   RM                                    24-Feb-2010
!!!$
!!!$.....................................................................
!!!$   PROGRAMMINTERNE PARAMETER:
!!!$   Hilfsvariablen
    INTEGER ::     i,j
    COMPLEX(KIND(0D0)) ::    cdum
!!!$.....................................................................
!!!$   Roughness bestimmen

    rough = 0d0

    DO j=1,manz
       IF (.NOT. lprior) THEN

          cdum = DCMPLX(smatm(j,1)) * par(j)

          IF (lfpi) THEN

             rough = DIMAG(cdum) * SUM(DIMAG(par))

          ELSE

             rough = DBLE(cdum) * REAL(SUM(DCONJG(par)))

          END IF

       ELSE

          cdum = DCMPLX(smatm(j,1)) * (par(j)-m0(j))

          IF (lfpi) THEN

             DO i=1,manz
                rough = rough + dimag(cdum)*dimag(par(i)-m0(i))
             END DO
          ELSE
             DO i=1,manz
                rough = rough + dble(cdum*dconjg(par(i)-m0(i)))
             END DO
          END IF
       END IF

    END DO

  END SUBROUTINE broughlma

  SUBROUTINE broughsto
!!!$
!!!$   Unterprogramm zum Belegen der Leitfaehigkeit und zum Bestimmen der
!!!$   Rauhigkeit. 
!!!$   Angepasst an die neue Regularisierungsmatrix (stoch. Kovarianzmatrix).
!!!$   
!!!$   Copyright by Andreas Kemna 2009
!!!$   
!!!$   Andreas Kemna / Roland Martin                            10-Jun-2009
!!!$   
!!!$   Letzte Aenderung   RM                                    30-Jun-2009
!!!$   
!!!$.....................................................................
!!!$   PROGRAMMINTERNE PARAMETER:
!!!$   Hilfsvariablen
    COMPLEX(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: parh
!!!$   parh: Parameter-Hilfsvektor (R^TR)m bzw (C_m^-1)m
!!!$.....................................................................
!!!$   Roughness bestimmen
    
    IF (.NOT. ALLOCATED(parh)) ALLOCATE (parh(manz),STAT=errnr)
    IF (errnr/=0) THEN
       fetxt = 'Allocation problem parh in proughsto'
       WRITE (*,'(/a/)')TRIM(fetxt)
       errnr = 97
       RETURN
    END IF
 
    IF (.NOT. lprior) THEN

       !$OMP WORKSHARE
       parh = MATMUL(par,DCMPLX(smatm))
       !$OMP END WORKSHARE

       IF (lfpi) THEN
          rough = DOT_PRODUCT(DIMAG(parh),DIMAG(par))
       ELSE
          rough = DOT_PRODUCT(DBLE(parh),REAL(DCONJG(par)))
       END IF

    ELSE

       !$OMP WORKSHARE
       parh = MATMUL((par - m0),DCMPLX(smatm))
       !$OMP END WORKSHARE

       IF (lfpi) THEN
          rough = DOT_PRODUCT(DIMAG(parh),DIMAG(par - m0))
       ELSE
          rough = DOT_PRODUCT(DBLE(parh),REAL(DCONJG(par - m0)))
       END IF

    END IF

    IF (ALLOCATED (parh)) DEALLOCATE (parh)

  END SUBROUTINE broughsto

END MODULE brough_mod

!> \file bsigma.f90
!> \brief set the forward model parameters \f$ \sigma_j \f$ from the inversion model parameters in ln-space, \f$ m_j \f$.

!> @author Roland Martin
!> @date 03/19/2010, last change 03/23/2010

SUBROUTINE bsigma
!     
!     Unterprogramm zur Belegung des Modell vektors (sigma)
!     mit dem verbesserten Modell aus par
!     im Moment noch unspektakulaer, da elanz = manz 
!     
!     Copyright by Andreas Kemna
!     
!     Erste Version von Roland Martin                          19-Mar-2010
!     
!     Letzte Aenderung                                         23-Mar-2010
!     
!.....................................................................

  USE invmod   ! fuer par
  USE sigmamod ! fuer sigma
  USE modelmod ! fuer manz und mnr
  USE elemmod  ! fuer elanz
  USE errmod ! fuer fetxt und errnr

  IMPLICIT none

!.....................................................................

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Hilfsfeld
!      LOGICAL,DIMENSION(:),ALLOCATABLE :: lfeld
!     Indexvariablen
  INTEGER (KIND = 4) :: i
!.....................................................................


  errnr = 4

  do i=1,elanz
     sigma(i) = CDEXP(par(mnr(i)))
  end do

  errnr = 0

end SUBROUTINE bsigma

subroutine randb2(my_a,my_b)

!!!$     Unterprogramm modifiziert die Matrix 'a' (Bandbreite 'mb') und den
!!!$     Konstantenvektor 'b' zur Beruecksichtigung der Dirichletschen Rand-
!!!$     bedingungen ('rwdanz' Randwerte 'rwd(rwdmax)' mit zugeh. Knotennummern
!!!$     'rwdnr(smax)').

!!!$     ( Vgl. Subroutine 'RBSTBNDN' in Schwarz (1991) )

!!!$     Andreas Kemna                                            12-Feb-1993
!!!$     Letzte Aenderung   15-Jul-2007

!!!$.....................................................................

  USE elemmod , ONLY : sanz, mb
  USE randbmod

  IMPLICIT none

!!!$.....................................................................
!!!$     EIN-/AUSGABEPARAMETER:

  COMPLEX (KIND (0D0)),DIMENSION ((mb+1)*sanz) :: my_a
  COMPLEX (KIND (0D0)),DIMENSION (sanz)        :: my_b

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Hilfsvariablen
  INTEGER(KIND = 4)   ::     m1
  COMPLEX(KIND(0D0))  ::     rwert

!!!$     Indexvariablen
  INTEGER(KIND = 4)   ::     ir,i,j,k,idk,ia,ki,ji

!!!$.....................................................................

  if (rwdanz.eq.0) return

  m1 = mb + 1

  do ir=1,rwdanz

     k      = rwdnr(ir)

     rwert  = rwd(ir)
     my_b(k)   = -rwert
     idk    = k*m1
     my_a(idk) = dcmplx(1d0)

     IF (k /= 1) THEN

        ia = max0(1,mb+2-k)

        do i=ia,mb
           j  = k+i-m1
           ki = idk+i-m1

           my_b(j)  = my_b(j) + rwert * my_a(ki)
           my_a(ki) = dcmplx(0d0)

        END do
     END IF

     if (k.eq.sanz) CYCLE

     ia = max0(1,k-sanz+m1)

     do i=ia,mb
        j  = k-i+m1
        ji = (j-1)*m1+i

        my_b(j)  = my_b(j) + rwert * my_a(ji)
        my_a(ji) = dcmplx(0d0)

     END do

  END do

  return
end subroutine randb2

!> \file bnachbar.f90
!> \brief find neighbouring forward modelling cells 
!> \details Find neighbouring model cells to carry out the triangular regularization in the inversion update process. The algorithms attempts to find equal edges of triangular and quadrilateral elements and marks them as neighbors 

!> @author Roland Martin
!> @date 07/29/2009, last change 08/26/2009
SUBROUTINE bnachbar
!!!$     
!!!$     Unterprogramm zum Bestimmen der Elementnachbarn
!!!$     zur Realisierung der Triangulationsregularisierung
!!!$     sowie der kleinsten moeglichen Skalenlaenge der
!!!$     stochastischen Regularisierung
!!!$     
!!!$     Copyright by Andreas Kemna 2009
!!!$     
!!!$     Erste Version von Roland Martin                          29-Jul-2009
!!!$     
!!!$     Letzte Aenderung                                         07-Aug-2009
!!!$     
!!!$.....................................................................

  USE alloci
  USE modelmod       ! fuer manz
  USE elemmod        ! fuer nachbar, nrel etc. 
  USE errmod       ! errnr und fetxt
  USE konvmod , ONLY : lverb

  IMPLICIT none


!!!$     PROGRAMMINTERNE PARAMETER:----------------------------------------
!!!$     Indexvariablen
  INTEGER :: i,j,ik,jk,count
!!!$     Knotennummer der Kanten zaehler von element i und j
  INTEGER :: ik1,ik2,jk1,jk2
!!!$-----------------------------------------------------------------------

  IF (.NOT.ALLOCATED (nachbar)) &
       ALLOCATE (nachbar(manz,max_nr_element_nodes+1),STAT=errnr)
  IF (errnr/=0) THEN
     WRITE (*,'(/a/)')'Allocation problem nachbar in bnachbar'
     errnr = 97
     RETURN
  END IF

  nachbar = 0
  count = 0
  !$OMP PARALLEL DEFAULT (none) &
  !$OMP PRIVATE (i,ik,ik1,ik2,j,jk,jk1,jk2) &
  !$OMP SHARED (nachbar,max_nr_element_nodes,count,elanz,nrel,lverb)
  !$OMP DO
  DO i=1,elanz

     !$OMP ATOMIC
     count = count + 1

     IF (lverb) WRITE (*,'(a,t70,F6.2,a)',ADVANCE='no')ACHAR(13)// &
          'bnachbar/ ',REAL (count * (100./elanz)),'%'

     DO ik=1,max_nr_element_nodes

        ik1 = nrel(i,ik)
        ik2 = nrel(i,MOD(ik,max_nr_element_nodes)+1)

        DO j=1,elanz

           IF (j==i) CYCLE

           DO jk=1,max_nr_element_nodes

              jk1 = nrel(j,jk)
              jk2 = nrel(j,MOD(jk,max_nr_element_nodes)+1)

              IF ( (ik1==jk1.AND.ik2==jk2) .OR. &
                   (ik1==jk2.AND.ik2==jk1) ) THEN

                 nachbar(i,ik) = j ! Element teilt kante
                 nachbar(i,max_nr_element_nodes+1) = nachbar(i,max_nr_element_nodes+1)+1 ! Anzahl der Nachbarn

              END IF

           END DO
!!$           IF (nachbar(i,max_nr_element_nodes + 1) < max_nr_element_nodes) THEN
!!$              PRINT*,'found border element',ik1,ik2
!!$           END IF
        END DO              ! inner loop j=1,elanz

     END DO

  END DO                    ! outer loop i=1,elanz
  !$OMP END PARALLEL

END SUBROUTINE bnachbar

subroutine parfit(fa,fb,fc,fmin,smin)

!!!$     Unterprogramm fittet Parabel durch die drei Punkte (0,fa), (0.5,fb)
!!!$     und (1,fc) und liefert Abszisse des Minimums in 'step', falls Minimum
!!!$     zwischen 0 und 1 existiert und Minimum < fmin. Sonst geeignete lineare
!!!$     Interpolation auf fmin.
!!!$     (Formel aus 'Numerical Recipes' (S. 395, eq. (10.2.1)))

!!!$     Andreas Kemna                                            28-May-1996
!!!$     Letzte Aenderung   22-Sep-1998

!!!$.....................................................................

  USE konvmod,ONLY:step

  IMPLICIT none


!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Funktionswerte, Grenzwerte
  REAL (KIND(0D0))  :: fa,fb,fc,fmin,smin

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     x-Werte
  REAL (KIND(0D0))  :: a,b,c

!!!$     Hilfsvariablen
  REAL (KIND(0D0))  :: bma,bmc,fbmfc,fbmfa,zaehler,nenner

!!!$.....................................................................

  a = 0d0
  b = 0.5d0
  c = 1d0

  if (fa.gt.fb) then

     if (fb.le.fc) then

        if (fb.le.fmin) then
           if (fa.lt.fmin.and.fc.gt.fa) then

!!!$     Zwischen 'fb' und 'fc' linear auf fmin interpolieren
              step = b + (c-b)*(fmin-fb)/(fc-fb)
           else 

!!!$     Zwischen 'fa' und 'fb' linear auf fmin interpolieren
              step = a + (b-a)*(fmin-fa)/(fb-fa)
           end if
        else

!!!$     Parabolische Interpolation auf Minimum
           bma     = b-a
           fbmfc   = fb-fc
           bmc     = b-c
           fbmfa   = fb-fa
           zaehler = bma*bma*fbmfc - bmc*bmc*fbmfa
           nenner  = bma*fbmfc - bmc*fbmfa
           step    = b - zaehler/(2d0*nenner)
        end if

     else if (fb.gt.fc) then

        if (fb.le.fmin) then

!!!$     Zwischen 'fa' und 'fb' linear auf fmin interpolieren
           step = a + (b-a)*(fmin-fa)/(fb-fa)
        else if (fc.le.fmin) then

!!!$     Zwischen 'fb' und 'fc' linear auf fmin interpolieren
           step = b + (c-b)*(fmin-fb)/(fc-fb)
        else

!!!$     Full step-length
           step = c
        end if

     end if

  else if (fa.lt.fb) then

     if (fb.ge.fc) then

        if (fb.ge.fmin) then
           if (fa.gt.fmin.and.fc.lt.fa) then

!!!$     Zwischen 'fb' und 'fc' linear auf fmin interpolieren
              step = b + (c-b)*(fmin-fb)/(fc-fb)
           else 

!!!$     Zwischen 'fa' und 'fb' linear auf fmin interpolieren
              step = a + (b-a)*(fmin-fa)/(fb-fa)
           end if
        else

!!!$     Parabolische Interpolation auf Maximum
           bma     = b-a
           fbmfc   = fb-fc
           bmc     = b-c
           fbmfa   = fb-fa
           zaehler = bma*bma*fbmfc - bmc*bmc*fbmfa
           nenner  = bma*fbmfc - bmc*fbmfa
           step    = b - zaehler/(2d0*nenner)
        end if

     else if (fb.lt.fc) then

        if (fb.ge.fmin) then

!!!$     Zwischen 'fa' und 'fb' linear auf fmin interpolieren
           step = a + (b-a)*(fmin-fa)/(fb-fa)
        else if (fc.ge.fmin) then

!!!$     Zwischen 'fb' und 'fc' linear auf fmin interpolieren
           step = b + (c-b)*(fmin-fb)/(fc-fb)
        else

!!!$     Full step-length
           step = c
        end if

     end if

  else if (fa.eq.fb) then

     if (fb.gt.fc) then

        if (fb.lt.fmin) then

!!!$     Parabolische Interpolation auf Maximum
           bma     = b-a
           fbmfc   = fb-fc
           bmc     = b-c
           fbmfa   = fb-fa
           zaehler = bma*bma*fbmfc - bmc*bmc*fbmfa
           nenner  = bma*fbmfc - bmc*fbmfa
           step    = b - zaehler/(2d0*nenner)
        else if (fc.le.fmin) then

!!!$     Zwischen 'fb' und 'fc' linear auf fmin interpolieren
           step = b + (c-b)*(fmin-fb)/(fc-fb)
        else

!!!$     Full step-length
           step = c
        end if

     else if (fb.lt.fc) then

        if (fb.gt.fmin) then

!!!$     Parabolische Interpolation auf Minimum
           bma     = b-a
           fbmfc   = fb-fc
           bmc     = b-c
           fbmfa   = fb-fa
           zaehler = bma*bma*fbmfc - bmc*bmc*fbmfa
           nenner  = bma*fbmfc - bmc*fbmfa
           step    = b - zaehler/(2d0*nenner)
        else if (fc.ge.fmin) then

!!!$     Zwischen 'fb' und 'fc' linear auf fmin interpolieren
           step = b + (c-b)*(fmin-fb)/(fc-fb)
        else

!!!$     Full step-length
           step = c
        end if

     else if (fb.eq.fc) then

!!!$     Mindest-step-length
        step = smin
     end if

  end if

!!!$     Genzen einhalten (wegen Möglichkeit der linearen "Extrapolation")
  step = dmax1(smin,step)
  step = dmin1(c,step)

  return
end subroutine parfit

!> \file rdatm.f90
!> \brief read data and electrode configurations for the forward modelling
!> @author Andreas Kemna 
!> @date 10/11/1993

subroutine rdatm(kanal,datei)

!     Unterprogramm zum Einlesen der Stromwerte sowie der Elektroden-
!     kennungen aus 'datei'.

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   22-Feb-2006

!.....................................................................

  USE datmod
  USE electrmod
  USE errmod

  IMPLICIT none


!.....................................................................

!     EIN-/AUSGABEPARAMETER:

!> unit number
  INTEGER(KIND = 4) ::    kanal

!> filename
  CHARACTER (80)    ::   datei

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariable
  INTEGER(KIND = 4) ::     i

!     Elektrodennummern
  INTEGER(KIND = 4) ::     elec1,elec2,elec3,elec4
!c check whether the file format is crtomo konform or not..
  LOGICAL           ::    crtf
!c
!.....................................................................

!     'datei' oeffnen
  fetxt = datei
  errnr = 1
  open(kanal,file=TRIM(fetxt),status='old',err=999)
  errnr = 3

!     Anzahl der Messwerte lesen
  read(kanal,*,end=1001,err=1000) nanz
!c check if data file format is CRTOmo konform..
  read(kanal,*,end=1001,err=1000) elec1
  BACKSPACE(kanal)

  elec3=elec1-10000 ! are we still positive?

  crtf=(elec3 .ge. 0) ! crtomo konform?

  ALLOCATE (strnr(nanz),strom(nanz),volt(nanz),sigmaa(nanz),&
       kfak(nanz),vnr(nanz),stat=errnr)
  IF (errnr /= 0) THEN
     fetxt = 'Error memory allocation volt '
     errnr = 94
     goto 1000
  END IF


!     Stromelektrodennummern, Stromwerte und Spannungselektrodennummern lesen
  do i=1,nanz
     WRITE (*,'(A,I6)',ADVANCE='no')ACHAR(13)//'Getting voltage ',i
     IF (crtf) THEN
        read(kanal,*,end=1001,err=1000)strnr(i),vnr(i)
     ELSE
        read(kanal,*,end=1001,err=1000)elec1,elec2,elec3,elec4
        strnr(i) = elec1*10000 + elec2
        vnr(i)   = elec3*10000 + elec4
     END IF
!     Einheitsstrom annehmen
     strom(i) = 1d0

!     Stromelektroden bestimmen
     elec1 = mod(strnr(i),10000)
     elec2 = (strnr(i)-elec1)/10000

!     Messelektroden bestimmen
     elec3 = mod(vnr(i),10000)
     elec4 = (vnr(i)-elec3)/10000

!     Ggf. Fehlermeldung
     if (elec1.lt.0.or.elec1.gt.eanz.or. &
          elec2.lt.0.or.elec2.gt.eanz.or. &
          elec3.lt.0.or.elec3.gt.eanz.or. &
          elec4.lt.0.or.elec4.gt.eanz) then
        WRITE (fetxt,'(a,I5,a)')'Electrode pair ',i,'not correct '
        errnr = 46
        goto 1000
     end if
! >> RM
! plausibility check of possible electrode intersection
! devide the strnr and vnr into elec{1,2,3,4}
! 
     IF ((elec1.eq.elec2).OR.(elec3.eq.elec4).OR.&
          &((((elec1.eq.elec3).or.(elec1.eq.elec4)).and.(elec1.ne.0)).or.&
          (((elec2.eq.elec3).or.(elec2.eq.elec4)).and.(elec2.ne.0)))) THEN
        WRITE (fetxt,'(a,I7)')' duplicate electrodes for reading ',i
        errnr = 73
        GOTO 1000
     END IF
! << RM

  end do

!     'datei' schliessen
  close(kanal)

  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

999 return

1000 close(kanal)
  return

1001 close(kanal)
  errnr = 2
  return

end subroutine rdatm

MODULE sigmamod
!!$
!!$c 'sigma.fin'
!!$
!!$c Andreas Kemna                                            10-Jul-1993
!!$c                                       Letzte Aenderung   20-Oct-1997
!!$
!!$c.....................................................................
!!$c Referenzleitfaehigkeit
    COMPLEX(KIND(0D0)),PUBLIC                          :: sigma0

    ! conductivities of the individual elements
    COMPLEX(KIND(0D0)),PUBLIC,ALLOCATABLE,DIMENSION(:) :: sigma
    !!$c save variable
    COMPLEX(KIND(0D0)),PUBLIC,ALLOCATABLE,DIMENSION(:) :: sigma2

    !!$c Background-Werte
    REAL(KIND(0D0)),PUBLIC                             :: bet0,pha0

    !!$ c Schalter ob "background" Werte eingelesen werden sollen
   LOGICAL,PUBLIC                                     :: lrho0

    !!$c Schalter ob "starting model" eingelesen werden soll
    LOGICAL,PUBLIC                                     :: lstart
    !!$c initial seed fuers verrauschen vom startmodell
   INTEGER(KIND = 4),PUBLIC                           :: iseedpri
    !!$c noise for starting model
   REAL(KIND(0D0)),PUBLIC                             :: modl_stdn


END MODULE sigmamod

!> \file rdati.f90
!> \brief read data with standard deviations and electrode configurations for the inversion
!> @author Andreas Kemna
!> @date 10/11/1993

SUBROUTINE rdati(kanal,datei)
    !     Unterprogramm zum Einlesen der Elektrodenkennungen und der Daten
    !     inkl. Standardabweichungen aus 'datei'.

    !     Andreas Kemna                                            11-Oct-1993
    !     Letzte Aenderung   20-Aug-2007

    !.....................................................................
    USE make_noise
    USE alloci, ONLY:rnd_r,rnd_p
    USE femmod
    USE datmod
    USE invmod
    USE electrmod
    USE errmod
    USE konvmod

    IMPLICIT NONE


    ! EIN-/AUSGABEPARAMETER:

    !> unit number
    INTEGER (KIND = 4) ::     kanal

    !> filename
    CHARACTER (80)     ::    datei

    !.....................................................................

    !     PROGRAMMINTERNE PARAMETER:

    !     Indexvariable
    INTEGER (KIND = 4) ::     i,ifp1,ifp2,ifp3

    !!! >> RM
    !  USED ONLY IF NOISE IS ADDED!!
    ! Magnitude and Phase of new data
    REAL(KIND(0D0))     ::     new_bet,new_pha
    ! Counting signum mismatches of magnitude and phases
    !    if noise is added
    INTEGER (KIND = 4) ::     icount_pha,icount_mag
    ! << RM

    !     Elektrodennummern
    INTEGER (KIND = 4) ::     elec1,elec2,elec3,elec4

    !     Betrag und Phase (in mrad) der Daten
    REAL(KIND(0D0))     ::     bet,pha

    !     Standardabweichung eines logarithmierten (!) Datums
    REAL(KIND(0D0))      ::     stabw

    !     Error of the resistance
    REAL(KIND(0D0))     ::     eps_r

    !     Standardabweichung der Phase
    REAL(KIND(0D0))     ::     stabwp,stabwb

    !     Error of the phase
    REAL(KIND(0D0))     ::     eps_p

    !     Pi
    REAL(KIND(0D0))     ::     pi

    ! check whether the file format is crtomo konform or not..
    LOGICAL             ::    crtf
    !.....................................................................
    pi = dacos(-1d0)

    ! 'datei' oeffnen
    fetxt = datei
    errnr = 1
    OPEN(kanal,file=TRIM(fetxt),status='old',err=999)
    errnr = 3

    ! Anzahl der Messwerte lesen
    ! also check if we may use individual errors or not
    READ(kanal,*,END=1001,err=11) nanz,lindiv
    IF (lindiv) PRINT*,'+ Individual data error!'
    GOTO 12
    11 PRINT*,'+ Taking error model'
    BACKSPACE(kanal)
    !c check if data file format is CRTOmo konform..
    12 READ(kanal,*,END=1001,err=1000) elec1
    BACKSPACE(kanal)

    elec3=elec1-10000 ! are we still positive?
    crtf=(elec3 .ge. 0) ! crtomo konform?

    ALLOCATE (strnr(nanz),strom(nanz),volt(nanz),sigmaa(nanz),&
       kfak(nanz),wmatdr(nanz),wmatdp(nanz),vnr(nanz),dat(nanz),&
       wmatd(nanz),wmatd2(nanz),sgmaa2(nanz),wdfak(nanz),wmatd_cri(nanz),&
       stat=errnr)

    wmatd = 0d0;wmatdp = 0d0; wmatdr = 0d0;wmatd_cri = 0d0
    IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation data space'
        errnr = 94
        GOTO 1000
    END IF

    !     Stromelektrodennummern, Spannungselektrodennummern, Daten inkl.
    !     auf 1 normierte Standardabweichungen lesen und Daten logarithmieren
    IF (lnse ) THEN
        icount_mag = 0;icount_pha = 0
        WRITE (*,'(A)',ADVANCE='no')ACHAR(13)//'Initializing noise'
        CALL get_unit(ifp3)
        OPEN (ifp3,FILE='inv.mynoise_voltages',STATUS='replace')
        WRITE (ifp3,*) nanz
        CALL get_unit(ifp1)
        OPEN (ifp1,FILE='inv.mynoise_rho',STATUS='replace')
        WRITE(ifp1,'(a)')'#  rnd_r'//ACHAR(9)//'eps_r'//&
            ACHAR(9)//ACHAR(9)//'bet(old)'//ACHAR(9)//'bet(new)'
        IF (.NOT. ldc) THEN
            CALL get_unit(ifp2)
            OPEN (ifp2,FILE='inv.mynoise_pha',STATUS='replace')
            WRITE(ifp2,'(a)')'#  rnd_p'//ACHAR(9)//'eps_p'//&
                ACHAR(9)//ACHAR(9)//'pha(old)'//ACHAR(9)//'pha(new)'
        END IF

        ALLOCATE (rnd_r(nanz))
        CALL Random_Init(iseed)
        DO i=1,nanz
            rnd_r(i) = Random_Gauss()
        END DO
        IF (.NOT.ldc) THEN
            ALLOCATE (rnd_p(nanz))
            CALL Random_Init(-iseed)
            DO i=1,nanz
                rnd_p(i) = Random_Gauss()
            END DO
        END IF
    END IF


    DO i=1,nanz
        stabwp = 0.; stabwb = 0.
        IF (lverb) WRITE (*,'(A,t70,F6.2,A)',ADVANCE='no')ACHAR(13)//&
            'data set ',REAL( i * (100./nanz) ),'%'
        IF (lindiv) THEN
            IF (ldc) THEN
                IF (crtf) THEN
                    READ(kanal,*,END=1001,err=1000)strnr(i),vnr(i),bet,stabw
                ELSE
                    READ(kanal,*,END=1001,err=1000)elec1,elec2,elec3,elec4,bet,&
                        stabw
                    strnr(i) = elec1*10000 + elec2
                    vnr(i)   = elec3*10000 + elec4
                END IF
            ELSE
                ! complex inversion or FPI always assume we get magnitude AND
                ! phase errors in the last two columns
                ! assume phase errors in mrad
                IF (crtf) THEN
                    READ(kanal,*,END=1001,err=1000)strnr(i),vnr(i),bet,pha,&
                        stabw,stabwp
                ELSE
                    READ(kanal,*,END=1001,err=1000)elec1,elec2,elec3,elec4,&
                        bet,pha,stabw,stabwp
                    strnr(i) = elec1*10000 + elec2
                    vnr(i)   = elec3*10000 + elec4
                END IF
                ! Ggf. Fehlermeldung
                IF (stabwp.LE.0d0) THEN
                    fetxt = ' '
                    errnr = 88
                    GOTO 1000
                END IF

                ! convert [mrad] error to [rad]
                stabwp = 1d-3*stabwp
            END IF
            ! we read in the linear errors in [Ohm]
            ! convert to log(Z) errors
            stabw = stabw / bet

            ! >> RM
            ! plausibility check of possible electrode intersection
            ! devide the strnr and vnr into elec{1,2,3,4}
            !
            ! Current electrodes
            elec1 = MOD(strnr(i),10000)
            elec2 = (strnr(i)-elec1)/10000
            ! potential electrodes
            elec3 = MOD(vnr(i),10000)
            elec4 = (vnr(i)-elec3)/10000

            IF ((elec1.eq.elec2).OR.(elec3.eq.elec4).OR.&
                  &((((elec1.eq.elec3).or.(elec1.eq.elec4)).and.(elec1.ne.0)).or.&
                  (((elec2.eq.elec3).or.(elec2.eq.elec4)).and.(elec2.ne.0)))) THEN
                WRITE (fetxt,'(a,I7)')' duplicate electrodes for reading ',i
                errnr = 73
                GOTO 1000
            END IF

            ! Ggf. Fehlermeldung
            IF (elec1.LT.0.OR.elec1.GT.eanz.OR. &
                 elec2.LT.0.OR.elec2.GT.eanz.OR. &
                 elec3.LT.0.OR.elec3.GT.eanz.OR. &
                 elec4.LT.0.OR.elec4.GT.eanz) THEN
                WRITE (fetxt,'(a,I5,a)')'Electrode pair ',i,'not correct '
                errnr = 46
                GOTO 1000
            END IF
            ! Ggf. Fehlermeldung
            IF (stabw.LE.0d0) THEN
               fetxt = ' '
               errnr = 88
               GOTO 1000
            END IF

        ELSE ! no individual errors (not lindiv)
            ! use the error model
            IF (ldc) THEN
                IF (crtf) THEN
                    READ(kanal,*,END=1001,err=1000)strnr(i),vnr(i),bet
                ELSE
                    READ(kanal,*,END=1001,err=1000)elec1,elec2,elec3,elec4,bet
                    strnr(i) = elec1*10000 + elec2
                    vnr(i)   = elec3*10000 + elec4
                END IF
            ELSE
                IF (crtf) THEN
                    READ(kanal,*,END=1001,err=1000)strnr(i),vnr(i),bet,pha
                ELSE
                    READ(kanal,*,END=1001,err=1000)elec1,elec2,elec3,elec4,bet,pha
                    strnr(i) = elec1*10000 + elec2
                    vnr(i)   = elec3*10000 + elec4
                END IF

                !!!!!!!!!!!!!!!!!!! PHASE ERROR!!!!!!!!!!!!!!!!!!!!!!!!!!!!
               stabwp = ( stabpA1*bet**stabpB &
                    + 1d-2*stabpA2*dabs(pha) + stabp0 ) * 1d-3
                !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            END IF

            ! Ggf. Fehlermeldung
            IF (bet.LE.0d0) THEN
                WRITE (fetxt,'(A,I6)')'Error reading ',i
                fetxt = 'Error memory allocation data space'

                errnr = 94
                GOTO 1000
            END IF

            !!!!!!!!!!!! RESISTANCE ERROR !!!!!!!!!!!!!!!!!!!!!!!!!!!!
            ! note that this already IS the error of log(Z) = 1 / bet * dZ
            stabw = 1d-2*stabw0 + stabm0/bet
            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

            IF ( lnse ) THEN ! add synthetic noise
                eps_r = 1d-2*nstabw0 * bet + nstabm0
                WRITE(ifp1,'(3(G14.4,1X))',ADVANCE='no')rnd_r(i),eps_r,bet

                ! initialize
                new_pha = pha; new_bet = bet

                IF (.NOT. ldc) THEN
                    eps_p = (nstabpA1*eps_r**nstabpB + 1d-2*nstabpA2*dabs(pha) &
                        + nstabp0)

                    ! eps_p = (nstabpA1*bet**nstabpB + 1d-2*nstabpA2*dabs(pha) + nstabp0)

                    WRITE(ifp2,'(3(G14.4,1X))',ADVANCE='no')rnd_p(i),eps_p,pha

                    new_pha = pha + rnd_p(i) * eps_p ! add noise

                    WRITE(ifp2,'(G14.4)')new_pha
                    IF (SIGN(pha,new_pha) /= SIGN(pha,pha)) THEN
                        icount_pha = icount_pha + 1
                    END IF
                END IF
                new_bet = bet + rnd_r(i) * eps_r ! add noise

                WRITE(ifp1,'(G14.4)')new_bet
                IF (SIGN(bet,new_bet) /= SIGN(bet,bet)) THEN
                    icount_mag = icount_mag + 1
                END IF

                !! assign the noised values
                bet = new_bet;pha = new_pha

                ! write out full noisy data as measured voltages..
                WRITE (ifp3,*)strnr(i),vnr(i),bet,pha
            END IF
        END IF

        ! Ggf. Fehlermeldung
        IF (bet.LE.0d0) THEN
            fetxt = ' '
            errnr = 94
            GOTO 1000
        END IF

        IF (ldc) THEN
            ! set phase to zero internally
            pha = 0d0
        ELSE
            ! Ggf. Fehlermeldung
            IF (dabs(pha).GT.1d3*pi) THEN
                fetxt = ' '
                errnr = 95
                GOTO 1000
            END IF
        END IF

        dat(i)   = dcmplx(-dlog(bet),-pha/1d3)

        wmatdr(i) = 1d0/(stabw**2d0) !=C_d^{-1} !!!!

        ! ak if (lfphai) wmatd(i)=1d0/dsqrt(stabw*stabw+stabwp*stabwp)
        IF (.NOT.ldc) THEN
            wmatd_cri(i)=1d0/(stabw**2d0+stabwp**2d0)
            wmatdp(i)=1d0/(stabwp**2d0)
        END IF

        wdfak(i) = 1

        ! Stromelektroden bestimmen
        elec1 = MOD(strnr(i),10000)
        elec2 = (strnr(i)-elec1)/10000

        ! Messelektroden bestimmen
        elec3 = MOD(vnr(i),10000)
        elec4 = (vnr(i)-elec3)/10000

        ! Ggf. Fehlermeldung
        IF (elec1.LT.0.OR.elec1.GT.eanz.OR. &
                elec2.LT.0.OR.elec2.GT.eanz.OR. &
                elec3.LT.0.OR.elec3.GT.eanz.OR. &
                elec4.LT.0.OR.elec4.GT.eanz) THEN
            WRITE (fetxt,'(a,I5,a)')'Electrode pair ',i,'not correct '
            errnr = 46
            GOTO 1000
        END IF
    END DO ! i=1,nanz
    ! ak
    IF (lindiv) THEN
        IF (ldc) THEN
            read(kanal,*,end=1001,err=1000) stabw
            if (stabw.le.0d0) then
                fetxt = ' '
                errnr = 88
                goto 1000
            end if
            wmatdr = wmatdr * stabw * stabw
        ELSE
            read(kanal,*,end=1001,err=1000) stabw,stabwp
            IF (stabw.le.0d0.OR.stabwp <= 0d0) THEN
                fetxt = ' '
                errnr = 88
                goto 1000
            END IF
            wmatdr = wmatdr * stabw * stabw
            wmatdp = wmatdp * stabwp * stabwp
        END IF
    END IF

    ! 'datei' schliessen
    CLOSE(kanal)
    IF ( lnse ) THEN
         IF (icount_pha > 0)THEN
            PRINT*
            PRINT*,'-- Counted ',icount_pha,&
                 ' different phase signs'
            !!$        fetxt = '-- check noise parameters in crt.noisemod (Phase > 0)'
            !!$        errnr = 57
            !!$        GOTO 1000
            PRINT*
        END IF
        IF (icount_mag > 0) THEN
            PRINT*
            PRINT*,'-- Counted ',icount_mag,&
                 ' different resistance signs'
            !!$        fetxt = '-- check noise parameters in crt.noisemod (Magnitude < 0)'
            !!$        errnr = 57
            !!$        GOTO 1000
            PRINT*
        END IF

        CLOSE (ifp1)
        IF (.NOT.ldc) CLOSE (ifp2)
        CLOSE (ifp3)
    END IF
    errnr = 0
    IF (ALLOCATED (rnd_r)) DEALLOCATE (rnd_r)
    IF (ALLOCATED (rnd_p)) DEALLOCATE (rnd_p)

    RETURN

    !:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    !     Fehlermeldungen

    999 RETURN

    1000 CLOSE(kanal)
      RETURN

    1001 CLOSE(kanal)
      errnr = 2
      RETURN

END SUBROUTINE rdati

MODULE randbmod
!!$c 'randb.fin'
!!$
!!$c Andreas Kemna                                            03-May-1993
!!$c                                       Letzte Aenderung   15-Jul-2007
!!$
!!$c.....................................................................

!!!$Anzahl der vorgegebenen Potentialwerte (Dirichletsche Randbedingung)
  INTEGER(KIND = 4),PUBLIC                             :: rwdanz

!!!$Knotennummern der vorgegebenen Potentialwerte
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE    :: rwdnr

!!!$Randwerte (Dirichletsche Randbedingung)
    REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE    :: rwddc
    COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE :: rwd

!!!$Zeiger ab wann Potentialwerte automatisch belegt werden sollen
    INTEGER(KIND = 4),PUBLIC                           :: rwdbnr

!!!$Anzahl der Randwerte (Neumannsche Randbedingung)
    INTEGER(KIND = 4),PUBLIC                           :: rwnanz
    
!!!$Randwerte (Neumannsche Randbedingung)
!!!$(fuer 'beta' belegt mit den Widerstandswerten der Randelemente)
    REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE    :: rwndc
    COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE :: rwn
  

END MODULE randbmod

!> \file gauleg.f90
!> \brief Gauss-Legendre integration
!> \details Gauss-Legendre integration: Returns the abcissas (x) and weights(w) of length n for a Gauss quadrature integration. Provides \f$x_i\f$ and \f$w_i \f$ inside
!> \f[ \sum_{x_1}^{x_2} f(x) dx = \sum_{i=1}^N w_i f(x_i) \f] 
!> Details can be found in Press et al. <I> Numerical Resipes in Fortran 77 and 90 (second edition) </I> (2001), pp. 145
!> @author William H. Press, Saul A. Teukolsky, William T. Vetterling, Brian P. Flannery
!> @date 2001

SUBROUTINE gauleg(x1,x2,x,w,n)
  IMPLICIT none
  INTEGER (KIND = 4)  :: n
  REAL (KIND(0D0))    :: x1,x2,x(n),w(n)
  REAL (KIND(0D0))    :: EPS
  PARAMETER (EPS=3.d-14)
  INTEGER (KIND = 4)  :: i,j,m
  REAL (KIND(0D0))    :: p1,p2,p3,pp,xl,xm,z,z1
  m=(n+1)/2
  xm=0.5d0*(x2+x1)
  xl=0.5d0*(x2-x1)
  do i=1,m
     z=cos(3.141592653589793d0*(dble(i)-.25d0)/(dble(n)+.5d0))
1    continue
     p1=1.d0
     p2=0.d0
     do j=1,n
        p3=p2
        p2=p1
        p1=((2.d0*dble(j)-1.d0)*z*p2-(dble(j)-1.d0)*p3)/dble(j)
     END DO
     pp=dble(n)*(z*p1-p2)/(z*z-1.d0)
     z1=z
     z=z1-p1/pp
     if(dabs(z-z1).gt.EPS)goto 1
     x(i)=xm-xl*z
     x(n+1-i)=xm+xl*z
     w(i)=2.d0*xl/((1.d0-z*z)*pp*pp)
     w(n+1-i)=w(i)
  END DO
  return
END SUBROUTINE gauleg

!> \file bpar.f90
!> \brief set the inversion (logarithmic) model parameters for all cells
!> \details Assign complex conductivity values \f$ \sigma_i \f$ to the corresponding model parameters \f$ m_j \f$. The routine is meant to be used in the future for <I> composite</I> elements, i.e., inversion parameters stretching over multiple modeling cells (\f$manz \neq nanz\f$).

!> @author Roland Martin
!> @date 03/19/2010, last change 03/23/2010

SUBROUTINE bpar
!     
!     Unterprogramm zur Belegung des Parameter Vektors
!     im Moment noch unspektakulaer, da elanz = manz 
!     
!     Copyright by Andreas Kemna
!     
!     Erste Version von Roland Martin                          19-Mar-2010
!     
!     Letzte Aenderung                                         23-Mar-2010
!     
!.....................................................................

  USE invmod, ONLY: par   ! fuer par
  USE sigmamod,ONLY: sigma ! fuer sigma
  USE modelmod,ONLY:mnr ! fuer manz und mnr
  USE elemmod,ONLY:elanz  ! fuer elanz
  USE errmod,ONLY:errnr ! fuer fetxt und errnr

  IMPLICIT none

!.....................................................................

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Hilfsfeld
!      LOGICAL,DIMENSION(:),ALLOCATABLE :: lfeld
!     Indexvariablen
  INTEGER (KIND = 4) ::     i
!.....................................................................


  errnr = 4

  do i=1,elanz
     par(mnr(i))   = CDLOG(sigma(i))
  end do

  errnr = 0

end SUBROUTINE bpar

SUBROUTINE linvz(a,p,n)
!!$c-----------------------------------------------------------------
!!$c
!!$c                Inverse of a Lower Triangular Matrix
!!$c                ************************************
!!$c
!!$c This subroutine finds the inverse of factorized Lower triangular
!!$c 
!!$c from Numerical recipies (Press et al 2003)
!!$c 
!!$c Changed and put into this format by R. Martin 2010
!!$c
!!$c
!!!$ in order to find the inverse of A we still need to compute 
!!!$ (L^-1)^T L^-1 , since
!!!$ (L^-1)^T L^-1 L L^T = I
!!!$
!!$c INPUT VARIABLES:
!!$c
!!$c   u(n,n)  Upper triangular matrix from chold
!!$c           which stores the inverse of A^-1 = (L^-1)^T L^-1
!!$c           in the upper part..
!!$c   p(n)    Eigenvalues of former A
!!$c   n       leading dimension 
!!$c-----------------------------------------------------------------
  IMPLICIT none
  
  INTEGER,INTENT (IN)                  :: n
  COMPLEX (KIND(0D0)), DIMENSION (n,n) :: a
  COMPLEX (KIND(0D0)), DIMENSION (n)   :: p
  COMPLEX (KIND(0D0))                  :: s
  INTEGER                              :: k,i,j


  DO i= 1 , n
     WRITE (*,'(A,t25,F6.2,A)',ADVANCE='no')&
          ACHAR(13)//'/ ',REAL( (i) * (100./n)),'%'

     a(i,i) = 1. / p(i)! main diagonal of L^-1

     DO j = i+1 , n

        s = 0.

        DO k = i , j-1

           s = s - a(j,k) * a(k,i)

        END DO

        a(j,i) = s / p(j) ! filling lower triangle of L^-1
        
        a(i,j) = 0. ! upper triangle eq zero for sum

     END DO

  END DO

!!$ --------------- own part -------------------
!!$ this part makes the inverse of A by MATMUL 
!!$ of L^-T L-^1 into the
!!$ upper part of a
!!$ --------------------------------------------

  DO i = 1, n
     WRITE (*,'(A,t25,F6.2,A)',ADVANCE='no')&
          ACHAR(13)//'/ ',REAL( (n-i) * (100./n)),'%'

     a(i,i) = a(i,i) * a(i,i) 

     DO k = i+1 , n

        a(i,i) = a(i,i) + a(k,i) * a(k,i) ! main diagonal

     END DO

     DO j = i + 1, n ! fills upper triangle with (L^-1)^T L^-1
        
        DO k = j, n

           a(i,j) = a(i,j) + a(k,i) * a(k,j) 

        END DO
     END DO

  END DO

END SUBROUTINE linvz
    

!> \file bsensi.f90
!> \brief inversion sensitivity calculation (divided by \f$ \sigma \f$)
!> \details Kemna (2000): An elegant way of deriving an appropriate sensitivity expression via reciprocity starts directly from the linear FE equations (e.g., Rodi, 1976; Oristaglio and Worthington, 1980). Substituting 
!> \f[ S = \sum_{j=1}^{N_e}{\sigma_j \left( S_{1j}+ k^2 S{2j} \right)} + \sum_{j=1}^{N_b}{\beta_j S_{3j}} \f]
!> and 
!> \f[ b = - \left[ \sum_{j=1}^{N_e}{\Delta \sigma_j \left( S_{1j} + k^2 S_{2j} \right)} + \sum_{j=1}^{N_e}{\Delta \beta_j S_{3j}} \right] \tilde \phi_p \f]
!> into the matrix equation
!> \f[ S\tilde \phi_s = b \f]
!>  and subsequently taking the derivative with respect to the complex conductivity of the j-th domain element, it is easily shown that
!> \f[ S \frac{\partial \tilde \phi}{\partial \sigma_j} = -\left( S_{1j} + k^2 S_{2j} \right) \tilde\phi \f]
!> Note that although the boundary-element parameters \f$ \beta_j \f$ in the first expression may be determined with the help of the conductivity values of the respective adjacent cells, virtually, they must not be considered as domain-element parameters. Therefore, the derivative within the right-hand side of the above equation includes no contribution on this account.
!> 
!> A further remark on the general complex differentiability of the discrete complex potential values in \f$ \tilde \phi \f$ may be added. Obviously, from the first equation it is  \f$ \partial S / \partial \sigma_j = \i \partial S / \partial \Re (\sigma_j) \f$. Hence, from the above equation, it is readily seen that each function \f$\tilde\phi_i (\sigma_j) \f$ fulfills the Cauchy-Riemann conditions
!> \f[ \frac{\partial \Re \tilde\phi_i}{\partial\Re \sigma_j} = \frac{\partial \Im \tilde\phi_i}{\partial\Im \sigma_j}, \ \frac{\partial \Im \tilde\phi_i}{\partial\Re \sigma_j} = -\frac{\partial \Re \tilde\phi_i}{\partial\Im \sigma_j} \f]
!> and, thus, is actually analytic (i.e., complex differentiable).
!> From the analogy with the original FE matrix equation for the (total) potential, the sensitivity \f$ \partial \tilde \phi_{i,l} / \partial \sigma_j \f$, corresponding to a potential \f$ \tilde \phi_{i,l} \f$ at node \f$ i \f$ due to a source at node \f$ l \f$, can be represented as a superposition of potentials \f$ \tilde \phi_{i,m} \f$ originated from ‘fictitious’ sources at the nodes  of the j-th domain element (e.g., Sasaki, 1989). By the principle of reciprocity, the values \f$ \tilde \phi_{i,m} \f$ can be expressed via potentials \f$ \tilde \phi_{m,i} \f$ at the nodes  due to a current \f$ I_i \f$ at node \f$ i \f$. Analogous to the DC resistivity problem (e.g., Kemna  1995), for the complex sensitivity the expression ultimately results in:
!> \f[ S \frac{\partial \tilde \phi}{\partial \sigma_j} = -\frac{1}{I_i} \sum_m{\sum_n{a_{j_{mn}} \tilde \phi_{{m,i}}} \tilde \phi_{n,l} }\f]
!> where the double sum is made over all nodes \f$ m,n \f$ of the respective element, and \f$ a_{j_{mn}}\f$ is the \f$ m,n\f$-th element of the matrix \f$ S_{1j} + k^2 S_{2j} \f$. From the last equation, the sensitivities are simply obtained by a weighted sum of complex potential products.

!> @author Andreas Kemna
!> @date 04/09/1995, last change 03/07/2003

SUBROUTINE bsensi(tictoc)

!!!$     Unterprogramm zur Berechnung der Sensitivitaeten.

!!!$     Andreas Kemna                                            09-Apr-1995
!!!$     Letzte Aenderung   07-Mar-2003

!!!$.....................................................................

  USE alloci
  USE femmod
  USE datmod
  USE sigmamod
  USE electrmod
  USE modelmod
  USE elemmod
  USE wavenmod
  USE errmod
  USE konvmod,ONLY: lverb
  USE ompmod
  USE tic_toc

  IMPLICIT NONE

!!!$.....................................................................
  LOGICAL :: tictoc
!!!$     PROGRAMMINTERNE PARAMETER:
  INTEGER,PARAMETER :: ntd=2
!!!$     Aktuelle Elementnummer
  INTEGER (KIND = 4)  ::     iel

!!!$     Aktueller Elementtyp
  INTEGER (KIND = 4)  ::     ntyp

!!!$     Anzahl der Knoten im aktuellen Elementtyp
  INTEGER (KIND = 4)  ::     nkel

!!!$     Elektrodennummern
  INTEGER (KIND = 4)  ::     elec1,elec2,elec3,elec4

!!!$     Beitraege zur Superposition
  COMPLEX (KIND(0D0)) ::    sup(4)

!!!$     Indexvariablen
  INTEGER (KIND = 4)  ::     ityp,jnel,mi,mj,imn,imax,imin
  INTEGER (KIND = 4)  ::     i,j,k,icount

!!!$     Hilfsfeld
  COMPLEX(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: hsens

!!!$     Hilfsvariablen
  INTEGER (KIND = 4)  ::     nzp,nnp,c1
  COMPLEX (KIND(0D0)) ::    dum

!!!$     Pi
  REAL (KIND(0D0))    ::     pi

!!!$.....................................................................

  pi = dacos(-1d0)
  !     get memory for hsens

  IF (tictoc) CALL tic(c1)
!!!$     Sensitivitaetenfeld auf Null setzen
  sens = DCMPLX(0d0)

  icount = 0
  !$OMP PARALLEL DEFAULT (none) &
  !$OMP FIRSTPRIVATE (hsens) &
  !$OMP SHARED (icount,strnr,vnr,typanz,typ,selanz,kwnanz,lverb,sigma,&
  !$OMP nrel,kpot,elbg,strom,kwnwi,pi,mnr,nanz,swrtr,nelanz,volt,sens) &
  !$OMP PRIVATE(iel,elec1,elec2,elec3,elec4,sup,imin,imn,&
  !$OMP ntyp,jnel,nkel,nzp,nnp,imax,dum)
  !$OMP DO SCHEDULE (GUIDED,CHUNK_0)
!!!$     Messwert hochzaehlen
  DO i=1,nanz
     iel = 0

     !$OMP ATOMIC
     icount = icount + 1

     IF (lverb) WRITE(*,'(a,t50,F6.2,A)',advance='no')ACHAR(13)//&
          'Sensitivity/ ',REAL(icount)/REAL(nanz) * 100.,'%'

!!!$     Stromelektroden bestimmen
     elec1 = MOD(strnr(i),10000)
     elec2 = (strnr(i)-elec1)/10000

!!!$     Messelektroden bestimmen
     elec3 = MOD(vnr(i),10000)
     elec4 = (vnr(i)-elec3)/10000

!!!$     Beitraege zur Superposition auf Null setzen
     DO j=1,4
        sup(j) = dcmplx(0d0)
     END DO

     DO ityp=1,typanz
        ntyp = typ(ityp)
        nkel = selanz(ityp)

!!!$     Ggf. zu neuem Messwert springen
        IF (ntyp.GT.10) CYCLE

        DO jnel=1,nelanz(ityp)

!!!$     Elementnummer hochzaehlen
           iel = iel + 1

!!!$     SENSITIVITAETEN BERECHNEN
          ALLOCATE (hsens(kwnanz))
           DO k=1,kwnanz
              hsens(k) = dcmplx(0d0)

!!!$     Knoten des aktuellen Elements hochzaehlen
              DO mi=1,nkel
                 nzp = nrel(iel,mi)

                 DO mj=1,nkel
                    nnp  = nrel(iel,mj)
                    imax = max0(mi,mj)
                    imin = min0(mi,mj)
                    imn  = imax*(imax-1)/2+imin

!!!$     Beitraege nach "Reziprozitaetsmethode" gewichtet aufaddieren und
!!!$     superponieren
!!!$     (beachte: 'volt = pot(elec4) - pot(elec3)' ,
!!!$     '+I' bei 'elec2', '-I' bei 'elec1' )
                    IF (elec1.GT.0) sup(1) = kpot(nnp,elec1,k)
                    IF (elec2.GT.0) sup(2) = kpot(nnp,elec2,k)
                    IF (elec3.GT.0) sup(3) = kpot(nzp,elec3,k)
                    IF (elec4.GT.0) sup(4) = kpot(nzp,elec4,k)

!!!$     ACHTUNG: Bei grossen Quellabstaenden UNDERFLOW moeglich, da einzelnen
!!!$     Potentiale sehr klein (vor allem bei grossen Wellenzahlen)!
!!!$     -> mittels Compiler-Einstellung auf Null setzen!
!!!$     MsDev5.0: "/fpe:3 /check:underflow" -> "/fpe:0"
                    dum      = (sup(2)-sup(1)) * (sup(4)-sup(3))
                    hsens(k) = hsens(k) + dcmplx(elbg(iel,imn,k))* dum

                 END DO
              END DO
           END DO
!!!$     GGF. RUECKTRANSFORMATION
           IF (swrtr.EQ.0) THEN

              dum = hsens(1)

           ELSE

              dum = dcmplx(0d0)

              DO k=1,kwnanz
                 dum = dum + hsens(k)*dcmplx(kwnwi(k))
              END DO

              dum = dum / dcmplx(pi)

           END IF
         DEALLOCATE (hsens)
!!!$     hier koennte auch eine mittelung passieren
           sens(i,mnr(iel)) = sens(i,mnr(iel)) + dum * sigma(iel)/volt(i)
        END DO
     END DO
  END DO
  !$OMP END PARALLEL
  fetxt = 'bsensi::'
  IF (tictoc) CALL toc(c1,fetxt)



END SUBROUTINE bsensi

SUBROUTINE chold(a,p,n,ierr,lverb)
!!$c-----------------------------------------------------------------
!!$c
!!$c                      Cholesky Decomposition
!!$c                      **********************
!!$c
!!$c This subroutine calculates the lower triangular matrix L which,
!!$c when multiplied by its own transpose, gives the symmetric 
!!$c matrix A. From Numerical recipies (Press et al 2003)
!!$c 
!!$c Changed and put into this format by R. Martin 2010
!!$c
!!$c**********          NOTE           ***************************
!!$c chold In this form needs only the upper triangular part of a
!!$c and stores L in the lower part.
!!$c P contains the diagonal entries (EVs)
!!$c**************************************************************
!!$c INPUT VARIABLES:
!!$c
!!$c   a(n,n) Symmetric positive definite nxn matrix
!!$c          to be decomposed
!!$c          Upper part still contains A and lower part is filled with L
!!$c   p(n)   Eigenvalues of a 
!!$c   ierr   Error code:  ierr=0 - no errors; ierr=1 - matrix a
!!$c          is not positive definite
!!$c NO EXTERNAL REFERENCES:
!!$c------------------------------------------------------------
  USE ompmod

  IMPLICIT none

  INTEGER,INTENT (IN)                             :: n
  REAL (KIND(0D0)), DIMENSION (n,n),INTENT(INOUT) :: a
  REAL (KIND(0D0)), DIMENSION (n),INTENT(OUT)     :: p
  LOGICAL,INTENT(IN)                              :: lverb
  INTEGER, INTENT (OUT)                           :: ierr
  INTEGER                                         :: i,k,j,count

  ierr = 0
  count = 0

  DO j = 1, n

     count = count + 1
     
     IF (lverb) WRITE (*,'(A,t25,F6.2,A)',ADVANCE='no')&
          ACHAR(13)//'Factorization',REAL( count * (100./n)),'%'
     DO k = 1, j - 1
        DO i = j, n
           a(i,j) = a(i,j) - a(i,k) * a(j,k)
        END DO
     END DO

     IF (a(j,j) <= 0) THEN
        PRINT*,'CHOLD:: - not positive definite', j,a(j,j)
        ierr = -j
        STOP
     END IF
     
     p(j) = DSQRT(a(j,j))
     a(j,j) = p(j)
     DO i = j + 1, n
        a(i,j) = a(i,j) / p(j)
     END DO
  END DO

END SUBROUTINE chold

!     -*- f90 -*-
!     This file is autogenerated with f2py (version:2.2.4)
!     It contains Fortran 90 wrappers to fortran functions.

      subroutine f2py_elemmod_getdims_typ(r,s,f2pysetdata,flag)
      use elemmod, only: d => typ

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_typ
      subroutine f2py_elemmod_getdims_nelanz(r,s,f2pysetdata,flag)
      use elemmod, only: d => nelanz

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_nelanz
      subroutine f2py_elemmod_getdims_selanz(r,s,f2pysetdata,flag)
      use elemmod, only: d => selanz

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_selanz
      subroutine f2py_elemmod_getdims_snr(r,s,f2pysetdata,flag)
      use elemmod, only: d => snr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_snr
      subroutine f2py_elemmod_getdims_sx(r,s,f2pysetdata,flag)
      use elemmod, only: d => sx

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_sx
      subroutine f2py_elemmod_getdims_sy(r,s,f2pysetdata,flag)
      use elemmod, only: d => sy

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_sy
      subroutine f2py_elemmod_getdims_spx(r,s,f2pysetdata,flag)
      use elemmod, only: d => spx

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_spx
      subroutine f2py_elemmod_getdims_spy(r,s,f2pysetdata,flag)
      use elemmod, only: d => spy

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_spy
      subroutine f2py_elemmod_getdims_nrel(r,s,f2pysetdata,flag)
      use elemmod, only: d => nrel

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_nrel
      subroutine f2py_elemmod_getdims_rnr(r,s,f2pysetdata,flag)
      use elemmod, only: d => rnr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_rnr
      
      subroutine f2pyinitelemmod(f2pysetupfunc)
      use elemmod, only : sanz
      use elemmod, only : typanz
      use elemmod, only : mb
      use elemmod, only : typ
      use elemmod, only : nelanz
      use elemmod, only : selanz
      use elemmod, only : snr
      use elemmod, only : sx
      use elemmod, only : sy
      use elemmod, only : spx
      use elemmod, only : spy
      use elemmod, only : nrel
      use elemmod, only : elanz
      use elemmod, only : relanz
      use elemmod, only : rnr
      use elemmod, only : smaxs
      external f2pysetupfunc
      external f2py_elemmod_getdims_typ
      external f2py_elemmod_getdims_nelanz
      external f2py_elemmod_getdims_selanz
      external f2py_elemmod_getdims_snr
      external f2py_elemmod_getdims_sx
      external f2py_elemmod_getdims_sy
      external f2py_elemmod_getdims_spx
      external f2py_elemmod_getdims_spy
      external f2py_elemmod_getdims_nrel
      external f2py_elemmod_getdims_rnr
      call f2pysetupfunc(sanz,typanz,mb,f2py_elemmod_getdims_typ,f2py_el&
     &emmod_getdims_nelanz,f2py_elemmod_getdims_selanz,f2py_elemmod_getd&
     &ims_snr,f2py_elemmod_getdims_sx,f2py_elemmod_getdims_sy,f2py_elemm&
     &od_getdims_spx,f2py_elemmod_getdims_spy,f2py_elemmod_getdims_nrel,&
     &elanz,relanz,f2py_elemmod_getdims_rnr,smaxs)
      end subroutine f2pyinitelemmod

      subroutine f2py_electrmod_getdims_enr(r,s,f2pysetdata,flag)
      use electrmod, only: d => enr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_electrmod_getdims_enr
      
      subroutine f2pyinitelectrmod(f2pysetupfunc)
      use electrmod, only : eanz
      use electrmod, only : enr
      external f2pysetupfunc
      external f2py_electrmod_getdims_enr
      call f2pysetupfunc(eanz,f2py_electrmod_getdims_enr)
      end subroutine f2pyinitelectrmod

      
      subroutine f2pyiniterrmod(f2pysetupfunc)
      use errmod, only : errnr
      use errmod, only : errflag
      use errmod, only : fetxt
      external f2pysetupfunc
      call f2pysetupfunc(errnr,errflag,fetxt)
      end subroutine f2pyiniterrmod

      
      subroutine f2pyinitcmk(f2pysetupfunc)
      use cmk, only : run_cutmck
      external f2pysetupfunc
      call f2pysetupfunc(run_cutmck)
      end subroutine f2pyinitcmk

!> \file update.f90
!> \brief compute the model update 
!> \details Computes the model update \f$ \Delta m \f$, which is the solution of the Normal Equations (Kemna and Binles 1996): 
!> \f[ B_q  \Delta m =b_q, \f]
!> with 
!> \f[ B_q = A_q^H W_d^H W_d A_q +\lambda W_m^T W_m \f]
!> and
!> \f[ b_q = A_q^H W_d^H W_d (d-f(m)) -\lambda W_m^T W_m m_q. \f]
!> In this case, \f$ A_q \f$ is the current Jacobian, \f$ W_d \f$ is the data weighting, \f$ W_m \f$ is the model weighing, \f$ d \f$ and \f$ f(m) \f$ are measured and synthetical data, respectively.

!!>     Unterprogramm zum Bestimmen und Anbringen der Modellverbesserung
!!!     mittels 'Smoothness Least Squares Method' und konjugierten
!!!     Gradienten.
!!<     Fuer beliebige Triangulierung und Stochastische Regularisierung.
!!     
!> @author Andreas Kemna
!> @date 01-Mar-1996
!> @author Roland Martin     
!> @date 03-Aug-2009 until Sep. 2013
!!> - translation to Fortran 90
!!> - added general in code docu for specific parts     
!!> - added and tested triangular regularization (2009)
!!> - added and tested stochastic regularization (2010-2011)
!!> - added and tested reference model regularization (2012)
!!> - added doxy comments (2013)

SUBROUTINE update()
!.....................................................................

  USE alloci
  USE femmod
  USE datmod
  USE invmod
  USE cjgmod
  USE sigmamod
  USE modelmod
  USE elemmod
  USE cg_mod
  USE errmod
  USE konvmod

  IMPLICIT NONE


!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

  COMPLEX (KIND(0D0)) ::   cdum,cdum2
  REAL (KIND(0D0))    ::   dum,dum2

  INTEGER (KIND=4)    ::  i,j,ij,in
!.....................................................................

  IF (.NOT. llam) THEN

!     Felder speichern
     dpar2 = dpar
     cgres2 = cgres

!     Smoothnessvektor berechnen, bzw die RHS (Right Hand Side)
!       b_q = A_q^h*C_d^-1*A_q*(d-f(m_q))-\lam C_m^-1 m_q
     IF (ltri==0) THEN
        DO i=1,manz
           cdum = dcmplx(0d0)
!     diff+<
           IF (.NOT.lprior) THEN
! C_m^-1 * m_q
!     diff+>
              IF (i.GT.1) cdum = dcmplx(smatm(i-1,2))*par(i-1)
              IF (i.LT.manz) cdum = cdum + dcmplx(smatm(i,2))*par(i+1)
              IF (i.GT.nx) cdum = cdum + dcmplx(smatm(i-nx,3))*par(i-nx)
              IF (i.LT.manz-nx+1) cdum = cdum + dcmplx(smatm(i,3))*par(i+nx)

              bvec(i) = cdum + dcmplx(smatm(i,1))*par(i)
!     diff+<
           ELSE
! C_m^-1 * (m_q - m_0)
              IF (i.GT.1) cdum = dcmplx(smatm(i-1,2)) * (par(i-1)-m0(i-1))
              IF (i.LT.manz) cdum = cdum + dcmplx(smatm(i,2)) * &
                   (par(i+1)-m0(i+1))
              IF (i.GT.nx) cdum = cdum + dcmplx(smatm(i-nx,3)) * &
                   (par(i-nx)-m0(i-nx))
              IF (i.LT.manz-nx+1) cdum = cdum + dcmplx(smatm(i,3)) * &
                   (par(i+nx)-m0(i+nx))

              bvec(i)=cdum+dcmplx(smatm(i,1))*(par(i)-m0(i))

           END IF
!     diff+>
        END DO
!!$c Damping--
     ELSE IF (ltri == 3.OR.ltri == 4) THEN

        WRITE(*,'(a)',ADVANCE='no')&
             'update:: damping has no part in the gradient'

!     triang>
     ELSE IF (ltri == 1.OR.ltri == 2.OR. &
          (ltri > 4 .AND. ltri < 15)) THEN
! C_m^-1 * m_q
! C_m^-1 * (m_q - m_0)
        DO i=1,manz
           cdum = dcmplx(0d0)
           DO ij=1,max_nr_element_nodes
              in = nachbar(i,ij)
              IF (in /= 0) THEN
                 IF (.NOT. lprior) THEN
                    cdum = cdum + DCMPLX(smatm(i,ij)) * par(in)
                 ELSE
                    cdum = cdum + DCMPLX(smatm(i,ij)) * (par(in) - m0(in))
                 END IF
              END IF
           END DO
           IF (.NOT. lprior) THEN
              bvec(i) = cdum + DCMPLX(smatm(i,max_nr_element_nodes+1)) * par(i)
           ELSE
              bvec(i) = cdum + DCMPLX(smatm(i,max_nr_element_nodes+1)) * (par(i) - m0(i))
           END IF
        END DO

     ELSE IF (ltri == 15) THEN
        IF (.NOT. lprior) THEN

!          !$OMP WORKSHARE
           bvec = MATMUL( DCMPLX(smatm),par)
!           !$OMP END WORKSHARE

        ELSE

!           !$OMP WORKSHARE
           bvec = MATMUL( DCMPLX(smatm),( par - m0 ) )
!           !$OMP END WORKSHARE

        END IF
     END IF

! >> RM ref model regu
     IF (lw_ref) THEN
        DO i=1,manz
           IF ((w_ref_re(i) > EPSILON(w_ref_re(i)) ).OR.&
                (w_ref_im(i) > EPSILON(w_ref_im(i))) ) THEN
              cdum = (par(i) - m_ref(i))
! ind ref grad
              IF (lam_ref_sw > 0) THEN
                 IF(ind_ref_grad(i) /= 0) THEN
                    
                    in = ind_ref_grad(i)
                    cdum2 = (par(in) - m_ref(in))
!!$
!!$                    cdum = ABS(CDEXP(par(i)) - CDEXP(par(in)))
!!$
!!$                    cdum2 = ABS(CDEXP(m_ref(i)) - CDEXP(m_ref(in)))

                    cdum =  (cdum - cdum2)

                 ELSE

                    cdum = 0d0 ! if the gradient is not there, we do not have a contribution on this side

                 END IF
              END IF

! (a*va , b*vb)
              cdum = DCMPLX(DBLE(cdum)*w_ref_re(i),DIMAG(cdum)*w_ref_im(i))

              bvec(i) = bvec(i) + lam_ref * cdum

           END IF
        END DO
     END IF
! << RM ref model regu

!     triang<

!  Skalierungsfaktoren bestimmen
! Preconditioning factors: 
! cgfac = diag(A^h_q * C_d^-1 * A + \lam C_m^-1)^-1
     DO j=1,manz
        dum = 0d0

        IF (ldc) THEN
           DO i=1,nanz
              dum = dum + sensdc(i,j) * sensdc(i,j) * wmatd(i) * &
                   DBLE(wdfak(i))
           END DO
        ELSE IF (lfpi) THEN
           DO i=1,nanz
              dum = dum + DBLE(sens(i,j)) * DBLE(sens(i,j)) * &
                   wmatd(i)*DBLE(wdfak(i))
           END DO
        ELSE
           DO i=1,nanz
              dum = dum + DBLE(dconjg(sens(i,j)) * sens(i,j)) * &
                   wmatd(i)*DBLE(wdfak(i))
           END DO
        END IF
        dum2 = dum

        IF (ltri==0) THEN

           dum    = dum + lam * smatm(j,1)

        ELSE IF (ltri == 1.OR.ltri == 2.OR. &
             (ltri > 4 .AND. ltri < 15)) THEN

           dum    = dum + lam * smatm(j,max_nr_element_nodes+1)

        ELSE IF (ltri == 3.OR.ltri == 4) THEN

           dum = dum + lam * smatm(j,1)

        ELSE IF (ltri == 15) THEN

           dum    = dum + lam * smatm(j,j)

        END IF

! >> RM ref model regu
        
        IF (lw_ref .AND. ( &
             (w_ref_re(i) > EPSILON(w_ref_re(i))) .OR. &
             (w_ref_im(i) > EPSILON(w_ref_im(i))) ) ) THEN
           dum = dum + lam * lam_ref*(w_ref_re(i) + w_ref_im(i))
! adding variances.. 
!!$ TODO: checking for exactness
        END IF
!!<< RM

        cgfac(j) = 1d0/dsqrt(dum)
     END DO

!     Konstantenvektor berechen und skalieren (RHS)
! the other part of the RHS system...
! A_q^h * C_d^-1 * (d-f(m_q)) + \lam C_m^-1 (m_q,(m_q-m_0))
    DO j=1,manz

        cdum = dcmplx(0d0)

!     diff+<
        IF (.NOT.ldiff) THEN
!     diff+>
           IF (ldc) THEN
              DO i=1,nanz
                 cdum = cdum + dcmplx(sensdc(i,j)*wmatd(i)* &
                      DBLE(wdfak(i)))*(dat(i)-sigmaa(i))
              END DO
           ELSE IF (lfpi) THEN
              DO i=1,nanz
                 cdum = cdum + dcmplx(DBLE(sens(i,j))*wmatd(i)* &
                      DBLE(wdfak(i)))*(dat(i)-sigmaa(i))
              END DO
           ELSE
              DO i=1,nanz
                 cdum = cdum + dconjg(sens(i,j))*dcmplx(wmatd(i)* &
                      DBLE(wdfak(i)))*(dat(i)-sigmaa(i))
              END DO
           END IF
!     diff+<
        ELSE
           IF (ldc) THEN
              DO i=1,nanz
                 cdum = cdum + dcmplx(sensdc(i,j)*wmatd(i)* &
                      DBLE(wdfak(i)))*(dat(i)-sigmaa(i)-(d0(i)-fm0(i)))
              END DO
           ELSE IF (lfpi) THEN
              DO i=1,nanz
                 cdum = cdum + dcmplx(DBLE(sens(i,j))*wmatd(i)* &
                      DBLE(wdfak(i)))*(dat(i)-sigmaa(i)-(d0(i)-fm0(i)))
              END DO
           ELSE
              DO i=1,nanz
                 cdum = cdum + dconjg(sens(i,j))*dcmplx(wmatd(i)* &
                      DBLE(wdfak(i)))*(dat(i)-sigmaa(i)-(d0(i)-fm0(i)))
              END DO
           END IF
        END IF
!     diff+>
        IF (ltri == 3.OR.ltri == 4) THEN

           bvec(j) = cdum

        ELSE
! RM ref model regu: reference model regu is already included in bvec (see above)..
           bvec(j) = cdum - dcmplx(lam)*bvec(j) 

        END IF

        bvec(j) = bvec(j)*dcmplx(cgfac(j))

!!$        print*,j,cdum,sens(1,j),sigma(j)

     END DO

!!$     DO i=1,nanz
!!$        print*,i,wmatd(i),dat(i),sigmaa(i),wdfak(i)
!!$     END Do
!     Modellverbesserung mittels konjugierter Gradienten bestimmen
     CALL cjg

!     Ggf. Verbesserung umspeichern
     IF (lfpi) THEN
        dpar = DCMPLX(0D0,DBLE(dpar))
     END IF

!     Verbesserung skalieren
     dpar = dpar * DCMPLX(cgfac)
!!$     do j=1,manz
!!$        dpar(j) = dpar(j)*dcmplx(cgfac(j))
!!$     end do

  ELSE                      ! (llam==.TRUE.)


!     Felder zuruecksetzen
     dpar = dpar2

     i = INT(cgres2(1))+1

     cgres(1:i) = cgres2(1:i)

  END IF

!     Ggf. (Leitfaehigkeits-)Phasen < 0 mrad korrigieren
!     if (lphi0.and.dimag(par(j)).lt.0d0)
!     1        par(j) = dcmplx(dble(par(j)))
!     akc Ggf. (Leitfaehigkeits-)Phasen < 1 mrad korrigieren
!     ak            if (lphi0.and.dimag(par(j)).lt.1d-3)
!     ak     1          par(j) = dcmplx(dble(par(j)),1d-3)

!     i.e Stepsize = ||\delta m||
  bdpar = 0d0

  in = 0
  DO j=1,manz

     par(j) = par(j) + DCMPLX(step) * dpar(j) ! model update

!!$  ! eventually correct for phase < 0 mrad
     IF (lphi0 .AND. dimag(par(j)) < 0D0) THEN 
        par(j) = DCMPLX(DBLE(par(j))) 
        in = in + 1 
     END IF

     bdpar = bdpar + DBLE(dpar(j)*dconjg(dpar(j)))

  END DO

  IF (in > 0) WRITE (*,'(/a,I9,a/)',ADVANCE = 'no')' forcing zero ',in&
       ,' times'
  bdpar = bdpar * step

END SUBROUTINE update

REAL (KIND(0D0)) FUNCTION chareal(txt,ltxt)

!!$c Die Funktion wandelt einen String in einen Real-Wert;
!!$c bei Real-Werten muss die Laenge incl. '.' angegeben werden.
!!$
!!$c Andreas Kemna                                            03-Feb-1993
!!!$                                       Letzte Aenderung   24-Oct-1996

!!!$.....................................................................

  CHARACTER (*) ::  txt
  INTEGER (KIND = 4)  ::     ltxt
  INTEGER (KIND = 4)  ::     i,ih1,pos,j
  REAL (KIND(0D0)) ::    h2
  LOGICAL ::     neg

!!!$.....................................................................

  h2  = 0.
  pos = index(txt(1:ltxt),'.')-1

!!$c Vorzeichen bestimmen
  if (index(txt(1:ltxt),'-').gt.0) then
     neg = .true.
  else
     neg = .false.
  end if

!!$c Umrechnung von Integer-Werten ermoeglichen
  if (pos.eq.-1) pos=ltxt

  j = 0

!!$c Vorkommastellen
  do i=pos,1,-1
     ih1 = ichar(txt(i:i))

     if (ih1.ge.48.and.ih1.le.57) then
        h2 = real(ih1-48)*10.**j + h2
        j  = j+1
     end if
  END DO

!!$c Dezimalstellen
  if (pos.ne.ltxt) then
     j = -1

     do i=pos+2,ltxt
        ih1 = ichar(txt(i:i))

        if (ih1.ge.48.and.ih1.le.57) then
           h2 = real(ih1-48)*10.**j + h2
           j  = j-1
        end if

     END DO
  end if

  if (neg) then
     chareal = -h2
  else
     chareal = h2
  end if

  return
end FUNCTION chareal

!> \file invmod.f90
!> \brief variable delarations for the inversion algorithm
!> \details Replacement of former 'inv.fin' 
!> @author Andreas Kemna
!> @date 04/02/1994, last change 07/27/2010
MODULE invmod
!!$c  'inv.fin'
!!$c
!!$c Original version by 
!!$c Andreas Kemna                                            02-Apr-1994
!!$c
!!$c Modified F90 module by Roland Martin
!!$c                                       Letzte Aenderung   27-07-2010
!!$c 
!!$c.....................................................................
!!!$ Datenvektor
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE   :: dat
!!$c Parametervektor
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE   :: par
!!$c Verbesserungsvektor
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE   :: dpar
!!$ storage
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE   :: dpar2
!!$c data vector for difference inversion
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE   :: d0
!!$c parameter vector for diff inv
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE   :: m0
!!$c model vector for diff inv
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE   :: fm0
!!!$ >> RM ref model regu
!!$c parameter vector for reference model regularization
  COMPLEX(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE   :: m_ref
!!!$ << RM ref model regu
!!!$ the reference vector is of the same length as par or m0
!!$c data weighting (data covariance) matrix (diag)
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE      :: wmatd
!!$c storage
  REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE      :: wmatd2
!!$c parameter variance
  REAL(KIND(0D0)),PUBLIC                               :: par_vari
!!$c Hilfsfeld, bestimmt welche Daten beruecksichtigt (=1) bzw. nicht
!!$c beruecksichtigt (=0) werden
  INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE    :: wdfak
!!$c Schalter ob reine Phaseninversion durchgefuehrt werden soll
  LOGICAL(KIND = 4),PUBLIC                             :: lfpi
!!!$ Auxiliary field accounts for if the background value is used as
!!$ hard reference regularization, i.e. RTR m + I(m - m0), where 
!!!$ each entry of m0 is multiplied with wmfak to cancel values out
  INTEGER (KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: wmfak

END MODULE invmod

!> \file bvolti.f90
!> \brief compute measured voltages for unity current \f$ 1A \f$.
!> \details Used for the inversion algorithm

!> @author Andreas Kemna
!> @date 09/03/1994, last change 11/13/1997

SUBROUTINE bvolti()

!     Unterprogramm zur Berechnung der modellierten Spannungswerte
!     (beachte: Potentialwerte wurden fuer Einheitsstrom berechnet).

!     Andreas Kemna                                            03-Sep-1994
!     Letzte Aenderung   13-Nov-1997

!.....................................................................

  USE alloci
  USE femmod
  USE datmod
  USE electrmod
  USE errmod

  IMPLICIT NONE


!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariable
  INTEGER (KIND = 4)  ::     i

!     Elektrodennummern
  INTEGER (KIND = 4)  ::     elec1,elec2,elec3,elec4

!     Hilfsvariablen
  COMPLEX (KIND(0D0)) ::    dum1,dum2,dum3,dum4
  REAL (KIND(0D0))    ::     dum1dc,dum2dc,dum3dc,dum4dc

!.....................................................................

  DO i=1,nanz

!     Stromelektroden bestimmen
     elec1 = MOD(strnr(i),10000)
     elec2 = (strnr(i)-elec1)/10000

!     Messelektroden bestimmen
     elec3 = MOD(vnr(i),10000)
     elec4 = (vnr(i)-elec3)/10000

!     Spannungswert berechnen (Superposition)
!     (beachte: Faktoren '.../2d0' (-> Potentialwerte fuer Einheitsstrom)
!     und '...*2d0' (-> Ruecktransformation) kuerzen sich weg !)
     IF (ldc) THEN
        dum1dc = DBLE(min0(elec4,1)*min0(elec2,1)) &
             *hpotdc(enr(max0(elec4,1)),max0(elec2,1))
        dum2dc = DBLE(min0(elec4,1)*min0(elec1,1)) &
             *hpotdc(enr(max0(elec4,1)),max0(elec1,1))
        dum3dc = DBLE(min0(elec3,1)*min0(elec2,1)) &
             *hpotdc(enr(max0(elec3,1)),max0(elec2,1))
        dum4dc = DBLE(min0(elec3,1)*min0(elec1,1)) &
             *hpotdc(enr(max0(elec3,1)),max0(elec1,1))

        volt(i) = dcmplx((dum1dc-dum2dc) - (dum3dc-dum4dc))
     ELSE
        dum1 = dcmplx(min0(elec4,1)*min0(elec2,1)) &
             *hpot(enr(max0(elec4,1)),max0(elec2,1))
        dum2 = dcmplx(min0(elec4,1)*min0(elec1,1)) &
             *hpot(enr(max0(elec4,1)),max0(elec1,1))
        dum3 = dcmplx(min0(elec3,1)*min0(elec2,1)) &
             *hpot(enr(max0(elec3,1)),max0(elec2,1))
        dum4 = dcmplx(min0(elec3,1)*min0(elec1,1)) &
             *hpot(enr(max0(elec3,1)),max0(elec1,1))

        volt(i) = (dum1-dum2) - (dum3-dum4)
     END IF

     IF (cdabs(volt(i)).EQ.0d0) THEN
        WRITE(fetxt,*)'index',i
        PRINT*,'bvolti exception::',i
        errnr = 82
        GOTO 1000
     END IF

!     Werte logarithmieren
     sigmaa(i) = -cdlog(volt(i))
  END DO

  errnr = 0
  RETURN

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 RETURN

END SUBROUTINE bvolti

module output_fempy
    ! modeling output of CRMod
    ! this module is used for the _no_fs version that tries to not touch the file system

    ! four point spreads
    integer(kind=4),dimension(:),allocatable,public :: out_ab
    integer(kind=4),dimension(:),allocatable,public :: out_mn
    real(kind=8),dimension(:),allocatable,public :: out_rmag
    real(kind=8),dimension(:),allocatable,public :: out_rpha_mrad

    ! node potential values
    real(kind=8),dimension(:),allocatable,public :: out_sx
    real(kind=8),dimension(:),allocatable,public :: out_dy
    real(kind=8),dimension(:),allocatable,public :: out_potmag
    real(kind=8),dimension(:),allocatable,public :: out_potrpha

    ! sensitivities
    real(kind=8),dimension(:,:),allocatable,public :: out_sens_rmag

    contains

end module output_fempy

SUBROUTINE wout_up(kanal,it,itr,switch)

!!!$     Unterprogramm zum Schreiben der Widerstandsverteilung und der
!!!$     modellierten Daten inkl. Elektrodenkennungen.

!!!$     Andreas Kemna                                            28-Sep-1994
!!!$     Letzte Aenderung   10-Mar-2007

!!!$.....................................................................
  USE datmod, ONLY : nanz, strnr, vnr, sigmaa
  USE invmod, ONLY : wdfak
  USE sigmamod, ONLY : sigma
  USE elemmod, ONLY : elanz, espx, espy
  USE errmod, ONLY : errnr
  USE konvmod, ONLY: pharms, betrms, nrmsd, lam
  USE pathmod, ONLY : ramd, lnramd, slash, mkdir_cmd, rmdir
  USE femmod, ONLY : ldc
  IMPLICIT NONE

!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Kanalnummer
  INTEGER (KIND=4),INTENT (IN) ::  kanal
!!!$     Iterationsnummer
  INTEGER (KIND=4),INTENT (IN) ::  it,itr
!!!$     Switching between parameter or data model output
  LOGICAL ,INTENT (IN) ::  switch

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:
!!!$     Indexvariablen
  INTEGER (KIND=4) ::  i
  INTEGER          :: ifp
!!!$     Hilfsvariablen
  CHARACTER (256)   ::  file,itdir

  CHARACTER (12)   ::   c_i ! iteration number as string for directory like
!!!$ IT_<number> with number in two digits (compatible with old CRTomo versions..)
  CHARACTER(2)    ::   ci ! iteration number as string
  CHARACTER(3)    ::   cu ! model update number as string
!!$  CHARACTER (6)   ::   c_i ! iteration number as string for directory like
!!$!!!$ IT_<number> with number in three digits..
!!$  CHARACTER(3)    ::   ci ! iteration number as string

!!!$     Dateinamen
  CHARACTER (80)   ::  foutfn

  LOGICAL :: crtf
!!!$.....................................................................

!!$ formatstrings


  foutfn = 'update'
  WRITE (ci,'(I2.2)')it
  WRITE (cu,'(I3.3)')itr

  c_i = 'IT_'//ci//'_UP_'//cu

  itdir = TRIM(ramd(1:lnramd))//slash//c_i

  IF (switch) THEN

     PRINT*,'overwrite existing '//TRIM(itdir)
     CALL get_unit(ifp)
     !  print*,TRIM(itdir)
!!$! workaround for compability issues with ifort..
     file = TRIM(itdir)//slash//'tmp.check'
     !  PRINT*,TRIM(file)
     crtf = .FALSE.
!!$ test if you can open a file in the directory..
     OPEN (ifp,FILE=TRIM(file),STATUS='replace',ERR=97)
!!$ if you can, you can, the directory exits and you can remove it safely
     CLOSE(ifp,STATUS='delete')
!!$ set this switch to circumvent mkdir
!!$  PRINT*,'Inversion directory exists, removing content '
!!$ TODO: remove content of invdir?
     CALL SYSTEM (rmdir//TRIM(itdir))
     crtf = .TRUE.
97   CONTINUE
!!$  PRINT*,'Creating inversion directory '//TRIM(itdir)
     CALL SYSTEM (mkdir_cmd//TRIM(itdir))

!!!$ write data to iteration directory
!!$ extracting the 'rho' from foutfn path
     file = TRIM(itdir)//slash//TRIM(foutfn)//'.mag'
     !  print*,'Trying to write '//TRIM(file)
     OPEN (kanal,FILE=TRIM(file),STATUS='replace',ERR=1000)
     WRITE (kanal,*,err=1000) elanz,betrms,lam
     WRITE (kanal,'(3(G12.4,2x))',err=1000) (REAL(espx(i)),REAL(espy(i)),&
          REAL(dlog10(cdabs(1d0/sigma(i)))),i=1,elanz)
     CLOSE (kanal)

     !  print*,TRIM(foutfn),TRIM(dvolt)
     file = TRIM(itdir)//slash//TRIM(foutfn)//'.pha'
     !  print*,'Trying to write '//TRIM(file)
     errnr = 1
     OPEN (kanal,FILE=TRIM(file),STATUS='replace',ERR=1000)
     errnr = 4
     WRITE (kanal,*,err=1000) elanz,pharms,lam
     WRITE (kanal,'(3(G12.4,2x))',err=1000)(REAL(espx(i)),REAL(espy(i)),&
          REAL(1d3*datan2(AIMAG(1d0/sigma(i)),REAL(1./sigma(i)))),i=1,elanz)

     CLOSE (kanal)

     file = TRIM(itdir)//slash//TRIM(foutfn)//'.modl'
     !  print*,'Trying to write '//TRIM(file)
     errnr = 1
     OPEN (kanal,FILE=TRIM(file),STATUS='replace',ERR=1000)
     errnr = 4
     WRITE(kanal,*,err=1000) elanz,nrmsd,lam
     WRITE (kanal,'(2(G12.4,2x))',err=1000)(1./REAL(sigma(i)),&
          REAL(1d3*datan2(AIMAG(1./sigma(i)),DBLE(1./sigma(i)))),&
          i=1,elanz)

     CLOSE (kanal)

  ELSE
     file = TRIM(itdir)//slash//TRIM(foutfn)//'.dat'
     PRINT*,'Trying to write '//TRIM(file)
     errnr = 1
     OPEN (kanal,FILE=TRIM(file),STATUS='replace',ERR=1000)
     errnr = 4
     WRITE(kanal,*,err=1000) nanz

!!!     Stromelektrodennummern, Spannungselektrodennummern und scheinbare
     !!     Widerstandswerte (Betrag und Phase (in mrad)) schreiben
     IF (ldc) THEN
        DO i=1,nanz
           WRITE(kanal,*,err=1000)strnr(i),vnr(i),&
                !         real(1d0/dexp(dble(sigmaa(i))))
!!$c     diff+<
                REAL(1d0/dexp(DBLE(sigmaa(i)))),wdfak(i)
!!$c     diff+>
        END DO
     ELSE
        DO i=1,nanz
           WRITE(kanal,*,err=1000)strnr(i),vnr(i),&
                REAL(1d0/dexp(DBLE(sigmaa(i)))),&
!!$c     diff-     1                      real(-1d3*dimag(sigmaa(i)))
!!$c     diff+<
                REAL(-1d3*dimag(sigmaa(i))),wdfak(i)
!!$c     diff+>
        END DO
     END IF

     CLOSE(kanal)
  END IF
  errnr = 0
  RETURN

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

1000 CLOSE(kanal)
  RETURN

END SUBROUTINE wout_up

!> \file errmod.f90
!> \brief variable declarations for error handling
!> \details Replacement of former 'err.fin'
!> @author Andreas Kemna, Roland Martin
!> @date 02/06/1993, last change 10/24/1996

MODULE errmod
!'err.fin'
!
!Andreas Kemna                                            06-Feb-1993
!                                      Letzte Aenderung   24-Oct-1996
!.....................................................................
!Fehlernummer
  INTEGER(KIND = 4)  ::     errnr
!Kanaele
  INTEGER(KIND = 4)  ::     fperr
  INTEGER(KIND = 4)  ::     fprun
  INTEGER(KIND = 4)  ::     fpinv
  INTEGER(KIND = 4)  ::     fpcjg
  INTEGER(KIND = 4)  ::     fpeps
  INTEGER(KIND = 4)  ::     fpcfg

! die io nummern werden nun ueber get_unit belegt..
!    9 - error.dat   -> fperr
!    10 - run.ctr    -> fprun
!    12 - crtomo.cfg -> fpcrf
!    13 - inv.ctr    -> fpinv
!    14 - cjg.ctr    -> fpcjg
!    15 - eps.ctr    -> fpeps
!Fehlerart
!0 : GKS - nicht aktiv, Programm nicht verlassen
!1 : GKS - nicht aktiv, Programm verlassen
!2 : GKS - aktiv      , Programm nicht verlassen
!3 : GKS - aktiv      , Programm verlassen und GKS schlieáen
  INTEGER(KIND = 4)  ::     errflag

!Fehlertext
  CHARACTER (256),PUBLIC   ::   fetxt

END MODULE errmod

!!$ $Id: tic_toc.f90 1.4 2008/07/29 14:05:36 Roland Martin Exp $
MODULE tic_toc

    IMPLICIT none
    PUBLIC :: tic
    PUBLIC :: toc

    INTEGER(KIND = 4),public         :: fix_f2py
    INTEGER(KIND = 4),PRIVATE         :: c2,i,l
    INTEGER(KIND = 4),PRIVATE         :: se,mi,st,ta,ms

CONTAINS

    SUBROUTINE tic(c1)
        INTEGER(KIND = 4), INTENT(OUT) :: c1 ! first call -> tic
        CALL SYSTEM_CLOCK (c1,i)
    END SUBROUTINE tic


    SUBROUTINE toc(c1, csz)
        INTEGER(KIND = 4), INTENT(IN) :: c1 ! first call -> tic
        CHARACTER (*),INTENT(INOUT)   :: csz
        !f2py intent(in, out) csz

110 FORMAT(a,I3,'d/',1X,I2,'h/',1X,I2,'m/',1X,I2,'s/',1X,I3,'ms')

        CALL SYSTEM_CLOCK (c2,i)

        ms = c2-c1    ! Gesamt Millisekunden
        ms = MODULO(ms,1000)

        l = (c2-c1)/i ! Gesamt Sekunden

        ta = INT(l/24/3600) ! Tage
        l = l - ta*3600*24
        st = INT(l/3600) ! Stunden
        l = l - st*3600
        mi = INT(l/60) ! Minuten
        se = l - mi*60
        PRINT*,TRIM(csz)

        WRITE (csz,110)TRIM(csz),ta,st,mi,se,ms

        PRINT*,TRIM(csz)

    END SUBROUTINE toc
END MODULE tic_toc

subroutine kompbdc(nelec,b_komp,fak_komp)

!!!$     Unterprogramm zur Kompilation des Konstanten- bzw. Stromvektors 'bdc'
!!!$     fuer Einheitsstrom.

!!!$     Andreas Kemna                                            11-Oct-1993
!!!$     Letzte Aenderung   16-Jul-2007

!!!$.....................................................................

  USE femmod
  USE electrmod
  USE elemmod

  IMPLICIT none

!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:
  REAL (KIND(0D0)),DIMENSION (sanz) :: b_komp
  REAL (KIND(0D0)),DIMENSION (sanz) :: fak_komp
!!!$     Aktuelle Elektrodennummer
  INTEGER (KIND = 4) ::     nelec

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Indexvariable
  INTEGER (KIND = 4) ::     i

!!!$.....................................................................

!!!$     Konstantenvektor auf Null setzen
!!$  b_komp = 0D0
  do i=1,sanz
     b_komp(i) = 0d0
  end do

!!!$     Aufbau des Konstanten- bzw. Stromvektors mit Skalierung
!!!$     ( A * x + b = 0 )
  b_komp(enr(nelec)) = -fak_komp(enr(nelec))

!!!$     akc BAW-Tank
!!!$     ak        bdc(211) = fak(211)
!!!$     akc Model EGS2003
!!!$     ak        bdc(1683) = fak(1683)
!!!$     akc Lysimeter hor_elem\normal
!!!$     ak        bdc(129) = fak(129)
!!!$     akc Lysimeter hor_elem\fine
!!!$     ak        bdc(497) = fak(497)
!!!$     akc Simple Tucson Model
!!!$     ak        bdc(431) = fak(431)
!!!$     akc TU Berlin Mesokosmos
!!!$     ak        bdc(201) = fak(201)
!!!$     akc Andy
!!!$     ak        bdc(2508) = fak(2508)
!!!$     akc Sandra (ele?_anom)
!!!$     ak        bdc(497) = fak(497)

  if (lsink) b_komp(nsink) = fak_komp(nsink)

end subroutine kompbdc

MODULE variomodel
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!$ Collection of subroutines to evaluate variogram and covariance 
!!!$ functions for anisotrop or isotrop lag values  
!!!$ 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!$ Copyright by Andreas Kemna 2010
!!!$
!!!$ Created by Roland Martin               30-Jul-2010
!!!$
!!!$ Last changed       RM                  Jul-2010
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  IMPLICIT none

  PUBLIC :: set_vario
!!!$ this sets the type opf variogram and covariance functions which may 
!!!$ differ. For e.g. one may choose exponetial model as variogram 
!!!$ function but a spherical model as covariance function ...
  PUBLIC :: get_vario
!!!$ this gets the current setting of vario or covario function types
!!!$ (i.e. model type)
  PUBLIC :: mvario
!!!$ returns the variogram function for (an)isotrope lag values
  PUBLIC :: mcova
!!!$ returns the covariance function for (an)isotrope lag values

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!   This was decoupeled from CRTomo momory before the main       !!!!!
!!!!   memory model changed, so the SAVE variables are less nice    !!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!$ c1 accounts for the variogram model
!!!$ c2 accounts for the covariance model
  INTEGER(KIND = 4),PRIVATE,SAVE    :: c1,c2 ! switches are set on first call
!!!$ the switches are needed internal to discriminate between the various 
!!!$ variogram and covariance functions.
  REAL(KIND(0D0)),PRIVATE,SAVE      :: omev,omec
!!$! power model exponent for variogram and covariance
  REAL(KIND(0D0)),PRIVATE,SAVE      :: tfac
!!$! exponent factor for covariance function according to exp(-tfac(variogram))
  CHARACTER (30),PRIVATE,SAVE       :: cszv,cszc  
!!$ strings of model type, cszv for variogram model
!!$ cszc for covariance model (can be decoupeled)
  REAL(KIND(0D0)),PRIVATE,SAVE      :: Ix_v,Iy_v
!!$ Correlation lengths (range) for variogram function
  REAL(KIND(0D0)),PRIVATE,SAVE      :: Ix_c,Iy_c
!!$ Correlation lengths for covariance function.
!!!$ It may look a littel strange but in fact there are some
!!!$ variogram models (Exponential and Gauss) which need 
!!!$ the Correlation length to be /3 (EXP) or /3^2 (GAU) of it. 
!!!$ So, be careful to mistake these numbers wrong. 
!!!$ See also the GSlib manual
  REAL(KIND(0D0)),PRIVATE,SAVE      :: axs,ays
!!$ True correlation length from user..

  PRIVATE 
CONTAINS

  SUBROUTINE set_vario (type,ax,ay,esp_mit,esp_med) 
    ! is called at the beginning
    INTEGER,INTENT(IN)          :: type ! type of variogram model
    REAL(KIND(0D0)),INTENT(IN)  :: ax,ay ! ax/ay anisotropy coefficients
    REAL(KIND(0D0)),INTENT(IN)  :: esp_mit,esp_med ! aus (besp_elem.for)

    omev = 1.5d0 ! 0<ome<2
    omec = omev
    tfac = omev ! just a "educated guess"

    c2 = INT(type/10) ! this sets the switches from outside
    c1 = type-c2*10

    IF (ABS(ax) < EPSILON(ax)) THEN ! taking default values if no value
       axs = esp_mit ! arithmetical mean of bnachbar
       ays = esp_mit
       PRINT*,'Choosing mean ESP distance as scale length:',esp_mit
    ELSE IF (ABS(ay) < EPSILON(ay)) THEN
       axs = esp_med ! median
       ays = esp_med
       PRINT*,'Choosing median ESP distance as scale length:',esp_med
    ELSE
       axs = ax ! save user values into SAVED
       ays = ay
    END IF

    Ix_v = axs;Ix_c = axs ! sets correlation lengths (range) for 
    Iy_v = ays;Iy_c = ays ! internal usage

    SELECT CASE (c1) ! string for variogram function
    CASE (1) !Gaussian 
       Ix_v = Ix_v / 3D0 ! scale is changed to match GSlib standard
       Iy_v = Iy_v / 3D0 ! 4/7 is from Kitanidis..
       WRITE (cszv,'(a)')'va(1-EXP(-(3h/a)^2))'
    CASE (2) ! Spherical
       WRITE (cszv,'(a)')'va((1.5(h/a)-.5(h/a)^3),1)'
    CASE (3) ! Power
       PRINT*,'Change power model exponent?[',omev,']'
       READ (*,'(a)')cszv
       IF (cszv /= '')READ (cszv,*)omev
       WRITE (cszv,'(a,F3.1)')'va(h/a)^',omev
    CASE DEFAULT! exponential
       Ix_v = Ix_v / 3D0! scale is changed to match GSlib standard
       Iy_v = Iy_v / 3D0
       WRITE (cszv,'(a)')'va(1-EXP(-(3h/a)))'
    END SELECT

    SELECT CASE (c2)
    CASE (1) !Gaussian
       Ix_c = Ix_c / 3D0! scale is changed to match GSlib standard
       Iy_c = Iy_c / 3D0
       WRITE (cszc,'(a)')'vaEXP(-(3h/a)^2)'
    CASE (2) !Spherical
       WRITE (cszc,'(a)')'va((1-1.5(h/a)+.5(h/a)^3),0)'
    CASE (3) !Power
       PRINT*,'Change power model exponent?[',omec,']'
       READ (*,'(a)')cszc
       IF (cszc /= '')READ (cszc,*)omec
       WRITE (cszc,'(a,F3.1,a)')'EXP(-va*(h/a)^',omec,')'
    CASE (4)!Lemma
       PRINT*,'Change exponent factor?[',tfac,']'
       READ (*,'(a)')cszc
       IF (cszc /= '')READ (cszc,*)tfac
       WRITE (cszc,'(a,F3.1,a)')'EXP(-',tfac,'*variogram(h))'
    CASE DEFAULT!Exponential1
       Ix_c = Ix_c / 3D0
       Iy_c = Iy_c / 3D0
       WRITE (cszc,'(a)')'va*EXP(-3h/a)'
    END SELECT

  END SUBROUTINE set_vario

  SUBROUTINE get_vario (ax,ay,csz,type)
    INTEGER,INTENT(IN)              :: type 
!!$! which info type=0 -> variogram type = 1->covariance
    REAL (KIND(0D0)),INTENT (OUT) :: ax,ay
    CHARACTER (*)                   :: csz
    ! gives back the correlation length used for the variogram
    ax = axs
    ay = ays

    SELECT CASE (type)
    CASE (0)
       csz =  TRIM(cszv)
    CASE (1)
       csz =  TRIM(cszc)
    END SELECT

  END SUBROUTINE get_vario

  REAL (KIND (0D0)) FUNCTION mvario (lagx,lagy,varianz)
    ! lag = distance/korrelation (lag)
    REAL (KIND (0D0)),INTENT (IN) :: lagx,lagy,varianz
    REAL (KIND (0D0))             :: r,r2 ! distances

    mvario = 0d0

    r = DSQRT((lagx / Ix_v)**2d0 + (lagy / Iy_v)**2d0)
    r2 = r*r ! just to be sure to have less numerical issues

    SELECT CASE (c1)
    CASE (1)
       mvario = varianz * (1d0 - DEXP(-r2)) !from GSlib
    CASE (2)
       IF (r < 1d0) THEN
          mvario = varianz * (r * (1.5d0 - .5d0 * r2)) !from GSlib
       ELSE
          mvario = varianz
       END IF
    CASE (3)
       mvario = varianz * r**omec !from GSlib
    CASE DEFAULT
       mvario = varianz*(1d0 - DEXP(-r)) !from GSlib
    END SELECT

  END FUNCTION mvario

  REAL (KIND (0D0)) FUNCTION mcova (lagx,lagy,varianz)
    ! lag = distance/korrelation (lag) varianz = variance (sill)
    REAL (KIND (0D0)),INTENT (IN) :: lagx,lagy,varianz
    REAL (KIND (0D0))             :: r,r2 ! distances
    mcova = 0d0

    r = DSQRT((lagx / Ix_c)**2d0 + (lagy / Iy_c)**2d0)

    r2 = r*r 

    IF (c2 == 1) r2 = r**1.9999 ! this is odd.. if we put it to 2., C_m is no longer
!!$ pos definite.. but with 1.99999, which is in fact nearly 2. it is ok
!!$ happens not all the time but sometimes..
!!$ the digit can vary up to 7 digits behind the dot. With 8 digits it becomes
!!$ somehow unstable..
!!$ I took 5 digits to be sure.machine
!!$ To me this sounds like a DOUBLE_PRECISION / SINGLE_PRECISION Problem..

    SELECT CASE (c2)
    CASE (1)
       mcova = varianz * DEXP(-r2) !from GSlib
    CASE (2)
       IF ( ABS(r) < 1d0 ) THEN
          mcova = varianz * (1d0 - r * (1.5d0 - .5d0 * r2) ) !from GSlib
       ELSE
          mcova = 0d0
       END IF
    CASE (3)
       mcova = varianz * r**omec !from GSlib
       mcova = DEXP(-mcova) ! own interpretation
    CASE (4)
       mcova = DEXP(-tfac*mvario(lagx,lagy,varianz)) ! this is from a lemma
    CASE DEFAULT
       mcova = varianz * DEXP(-r) !from GSlib
    END SELECT

  END FUNCTION mcova

END MODULE variomodel

module get_error_modx
    contains
        subroutine get_error(ftext,errnr,errflag,intext)

          CHARACTER(256),INTENT (OUT) :: ftext
          INTEGER,INTENT (IN) :: errnr
          INTEGER,INTENT (IN) :: errflag
          CHARACTER(80),INTENT (IN) :: intext

          ! character(256) :: fetxt(101)
          INCLUDE 'crerror.h'
          ftext=TRIM(ADJUSTL(fetxt(errnr)))//' '//TRIM(intext)
          ! indicate that everything went well
          ! errflag  = 0


        end subroutine get_error
end module get_error_modx

!> \file bkfak.f90
!> \brief compute geometry factors
!> \details Compute the geometry factors of all measurements in case of a surface geometry, allowing borehole electrodes. 
!> @author Andreas Kemna
!> @date 05/02/1996, last change 04/29/2003

subroutine bkfak()

!     Unterprogramm zur Berechnung der Konfigurationsfaktoren
!     (bei Standard-Geometrie!).

!     Andreas Kemna                                            02-May-1996
!     Letzte Aenderung   29-Apr-2003

!.....................................................................

  USE datmod
  USE electrmod
  USE elemmod,only:sx,sy,snr
  USE errmod

  IMPLICIT none


!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariable
  INTEGER (KIND = 4)  ::     i,fp

!     Elektrodennummern
  INTEGER (KIND = 4)  ::     elec1,elec2,elec3,elec4

!     Koordinaten
  REAL (KIND(0D0))    ::     xk(4)= 0D0,yk(4) = 0D0

!     Pi
  REAL (KIND(0D0))    ::     pi

!     Hilfsvariablen
  REAL (KIND(0D0))    ::     dx,dym,dyp,dum,r1,r2,r3,r4

!.....................................................................

  pi = dacos(-1d0)
  xk = 0D0
  yk = 0D0
  CALL get_unit(fp)
  OPEN (fp,FILE='tmp.kfak',STATUS='replace')

  do i=1,nanz
     elec1 = mod(strnr(i),10000)
     elec2 = (strnr(i)-elec1)/10000

     elec3 = mod(vnr(i),10000)
     elec4 = (vnr(i)-elec3)/10000

     if (elec1.gt.0) then
        xk(1) = sx(snr(enr(elec1)))
        yk(1) = sy(snr(enr(elec1)))
     end if

     if (elec2.gt.0) then
        xk(2) = sx(snr(enr(elec2)))
        yk(2) = sy(snr(enr(elec2)))
     end if

     if (elec3.gt.0) then
        xk(3) = sx(snr(enr(elec3)))
        yk(3) = sy(snr(enr(elec3)))
     end if

     if (elec4.gt.0) then
        xk(4) = sx(snr(enr(elec4)))
        yk(4) = sy(snr(enr(elec4)))
     end if

     if (elec3.gt.0.and.elec1.gt.0) then
        dx  = xk(3)-xk(1)
        dym = yk(3)-yk(1)
        dyp = yk(3)+yk(1)
        dym = 1d0/dsqrt(dx*dx+dym*dym)
        dyp = 1d0/dsqrt(dx*dx+dyp*dyp)
        r4  = dym+dyp
     else
        r4  = 0d0
     end if

     if (elec3.gt.0.and.elec2.gt.0) then
        dx  = xk(3)-xk(2)
        dym = yk(3)-yk(2)
        dyp = yk(3)+yk(2)
        dym = 1d0/dsqrt(dx*dx+dym*dym)
        dyp = 1d0/dsqrt(dx*dx+dyp*dyp)
        r3  = dym+dyp
     else
        r3  = 0d0
     end if

     if (elec4.gt.0.and.elec1.gt.0) then
        dx  = xk(4)-xk(1)
        dym = yk(4)-yk(1)
        dyp = yk(4)+yk(1)
        dym = 1d0/dsqrt(dx*dx+dym*dym)
        dyp = 1d0/dsqrt(dx*dx+dyp*dyp)
        r2  = dym+dyp
     else
        r2  = 0d0
     end if

     if (elec4.gt.0.and.elec2.gt.0) then
        dx  = xk(4)-xk(2)
        dym = yk(4)-yk(2)
        dyp = yk(4)+yk(2)
        dym = 1d0/dsqrt(dx*dx+dym*dym)
        dyp = 1d0/dsqrt(dx*dx+dyp*dyp)
        r1  = dym+dyp
     else
        r1  = 0d0
     end if

     dum = (r1-r2) - (r3-r4)

     if (dabs(dum).eq.0d0) then
        fetxt = 'index '
        write(fetxt(7:10),'(i4)') i
        errnr = 93
        goto 1000
!     tmp                write(*,'(i4)') i
!     tmp                dum = 1d-12
     end if

     kfak(i) = 4d0*pi / dum

  end do
  WRITE (fp,'(I8,2X,G12.4)')(i,kfak(i),i=1,nanz)
  CLOSE (fp)

  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 return

end subroutine bkfak

!> \file scaldc.f90
!> \brief scale the FE equations for better numerical accuracy for DC case
!> \details Schwarz 1991 and Kemna (private communication):
!> The diagonal elements of \f$ S \f$ in the linear system \f$ Sx = b \f$ are scaled to \f$ 1 \f$. Accordingly, the other elements of \f$ S\f$, \f$ x \f$ and \f$ b\f$ need to be scaled as well to maintain corrent results. In matrix notation, this is
!> \f[ S x = b \rightarrow (D S D) \  (D^{-1}x) = (D b) \f]
!> with the diagonal matrix \f$ D\f$ containing the scaling factors, namely
!> \f[ D_{ii} = 1/\sqrt{S_{ii}}, \ i = (1,...,n) \f]
!> Finally, the modified linear system 
!> \f[ \hat S \hat x = \hat b, \f]
!> with \f$ \hat S = D\ S\ D, \hat x = D^{-1}x, \hat b = D\ b \f$ is solved with super accuracy
!> @author Andreas Kemna 
!> @date 10/11/1993

SUBROUTINE scaldc(a_scal,b_scal,fak_scal)

!     Unterprogramm skaliert 'adc' und 'bdc' und liefert die Skalierungs-
!     faktoren im Vektor 'fak'.

!     ( Vgl. Subroutine 'SCALBNDN' in Schwarz (1991) )

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   07-Mar-2003

!.....................................................................

  USE alloci
  USE femmod
  USE elemmod
  USE errmod

  IMPLICIT NONE


!.....................................................................
  REAL(KIND(0D0)),DIMENSION((mb+1)*sanz)  ::  a_scal
  REAL(KIND(0D0)),DIMENSION(sanz)  ::  b_scal
  REAL(KIND(0D0)),DIMENSION(sanz)  ::  fak_scal

!     Hilfsvariablen
  INTEGER (KIND=4) ::     idi,i0
  INTEGER (KIND=4) ::     ja
  REAL(KIND(0D0))  ::     dum

!     Indexvariablen
  INTEGER (KIND=4) ::     i,j

!.....................................................................

  DO i=1,sanz

     idi = i*(mb+1)
     dum = a_scal(idi)

     IF (dum.LE.0d0) THEN
        WRITE (fetxt,'(a,I6,A,I6)')'scaldc',i,'idi',idi
        errnr = 27
        RETURN
     END IF

     a_scal(idi) = 1d0
     fak_scal(i)   = 1d0 / dsqrt(dum)
     b_scal(i)   = b_scal(i) * fak_scal(i)

     IF (i == 1) CYCLE

     i0 = i*mb
     ja = max0(1,i-mb)

     DO j=ja,i-1
        a_scal(i0+j) = a_scal(i0+j)*fak_scal(i)*fak_scal(j)
     END DO

  END DO

  errnr = 0

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen
END SUBROUTINE scaldc

module cmk

    contains
        subroutine run_cutmck(return_value)

        !     Programm zur optimalen Numerierung der Knotenpukte nach dem
        !     Algorithmus von Cuthill-McKee. Ist die Anzahl der Startpunkte 'spanz'
        !     kleiner Null, werden die Startpunkte mit minimalem Grad automatisch
        !     bestimmt. Andernfalls werden die vorgegebenen Nummern der Startpunkte
        !     aus 'dstart' gelesen.

        !     Andreas Kemna                                            11-Oct-1993
        !     Letzte Aenderung, RM   11-Sep-2009

        !     ( Vgl. entspr. Hauptprogramm in Schwarz (1991) )

        !.....................................................................

        USE errmod, only: fetxt, errnr
        USE elemmod, only: sanz, snr, nelanz, selanz, nrel, elanz, typanz, mb
        USE electrmod
        USE relem_mod
        USE relectrmod
        USE welectrmod
        USE welemmod
        USE get_error_modx

        IMPLICIT none
        ! INCLUDE 'err.fin'
        ! COMMON
        INTEGER(KIND = 4), INTENT(OUT) :: return_value

        ! Fehlerart
        ! 0 : GKS - nicht aktiv, Programm nicht verlassen
        ! 1 : GKS - nicht aktiv, Programm verlassen
        ! 2 : GKS - aktiv      , Programm nicht verlassen
        ! 3 : GKS - aktiv      , Programm verlassen und GKS schlieáen
        integer :: errflag

        ! Fehlertext
        ! character(80) :: fetxt

!.....................................................................

!     Schalter ob Kontrolldateien ('*.ctr') ausgegeben werden sollen
      logical :: kont

!     Dateinamen
      character(80) :: delem,delectr
      CHARACTER(256) :: ftext
!     Maximaler Grad der Knotenpunkte
      INTEGER,PARAMETER :: grmax=500
!     Maximale Anzahl vorgegebener Startpunkte im Cuthill-McKee-Algorithmus
      INTEGER,PARAMETER :: spmax=100
!     Maximale Anzahl der Stufen im Cuthill-McKee-Algorithmus
      INTEGER,PARAMETER :: stmax=100

!     Permutationsvektor der Umnumerierung
      INTEGER,DIMENSION(:),ALLOCATABLE   :: perm

!     Knotennummern der Startpunkte
      INTEGER,DIMENSION(:),ALLOCATABLE   :: start

!     Hilfsvariablen
      INTEGER,DIMENSION(:,:),ALLOCATABLE :: graph
      INTEGER,DIMENSION(:),ALLOCATABLE   :: grad,neu,neuin,level

      integer ::  gradzp,fcm,kbdm,nstart,spanz,i,j,k,l,m,idum,is,nzp,nnp,maxgd,mingd, minbd,mmin,mingr,levs,leve,nlev

      LOGICAL,DIMENSION(:),ALLOCATABLE   :: num
      logical :: exi1,exi2,exi3
      integer :: c1,c2,se,mi,st,ta,fp,fp2
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
4    FORMAT(/'  minimum grade =',I6/'  maximum grade =',I6, '  minimum bandwidth =',I6)
! 6    FORMAT(/'Ergebnisse der Nuenummerierungen '/,'Startpunkt',3x, 'Bandbreite',3x,'Profil (normal)',3x,'Profil (reverse)')
8    FORMAT(3(I8,4X),I8)
9    FORMAT(//'  minimum bandwidth =',i5,'  for init.node', i5//'  vector of permutation ='/)
11   FORMAT((3x,10i5))
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      CALL SYSTEM_CLOCK (c1,i)
      kont   = .FALSE.

      fp = 11
      fp2 = 12
!     Fehlerdatei oeffnen
      open(10,file='error.dat',status='unknown')

!     Fehlerflag setzen
      errflag = 2

!     'CutMck.cfg' einlesen
      fetxt = 'cutmck.cfg'
      INQUIRE (FILE=fetxt,EXIST=exi1)
      IF (exi1) THEN
         errnr = 1
         open(fp,file=fetxt,status='old',err=1000)

         errnr = 3
         read(fp,'(a,/,a)',end=1001,err=1000) delem,delectr
         close(fp)
      ELSE                      !check for defaults
         delem='elem.dat'
         delectr='elec.dat'
         INQUIRE (FILE=delem,EXIST=exi2)
         INQUIRE (FILE=delectr,EXIST=exi3)
         IF (exi2.AND.exi3) THEN
            PRINT*,'trying default::',TRIM(delem),'  ',TRIM(delectr)
         ELSE
            IF (.NOT.exi2) THEN
               fetxt=TRIM(delem)
               PRINT*,'no default grid file::',TRIM(delem)
            END IF
            IF (.NOT.exi3)THEN
               fetxt=TRIM(fetxt)//' '//TRIM(delectr)
               PRINT*,'no default electrode file::',TRIM(delectr)
            END IF
            errnr = 3
            GOTO 1000
         END IF
      END IF
      print*,'read in elements...'
!     'delem' einlesen
      call relem(fp,fp2,delem)
      if (errnr.ne.0) goto 1000
      print*,'read in electrodes'
!     'delectr' einlesen
      call relectr(fp,delectr)
      if (errnr.ne.0) goto 1000
      print*,'ok'

      ALLOCATE (graph(grmax,sanz),perm(sanz),grad(sanz),neu(sanz), neuin(sanz),level(sanz),start(sanz),num(sanz),stat=errnr)

      IF (errnr /= 0) THEN
         PRINT*,'error allocating fields',errnr
         RETURN
      END IF

!     Aufbau des Graphen aufgrund der Knotennummern der Elemente
      grad=0;graph=0

      idum = 0
      grad=0.;graph=0.
      DO l = 1 , typanz

         DO m = 1 , nelanz(l)

            DO i = 1 , selanz(l)-1

               nzp = nrel(idum+m,i)

               DO j=i+1,selanz(l)

                  nnp = nrel(idum+m,j)

                  DO k=1,grmax

                     IF (graph(k,nzp) == nnp) GOTO 10
                     IF (graph(k,nzp) > 0) CYCLE

                     graph(k,nzp)=nnp
                     grad(nzp)=grad(nzp)+1

                     EXIT
                  END DO

                  grad(nnp) = grad(nnp)+1
                  IF (grad(nnp) <= grmax) graph(grad(nnp),nnp)=nzp

10               CONTINUE

               END DO

            END DO

         END DO

         idum = idum + nelanz(l)

      END DO

      PRINT*,'graph erstellt'

      mingd = MINVAL(grad(1:sanz))
      maxgd = MAXVAL(grad(1:sanz))

      IF (mingd==0) THEN
         PRINT*,'existance of zero nodes.. aborting'
         return_value = -1
         return
      ENDIF

      minbd = (maxgd+1)/2
!     Ggf. Kontrolldatei oeffnen

      IF (kont) THEN
         fetxt = 'cutmck.ctr'
         OPEN(fp,file=TRIM(fetxt),status='unknown')
         WRITE(fp,4) mingd,maxgd,minbd
      END IF

!     rm
      spanz = INT(elanz / 10)
      spanz = MAX(spanz,1000)
      k = 0
      spanz = MIN(spanz,spmax)
      WRITE(*,'(a,I8)',ADVANCE='no')'mingd::',mingd
110  do 120 i=1,sanz
         if (grad(i).eq.mingd) then
            k = k+1
            start(k) = i
            if (k.ge.spanz) goto 130
         end if
120  continue
      IF (mingd>elanz/10) GOTO 130
      mingd = mingd+1
      WRITE(*,'(a,I8)',ADVANCE='no')ACHAR(13)//'mingd::',mingd
      goto 110

130  continue

      spanz=k-1
      print*,'errechnete startpunkte ',spanz
      if (kont) then

         errnr = 4
         write(11,7,err=1000)
7       format(//'  init.node   bandwidth'/)
      end if

!     Neunumerierung der Knotenpunkte fuer alle Startpunkte
      mmin = sanz
      kbdm = 0

      do is=1,spanz
         nstart        = start(is)

         WRITE (*,'(2(a,1X,I6,2X))',ADVANCE='no') ACHAR(13)//'startknoten',nstart,'bandbreite',mmin

         neu(1)        = nstart
         neuin(nstart) = 1

         do i=1,sanz
            num(i) = .false.
         end do

         num(nstart) = .true.
         level(1)    = 1
         levs        = 1
         leve        = 1
         nlev        = 1
         l           = 1

150     do 180 j=levs,leve
            nzp    = neu(j)
            gradzp = grad(nzp)
160        mingr  = grmax
            k      = 0

            do 170 i=1,gradzp
               nnp = graph(i,nzp)

               if (num(nnp).or.grad(nnp).gt.mingr) goto 170

               mingr = grad(nnp)
               k     = nnp
170        continue

            if (k.eq.0) goto 180

            l        = l+1
            neu(l)   = k
            neuin(k) = l
            num(k)   = .true.

            goto 160
180     continue
         levs        = levs+level(nlev)
         nlev        = nlev+1
         level(nlev) = l-levs+1
         leve        = leve+level(nlev)


         if (leve.lt.sanz) goto 150

!     Bandbreite 'mb'
         mb = 0

         do i=1,sanz
            nzp    = neuin(i)
            fcm    = nzp
            gradzp = grad(i)

            do j=1,gradzp
               k   = neuin(graph(j,i))
               mb  = max0(mb,iabs(k-nzp))
               fcm = min0(fcm,k)
            end do
         end do

         if (kont) then
            write(fp,8,err=1000) nstart,mb
         end if

         if (mb.lt.mmin) then

            mmin = mb
            kbdm = is
            do i=1,sanz
               perm(i) = neuin(i)
            end do
         end if

      end do                    ! is

      if (kont) then
         write(fp,9,err=1000) mmin,start(kbdm)
         write(fp,11,err=1000) (perm(i),i=1,sanz)
         close(fp)
      end if

!     Minimale Bandbreite setzen
      mb = mmin

!     UMNUMERIERUNG

!     Knotennummern der Elemente umspeichern
      idum = 0

      do i=1,typanz
         do j=1,nelanz(i)
            do k=1,selanz(i)
               nrel(idum+j,k) = perm(nrel(idum+j,k))
            end do
         end do
         idum = idum+nelanz(i)
      end do

!     Zeiger auf Koordinaten der Knoten umspeichern ('grad' als Hilfsfeld)
      do i=1,sanz
         grad(i) = snr(i)
      end do

      do i=1,sanz
         snr(perm(i)) = grad(i)
      end do

!     Knotennummern der Elektroden umspeichern
      do i=1,eanz
         enr(i) = perm(enr(i))
      end do

!     Startwerte umspeichern (zur Kontrolle)
      do i=1,spanz
         start(i) = perm(start(i))
      end do
      PRINT*,' writing out new values '
!     Elementeinteilung und Elektrodenverteilung schreiben
!     delem=TRIM(ADJUSTL(delem))//'_ctm'
      fetxt='cp -f '//TRIM(delem)//' '//TRIM(delem)//'.orig'
      CALL SYSTEM (fetxt)
      call welem(11,delem)
      if (errnr.ne.0) goto 1000

      fetxt='cp -f '//TRIM(delectr)//' '//TRIM(delectr)//'.orig'
      CALL SYSTEM (fetxt)
!     delectr=TRIM(ADJUSTL(delectr))//'_ctm'
      call welectr(11,delectr)
      if (errnr.ne.0) goto 1000

!     Fehlerdatei loeschen
      close(10,status='delete')

      CALL SYSTEM_CLOCK (c2,i)
      k=(c2-c1)/i               ! Sekunden
      mi=INT(k/60)              ! Minuten
      st=INT(k/60/60)           ! Stunden
      ta=INT(k/60/60/24)        ! Tage
      se=k-mi*60-st*60*60-ta*60*60*24 ! Sekunden
3    FORMAT(I2,'d/',1X,I2,'h/',1X,I2,'m/',1X,I2,'s')
      WRITE (*,3)ta,st,mi,se

      return_value = 0
      return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 CALL get_error(ftext,errnr,errflag,fetxt)
      write(10,'(a80,i2,i1)') fetxt,errnr,errflag
      write(10,*)ftext
      close(10)
      return_value = -1
      return

1001 errnr = 2
      CALL get_error(ftext,errnr,errflag,fetxt)
      write(10,'(a80,i2,i1)') fetxt,errnr,errflag
      write(10,*)ftext
      close(10)
      return_value = -1
      return

      end subroutine run_cutmck
 end module cmk

!> \file potana.f90
!> \brief compute analytical solution
!> \details Compute the analytical solution of the Helmholtz equation of a homogeneous half-space for unity current \f$ 1A \f$. 
!> @author Andreas Kemna 
!> @date 01/04/1996

subroutine potana(l,k,my_pota)

!     Unterprogramm zur Berechnung der analytischen Loesung der
!     Helmholtzgleichung fuer einen homogenen Halbraum (fuer Einheitsstrom !).

!     Andreas Kemna                                            04-Jan-1996
!     Letzte Aenderung   11-Nov-1997

!.....................................................................

  USE sigmamod
  USE electrmod
  USE elemmod, ONLY : sanz, snr, sx, sy
  USE wavenmod

  IMPLICIT none

!.....................................................................

!     EIN-/AUSGABEPARAMETER:

!     Elektrodenindex
  INTEGER (KIND=4)  :: l

!     Wellenzahlindex
  INTEGER (KIND=4)  :: k

!!$ Analytische berechnete Potentialwerte 
  COMPLEX (KIND(0D0)), DIMENSION(sanz) :: my_pota

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Hilfsfunction
  REAL (KIND(0D0))  :: bessk0

!     Hilfsvariablen
  REAL (KIND(0D0))  :: xk1,yk1,xk2,yk2,x21,y21m,y21p,rm,rp,potmax,dum
  COMPLEX (KIND(0D0))  ::    dum2
  INTEGER (KIND=4)  ::  idum,j

!     Pi
  REAL (KIND(0D0))  ::  pi

!.....................................................................

  pi = dacos(-1d0)

  xk1    = sx(snr(enr(l)))
  yk1    = sy(snr(enr(l)))
  idum   = enr(l)
  potmax = 0d0

  do j=1,idum-1
     xk2  = sx(snr(j))
     yk2  = sy(snr(j))
     x21  = xk2-xk1
     y21m = yk2-yk1
     y21p = yk2+yk1
     rm   = dsqrt(x21*x21+y21m*y21m)
     rp   = dsqrt(x21*x21+y21p*y21p)

     dum     = bessk0(rm*kwn(k)) + bessk0(rp*kwn(k))
     potmax  = dmax1(potmax,dum)
     my_pota(j) = dcmplx(dum)
  end do

  do j=idum+1,sanz
     xk2  = sx(snr(j))
     yk2  = sy(snr(j))
     x21  = xk2-xk1
     y21m = yk2-yk1
     y21p = yk2+yk1
     rm   = dsqrt(x21*x21+y21m*y21m)
     rp   = dsqrt(x21*x21+y21p*y21p)

     dum     = bessk0(rm*kwn(k)) + bessk0(rp*kwn(k))
     potmax  = dmax1(potmax,dum)
     my_pota(j) = dcmplx(dum)
  end do

!     Endlichen Wert fuer Singularitaet vorgeben (beeinflusst nur
!     berechnete Potentialwerte in direkter Umgebung des Stromknotens !)
!     ak
  my_pota(idum) = dcmplx(5d0*potmax)

!     Potentialwerte skalieren (fuer Einheitsstrom !)
  dum2 = dcmplx(5d-1/pi) / sigma0

  my_pota = my_pota * dum2

end subroutine potana

subroutine rrandb(kanal,datei)

!!!$     Unterprogramm zum Einlesen der Randwerte aus 'datei'.

!!!$     Andreas Kemna                                            12-Feb-1993
!!!$     Letzte Aenderung   15-Jul-2007

!!!$.....................................................................

  USE femmod
  USE elemmod
  USE randbmod
  USE errmod

  IMPLICIT none


!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Kanalnummer
  INTEGER (KIND =4) ::     kanal

!!!$     Datei
  CHARACTER (80)    ::    datei

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Indexvariable
  INTEGER (KIND=4)  ::  i

!!!$.....................................................................

!!!$     'datei' oeffnen
  fetxt = datei

  errnr = 1
  open(kanal,file=TRIM(fetxt),status='old',err=999)
  errnr = 3

!!!$     DC CASE
  if (ldc) then

!!!$     Anzahl der Randwerte einlesen (Dirichlet)
     read(kanal,*,end=1001,err=1000) rwdanz

     ALLOCATE (rwdnr(rwdanz),rwddc(rwdanz),stat=errnr)
     IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation rwdnr '
        errnr = 94
        goto 1000
     END IF

!!!$     Knotennummern der Randwerte sowie Randwerte einlesen (Dirichlet)
     do i=1,rwdanz
        read(kanal,*,end=1001,err=1000) rwdnr(i),rwddc(i)

!!!$     Ggf. Fehlermeldung
        if (rwdnr(i).gt.sanz) then
           fetxt = ' '
           errnr = 30
           goto 1000
        end if
     end do

!!!$     Anzahl der Randwerte einlesen (Neumann)
     read(kanal,*,end=1001,err=1000) rwnanz

     ALLOCATE (rwndc(rwnanz),stat=errnr)
     IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation rwdnr '
        errnr = 94
        goto 1000
     END IF

!!!$     Randwerte einlesen (Neumann)
     if (rwnanz.gt.0) read(kanal,*,end=1001,err=1000) &
          (rwndc(i),i=1,rwnanz)
  else

!!!$     COMPLEX CASE

!!!$     Anzahl der Randwerte einlesen (Dirichlet)
     read(kanal,*,end=1001,err=1000) rwdanz

     ALLOCATE (rwdnr(rwdanz),rwd(rwdanz),stat=errnr)
     IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation rwdnr '
        errnr = 94
        goto 1000
     END IF

!!!$     Knotennummern der Randwerte sowie Randwerte einlesen (Dirichlet)
     do i=1,rwdanz
        read(kanal,*,end=1001,err=1000) rwdnr(i),rwd(i)

!!!$     Ggf. Fehlermeldung
        if (rwdnr(i).gt.sanz) then
           fetxt = ' '
           errnr = 30
           goto 1000
        end if
     end do

!!!$     Anzahl der Randwerte einlesen (Neumann)
     read(kanal,*,end=1001,err=1000) rwnanz

     ALLOCATE (rwn(rwnanz),stat=errnr)
     IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation rwdnr '
        errnr = 94
        goto 1000
     END IF

!!!$     Randwerte einlesen (Neumann)
     if (rwnanz.gt.0) read(kanal,*,end=1001,err=1000) &
          (rwn(i),i=1,rwnanz)

!!!$     'datei' schliessen
  end if

  close(kanal)

  errnr = 0
  return

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

999 return

1000 close(kanal)
  return

1001 close(kanal)
  errnr = 2
  return

end subroutine rrandb

MODULE electrmod
    !!$c 'electr.fin'
    !!$
    !!$c Andreas Kemna                                            22-Jan-1993
    !!$c                                       Letzte Aenderung   24-Oct-1996
    !!$
    !!$c.....................................................................
    !!$c Anzahl der
    INTEGER(KIND = 4),PUBLIC                          :: eanz

    !!$c Knotennummern der Elektroden
    INTEGER(KIND = 4),PUBLIC,ALLOCATABLE,DIMENSION(:) :: enr

END MODULE electrmod

!> \file bsmatm_mod.f90
!> \brief compute the model weighting matrices \f$ W_m \f$

!> @author Roland Martin
!> @date 07/30/2010

MODULE bsmatm_mod
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Collection of subroutines to set the regularization matrix
! (smatm) on different purposes.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Copyright by Andreas Kemna 2010
!
! Created by Roland Martin               30-Jul-2010
!
! Last changed       RM                  Jul-2010
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    USE tic_toc ! counts calculation time
    USE alloci , ONLY : sens,sensdc,smatm
    USE femmod , ONLY : fak,ldc
    USE elemmod, ONLY : max_nr_element_nodes,sx,sy,espx,espy,nrel,snr,elanz,nachbar,edecoup,edecstr,decanz
    USE invmod , ONLY : lfpi,par,wmatd,wdfak
    USE errmod , ONLY : errnr,fetxt
    USE konvmod , ONLY : ltri,lgauss,lam,nx,nz,alfx,alfz,betamgs,lverb,lverb_dat
    USE modelmod , ONLY : manz
    USE datmod , ONLY : nanz
    USE errmod, ONLY : errnr,fetxt
    USE sigmamod , ONLY : sigma
    USE ompmod
    USE variomodel
    USE pathmod

    IMPLICIT NONE

    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE,PRIVATE :: csens

    PUBLIC :: bsmatm
    ! controls which regularization is to apply

    PRIVATE :: bcsens
    !!$ calculates diaigonal of A^TC_d^{-1}A

    PRIVATE :: bsmatmreg
    ! sets smatm for smooth regularization on regular grids
    PRIVATE :: bsmatmtri
    ! .. same but for unstructured grids (recommended)
    PRIVATE :: bsmatmlma
    ! Levenberg and Levenber-Marquardt Regularization
    PRIVATE :: bsmatmmgs
    ! Minimum gradient support regu
    PRIVATE :: bsmatmtv
    ! Total variance regu (alpha)
    PRIVATE :: bsmatmsto
    ! Stochastical regularization
    INTEGER (kind = 4) :: p

CONTAINS

    SUBROUTINE bsmatm(it,l_bsmat)
    !
    ! This sub is the control unit of the smatm calculation
    !
        INTEGER (KIND = 4 ), INTENT(IN) :: it
        INTEGER (KIND = 4 )   :: c1
        LOGICAL, INTENT (INOUT) :: l_bsmat

        errnr = 2

        ! pre query if smatm is  ever to be recalculated again..

        IF (ltri > 4 .AND. ltri < 10) THEN
            IF (betamgs < 0d0) THEN
                PRINT*
                PRINT*, 'Fixing Regularization matrix'
                PRINT*
                betamgs = ABS(betamgs)
                l_bsmat = .FALSE.
            ELSE
                l_bsmat = .TRUE.
            END IF
        ELSE IF (ltri == 4) THEN ! for levenberg-marquardt JTJ scaling
            l_bsmat = .TRUE.
        ELSE
            l_bsmat = .FALSE. ! calculate just once
        END IF

        ! get time
        CALL TIC(c1)

        IF (.NOT.ALLOCATED(csens)) ALLOCATE (csens(manz),STAT=errnr)
        IF (errnr/=0) THEN
            fetxt = 'Allocation problem csens in bsmatmmgs'
            WRITE (*,'(/a/)')TRIM(fetxt)
            errnr = 97
            RETURN
        END IF

        IF (it == 1) WRITE (*,'(/a)', ADVANCE='no')'Regularization::'

        IF (ltri == 0) THEN
            WRITE (*,'(a)')' Rectangular smooth'
            CALL bsmatmreg
        ELSE IF (ltri == 1.OR.ltri == 2) THEN
            WRITE (*,'(a)')' Triangular smooth'
            CALL bsmatmtri
        ELSE IF (ltri == 3.OR.ltri==4) THEN
            IF (it == 1) THEN
                IF (ltri == 3) WRITE (*,'(a)') &
                    'Levenberg damping (LA)'
                IF (ltri == 4) WRITE (*,'(a)') &
                   'Marquardt-Levenberg damping (LMA)'
            ELSE
                WRITE (*,'(a)')' Updating damping'
            END IF
            CALL bsmatmlma
        ELSE IF (ltri > 4 .AND. ltri < 10) THEN
            IF (it == 1) THEN
                IF (ltri == 5) WRITE (*,'(a)') &
                   ' Triangular pure MGS (beta)'
                IF (ltri == 6.OR.ltri == 8) WRITE (*,'(a)') &
                   ' Triangular sens weighted MGS (beta)'
                IF (ltri == 7.OR.ltri == 9) WRITE (*,'(a)') &
                   ' Triangular sens weighted MGS mean (beta)'
            ELSE
                WRITE (*,'(a)')' Updating MGS functional'
            END IF
           CALL bsmatmmgs
        ELSE IF (ltri == 10) THEN
            WRITE (*,'(a)')' Triangular Total variance (alpha)'
            CALL bsmatmtv
        ELSE IF (ltri == 15) THEN
            WRITE (*,'(a)')' Triangular Stochastic (beta)'
            CALL bsmatmsto
            IF (errnr /= 0) STOP
        ELSE
            WRITE (*,'(a)')' Error:: '// &
                'Regularization can just be '//&
                '0,1,3,4,5,6,7,8,9,10 or 15'
            RETURN
        END IF

        IF (ALLOCATED(csens)) DEALLOCATE (csens)

        fetxt = 'C_m^ calculation time'
        CALL TOC(c1,fetxt)

    END SUBROUTINE bsmatm

    SUBROUTINE bcsens (csensmax,csensavg)
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ! This subroutine calculates the squared coverage or diag{A^TC_d^{-1}A}!
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        INTEGER :: i,j
        REAL(KIND(0D0)) :: csensmax ! maximum
        REAL(KIND(0D0)) :: csensavg !mean coverage value

        csens=0d0 ! csens was already allocated (low dimensional) in bsmatm 

        !$OMP PARALLEL DEFAULT (none) &
        !$OMP SHARED (csens,wmatd,sens,sensdc,wdfak,lfpi,ldc,manz,nanz) &
        !$OMP PRIVATE(j,i)
        !$OMP DO SCHEDULE (GUIDED,CHUNK_0)
        DO j=1,manz
            DO i=1,nanz
                IF (lfpi) THEN
                    csens(j) = csens(j) + DBLE(sens(i,j)) * &
                        DBLE(sens(i,j)) * wmatd(i)*DBLE(wdfak(i))
                ELSE IF (ldc) THEN
                    csens(j) = csens(j) + sensdc(i,j) * &
                        sensdc(i,j) * wmatd(i)*DBLE(wdfak(i))
                ! wechselt automatisch wmatdp bei lfpi
                ELSE
                    csens(j) = csens(j) + REAL(DCONJG(sens(i,j)) * &
                        sens(i,j)) * wmatd(i)*DBLE(wdfak(i))
                ENDIF
            END DO
        END DO
        !$OMP END PARALLEL

        ! for normalization
        csensmax = MAXVAL(csens)

        csensavg = SUM (csens) / DBLE(manz)

    END SUBROUTINE bcsens

    SUBROUTINE bsmatmreg
        ! Unterprogramm belegt die Rauhigkeitsmatrix.
        !
        !    Andreas Kemna                                        29-Feb-1996
        !    Letzte Aenderung   RM                                Jul-2010
        !
        !....................................................................
        !    PROGRAMMINTERNE PARAMETER:
        !
        !    Variablen zur Beruecksichtigung von Diskontinuitaeten (keine
        !    Glaettung in x bzw. z-Richtung)
        INTEGER(KIND = 4) :: ndis_z,idis_z(3),m,ndis_x,idis_x(4)
        LOGICAL ::     lup,ldown,lleft,lright
        REAL(KIND(0D0)) :: alfdis

        ! Hilfsvariablen
        REAL(KIND(0D0)) :: dum,dzleft,dzright,xleft,xmean,xright,&
            dxup,dxdown,zup,zmean,zdown

        INTEGER(KIND = 4) :: i,j,l

        ! Hilfsfunction
        INTEGER(KIND = 4) ::     k

        k(i,j) = (i-1) * nx + j

        !....................................................................

        IF (.NOT.ALLOCATED (smatm)) ALLOCATE (smatm(manz,3))
        ndis_z = 0
        !    ak BAW
        !    ak        ndis_z    = 2
        idis_z(1) = 15
        idis_z(2) = 18

        ndis_x = 0
        !    ak Bohrloch-Effekt
        !    ak        ndis_x    = 4
        idis_x(1) = 4
        idis_x(2) = 6
        idis_x(3) = nx-4
        idis_x(4) = nx-2

        !    ak fuer Christoph (Wald)
        !    ak        ndis_z    = 3
        idis_z(1) = 6
        idis_z(2) = 12
        idis_z(3) = 19

        IF (.NOT.ALLOCATED (smatm)) ALLOCATE (smatm(manz,3))

        ! Rauhigkeitsmatrix auf Null setzen
        smatm = 0d0

        DO i=1,nz
            lup   = .TRUE.
            ldown = .TRUE.

            DO m=1,ndis_z
                IF (i  .EQ.idis_z(m)) lup  =.FALSE.
                IF (i+1.EQ.idis_z(m)) ldown=.FALSE.
            END DO

            DO j=1,nx
                lleft  = .TRUE.
                lright = .TRUE.

                DO m=1,ndis_x
                    IF (j  .EQ.idis_x(m)) lleft =.FALSE.
                    IF (j+1.EQ.idis_x(m)) lright=.FALSE.
                END DO

                ! Beitrag von Wx^t*Wx zur Rauhigkeitsmatrix
                dzleft  = dabs( sy(snr(nrel(k(i,j),4))) &
                    -sy(snr(nrel(k(i,j),1))))
                dzright = dabs( sy(snr(nrel(k(i,j),3))) &
                    -sy(snr(nrel(k(i,j),2))))

                xmean = 0d0
                DO l=1,4
                    xmean = xmean + sx(snr(nrel(k(i,j),l)))
                END DO
                xmean = xmean/4d0

                IF (j.GT.1) THEN
                    IF (lleft) THEN
                        alfdis = 1d0
                    ELSE
                        !    ak
                        alfdis = 1d-3
                    END IF

                    xleft = 0d0
                    DO l=1,4
                        xleft = xleft + sx(snr(nrel(k(i,j-1),l)))
                    END DO

                    xleft = xleft/4d0

                    smatm(k(i,j),1) = alfdis*alfx * dzleft/dabs(xmean-xleft)
                END IF

                IF (j.LT.nx) THEN
                    IF (lright) THEN
                        alfdis = 1d0
                    ELSE
                        !    ak
                        alfdis = 1d-3
                    END IF

                    xright = 0d0
                    DO l=1,4
                        xright = xright + sx(snr(nrel(k(i,j+1),l)))
                    END DO

                    xright = xright/4d0
                    dum = alfdis*alfx * dzright/dabs(xright-xmean)

                    smatm(k(i,j),1) = smatm(k(i,j),1) + dum
                    smatm(k(i,j),2) = -dum
                END IF

                ! Beitrag von Wz^t*Wz zur Rauhigkeitsmatrix
                dxup = dabs( sx(snr(nrel(k(i,j),3))) &
                    -sx(snr(nrel(k(i,j),4))))
                dxdown = dabs( sx(snr(nrel(k(i,j),2))) &
                    -sx(snr(nrel(k(i,j),1))))

                zmean = 0d0
                DO l=1,4
                    zmean = zmean + sy(snr(nrel(k(i,j),l)))
                END DO
                zmean = zmean/4d0

                IF (i.GT.1) THEN
                    IF (lup) THEN
                        alfdis = 1d0
                    ELSE
                        alfdis = 0d0
                    END IF

                    zup = 0d0
                    DO l=1,4
                        zup = zup + sy(snr(nrel(k(i-1,j),l)))
                    END DO

                    zup = zup/4d0
                    dum = alfdis*alfz * dxup/dabs(zup-zmean)

                    smatm(k(i,j),1) = smatm(k(i,j),1) + dum
                END IF

                IF (i.LT.nz) THEN
                    IF (ldown) THEN
                        alfdis = 1d0
                    ELSE
                        alfdis = 0d0
                    END IF

                    zdown = 0d0
                    DO l=1,4
                        zdown = zdown + sy(snr(nrel(k(i+1,j),l)))
                    END DO

                    zdown = zdown/4d0
                    dum   = alfdis*alfz * dxdown/dabs(zmean-zdown)

                    smatm(k(i,j),1) = smatm(k(i,j),1) + dum
                    smatm(k(i,j),3) = -dum
                END IF
            END DO
        END DO
    END SUBROUTINE bsmatmreg

    SUBROUTINE bsmatmtri      !tri
        !
        !    Unterprogramm belegt die Rauhigkeitsmatrix....
        !    fuer beliebige Triangulierung
        !    Angelehnt an R. Blaschek (2008)
        !
        !    Copyright by Andreas Kemna 2009
        !    Created by Roland Martin                            23-Jun-2009
        !    Letzte Aenderung   RM                                    Jul-2010
        !
        !........................................................................
        !    PROGRAMMINTERNE PARAMETER:
        !
        !    Hilfsvariablen
        ! REAL(KIND(0D0)) :: dum    !dummy stores numbers
        ! store regularisation strength for each individual cell border
        ! this is a temporary variable
        REAL(kind(0D0)) :: regularisation_strength
        INTEGER         :: i,k,decn
        INTEGER :: next_node_id
        REAL(KIND(0D0)) :: edglen !Kantenlaenge
        REAL(KIND(0D0)) :: dist   !Abstand der Schwerpunkte
        REAL(KIND(0D0)) :: sp1(2),sp2(2) !Schwerpunktkoordinaten
        REAL(KIND(0D0)) :: ang    !Winkel fuer anisotrope Glaettung
        REAL(KIND(0D0)) :: alfgeo !Anisotrope (geometrische) Glaettung
        !.....................................................................

        IF (.NOT.ALLOCATED (smatm)) ALLOCATE (smatm(manz,max_nr_element_nodes+1),STAT=errnr)
        IF (errnr/=0) THEN
            WRITE (*,'(/a/)')'Allocation problem smatm in bsmatmtri'
            errnr = 97
            RETURN
        END IF

        smatm = 0D0               !initialize smatm

        IF (elanz/=manz)PRINT*,'elanz/=manzSMATMTRI may be wrong'

        DO i=1,elanz
            sp1(1) = espx(i)
            sp1(2) = espy(i)

            DO k=1,max_nr_element_nodes  ! jedes flaechenelement hat mind einen nachbarn

                next_node_id = MOD(k,max_nr_element_nodes) + 1 !!! associates the next node, or itself

                edglen = SQRT( &
                        (sx(snr(nrel(i, k))) - sx(snr(nrel(i, next_node_id))))**2d0 + &
                        (sy(snr(nrel(i, k))) - sy(snr(nrel(i, next_node_id))))**2d0 &
                    ) !edge

                IF (nachbar(i,k)>0) THEN !nachbar an der Kante existiert

                    ! x/z component of neighbouring cell center
                    sp2(1) = espx(nachbar(i,k))
                    sp2(2) = espy(nachbar(i,k))

                    ! Geometrical part...
                    ! distance between cell centers
                    dist = SQRT((sp1(1) - sp2(1))**2d0 + (sp1(2) - sp2(2))**2d0)

                    ! angle of direct line between cell centers
                    ang = DATAN2((sp1(2) - sp2(2)),(sp1(1) - sp2(1))) !Angle

                    ! regularisation contributions of anisotropic regularisation weights
                    alfgeo = DSQRT((alfx*DCOS(ang))**2d0 + (alfz*DSIN(ang))**2d0)

                    ! norm the regularisation component with edgewidth and distance
                    regularisation_strength = edglen / dist * alfgeo

                    ! grid decoupling
                    ! note that the triangular regularisation works in both directions,
                    ! therefore the .OR. chaining with switched positions
                    DO decn=1,decanz
                        IF (((i == edecoup(decn, 1)) .AND. (nachbar(i, k) == edecoup(decn, 2))) .OR. &
                            ((nachbar(i, k) == edecoup(decn, 1)) .AND. (i == edecoup(decn, 2))) ) &
                                THEN
                            ! if we would introduce anistroptic decoupling parameters, then the following line would be used to
                            ! compute the decoupling strength
                            ! decstr = DSQRT((edecstr(decn, 1) *DCOS(ang))**2d0 + (edecstr(decn, 2)*DSIN(ang))**2d0)

                            regularisation_strength = regularisation_strength * edecstr(decn)
                        END IF
                    END DO

                    ! set off-diagonal of R (these entries are only set once for each
                    !  specific cell-neighboring cell pair
                    smatm(i,k) = -regularisation_strength

                    ! set main diagonal
                    ! we need to sum up contribution from various cell interfaces here
                    smatm(i,max_nr_element_nodes+1) = smatm(i,max_nr_element_nodes+1) + regularisation_strength

                END IF
            END DO
        END DO
    END SUBROUTINE bsmatmtri

    SUBROUTINE bsmatmlma      ! levenberg-marquardt damping
        !
        !    Unterprogramm belegt die Glaettungsmtrix
        !    (hier Daempfungsmatrix (smatm))
        !
        !    Copyright by Andreas Kemna                          2009
        !    Erstellt von Roland Martin                          18-Dec-2009
        !    Letzte Aenderung RM                                 Jul-2010
        !
        !.....................................................................
        !    PROGRAMMINTERNE PARAMETER:
        REAL(KIND(0D0)) :: csensmax  !Maximale Covarage
        REAL(KIND(0D0)) :: csensavg  !Mittlere Covarage
        INTEGER :: j
        !.....................................................................

        IF (.NOT.ALLOCATED (smatm)) ALLOCATE (smatm(manz,1),STAT=errnr)
        IF (errnr/=0) THEN
            WRITE (*,'(/a/)')'Allocation problem smatm in bsmatmlma'
            errnr = 97
            RETURN
        END IF

        ! initialize smatm
        smatm = 0d0

        IF (ltri==3) THEN
            smatm = 1d0 ! Levenberg Damping
        ELSE
            CALL bcsens (csensmax,csensavg)
            DO j = 1,manz
                smatm(j,1) = csensmax/csens(j)
            END DO
        END IF
    END SUBROUTINE bsmatmlma


    SUBROUTINE bsmatmmgs      !MGS
        !
        ! Unterprogramm belegt die Rauhigkeitsmatrix ala
        ! Portniaguine und Zhdanov [1999]
        ! Fuer beliebige Triangulierung mit Sensitivitäten gewichtet [Blaschek 2008]
        !
        !    Copyright by Andreas Kemna 2009
        !
        !    Erste Version von Roland Martin                          03-Nov-2009
        !
        !    Last edited  RM                                          18-Dec-2009
        !
        !........................................................................
        !     PROGRAMMINTERNE PARAMETER:
        !     Hilfsvariablen 
        REAL(KIND(0D0)) :: dum,dum2 ! helpers
        REAL(KIND(0D0)) :: mgrad,sqmgrad ! model gradient and squared model grad
        INTEGER         :: i,k,ik
        REAL(KIND(0D0)) :: edglen ! Kantenlaenge
        REAL(KIND(0D0)) :: dist ! Abstand der Schwerpunkte
        REAL(KIND(0D0)) :: sp1(2),sp2(2) ! Schwerpunktkoordinaten
        REAL(KIND(0D0)) :: ang    !Winkel fuer anisotrope Glaettung
        REAL(KIND(0D0)) :: csensmax  !Maximale Covarage
        REAL(KIND(0D0)) :: csensavg  !Mittlere Covarage
        REAL(KIND(0D0)) :: alfgeo !Anisotrope Glaettung
        REAL(KIND(0D0)) :: alfmgs !MGS Glaettung
        !.....................................................................

        errnr = 0
        dum = 0D0
        CALL bcsens(csensmax,csensavg)

        IF (csensmax > 1d-12) THEN
            csens = csens / csensmax
        END IF

        PRINT*,'csensavg/csensmax',csensavg,'/',csensmax

        IF (.NOT.ALLOCATED(smatm)) ALLOCATE (smatm(manz,max_nr_element_nodes+1), STAT=errnr)

        IF (errnr/=0) THEN
            PRINT*,'DEBUG',manz,max_nr_element_nodes+1
            fetxt = 'Allocation problem WORK in bmcm'
            WRITE (*,'(/a/)')TRIM(fetxt)
            errnr = 97
            RETURN
        END IF

        ! initialize smatm
        smatm = 0d0

        DO i=1,elanz ! elanz = flaecheneles
            sp1(1) = espx(i) ! Mittelpunkt des aktuellen Elements
            sp1(2) = espy(i)

            DO k=1,max_nr_element_nodes  ! jedes flaechenele hat mind einen nachbarn
                ik = MOD(k,max_nr_element_nodes) + 1 !!! associates the next node, or itself

                edglen = SQRT( &
                    (sx(snr(nrel(i,k))) - sx(snr(nrel(i,ik))))**2d0 + &
                    (sy(snr(nrel(i,k))) - sy(snr(nrel(i,ik))))**2d0 &
                )
                !!$! edge of i,k and the next..

                IF (nachbar(i,k)>0) THEN !nachbar existiert
                    ! Schwerpunkt des nachbar elements
                    sp2(1) = espx(nachbar(i,k))! center point of element
                    sp2(2) = espy(nachbar(i,k))

                    ! Geometrical part...
                    ! distance of the mid points
                    dist = SQRT((sp1(1) - sp2(1))**2d0 + (sp1(2) - sp2(2))**2d0)
                    !!$! including anisotropy!
                    !angle to horizon
                    ang = DATAN2((sp1(2) - sp2(2)),(sp1(1) - sp2(1)))
                    ! geometrical contribution... (as smooth regularization..)
                    ! projected effective contribution due to anisotropic regu
                    alfgeo = DSQRT((alfx*DCOS(ang))**2d0 + (alfz*DSIN(ang))**2d0)

                    ! Model value gradient (\nabla m)

                    !!! TODO
                    mgrad = CDABS(sigma(i) - sigma(nachbar(i,k))) / dist
                    sqmgrad = mgrad * mgrad
                    ! TODO
                    ! MGS Teil
                    !
                    !    \int \frac{(\nabla m_{ij})^2}{(\nabla m_{ij})^2+\beta^2}\;dA
                    !    -> (m_i-m_{i+1})^2 \frac{\Delta z_i}{\Delta x_i}
                    !            !!!! ATTENTION !!!!
                    ! The squared model gradient in the
                    ! nominator of the stabilizer,  i.e. (m_i-m_{i+1})^2
                    ! !!!   IS EVALUATED LATER ON AS MATRIX VECTOR PRODUCT   !!!
                    ! for now we have to deal with the denominator stuff only at this point!!
                    ! The gemoetrical part is than reduced to
                    ! \frac{\Delta z_i}{\Delta x_i} which is edglen / dist!!!
                    ! -> smatm(i) = \frac{\Delta z_i}{\Delta x_i} * geometrical part
                    !  of anisotropy
                    IF (ltri == 5) THEN !reines MGS
                        dum = sqmgrad + betamgs**2d0
                        ! proportional contribution of integrated cell
                        dum = alfgeo * edglen / dist / dum

                    ELSE IF (ltri == 6) THEN !sensitivitaetswichtung 1 von RM
                        ! f(i,k) = 1 + g(i) + g(k)
                        dum2 = 1d0 + DABS(DLOG10(csens(i))) + &
                            DABS(DLOG10(csens(nachbar(i,k))))
                        ! dum2 = f(i,k)^2
                        dum2 = dum2**2d0
                        ! dum = grad(m)^2 + (\beta/f(i,k)^2)^2
                        dum = sqmgrad + (betamgs / dum2)**2d0
                        ! dum = \alpha_{xz} * \Delta z / \Delta x / f(i,k)^2 /
                        ! grad(m)^2 + (\beta/f(i,k)^2)^2
                        dum = alfgeo * edglen / dist / dum2 / dum
                    ELSE IF (ltri == 7) THEN
                        ! previously this mgs type was used for a custom
                        ! implementation by Roland Martin. See commented dum2
                        ! below.  However, as none of these custom
                        ! imlementations is documented anywhere we now
                        ! change this type (ltri==7)
                        ! back to the sensitivity-focussing version of Roland
                        !  Blaschek, as described in the 2008 paper in
                        ! Geophysics.

                        ! note that by multiplying the last term with a number
                        ! between 0 and 1, the effect on the beta can be
                        dum2 = 1d0 + (DABS(DLOG10(csens(i))) + DABS(DLOG10(csens(nachbar(i,k))))) / &
                        DABS(DLOG10(csensavg))

                        ! Old version by Roland Martin:
                        ! f(i,k) = 1 + (g(i) + g(k))/mean(g)
                        ! dum2 = 1d0 + DABS( &
                        !     (DLOG10(csens(i))) + DABS(DLOG10(csens(nachbar(i,k))))&
                        ! ) / csensavg
                        !    dum2 = f(i,k)^2
                        dum2 = dum2**2d0
                        !    dum = grad(m)^2 + (\beta/f(i,k)^2)^2
                        dum = sqmgrad + (betamgs / dum2)**2d0
                        ! dum = \alpha_{xz} * \Delta z / \Delta x / f(i,k)^2 /
                        ! grad(m)^2 + (\beta/f(i,k)^2)^2
                        dum = alfgeo * edglen / dist / dum2 / dum
                    ELSE IF (ltri == 8) THEN !sensitivitaetswichtung von RB
                        !    der folgende code wurde mir so ueberliefert...
                        ! kam von RB aber keine ahnung was das genau macht
                        dum = mgrad * (1d0 + 0.2d0 * (DABS( DLOG10(csens(i)) + &
                            DLOG10(csens(nachbar(i,k))) ) ))
                        alfmgs = 1d0 - dum**2d0 / (dum**2d0 + betamgs**2d0)
                        dum =  edglen * alfgeo * alfmgs
                    ELSE IF (ltri == 9) THEN
                        dum = mgrad * (1d0 + 0.2d0 * (DABS( DLOG10(csens(i)) + &
                            DLOG10(csens(nachbar(i,k))) ) / csensavg ))

                        alfmgs = 1d0 - dum**2d0 / (dum**2d0 + betamgs**2d0)
                        dum =  edglen * alfgeo * alfmgs
                    END IF
                    ! nun Glaettung belegen
                    smatm(i,k) = -dum ! Nebendiagonale
                    smatm(i,max_nr_element_nodes+1) = smatm(i,max_nr_element_nodes+1) + dum ! Hauptdiagonale
                END IF
            END DO
        END DO

        ! we don't need this here, csens is taken care of in bsmatm()
        ! DEALLOCATE (csens)

        errnr = 0
    END SUBROUTINE bsmatmmgs

    SUBROUTINE bsmatmtv      !betatv
        !
        !    Unterprogramm belegt die Rauhigkeitsmatrix mit total variance
        !    fuer beliebige Triangulierung 
        !
        !    Copyright by Andreas Kemna 2009
        !    
        !    Created by Roland Martin                          23-Nov-2009
        !    
        !    Letzte Aenderung   RM                                    23-Nov-2009
        !    
        !........................................................................
        !   PROGRAMMINTERNE PARAMETER:
        !   Hilfsvariablen 
        REAL(KIND(0D0)) :: dum
        INTEGER         :: i,k,ik
        REAL(KIND(0D0)) :: edglen !Kantenlaenge
        REAL(KIND(0D0)) :: dist   !Abstand der Schwerpunkte
        REAL(KIND(0D0)) :: sp1(2),sp2(2) !Schwerpunktkoordinaten
        REAL(KIND(0D0)) :: ang    !Winkel fuer anisotrope Glaettung
        REAL(KIND(0D0)) :: alfgeo !Anisotrope (geometrische) Glaettung
        REAL(KIND(0D0)) :: alftv  !TV Glaettung
    !.....................................................................

        IF (.NOT.ALLOCATED(smatm)) ALLOCATE (smatm(manz,max_nr_element_nodes+1))
    smatm = 0d0               !initialize smatm

    DO i=1,elanz
       sp1(1) = espx(i) !Mittelpunkt des aktuellen Elements
       sp1(2) = espy(i)

       DO k=1,max_nr_element_nodes           !jedes flaechenele hat mind einen nachbarn

          ik = MOD(k,max_nr_element_nodes) + 1

          edglen = SQRT((sx(snr(nrel(i,k))) - sx(snr(nrel(i,ik))))**2d0 + &
               (sy(snr(nrel(i,k))) - sy(snr(nrel(i,ik))))**2d0) !edge


          IF (nachbar(i,k)>0) THEN !nachbar existiert 

             sp2(1) = espx(nachbar(i,k)) !schwerpunkt des nachbar elements
             sp2(2) = espy(nachbar(i,k))

!   Geometrischer Teil...
             dist = SQRT((sp1(1) - sp2(1))**2d0 + (sp1(2) - sp2(2))**2d0)

             ang = DATAN2((sp1(2) - sp2(2)),(sp1(1) - sp2(1))) !neu

             alfgeo = DSQRT((alfx*DCOS(ang))**2d0 + (alfz*DSIN(ang))**2d0)

             alftv = edglen / dist * alfgeo

!   Total variance
             dum = SQRT(alftv**2d0 + betamgs**2d0)
!   nun glaettung belegen

             smatm(i,k) = -dum ! off diagonal

             smatm(i,max_nr_element_nodes+1) = smatm(i,max_nr_element_nodes+1) + dum !main diagonal

          END IF

       END DO
    END DO

  END SUBROUTINE bsmatmtv

  SUBROUTINE bsmatmsto
!
!    Unterprogramm belegt die Kovarianzmatrix.   
!    Neue Regularisierungsmatrix (stoch. Kovarianzmatrix).
!
!    Copyright by Andreas Kemna                              2009
!    Created by Anastasia August / Roland Martin             03-Apr-2009
!
!    Last edited RM                                          Jul-2010
!....................................................................
!    Hilfsmatrix
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: work
    REAL(KIND(0D0)),DIMENSION(:,:),ALLOCATABLE :: myold,proof
!    Korrelation lengths, variance (var) and nugget
    REAL(KIND(0D0))      :: hx,hy,var,nugget
    REAL                 :: epsi
!    gibt es evtl schon eine inverse?
    LOGICAL              :: ex
!    Hilfsvariablen
    INTEGER              :: i,j,ifp
!    smatm file name
    CHARACTER(124)        :: fsmat
!    clearscreen
    CHARACTER(80)        :: csz

    epsi=EPSILON(epsi)
    IF (lverb) WRITE (*,*)'Epsilon smatm::',epsi

    errnr = 1
    CALL get_unit(ifp)

    var = 1d0
    nugget = 1d-4

    fsmat = ramd(1:lnramd)//slash(1:1)//'inv.smatmi'

    DO i=1,79
       csz(i:i+1)=' '
    END DO

    WRITE (*,'(A80)')ACHAR(13)//TRIM(csz)

    WRITE (*,'(A,1X,F6.2,1X,A)')ACHAR(13)//'Speicher fuer model '//&
         'covariance: ',REAL ((manz**2*8.)/(1024.**3)),'GB'

    IF (.NOT.ALLOCATED (smatm))ALLOCATE (smatm(manz,manz),STAT=errnr)
    IF (errnr/=0) THEN
       WRITE (*,'(/a/)')'Allocation problem smatm in bsmatmsto'
       errnr = 97
       RETURN
    END IF
    IF (.NOT.ALLOCATED (proof).AND.lverb) THEN
       ALLOCATE (proof(manz,manz),STAT=errnr)
       IF (errnr/=0) THEN
          WRITE (*,'(/a/)')'Allocation problem smatm in bsmatmsto'
          errnr = 97
          RETURN
       END IF
       ALLOCATE (myold(manz,manz),STAT=errnr)
       IF (errnr/=0) THEN
          WRITE (*,'(/a/)')'Allocation problem smatm in bsmatmsto'
          errnr = 97
          RETURN
       END IF
    END IF
!    Belege die Matrix

    smatm = 0d0

    INQUIRE(FILE=fsmat,EXIST=ex) !already an inverse c_m ?

    IF (ex) THEN

       WRITE (*,'(a)',ADVANCE='no')'checking '//fsmat
       OPEN (ifp,FILE=fsmat,STATUS='old',ACCESS='sequential',&
            FORM='unformatted')
       READ (ifp) i
       IF (i == manz) THEN
          WRITE(*,'(t40,a)')'ok!'
          READ (ifp) smatm
       END IF
       CLOSE (ifp)

       errnr = 0

    ELSE

       !$OMP PARALLEL DEFAULT (none) &
       !$OMP SHARED (smatm,manz,epsi,lverb,ifp,espx,espy,var) &
       !$OMP PRIVATE (i,j,hx,hy)
       !$OMP DO SCHEDULE (GUIDED,CHUNK_0)
       DO i = 1 , manz
          IF (lverb) WRITE (*,'(a,t25,F6.2,A,t70,a)',ADVANCE='no')ACHAR(13)//&
               'cov/',REAL(i*(100./manz)),'%',''

          smatm(i,i) = var ! nugget (=variance) effect on the main
! R(h) = C_0 \delta(h)  = 
! \begin{case} C_0 & \mbox{if}\;h = 0 \\ 0 & else \end{case}

          DO j = i+1 , manz   !fills upper triangle

             hx = (espx(i) - espx(j)) !main point differences
             hy = (espy(i) - espy(j))

             smatm(i,j) = mcova(hx,hy,var) ! compute covariance

             smatm(j,i) = smatm(i,j) ! lower triangle

          END DO
       END DO
       !$OMP END PARALLEL

       IF (lverb_dat) THEN
          fetxt = 'cm0.dat'
          PRINT*,'writing '//TRIM(fetxt)
          OPEN (ifp,FILE=TRIM(fetxt),STATUS='replace',&
               ACCESS='sequential',FORM='formatted')
          DO i = 1,manz
             WRITE (ifp,*)espx(i),espy(i),(smatm(i,j),j=i,manz)
          END DO
          CLOSE (ifp)
       END IF

       IF (lverb) myold = smatm

!    Berechne nun die Inverse der Covarianzmatrix!!!
       IF (lgauss) THEN
          PRINT*,'   Gauss elemination ... '
          CALL gauss_dble(smatm,manz,errnr)
          IF (errnr/=0) THEN
             fetxt='there was something wrong..'
             PRINT*,'Zeile(',ABS(errnr),')::',smatm(ABS(errnr),:)
             errnr = 108
             RETURN
          END IF
       ELSE                   !default..
          WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//'Factorization...'
          ALLOCATE (work(manz))
          CALL CHOLD(smatm,work,manz,errnr,lverb)
          IF (errnr/=0) THEN
             fetxt='CHOLD smatm :: matrix not pos definite..'
             PRINT*,'Zeile(',ABS(errnr),')'
             errnr = 108
             RETURN
          END IF
          WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//'Inverting...'
          CALL LINVD(smatm,work,manz,lverb)
          DEALLOCATE (work)
          !$OMP PARALLEL DEFAULT (none) &
          !$OMP SHARED (smatm,manz,epsi,lverb) &
          !$OMP PRIVATE (i,j)
          !$OMP DO SCHEDULE (GUIDED,CHUNK_0)
          DO i= 1, manz
             IF (lverb) WRITE (*,'(A,t25,F6.2,A)',ADVANCE='no')ACHAR(13)//&
                  'Filling upper C_m',REAL( i * (100./manz)),'%'
             DO j = 1, i - 1

                smatm(i,j) = smatm(j,i)

             END DO
          END DO
          !$OMP END PARALLEL
       END IF

       IF (lverb) THEN

          !$OMP WORKSHARE
          proof = MATMUL(smatm,myold)
          !$OMP END WORKSHARE

          DEALLOCATE (myold)
          DO i=1,manz
             IF (ABS(proof(i,i) - 1d0) > 0.1) PRINT*,'bad approximation at parameter'&
                  ,i,proof(i,i)
          END DO

       END IF

       IF (errnr == 0) THEN
          WRITE (*,'(a)',ADVANCE='no')ACHAR(13)//'got inverse'
          IF (lverb) THEN
             WRITE (*,'(a)',ADVANCE='no')' .. write out'//TRIM(fsmat)
             OPEN (ifp,FILE=fsmat,STATUS='replace',ACCESS='sequential',&
                  FORM='unformatted')
             WRITE (ifp) manz
             WRITE (ifp) smatm
             CLOSE (ifp)
          END IF

       ELSE

          PRINT*,'got NO inverse'
          errnr = 108
          RETURN

       END IF

!! verbose output of inverse smatm data
       IF (lverb_dat) THEN
          fetxt = 'cm0_inv.dat'
          PRINT*,'writing '//TRIM(fetxt)
          OPEN (ifp,FILE=TRIM(fetxt),STATUS='replace',&
               ACCESS='sequential',FORM='formatted')
          DO i = 1,manz
             WRITE (ifp,*)espx(i),espy(i),(smatm(i,j),j=i,manz)
          END DO
          CLOSE (ifp)
       END IF


    END IF
    IF (ALLOCATED(proof)) DEALLOCATE (proof)

  END SUBROUTINE bsmatmsto

END MODULE bsmatm_mod

function filpat(disfile,ln,sw,slash)

!!!$     Die Funktion separiert aus einem kompletten Pfad 'disfile' den
!!!$     File-Namen (sw = 0) bzw. den Ordner (sw = 1) der Laenge 'ln'.

!!!$     Andreas Kemna                                            19-Jan-1993
!!!$     Letzte Aenderung   24-Oct-1996

!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

  IMPLICIT none
  CHARACTER (*)       ::  disfile
  CHARACTER (*)       ::  filpat
  INTEGER (KIND = 4)  ::     ln
  INTEGER (KIND = 4)  ::     sw
  CHARACTER (1)       ::    slash

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

  INTEGER (KIND = 4)  ::     id1,id2

!!!$.....................................................................

  id2 = 0
  id1 = 1
  DO WHILE (id1 /= 0) 
     id1 = index(disfile(id2+1:len(disfile)),slash(1:1))
     if (id1.ne.0) then
        id2 = id1+id2
     end if
  END DO
  if (sw.eq.0) then
     filpat = disfile(id2+1:len(disfile))
  else
     if (id2.ge.2) then
        filpat = disfile(1:id2-1)
     else
        filpat = ' '
     end if
  end if

  ln = index(filpat,' ')-1
  ln = max(ln,1)

  return
end function filpat

!> \file rsigma.f90
!> \brief read model conductivity file.
!> \details Read model conductivity file and store it in the complex format \f$ \sigma = \frac{1}{| \rho |} \exp^{\i \varphi} \f$
!> @author Andreas Kemna 
!> @date 10/11/1993


SUBROUTINE rsigma(kanal,datei)

!     Unterprogramm zum Einlesen der Widerstandsverteilung aus 'datei'.

!     Andreas Kemna                                            20-Dec-1993
!     Letzte Aenderung   07-Nov-1997

!.....................................................................

  USE make_noise
  USE alloci,ONLY:rnd_r,rnd_p
  USE femmod
  USE invmod
  USE sigmamod
  USE modelmod
  USE elemmod
  USE errmod
  USE konvmod

  IMPLICIT NONE

!.....................................................................

!     EIN-/AUSGABEPARAMETER:

!> unit number
  INTEGER (KIND=4) ::    kanal

!> filename
  CHARACTER (80)   ::    datei

!.....................................................................
! FUNCTION
  INTEGER :: set_ind_ref_grad

!     PROGRAMMINTERNE PARAMETER:

!     Hilfsvariablen
  INTEGER (KIND=4) ::     i,idum,ifp1,ifp2
  REAL(KIND(0D0))  ::     bet,pha,eps_r,eps_p,bet_ref,pha_ref
! Pi
  REAL (KIND(0D0)) ::    pi
!.....................................................................
  pi = dacos(-1d0)

  lw_ref = .FALSE.
  lam_ref = -1d0 
  lam_ref_sw = 0

!     'datei' oeffnen
  fetxt = datei

  errnr = 1
  OPEN(kanal,file=TRIM(fetxt),status='old',err=999)

  errnr = 3
  IF (lnsepri) THEN
     PRINT*,''
     CALL get_unit(ifp1)
     PRINT*,'iseedpri / std. err.',iseedpri,modl_stdn
     OPEN (ifp1,FILE='tmp.mynoise_mprior_rho',STATUS='replace')
     WRITE (*,'(A)',advance='no')' Initializing noise '
     ALLOCATE (rnd_r(elanz))
     CALL Random_Init(iseedpri)
     DO i=1,elanz
        rnd_r(i) = Random_Gauss()
     END DO
     IF (.NOT.ldc) THEN
        CALL get_unit(ifp2)
        OPEN (ifp2,FILE='tmp.mynoise_mprior_phase',STATUS='replace')
        ALLOCATE (rnd_p(elanz))
        CALL Random_Init(-iseedpri)
        DO i=1,elanz
           rnd_p(i) = Random_Gauss()
        END DO
     END IF
     PRINT*,''
  END IF

!     Anzahl der Messwerte lesen
! also check if we may use individual errors or not
!!! Failsafe read in one line

  READ(kanal,*,END=11,err=11) idum,lw_ref,lam_ref,lam_ref_sw
  WRITE (*,'(a)',ADVANCE='no')'Successful I/O of all reference regu options'
  IF (lw_ref) THEN
     IF (lam_ref_sw == 1) WRITE(*,'(a)')&
          '  -> vertical gradient'
     IF (lam_ref_sw == 2) WRITE(*,'(a)')&
          '  -> horizontal gradient'
  END IF
  GOTO 12
11 IF (lam_ref < 0d0) lam_ref = 1d0 
  BACKSPACE (kanal)
  
12 IF (lw_ref) THEN
     

     ALLOCATE (ind_ref_grad(manz)) ! which is in fact manz for now
     
     ind_ref_grad = 0

     PRINT*,'---> Reference model regularization '
     IF (lam_ref <= EPSILON(REAL(lam_ref))) THEN
        lam_ref = 0d0 ! so, what again is zero ??
     END IF
     PRINT*,'     lambda ref (factor)=',lam_ref
  END IF

!     Ggf. Fehlermeldung
  IF (idum.NE.elanz) THEN
     fetxt = ' '
     errnr = 47
     GOTO 1000
  END IF
  


!     Betrag und Phase (in mrad) des komplexen Widerstandes einlesen
  DO i=1,elanz
     
     IF (lw_ref) THEN
!!$        IF (ldc) THEN
!!$           READ(kanal,*,END=1001,err=1002) bet,pha,bet_ref,w_ref_re(mnr(i))
!!$           pha_ref = 0d0
!!$        ELSE
        READ(kanal,*,END=1001,err=1002) bet,pha,bet_ref,eps_r,pha_ref,eps_p
        w_ref_re(mnr(i)) = eps_r * eps_r ! make std err -> variance
        w_ref_im(mnr(i)) = eps_p * eps_p ! std err -> variance
        pha_ref = 1d-3 * pha_ref ! mRad -> Rad
!!$        END IF
     ELSE
        READ(kanal,*,END=1001,err=1000) bet,pha
     END IF

     pha      = 1d-3*pha

     IF (lprior) THEN 
        !     set prior model ...             
        IF (bet0 <= 0. .OR. &
             (.NOT.ldc.AND.dabs(pha0).GT.1d3*pi)) THEN
           fetxt = 'starting model incorrect '
           errnr = 91
           GOTO 999
        END IF

        IF (bet > 0d0) THEN  
           !     TODO: meaningful phase check.. 
           IF (lnsepri) THEN
              eps_r = 1d-2*modl_stdn * bet
              WRITE(ifp1,'(3(G14.4,1X))',ADVANCE='no')rnd_r(i),eps_r,bet
              bet = bet + rnd_r(i) * eps_r
              WRITE(ifp1,'(G14.4)')bet
              IF (.NOT. ldc) THEN
                 eps_p = 1d-2*modl_stdn*dabs(pha)
                 WRITE(ifp2,'(3(G14.4,1X))',ADVANCE='no')rnd_p(i),eps_p,pha
                 pha = pha + rnd_p(i) * eps_p
                 WRITE(ifp2,'(G14.4)')pha
              END IF
           END IF
           sigma(i) = dcmplx(dcos(pha)/bet,-dsin(pha)/bet)
!    hier koennte mittelung passieren
           m0(mnr(i)) = cdlog(sigma(i))
        ELSE                
           !     or let it stay at zero and take background cond
           sigma(i) = dcmplx( dcos(pha0/1d3)/bet0 , -dsin(pha0/1d3)/bet0 )
           m0(mnr(i)) = DCMPLX(0d0)
        END IF

     ELSE

!     Ggf. Fehlermeldung
        IF (bet.LT.1d-12) THEN
           fetxt = ' '
           errnr = 11
           GOTO 999
        END IF

!     Komplexe Leitfaehigkeit bestimmen
        sigma(i) = dcmplx(dcos(pha)/bet,-dsin(pha)/bet)

     END IF

! >> RM ref model regu
     IF (.NOT.lw_ref) CYCLE ! next i 
     IF (w_ref_re(mnr(i)) > EPSILON(eps_r)) THEN

! variance -> inverse weighting        
        w_ref_re(mnr(i)) = 1d0/w_ref_re(mnr(i))

! assign m_ref = \ln(|\sigma|) + i \phi(\sigma) 
!              = -\ln(|\rho|) - i\phi(\rho) 
!              = - (\ln(|\rho|)+i\phi(\rho)
! for \phi(z) = Im(z) / Re(z), z\inC

        m_ref(mnr(i)) = -DCMPLX(DLOG(bet_ref),pha_ref)
        IF (w_ref_im(mnr(i)) > EPSILON(eps_p)) THEN
           w_ref_im(mnr(i)) = 1d0/w_ref_im(mnr(i))
        ELSE ! force zero
           w_ref_im(mnr(i)) = 0D0
        END IF

        ind_ref_grad(i) = set_ind_ref_grad(i)

     ELSE
        m_ref(mnr(i)) = DCMPLX(0d0)

     END IF
! << RM ref model regu

  END DO

!     'datei' schliessen
  CLOSE(kanal)

  IF (lw_ref .AND. lam_ref_sw > 0) THEN
     OPEN (kanal,FILE='tmp.ind_ref',STATUS='replace')
     DO i = 1,elanz
        IF (ind_ref_grad(i) /= 0) WRITE (kanal,*) &
             i,ind_ref_grad(i),REAL(espx(i)),REAL(espy(i)),&
             REAL(espx(ind_ref_grad(i))),REAL(espy(ind_ref_grad(i)))
     END DO
     CLOSE (kanal)
  END IF
!  IF (lw_ref .AND. (lam_ref_sw > 0)) CALL set_ind_ref_grad2

  IF (lnsepri) THEN
     CLOSE (ifp1)
     IF (.NOT.ldc) CLOSE(ifp2)
  END IF

  errnr = 0
  RETURN

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

999 RETURN

1000 CLOSE(kanal)
  RETURN

1001 CLOSE(kanal)
  errnr = 2
  RETURN

1002 CLOSE(kanal)
  fetxt = 'reference assignment failed'
  errnr = 2
  RETURN

END SUBROUTINE rsigma

INTEGER FUNCTION set_ind_ref_grad(i)

  USE elemmod
  USE konvmod, ONLY: lam_ref_sw

  IMPLICIT NONE

  INTEGER :: k,nik
  INTEGER,INTENT(IN) :: i
  REAL(KIND(0d0)) :: ax,ay

  set_ind_ref_grad = 0

  DO k = 1, nachbar(i,max_nr_element_nodes + 1) ! check all neighboring elements
     
     nik = nachbar(i,k)
     
     IF (nik == 0) CYCLE ! if it is not a neighbor.. skip it
!!! else check the element number
     ax = ABS(espx(i) - espx(nik)) ! center point differences
! for vertical gradient, this needs to be smaller than the grid distance
     ay = ABS(espy(i) - espy(nik)) ! center point differences
     
     
     IF ( ((lam_ref_sw == 1) .AND. &
          (ax >= grid_minx .OR. espy(nik) > espy(i))) .OR. &
          ((lam_ref_sw == 2) .AND. &
          (ay >= grid_miny .OR. espx(nik) < espx(i))) ) CYCLE
     
     set_ind_ref_grad = nik
     
  END DO

END FUNCTION  set_ind_ref_grad

SUBROUTINE set_ind_ref_grad2
  USE sigmamod
  USE modelmod
  USE elemmod
  USE errmod
  USE elemmod
  USE konvmod, ONLY: lam_ref_sw

  IMPLICIT NONE

  INTEGER :: i,k,nik
  INTEGER :: ifp
  REAL(KIND(0d0)) :: ax,ay


  PRINT*,'setting ind_ref_grad'
  CALL get_unit(ifp)
  OPEN (ifp,FILE='tmp.ind_ref',STATUS='replace')

  DO i = 1,elanz

     DO k = 1, nachbar(i,max_nr_element_nodes + 1) ! check all neighboring elements

        nik = nachbar(i,k)

        IF (nik == 0) CYCLE ! if it is not a neighbor.. skip it
!!! else check the element number
        ax = ABS(espx(i) - espx(nik)) ! center point differences
! for vertical gradient, this needs to be smaller than the grid distance
        ay = ABS(espy(i) - espy(nik)) ! center point differences
        

!!$        IF (lam_ref_sw == 1 ) THEN ! vertical gradient
!!$           IF (ax < grid_minx) THEN ! if the points are at the same profile coordinate
!!$!!! There are just two or less more pints: 
!!$! one above and one below
!!$              PRINT*,i,nachbar(i,k)
!!$              IF (espy(nachbar(i,k)) < espy(i)) THEN ! is the point is _below_ the other..
!!$! save its number
!!$                 ind_ref_grad(i) = nachbar(i,k)
!!$              END IF
!!$           END IF
!!$        ELSE
!!$           IF (ay < grid_miny) THEN ! if the points are at the same profile coordinate
!!$              IF (espx(nachbar(i,k)) > espx(i)) THEN ! i the point is _below_ the other..
!!$                 ind_ref_grad(i) = nachbar(i,k)
!!$              END IF
!!$           END IF
!!$
!!$        END IF


! shorter XOR variant

        IF ( ((lam_ref_sw == 1) .AND. &
             (ax >= grid_minx .OR. espy(nik) > espy(i))) .OR. &
             ((lam_ref_sw == 2) .AND. &
             (ay >= grid_miny .OR. espx(nik) < espx(i))) ) CYCLE

        ind_ref_grad(i) = nik
        
     END DO

     IF (ind_ref_grad(i) /= 0) THEN
        WRITE (ifp,*) i,ind_ref_grad(i),REAL(espx(i)),&
             REAL(espy(i)),REAL(espx(ind_ref_grad(i))),REAL(espy(ind_ref_grad(i)))
     ELSE
        WRITE (ifp,*) nachbar(i,max_nr_element_nodes + 1),i,ind_ref_grad(i),REAL(espx(i)),REAL(espy(i))
     END IF


  END DO

  CLOSE (ifp)


END SUBROUTINE set_ind_ref_grad2

!!!$     diff-        subroutine kont1(delem,delectr,dstrom,drandb)
!!!$     diff+<
SUBROUTINE kont1(delem,delectr,dstrom,drandb,dd0,dm0,dfm0,lagain)
!!!$     diff+>

!!!$     Unterprogramm zur Ausgabe der Kontrollvariablen.

!!!$     Andreas Kemna                                            16-Apr-1996
!!!$     Letzte Aenderung   16-Jul-2007

!!!$.....................................................................

  USE variomodel
  USE femmod
  USE datmod
  USE cjgmod
  USE sigmamod
  USE modelmod
  USE elemmod
  USE wavenmod
  USE randbmod
  USE errmod
  USE konvmod
  USE pathmod
  USE get_ver,ONLY : version

  IMPLICIT NONE

!!!$.....................................................................
!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Dateinamen
  CHARACTER (80)  :: delem,delectr,dstrom,dd0,dm0,dfm0,drandb
  LOGICAL :: lagain
  REAL(KIND(0D0)) :: Ix,Iy

  fetxt = ramd(1:lnramd)//slash(1:1)//'inv.ctr'
  OPEN(fpinv,file=TRIM(fetxt),status='old',POSITION='append',err=999)


!!!$     HEADER AUSGEBEN
10 FORMAT (l1,t20,a)
11 FORMAT (g11.5,t20,a)
12 FORMAT (I8,t20,a)
13 FORMAT (t1, a3, t5,a3,t11,a8,t23,a8,t34,a8,t46,a8,t58,a8,&
       t69,a8,t81,a8,t93,a8,t105,a8,t117,a10)
14 FORMAT (t1, a3, t5,a3,t11,a8,t23,a8,t34,a8,t46,a8,t58,a8,&
       t69,a8,t81,a8,t93,a8,t105,a10)


  WRITE (fpinv,'(a)')'##'
  WRITE (fpinv,'(a)')'## Complex Resistivity Tomography (CRTomo)'
  WRITE (fpinv,'(a)')'##'
  WRITE (fpinv,'(a)')'## Git-Branch '//TRIM(version(1))
  WRITE (fpinv,'(a)')'## Git-ID     '//TRIM(version(2))
  WRITE (fpinv,'(a)')'## Compiler   '//TRIM(version(4))
  WRITE (fpinv,'(a)')'## OS         '//TRIM(version(5))
  WRITE (fpinv,'(a)')'##'
  WRITE (fpinv,'(a)')'## Created  '//TRIM(version(3))
  WRITE (fpinv,'(a)')'##'
  WRITE (fpinv,'(a)')''

  IF (mswitch /= 0) THEN
     WRITE(fpinv,12,err=999)mswitch,'#  mswitch'
  ELSE
     WRITE(fpinv,'(a)',err=999) '***FILES***'
  END IF

  WRITE(fpinv,'(a)',err=999) TRIM(delem)//' # FEM grid'
  WRITE(fpinv,'(a)',err=999) TRIM(delectr)//' # Electrodes'
  WRITE(fpinv,'(a)',err=999) TRIM(dstrom)//' # Measurements'
  WRITE(fpinv,'(a)',err=999) TRIM(ramd)//' # Inversion results'
!!!$     diff+<
  WRITE(fpinv,10,err=999) ldiff.OR.lprior,&
       '! difference inversion or (m - m_{prior})'
  WRITE(fpinv,'(a)',err=999) TRIM(dd0)
  WRITE(fpinv,'(a)',err=999) TRIM(dm0)
  WRITE(fpinv,'(a)',err=999) TRIM(dfm0)
!!!$     diff+>
  IF (lnsepri) THEN
     WRITE (fpinv,*,err=999) iseedpri,modl_stdn
  ELSE
     WRITE(fpinv,'(a)',err=999) '***PARAMETERS***'
  END IF
  WRITE(fpinv,12,err=999) nx,'! nx-switch or # cells in x-direction'
  WRITE(fpinv,12,err=999) nz,'! nz-switch or # cells in z-direction'
  WRITE(fpinv,11,err=999) alfx,'! smoothing parameter in x-direction'
  WRITE(fpinv,11,err=999) alfz,'! smoothing parameter in z-direction'
  WRITE(fpinv,12,err=999) itmax,'! max. # inversion iterations'
!!!$     ak        write(fpinv,'(g11.5,t18,a15)',err=999) nrmsdm,'! min. data RMS'
  WRITE(fpinv,10,err=999) ldc,'! DC inversion ?'
!!!$     ak        write(fpinv,'(l1,t18,a23)',err=999) lsr,'! singularity removal ?'
  WRITE(fpinv,10,err=999) lrobust,'! robust inversion ?'
!!!$     ak        write(fpinv,'(l1,t18,a33)',err=999) lpol,
!!!$     ak     1           '! automatic polarity adjustment ?'
  WRITE(fpinv,10,err=999) lfphai,'! final phase improvement ?'
  WRITE(fpinv,11,err=999) stabw0,'! rel. resistance error level (%)'// &
       '  (parameter A1 in err(R) = A1*abs(R) + A2)'
  WRITE(fpinv,11,err=999) stabm0,'! min. abs. resistance error (ohm)'// &
       ' (parameter A2 in err(R) = A1*abs(R) + A2)'
  WRITE(fpinv,11,err=999) stabpA1,&
       '! phase error model parameter A1 (mrad/ohm^B) '// &
       '(in err(pha) = A1*abs(R)**B + A2*abs(pha) + A3)'
  WRITE(fpinv,11,err=999) stabpB, &
       '! phase error model parameter B  (-)          '// &
       '(in err(pha) = A1*abs(R)**B + A2*abs(pha) + A3)'
  WRITE(fpinv,11,err=999) stabpA2, &
       '! phase error model parameter A2 (%)          '// &
       '(in err(pha) = A1*abs(R)**B + A2*abs(pha) + A3)'
  WRITE(fpinv,11,err=999) stabp0, &
       '! phase error model parameter A3 (mrad)       '// &
       '(in err(pha) = A1*abs(R)**B + A2*abs(pha) + A3)'
  WRITE(fpinv,10,err=999) lrho0,'! homogeneous background resistivity ?'
  WRITE(fpinv,11,err=999) bet0,'! background magnitude (ohm*m)'
  WRITE(fpinv,11,err=999) pha0,'! background phase (mrad)'
  WRITE(fpinv,10,err=999) lagain,'! Another dataset?'
  WRITE(fpinv,12,err=999) swrtr,'! 2D (=0) or 2.5D (=1)'
  WRITE(fpinv,10,err=999) lsink,'! fictitious sink ?'
  WRITE(fpinv,12,err=999) nsink,'! fictitious sink node number'
  WRITE(fpinv,10,err=999) lrandb2,'! boundary values ?'
  WRITE(fpinv,'(a)',err=999) TRIM(drandb)
  IF (BTEST(llamf,0)) THEN
     IF (BTEST(llamf,1)) THEN
        WRITE (fpinv,'(I2)') ltri + 2**5 + 2**6
     ELSE
        WRITE (fpinv,'(I2)') ltri + 2**5
     END IF
  ELSE
     WRITE (fpinv,'(I2)') ltri
  END IF
  WRITE (fpinv,'(I2)',err=999) ltri
  IF (BTEST(ltri,5)) WRITE (fpinv,*,err=999) lamfix
  IF (ltri > 4 .AND. ltri < 15) WRITE (fpinv,*,err=999) betamgs
  IF ( lnse ) WRITE (fpinv,*,err=999) iseed
100 FORMAT (a,t39,l1)
101 FORMAT (a,t30,g10.5)
102 FORMAT (a,t30,I8)

  WRITE(fpinv,'(/a)',err=999)'***Model stats***'
  WRITE(fpinv,102,err=999)'# Model parameters',manz
  WRITE(fpinv,102,err=999)'# Data points',nanz
  WRITE(fpinv,100,err=999)'Add data noise ?',lnse
  WRITE(fpinv,100,err=999)'Couple to Err. Modl?',.NOT.lnse2
  WRITE(fpinv,102,err=999)'    seed',iseed
  WRITE(fpinv,101,err=999)'    Variance',nstabw0
  WRITE(fpinv,100,err=999)'Add model noise ?',lnsepri
  WRITE(fpinv,102,err=999)'    seed',iseedpri
  WRITE(fpinv,101,err=999)'    Variance',modl_stdn
  WRITE(fpinv,'(/a)',err=999)'******** Regularization Part *********'
  WRITE(fpinv,100,err=999)'Prior regualrization',lprior
  WRITE(fpinv,100,err=999)'Reference regualrization',lw_ref
  IF (lw_ref) THEN
     IF (lam_ref_sw == 1) WRITE(fpinv,'(a)',err=999)&
          '  -> vertical gradient'
     IF (lam_ref_sw == 2) WRITE(fpinv,'(a)',err=999)&
          '  -> horizontal gradient'
     WRITE(fpinv,101,err=999)'  global regularization strength',lam_ref
  END IF
  WRITE(fpinv,101,err=999)'Regularization-switch',ltri
  WRITE(fpinv,100,err=999)'Regular grid smooth',(ltri==0)
  WRITE(fpinv,100,err=999)'Triangular regu',(ltri==1)
  WRITE(fpinv,100,err=999)'Triangular regu2',(ltri==2)
  WRITE(fpinv,100,err=999)'Levenberg damping',(ltri==3)
  WRITE(fpinv,100,err=999)'Marquardt damping',(ltri==4)
  WRITE(fpinv,100,err=999)'Minimum grad supp',(ltri==5)
  WRITE(fpinv,100,err=999)'MGS beta/sns1 (RM)',(ltri==6)
  WRITE(fpinv,100,err=999)'MGS beta/sns2 (RM)',(ltri==7)
  WRITE(fpinv,100,err=999)'MGS beta/sns1 (RB)',(ltri==8)
  WRITE(fpinv,100,err=999)'MGS beta/sns2 (RB)',(ltri==9)
  WRITE(fpinv,100,err=999)'TV (Huber)',(ltri==10)

  IF (ltri>4.AND.ltri<15)&
       WRITE(fpinv,101,err=999)'  Stabilizer beta',betamgs

  !  WRITE(fpinv,100,err=999)'Stochastic regu',(ltri==15)

  IF (ltri == 15) THEN
     CALL get_vario (Ix,Iy,fetxt,1) ! get covariance..
     WRITE (fpinv,'(a)',err=999)'Covariance regu ('//TRIM(fetxt)//')'
     WRITE (*,'(a)')ACHAR(9)//'Covariance ('//TRIM(fetxt)//')'
  END IF

  IF (lvario) THEN
     WRITE (fpinv,'(a)',err=999)'Caculate experimental Variogram::'
     WRITE (fpinv,'(a,I4)',err=999)ACHAR(9)//'nx-switch  : ',nx
     CALL get_vario (Ix,Iy,fetxt,0) ! get korrelation lengths
     WRITE (fpinv,'(2(a,F5.2))',ERR=999)ACHAR(9)// &
          'Correlation lengths Ix/Iy',Ix,'/',Iy
     WRITE (*,'(2(a,F5.2),a)')ACHAR(9)// &
          'Correlation lengths (I{x,y}) (',Ix,'/',Iy,') [m]'
     WRITE (fpinv,'(a)',err=999)ACHAR(9)// &
          'Variogram ('//TRIM(fetxt)//')'
     WRITE (*,'(a)')ACHAR(9)//'Variogram ('//TRIM(fetxt)//')' 
  END IF

  WRITE(fpinv,100,err=999)'Fixed lambda?',BTEST(llamf,0)
  IF (BTEST(llamf,0)) WRITE (fpinv,101,err=999)'Lambda=',lamfix
  IF (BTEST(llamf,1)) WRITE(fpinv,100,err=999)'Cooling lambda?',&
       BTEST(llamf,1)

  IF (nz<0) THEN
     WRITE(fpinv,'(a)',err=999,ADVANCE='no')'Taking easy lam_0 : '
     IF (nz<-1) WRITE(fpinv,*,err=999) -REAL(nz)
     IF (nz==-1) WRITE(fpinv,*,err=999)MAX(REAL(manz),REAL(nanz))
  END IF

  WRITE(fpinv,'(/a,I6)',err=999)'******** Additional output *********'
  WRITE(fpinv,101,err=999)'mswitch',mswitch
  WRITE(fpinv,100,err=999)'Read start model?',lstart
  WRITE(fpinv,100,err=999)'Write coverage?',lsens
  WRITE(fpinv,100,err=999)'Write MCM 1?',lcov1
  WRITE(fpinv,100,err=999)'Write resolution?',lres
  WRITE(fpinv,100,err=999)'Write MCM 2?',lcov2
  WRITE(fpinv,100,err=999)'Using Gauss ols?',lgauss
  WRITE(fpinv,100,err=999)'Forcing negative phase?',lphi0
  WRITE(fpinv,100,err=999)'Calculate sytop?',lsytop
  WRITE(fpinv,100,err=999)'Verbose?',lverb
  WRITE(fpinv,100,err=999)'Error Ellipses?',lelerr
  WRITE(fpinv,100,err=999)'Restart FPI with homogenous phase?',lffhom
  WRITE(fpinv,'(l1,t18,a20)',err=999) lindiv,'! individual error ?'

  WRITE(fpinv,'(/a)',err=999) '***FIXED***'

  IF (swrtr.EQ.1) THEN
     WRITE(fpinv,'(a,t50,i2)',err=999) ' # wavenumbers :',kwnanz
     WRITE(fpinv,'(a,t50,g11.5,t62,a1)',err=999)&
          ' Inverse Fourier transform range :',amin,'m'
     WRITE(fpinv,'(t50,g11.5,t62,a1)',err=999) amax,'m'
  END IF
  IF (lsytop) THEN
     WRITE(fpinv,'(a,t50,g11.5)',err=999) &
          ' -- Sytop [m] :',sytop
  END IF
  IF (.NOT.lrho0.AND..NOT.lstart) THEN
     bet0 = cdabs(dcmplx(1d0)/sigma0)
     pha0 = 1d3*datan2(dimag(dcmplx(1d0)/sigma0),DBLE(dcmplx(1d0)/sigma0))
     WRITE(fpinv,'(a,t50,g11.5,t62,a5)',err=999) &
          ' Background resistivity :',bet0,'ohm*m'
     WRITE(fpinv,'(t50,g11.5,t62,a4)',err=999)pha0,'mrad'
  END IF
  WRITE(fpinv,'(a,t50,l1)',err=999)' Force negative phase ?',lphi0
  WRITE(fpinv,'(a16,t50,l1)',err=999) ' Ratio dataset ?',lratio
  IF (lrobust.OR.lfphai) WRITE(fpinv,'(a13,t50,g11.5)',err=999)&
       ' Min. L1 norm',l1min
  WRITE(fpinv,'(a,t50,g11.5)',err=999)&
       ' Min. rel. decrease of data RMS :',mqrms
  WRITE(fpinv,'(a,t50,g11.5)',err=999)&
       ' Min. steplength              :',stpmin
  WRITE(fpinv,'(a,t50,g11.5)',err=999)&
       ' Min. stepsize (||\delta m||) :',bdmin
  WRITE(fpinv,'(a,t50,g11.5)',err=999)&
       ' Min. error in relaxation :',eps
  WRITE(fpinv,'(a,t50,i5)',err=999)&
       ' Max. # relaxation iterations :',ncgmax
  WRITE(fpinv,'(a,t50,i3)',err=999)&
       ' Max. # regularization steps :',nlam
  WRITE(fpinv,'(a,t50,g11.5)',err=999)' Initial step factor :',fstart
  WRITE(fpinv,'(a,t50,g11.5)',err=999)' Final   step factor :',fstop
  WRITE(fpinv,*,err=999)
  WRITE(fpinv,'(a48,a48,a13)',err=999)&
       '------------------------------------------------',&
       '------------------------------------------------',&
       '-------------'
  WRITE(fpinv,*,err=999)
!!!$     Robuste Inversion
  IF (lrobust) THEN
     WRITE(fpinv,13,err=999)'ID','it.','data RMS','stepsize',&
          ' lambda ',' roughn.','CG-steps',' mag RMS',' pha RMS',&
          '- # data','L1-ratio','steplength'
  ELSE
     WRITE(fpinv,14,err=999)&
          'ID','it.','data RMS','stepsize',' lambda ',' roughn.',&
          'CG-steps',' mag RMS',' pha RMS','- # data','steplength'
  END IF
  WRITE(fpinv,*,err=999)

!!!$     'inv.ctr' schliessen
  CLOSE(fpinv)

  errnr = 0
  RETURN

!!!$:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!!!$     Fehlermeldungen

999 RETURN

END SUBROUTINE kont1

!> \file relectr.f90
!> \brief read electrode configurations for the forward modeling
!> \details Read node numbers of all electrodes
!> @author Andreas Kemna
!> @date 10/11/1993

subroutine relectr(kanal,datei)
    !     Unterprogramm zum Einlesen der Elektrodenverteilung aus 'datei'.
    !     Andreas Kemna                                            11-Oct-1993
    !     Letzte Aenderung   24-Oct-1996
    !.....................................................................

    USE electrmod
    USE elemmod
    USE errmod

    IMPLICIT none

    !.....................................................................

    ! EIN-/AUSGABEPARAMETER:

    ! unit number
    INTEGER (KIND = 4) ::     kanal

    ! filename
    CHARACTER (80) ::    datei

    !.....................................................................
    !     PROGRAMMINTERNE PARAMETER:
    !     Indexvariable
    INTEGER (KIND =4) ::     i,ifp
    !.....................................................................

    !     'datei' oeffnen
    fetxt = datei
    errnr = 1
    open(kanal,file=TRIM(fetxt),status='old',err=999)
    CALL get_unit(ifp)

    OPEN (ifp,FILE='inv.elecpositions',STATUS='replace')

    errnr = 3

    ! Anzahl der Elektroden einlesen
    read(kanal,*,end=1001,err=1000) eanz

    ! memory allocation
    ALLOCATE (enr(eanz),stat=errnr)
    IF (errnr /= 0) THEN
        fetxt = 'Error memory allocation enr'
        errnr = 94
        goto 1000
    END IF

    WRITE (ifp,*)eanz

    ! Knotennummern der Elektroden einlesen
    do i=1,eanz
        read(kanal,*,end=1001,err=1000) enr(i)
        WRITE (ifp,*)i,sx(snr(enr(i))),sy(snr(enr(i)))
        ! Ggf. Fehlermeldung
        if (enr(i).gt.sanz) then
            fetxt = ' '
            errnr = 29
            goto 1000
        end if
    end do

    !     'datei' schliessen
    CLOSE (ifp)
    close(kanal)

    errnr = 0
    return

    !:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    !     Fehlermeldungen
999 return

1000 close(kanal)
  return

1001 close(kanal)
  errnr = 2
  return

end subroutine relectr

!> \file elem8.f90
!> \brief form functions of quadrilateral area elements (e.g., rectangles)
!> \details Kemna (1995): The stiffness matrix contribution of a quadrilateral element \f$ G^{(j)}\f$ consisting of 4 individual triangles with a linear approach, \f$ G^{(j_1)},..., G^{(j_4)}\f$ is \f$ \sigma_j S^{(j)} \f$, where
!> \f[ S^{(j)} = \sum_{m=1}^4 \left( S_1^{(j_m)} + k^2 S_2^{(j_m)} \right) \f]
!> This requires the four triangles to have the identical conductivities \f$ \sigma \f$. 
!>
!> By analogy with <I> elem3 </I>, the  global \f$ n_k \times n_k \f$ stiffness matrix \f$ S^{(j)} \f$ with the node values \f$ \tilde \phi_{i_1 (j)}, ,..., \tilde \phi_{i_5 (j)} \f$ can be transformed into a \f$ 5 \times 5 \f$ matrix \f$ S^{'(j)} \f$:
!> \f[ (s^{'(j)})_{\kappa \lambda} = (s^{(j)})_{m n} \f]
!> with \f$ m=i_\kappa(j) \f$ and \f$ n=i_\lambda (j) \f$, \f$ \kappa, \lambda \in \{ 1,...,5 \} \f$ 
!> \image html elem8_sketch.png "Assembled quadrilateral element"
!> The node \f$ i_5 (j) \f$ is an internal node of the quadrilateral element in the above figure. Generally, due to the underlying extremum prinviple, it is possible to substitude internal node values by the corresponding element boundary values (Schwarz 1991). This means that prior to solving the Finite Element equation, \f$ \tilde \phi_{i_5(j)} \f$ can be eliminated. The process is named <I> condensation </I> and involves the transformation into \f$ S_*^{'(j)} \f$. The assembled quadrilateral element contribution yields
!> \f[ (s_*^{'(j)})_{\kappa\lambda} = (s^{'(j)})_{\kappa\lambda} - \frac{(s^{'(j)})_{\kappa 5}} (s^{'(j)})_{5 \lambda}{(s^{'(j)})_{55}} \f]
!> with \f$ \kappa, \lambda \in \{ 1,...,5 \}  \f$. The corresponding transformation to the globals stiffness matrix requires the coordinates of the four nodes and their values, \f$ \tilde \phi_{i_1(j)}, ..., \tilde \phi_{i_5(j)} \f$, and the base matrices \f$ U_1,...,U_4 \f$ of the triangle elements. Finally, \f$ \sigma \S_*^{(j)} \f$ is the total contribution of the quadrilateral element to the FE stiffness matrix.

!> @author Andreas Kemna
!> @date 10/11/1993, last change 1/26/1998

subroutine elem8(kelmas,kelve,kwert,max_nr_element_nodes)

!     Unterprogramm liefert die Elementmatrix 'kelmas(4,4)' und den Element-
!     vektor 'kelve(4)' fuer ein zusammengesetztes Viereckelement
!     (vier Teildreiecke mit linearem Ansatz) ( Elementtyp Nr.8 ).

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   26-Jan-1998

!.....................................................................

  USE elemmod,only:xk,yk
  USE errmod

  IMPLICIT none


!.....................................................................
!> element contribution after condensation
  REAL(KIND(0D0)),DIMENSION(max_nr_element_nodes,max_nr_element_nodes) :: kelmas

!> element vector after condensation
  REAL(KIND(0D0)),DIMENSION(max_nr_element_nodes)       :: kelve

!> wave number
  REAL(KIND(0D0))                        :: kwert

!> unused
  INTEGER (KIND = 4)                     :: max_nr_element_nodes

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Hilfskoordinaten
  REAL (KIND(0D0))    ::     xkdum(5),ykdum(5)

!     Beteiligte Knoten des zusammengesetzten Elements am Teildreieck
  INTEGER (KIND = 4)  ::     ik(3)

!     Elementmatrizen vor der Kondensation
  REAL (KIND(0D0))    ::     elmas(5,5),elmam(5,5)

!     Elementvektor vor der Kondensation
  REAL (KIND(0D0))    ::     elve(5)

!     Indexvariablen
  INTEGER (KIND = 4)  ::     i,j,k

!     Grundelementmatrizen
  INTEGER (KIND = 4)  ::     s1(3,3),s2(3,3),s3(3,3),s4(3,3)

!     Grundelementvektor
  INTEGER (KIND = 4)  ::     sb(3)

!     Hilfsvariablen
  REAL (KIND(0D0))    ::     x21,x31,y21,y31,det,a,b,c,a1,a2

!.....................................................................

  data s1/1,-1,0,-1,1,0,0,0,0/
  data s2/2,-1,-1,-1,0,1,-1,1,0/
  data s3/1,0,-1,0,0,0,-1,0,1/
  data s4/2,1,1,1,2,1,1,1,2/
  data sb/1,1,1/

!     Elementmatrix bzw. -vektor des zusammengesetzten Elements gleich
!     Null setzen
  do i=1,5
     elve(i) = 0d0

     do j=1,5
        elmas(i,j) = 0d0
        elmam(i,j) = 0d0
     end do
  end do

!     Hilfskoordinaten bestimmen
  a1 = xk(3)-xk(1)
  a2 = xk(4)-xk(2)

!     Ggf. Fehlermeldung
  if (dabs(a1).le.1d-12.or.dabs(a2).le.1d-12) then
     fetxt = ' '
!     ak            write(fetxt(1:20),'(g20.5)') dabs(a1)
!     ak            write(fetxt(26:45),'(g20.5)') dabs(a2)
     errnr = 26
     goto 1000
  end if

  a1 = (yk(3)-yk(1))/a1
  a2 = (yk(4)-yk(2))/a2

!     Ggf. Fehlermeldung
  if (dabs(a1-a2).le.1d-12) then
     fetxt = ' '
!     ak            write(fetxt(1:20),'(g20.5)') dabs(a1-a2)
     errnr = 26
     goto 1000
  end if

  xkdum(5) = (a1*xk(1)-yk(1)-a2*xk(2)+yk(2))/(a1-a2)
  ykdum(5) = yk(1)+a1*(xkdum(5)-xk(1))

!     Restlichen Koordinaten umspeichern
  do i=1,4
     xkdum(i) = xk(i)
     ykdum(i) = yk(i)
  end do

!     Beitraege der Teilelemente aufaddieren
  do k=1,4

!     Beteiligte Knotenpunkte definieren
     if (k.eq.1) then
        ik(1) = 1
        ik(2) = 2
        ik(3) = 5
     else if (k.eq.2) then
        ik(1) = 2
        ik(2) = 3
        ik(3) = 5
     else if (k.eq.3) then
        ik(1) = 5
        ik(2) = 3
        ik(3) = 4
     else if (k.eq.4) then
        ik(1) = 1
        ik(2) = 5
        ik(3) = 4
     end if

     x21 = xkdum(ik(2)) - xkdum(ik(1))
     x31 = xkdum(ik(3)) - xkdum(ik(1))
     y21 = ykdum(ik(2)) - ykdum(ik(1))
     y31 = ykdum(ik(3)) - ykdum(ik(1))
     det = x21*y31 - x31*y21

!     Ggf. Fehlermeldung
     if (det.le.1d-12) then
        fetxt = ' '
        write(fetxt(1:20),'(g20.5)') det
        errnr = 26
        goto 1000
     end if

     a =   (x31*x31 + y31*y31) / det
     b = - (x31*x21 + y31*y21) / det
     c =   (x21*x21 + y21*y21) / det

     do i=1,3
        elve(ik(i)) = elve(ik(i)) + det * dble(sb(i)) / 6d0

        do j=1,3
           elmas(ik(i),ik(j)) = elmas(ik(i),ik(j)) + &
                (a*dble(s1(i,j)) + b*dble(s2(i,j)) + &
                c*dble(s3(i,j))) / 2d0
           elmam(ik(i),ik(j)) = elmam(ik(i),ik(j)) + &
                det * dble(s4(i,j)) / 2.4d1
        end do
     end do
  end do

!     Kondensationsschritt
  do i=1,5
     do j=1,5
        elmas(i,j) = elmas(i,j) + kwert*kwert*elmam(i,j)
     end do
  end do

  do i=1,4
     kelve(i) = elve(i) - elmas(i,5)*elve(5)/elmas(5,5)

     do j=1,4
        kelmas(i,j) = elmas(i,j) - elmas(i,5)*elmas(5,j)/elmas(5,5)
     end do
  end do

  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 return

end subroutine elem8

!> \file scalab.f90
!> \brief scale the FE equations for better numerical accuracy
!> \details Schwarz 1991 and Kemna (private communication):
!> The diagonal elements of \f$ S \f$ in the linear system \f$ Sx = b \f$ are scaled to \f$ 1 \f$. Accordingly, the other elements of \f$ S\f$, \f$ x \f$ and \f$ b\f$ need to be scaled as well to maintain corrent results. In matrix notation, this is
!> \f[ S x = b \rightarrow (D S D) \  (D^{-1}x) = (D b) \f]
!> with the diagonal matrix \f$ D\f$ containing the scaling factors, namely
!> \f[ D_{ii} = 1/\sqrt{S_{ii}}, \ i = (1,...,n) \f]
!> Finally, the modified linear system 
!> \f[ \hat S \hat x = \hat b, \f]
!> with \f$ \hat S = D\ S\ D, \hat x = D^{-1}x, \hat b = D\ b \f$ is solved with super accuracy
!> @author Andreas Kemna 
!> @date 10/11/1993

subroutine scalab(a_scal,b_scal,fak_scal)

!     Unterprogramm skaliert 'a' und 'b' und liefert die Skalierungs-
!     faktoren im Vektor 'fak'.

!     ( Vgl. Subroutine 'SCALBNDN' in Schwarz (1991) )

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   07-Mar-2003

!.....................................................................

  USE alloci
  USE femmod
  USE elemmod
  USE errmod

  IMPLICIT none


!.....................................................................
!!$Gesamtsteifigkeitsmatrix
  COMPLEX (KIND(0D0)),DIMENSION(*):: a_scal
!!$ Berechnete Potentialwerte (bzw. Loesungsverktor)
  COMPLEX (KIND(0D0)),DIMENSION(*):: b_scal
!!$ Skalirerungsfaktor
  REAL (KIND(0D0)),DIMENSION(*)  :: fak_scal

!     Hilfsvariablen
  INTEGER (KIND=4) ::    idi,i0
  INTEGER (KIND=4) ::     ja
  REAL(KIND(0D0))  ::     dum

!     Indexvariablen
  INTEGER (KIND=4) ::     i,j

!.....................................................................

  do  i=1,sanz

     idi = i*(mb+1)
     dum = cdabs(a_scal(idi))

     if (dum.le.0d0) then
        WRITE (fetxt,*)'scalab idi',idi,'i',i
        errnr = 27
        goto 1000
     end if

     a_scal(idi) = a_scal(idi) / dcmplx(dum)
     fak_scal(i) = 1d0 / dsqrt(dum)
     b_scal(i)   = b_scal(i) * dcmplx(fak_scal(i))

     if (i.eq.1) CYCLE

     i0 = i*mb
     ja = max0(1,i-mb)

     do j=ja,i-1
        a_scal(i0+j) = a_scal(i0+j) * dcmplx(fak_scal(i)*fak_scal(j))
     END do

  END do

  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 return

end subroutine scalab

!     -*- f90 -*-
!     This file is autogenerated with f2py (version:2.2.4)
!     It contains Fortran 90 wrappers to fortran functions.

      subroutine f2py_alloci_getdims_a(r,s,f2pysetdata,flag)
      use alloci, only: d => a

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_a
      subroutine f2py_alloci_getdims_kpot(r,s,f2pysetdata,flag)
      use alloci, only: d => kpot

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_kpot
      subroutine f2py_alloci_getdims_hpot(r,s,f2pysetdata,flag)
      use alloci, only: d => hpot

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_hpot
      subroutine f2py_alloci_getdims_sens(r,s,f2pysetdata,flag)
      use alloci, only: d => sens

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_sens
      subroutine f2py_alloci_getdims_csens(r,s,f2pysetdata,flag)
      use alloci, only: d => csens

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_csens
      subroutine f2py_alloci_getdims_adc(r,s,f2pysetdata,flag)
      use alloci, only: d => adc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_adc
      subroutine f2py_alloci_getdims_kpotdc(r,s,f2pysetdata,flag)
      use alloci, only: d => kpotdc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_kpotdc
      subroutine f2py_alloci_getdims_hpotdc(r,s,f2pysetdata,flag)
      use alloci, only: d => hpotdc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_hpotdc
      subroutine f2py_alloci_getdims_sensdc(r,s,f2pysetdata,flag)
      use alloci, only: d => sensdc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_sensdc
      subroutine f2py_alloci_getdims_cov_d(r,s,f2pysetdata,flag)
      use alloci, only: d => cov_d

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_cov_d
      subroutine f2py_alloci_getdims_smatm(r,s,f2pysetdata,flag)
      use alloci, only: d => smatm

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_smatm
      subroutine f2py_alloci_getdims_rnd_r(r,s,f2pysetdata,flag)
      use alloci, only: d => rnd_r

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_rnd_r
      subroutine f2py_alloci_getdims_rnd_p(r,s,f2pysetdata,flag)
      use alloci, only: d => rnd_p

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_rnd_p
      subroutine f2py_alloci_getdims_ata(r,s,f2pysetdata,flag)
      use alloci, only: d => ata

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_ata
      subroutine f2py_alloci_getdims_ata_reg(r,s,f2pysetdata,flag)
      use alloci, only: d => ata_reg

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_ata_reg
      subroutine f2py_alloci_getdims_cov_m(r,s,f2pysetdata,flag)
      use alloci, only: d => cov_m

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_alloci_getdims_cov_m
      
      subroutine f2pyinitalloci(f2pysetupfunc)
      use alloci, only : a
      use alloci, only : kpot
      use alloci, only : hpot
      use alloci, only : sens
      use alloci, only : csens
      use alloci, only : adc
      use alloci, only : kpotdc
      use alloci, only : hpotdc
      use alloci, only : sensdc
      use alloci, only : cov_d
      use alloci, only : smatm
      use alloci, only : rnd_r
      use alloci, only : rnd_p
      use alloci, only : ata
      use alloci, only : ata_reg
      use alloci, only : cov_m
      external f2pysetupfunc
      external f2py_alloci_getdims_a
      external f2py_alloci_getdims_kpot
      external f2py_alloci_getdims_hpot
      external f2py_alloci_getdims_sens
      external f2py_alloci_getdims_csens
      external f2py_alloci_getdims_adc
      external f2py_alloci_getdims_kpotdc
      external f2py_alloci_getdims_hpotdc
      external f2py_alloci_getdims_sensdc
      external f2py_alloci_getdims_cov_d
      external f2py_alloci_getdims_smatm
      external f2py_alloci_getdims_rnd_r
      external f2py_alloci_getdims_rnd_p
      external f2py_alloci_getdims_ata
      external f2py_alloci_getdims_ata_reg
      external f2py_alloci_getdims_cov_m
      call f2pysetupfunc(f2py_alloci_getdims_a,f2py_alloci_getdims_kpot,&
     &f2py_alloci_getdims_hpot,f2py_alloci_getdims_sens,f2py_alloci_getd&
     &ims_csens,f2py_alloci_getdims_adc,f2py_alloci_getdims_kpotdc,f2py_&
     &alloci_getdims_hpotdc,f2py_alloci_getdims_sensdc,f2py_alloci_getdi&
     &ms_cov_d,f2py_alloci_getdims_smatm,f2py_alloci_getdims_rnd_r,f2py_&
     &alloci_getdims_rnd_p,f2py_alloci_getdims_ata,f2py_alloci_getdims_a&
     &ta_reg,f2py_alloci_getdims_cov_m)
      end subroutine f2pyinitalloci

      subroutine f2py_datmod_getdims_strnr(r,s,f2pysetdata,flag)
      use datmod, only: d => strnr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_strnr
      subroutine f2py_datmod_getdims_strom(r,s,f2pysetdata,flag)
      use datmod, only: d => strom

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_strom
      subroutine f2py_datmod_getdims_vnr(r,s,f2pysetdata,flag)
      use datmod, only: d => vnr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_vnr
      subroutine f2py_datmod_getdims_volt(r,s,f2pysetdata,flag)
      use datmod, only: d => volt

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_volt
      subroutine f2py_datmod_getdims_sigmaa(r,s,f2pysetdata,flag)
      use datmod, only: d => sigmaa

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_sigmaa
      subroutine f2py_datmod_getdims_sgmaa2(r,s,f2pysetdata,flag)
      use datmod, only: d => sgmaa2

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_sgmaa2
      subroutine f2py_datmod_getdims_kfak(r,s,f2pysetdata,flag)
      use datmod, only: d => kfak

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_kfak
      subroutine f2py_datmod_getdims_wmatdp(r,s,f2pysetdata,flag)
      use datmod, only: d => wmatdp

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_wmatdp
      subroutine f2py_datmod_getdims_wmatdr(r,s,f2pysetdata,flag)
      use datmod, only: d => wmatdr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_wmatdr
      subroutine f2py_datmod_getdims_wmatd_cri(r,s,f2pysetdata,flag)
      use datmod, only: d => wmatd_cri

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_datmod_getdims_wmatd_cri
      
      subroutine f2pyinitdatmod(f2pysetupfunc)
      use datmod, only : nanz
      use datmod, only : strnr
      use datmod, only : strom
      use datmod, only : vnr
      use datmod, only : volt
      use datmod, only : sigmaa
      use datmod, only : sgmaa2
      use datmod, only : kfak
      use datmod, only : wmatdp
      use datmod, only : wmatdr
      use datmod, only : wmatd_cri
      use datmod, only : stabw0
      use datmod, only : stabm0
      use datmod, only : stabp0
      use datmod, only : stabpa1
      use datmod, only : stabpb
      use datmod, only : stabpa2
      use datmod, only : lindiv
      use datmod, only : lratio
      use datmod, only : lpol
      use datmod, only : lnse
      use datmod, only : lnse2
      use datmod, only : iseed
      use datmod, only : nstabw0
      use datmod, only : nstabm0
      use datmod, only : nstabpb
      use datmod, only : nstabpa1
      use datmod, only : nstabpa2
      use datmod, only : nstabp0
      use datmod, only : npol
      external f2pysetupfunc
      external f2py_datmod_getdims_strnr
      external f2py_datmod_getdims_strom
      external f2py_datmod_getdims_vnr
      external f2py_datmod_getdims_volt
      external f2py_datmod_getdims_sigmaa
      external f2py_datmod_getdims_sgmaa2
      external f2py_datmod_getdims_kfak
      external f2py_datmod_getdims_wmatdp
      external f2py_datmod_getdims_wmatdr
      external f2py_datmod_getdims_wmatd_cri
      call f2pysetupfunc(nanz,f2py_datmod_getdims_strnr,f2py_datmod_getd&
     &ims_strom,f2py_datmod_getdims_vnr,f2py_datmod_getdims_volt,f2py_da&
     &tmod_getdims_sigmaa,f2py_datmod_getdims_sgmaa2,f2py_datmod_getdims&
     &_kfak,f2py_datmod_getdims_wmatdp,f2py_datmod_getdims_wmatdr,f2py_d&
     &atmod_getdims_wmatd_cri,stabw0,stabm0,stabp0,stabpa1,stabpb,stabpa&
     &2,lindiv,lratio,lpol,lnse,lnse2,iseed,nstabw0,nstabm0,nstabpb,nsta&
     &bpa1,nstabpa2,nstabp0,npol)
      end subroutine f2pyinitdatmod

      subroutine f2py_electrmod_getdims_enr(r,s,f2pysetdata,flag)
      use electrmod, only: d => enr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_electrmod_getdims_enr
      
      subroutine f2pyinitelectrmod(f2pysetupfunc)
      use electrmod, only : eanz
      use electrmod, only : enr
      external f2pysetupfunc
      external f2py_electrmod_getdims_enr
      call f2pysetupfunc(eanz,f2py_electrmod_getdims_enr)
      end subroutine f2pyinitelectrmod

      subroutine f2py_elemmod_getdims_typ(r,s,f2pysetdata,flag)
      use elemmod, only: d => typ

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_typ
      subroutine f2py_elemmod_getdims_nelanz(r,s,f2pysetdata,flag)
      use elemmod, only: d => nelanz

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_nelanz
      subroutine f2py_elemmod_getdims_selanz(r,s,f2pysetdata,flag)
      use elemmod, only: d => selanz

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_selanz
      subroutine f2py_elemmod_getdims_snr(r,s,f2pysetdata,flag)
      use elemmod, only: d => snr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_snr
      subroutine f2py_elemmod_getdims_sx(r,s,f2pysetdata,flag)
      use elemmod, only: d => sx

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_sx
      subroutine f2py_elemmod_getdims_sy(r,s,f2pysetdata,flag)
      use elemmod, only: d => sy

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_sy
      subroutine f2py_elemmod_getdims_espx(r,s,f2pysetdata,flag)
      use elemmod, only: d => espx

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_espx
      subroutine f2py_elemmod_getdims_espy(r,s,f2pysetdata,flag)
      use elemmod, only: d => espy

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_espy
      subroutine f2py_elemmod_getdims_nachbar(r,s,f2pysetdata,flag)
      use elemmod, only: d => nachbar

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_nachbar
      subroutine f2py_elemmod_getdims_nrel(r,s,f2pysetdata,flag)
      use elemmod, only: d => nrel

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_nrel
      subroutine f2py_elemmod_getdims_rnr(r,s,f2pysetdata,flag)
      use elemmod, only: d => rnr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_rnr
      subroutine f2py_elemmod_getdims_xk(r,s,f2pysetdata,flag)
      use elemmod, only: d => xk

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_xk
      subroutine f2py_elemmod_getdims_yk(r,s,f2pysetdata,flag)
      use elemmod, only: d => yk

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_yk
      subroutine f2py_elemmod_getdims_elmam(r,s,f2pysetdata,flag)
      use elemmod, only: d => elmam

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_elmam
      subroutine f2py_elemmod_getdims_elmas(r,s,f2pysetdata,flag)
      use elemmod, only: d => elmas

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_elmas
      subroutine f2py_elemmod_getdims_elve(r,s,f2pysetdata,flag)
      use elemmod, only: d => elve

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_elve
      subroutine f2py_elemmod_getdims_edecoup(r,s,f2pysetdata,flag)
      use elemmod, only: d => edecoup

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_edecoup
      subroutine f2py_elemmod_getdims_edecstr(r,s,f2pysetdata,flag)
      use elemmod, only: d => edecstr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_edecstr
      subroutine f2py_elemmod_getdims_electrode_capacitances(r,s,f2pyset&
     &data,flag)
      use elemmod, only: d => electrode_capacitances

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_elemmod_getdims_electrode_capacitances
      
      subroutine f2pyinitelemmod(f2pysetupfunc)
      use elemmod, only : sanz
      use elemmod, only : typanz
      use elemmod, only : mb
      use elemmod, only : typ
      use elemmod, only : nelanz
      use elemmod, only : selanz
      use elemmod, only : snr
      use elemmod, only : sx
      use elemmod, only : sy
      use elemmod, only : espx
      use elemmod, only : espy
      use elemmod, only : nachbar
      use elemmod, only : nrel
      use elemmod, only : elanz
      use elemmod, only : relanz
      use elemmod, only : rnr
      use elemmod, only : max_nr_element_nodes
      use elemmod, only : esp_min
      use elemmod, only : esp_max
      use elemmod, only : esp_mit
      use elemmod, only : esp_med
      use elemmod, only : esp_std
      use elemmod, only : grid_min
      use elemmod, only : grid_max
      use elemmod, only : grid_minx
      use elemmod, only : grid_miny
      use elemmod, only : grid_maxx
      use elemmod, only : grid_maxy
      use elemmod, only : lsink
      use elemmod, only : nsink
      use elemmod, only : lrandb2
      use elemmod, only : sytop
      use elemmod, only : xk
      use elemmod, only : yk
      use elemmod, only : elmam
      use elemmod, only : elmas
      use elemmod, only : elve
      use elemmod, only : decexi
      use elemmod, only : edecoup
      use elemmod, only : edecstr
      use elemmod, only : decanz
      use elemmod, only : nr_elec_capacitances
      use elemmod, only : elec_caps_file_exists
      use elemmod, only : electrode_capacitances
      external f2pysetupfunc
      external f2py_elemmod_getdims_typ
      external f2py_elemmod_getdims_nelanz
      external f2py_elemmod_getdims_selanz
      external f2py_elemmod_getdims_snr
      external f2py_elemmod_getdims_sx
      external f2py_elemmod_getdims_sy
      external f2py_elemmod_getdims_espx
      external f2py_elemmod_getdims_espy
      external f2py_elemmod_getdims_nachbar
      external f2py_elemmod_getdims_nrel
      external f2py_elemmod_getdims_rnr
      external f2py_elemmod_getdims_xk
      external f2py_elemmod_getdims_yk
      external f2py_elemmod_getdims_elmam
      external f2py_elemmod_getdims_elmas
      external f2py_elemmod_getdims_elve
      external f2py_elemmod_getdims_edecoup
      external f2py_elemmod_getdims_edecstr
      external f2py_elemmod_getdims_electrode_capacitances
      call f2pysetupfunc(sanz,typanz,mb,f2py_elemmod_getdims_typ,f2py_el&
     &emmod_getdims_nelanz,f2py_elemmod_getdims_selanz,f2py_elemmod_getd&
     &ims_snr,f2py_elemmod_getdims_sx,f2py_elemmod_getdims_sy,f2py_elemm&
     &od_getdims_espx,f2py_elemmod_getdims_espy,f2py_elemmod_getdims_nac&
     &hbar,f2py_elemmod_getdims_nrel,elanz,relanz,f2py_elemmod_getdims_r&
     &nr,max_nr_element_nodes,esp_min,esp_max,esp_mit,esp_med,esp_std,gr&
     &id_min,grid_max,grid_minx,grid_miny,grid_maxx,grid_maxy,lsink,nsin&
     &k,lrandb2,sytop,f2py_elemmod_getdims_xk,f2py_elemmod_getdims_yk,f2&
     &py_elemmod_getdims_elmam,f2py_elemmod_getdims_elmas,f2py_elemmod_g&
     &etdims_elve,decexi,f2py_elemmod_getdims_edecoup,f2py_elemmod_getdi&
     &ms_edecstr,decanz,nr_elec_capacitances,elec_caps_file_exists,f2py_&
     &elemmod_getdims_electrode_capacitances)
      end subroutine f2pyinitelemmod

      
      subroutine f2pyiniterrmod(f2pysetupfunc)
      use errmod, only : errnr
      use errmod, only : fperr
      use errmod, only : fprun
      use errmod, only : fpinv
      use errmod, only : fpcjg
      use errmod, only : fpeps
      use errmod, only : fpcfg
      use errmod, only : errflag
      use errmod, only : fetxt
      external f2pysetupfunc
      call f2pysetupfunc(errnr,fperr,fprun,fpinv,fpcjg,fpeps,fpcfg,errfl&
     &ag,fetxt)
      end subroutine f2pyiniterrmod

      subroutine f2py_femmod_getdims_pot(r,s,f2pysetdata,flag)
      use femmod, only: d => pot

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_femmod_getdims_pot
      subroutine f2py_femmod_getdims_pota(r,s,f2pysetdata,flag)
      use femmod, only: d => pota

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_femmod_getdims_pota
      subroutine f2py_femmod_getdims_b(r,s,f2pysetdata,flag)
      use femmod, only: d => b

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_femmod_getdims_b
      subroutine f2py_femmod_getdims_bdc(r,s,f2pysetdata,flag)
      use femmod, only: d => bdc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_femmod_getdims_bdc
      subroutine f2py_femmod_getdims_fak(r,s,f2pysetdata,flag)
      use femmod, only: d => fak

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_femmod_getdims_fak
      subroutine f2py_femmod_getdims_elbg(r,s,f2pysetdata,flag)
      use femmod, only: d => elbg

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_femmod_getdims_elbg
      subroutine f2py_femmod_getdims_relbg(r,s,f2pysetdata,flag)
      use femmod, only: d => relbg

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_femmod_getdims_relbg
      subroutine f2py_femmod_getdims_kg(r,s,f2pysetdata,flag)
      use femmod, only: d => kg

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_femmod_getdims_kg
      
      subroutine f2pyinitfemmod(f2pysetupfunc)
      use femmod, only : pot
      use femmod, only : pota
      use femmod, only : b
      use femmod, only : bdc
      use femmod, only : fak
      use femmod, only : elbg
      use femmod, only : relbg
      use femmod, only : kg
      use femmod, only : lbeta
      use femmod, only : lrandb
      use femmod, only : lsr
      use femmod, only : ldc
      external f2pysetupfunc
      external f2py_femmod_getdims_pot
      external f2py_femmod_getdims_pota
      external f2py_femmod_getdims_b
      external f2py_femmod_getdims_bdc
      external f2py_femmod_getdims_fak
      external f2py_femmod_getdims_elbg
      external f2py_femmod_getdims_relbg
      external f2py_femmod_getdims_kg
      call f2pysetupfunc(f2py_femmod_getdims_pot,f2py_femmod_getdims_pot&
     &a,f2py_femmod_getdims_b,f2py_femmod_getdims_bdc,f2py_femmod_getdim&
     &s_fak,f2py_femmod_getdims_elbg,f2py_femmod_getdims_relbg,f2py_femm&
     &od_getdims_kg,lbeta,lrandb,lsr,ldc)
      end subroutine f2pyinitfemmod

      subroutine f2py_invmod_getdims_dat(r,s,f2pysetdata,flag)
      use invmod, only: d => dat

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_dat
      subroutine f2py_invmod_getdims_par(r,s,f2pysetdata,flag)
      use invmod, only: d => par

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_par
      subroutine f2py_invmod_getdims_dpar(r,s,f2pysetdata,flag)
      use invmod, only: d => dpar

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_dpar
      subroutine f2py_invmod_getdims_dpar2(r,s,f2pysetdata,flag)
      use invmod, only: d => dpar2

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_dpar2
      subroutine f2py_invmod_getdims_d0(r,s,f2pysetdata,flag)
      use invmod, only: d => d0

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_d0
      subroutine f2py_invmod_getdims_m0(r,s,f2pysetdata,flag)
      use invmod, only: d => m0

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_m0
      subroutine f2py_invmod_getdims_fm0(r,s,f2pysetdata,flag)
      use invmod, only: d => fm0

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_fm0
      subroutine f2py_invmod_getdims_m_ref(r,s,f2pysetdata,flag)
      use invmod, only: d => m_ref

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_m_ref
      subroutine f2py_invmod_getdims_wmatd(r,s,f2pysetdata,flag)
      use invmod, only: d => wmatd

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_wmatd
      subroutine f2py_invmod_getdims_wmatd2(r,s,f2pysetdata,flag)
      use invmod, only: d => wmatd2

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_wmatd2
      subroutine f2py_invmod_getdims_wdfak(r,s,f2pysetdata,flag)
      use invmod, only: d => wdfak

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_wdfak
      subroutine f2py_invmod_getdims_wmfak(r,s,f2pysetdata,flag)
      use invmod, only: d => wmfak

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_invmod_getdims_wmfak
      
      subroutine f2pyinitinvmod(f2pysetupfunc)
      use invmod, only : dat
      use invmod, only : par
      use invmod, only : dpar
      use invmod, only : dpar2
      use invmod, only : d0
      use invmod, only : m0
      use invmod, only : fm0
      use invmod, only : m_ref
      use invmod, only : wmatd
      use invmod, only : wmatd2
      use invmod, only : par_vari
      use invmod, only : wdfak
      use invmod, only : lfpi
      use invmod, only : wmfak
      external f2pysetupfunc
      external f2py_invmod_getdims_dat
      external f2py_invmod_getdims_par
      external f2py_invmod_getdims_dpar
      external f2py_invmod_getdims_dpar2
      external f2py_invmod_getdims_d0
      external f2py_invmod_getdims_m0
      external f2py_invmod_getdims_fm0
      external f2py_invmod_getdims_m_ref
      external f2py_invmod_getdims_wmatd
      external f2py_invmod_getdims_wmatd2
      external f2py_invmod_getdims_wdfak
      external f2py_invmod_getdims_wmfak
      call f2pysetupfunc(f2py_invmod_getdims_dat,f2py_invmod_getdims_par&
     &,f2py_invmod_getdims_dpar,f2py_invmod_getdims_dpar2,f2py_invmod_ge&
     &tdims_d0,f2py_invmod_getdims_m0,f2py_invmod_getdims_fm0,f2py_invmo&
     &d_getdims_m_ref,f2py_invmod_getdims_wmatd,f2py_invmod_getdims_wmat&
     &d2,par_vari,f2py_invmod_getdims_wdfak,lfpi,f2py_invmod_getdims_wmf&
     &ak)
      end subroutine f2pyinitinvmod

      
      subroutine f2pyinitkonvmod(f2pysetupfunc)
      use konvmod, only : lam
      use konvmod, only : lammax
      use konvmod, only : lam_cri
      use konvmod, only : lamnull_cri
      use konvmod, only : lamnull_fpi
      use konvmod, only : lam_ref
      use konvmod, only : lam_ref_sw
      use konvmod, only : lamfix
      use konvmod, only : dlam
      use konvmod, only : dlalt
      use konvmod, only : nlam
      use konvmod, only : alam
      use konvmod, only : fstart
      use konvmod, only : fstop
      use konvmod, only : step
      use konvmod, only : stpalt
      use konvmod, only : stpmin
      use konvmod, only : llam
      use konvmod, only : lstep
      use konvmod, only : ldlami
      use konvmod, only : ldlamf
      use konvmod, only : llamf
      use konvmod, only : lfstep
      use konvmod, only : nrmsd
      use konvmod, only : rmsalt
      use konvmod, only : rmsreg
      use konvmod, only : rmssum
      use konvmod, only : betrms
      use konvmod, only : pharms
      use konvmod, only : rough
      use konvmod, only : nrmsdm
      use konvmod, only : mqrms
      use konvmod, only : l1min
      use konvmod, only : l1rat
      use konvmod, only : bdpar
      use konvmod, only : bdmin
      use konvmod, only : nx
      use konvmod, only : nz
      use konvmod, only : itmax
      use konvmod, only : it
      use konvmod, only : itr
      use konvmod, only : alfx
      use konvmod, only : alfz
      use konvmod, only : betamgs
      use konvmod, only : lrobust
      use konvmod, only : ldiff
      use konvmod, only : lphi0
      use konvmod, only : lfphai
      use konvmod, only : lffhom
      use konvmod, only : ltri
      use konvmod, only : lprior
      use konvmod, only : lw_ref
      use konvmod, only : lnsepri
      use konvmod, only : lsens
      use konvmod, only : lres
      use konvmod, only : lcov1
      use konvmod, only : lcov2
      use konvmod, only : mswitch
      use konvmod, only : lgauss
      use konvmod, only : lvario
      use konvmod, only : lverb
      use konvmod, only : lverb_dat
      use konvmod, only : lsytop
      use konvmod, only : lelerr
      external f2pysetupfunc
      call f2pysetupfunc(lam,lammax,lam_cri,lamnull_cri,lamnull_fpi,lam_&
     &ref,lam_ref_sw,lamfix,dlam,dlalt,nlam,alam,fstart,fstop,step,stpal&
     &t,stpmin,llam,lstep,ldlami,ldlamf,llamf,lfstep,nrmsd,rmsalt,rmsreg&
     &,rmssum,betrms,pharms,rough,nrmsdm,mqrms,l1min,l1rat,bdpar,bdmin,n&
     &x,nz,itmax,it,itr,alfx,alfz,betamgs,lrobust,ldiff,lphi0,lfphai,lff&
     &hom,ltri,lprior,lw_ref,lnsepri,lsens,lres,lcov1,lcov2,mswitch,lgau&
     &ss,lvario,lverb,lverb_dat,lsytop,lelerr)
      end subroutine f2pyinitkonvmod

      subroutine f2py_modelmod_getdims_mnr(r,s,f2pysetdata,flag)
      use modelmod, only: d => mnr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_modelmod_getdims_mnr
      subroutine f2py_modelmod_getdims_w_ref_re(r,s,f2pysetdata,flag)
      use modelmod, only: d => w_ref_re

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_modelmod_getdims_w_ref_re
      subroutine f2py_modelmod_getdims_w_ref_im(r,s,f2pysetdata,flag)
      use modelmod, only: d => w_ref_im

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_modelmod_getdims_w_ref_im
      subroutine f2py_modelmod_getdims_ind_ref_grad(r,s,f2pysetdata,flag&
     &)
      use modelmod, only: d => ind_ref_grad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_modelmod_getdims_ind_ref_grad
      
      subroutine f2pyinitmodelmod(f2pysetupfunc)
      use modelmod, only : manz
      use modelmod, only : mnr
      use modelmod, only : w_ref_re
      use modelmod, only : w_ref_im
      use modelmod, only : ind_ref_grad
      external f2pysetupfunc
      external f2py_modelmod_getdims_mnr
      external f2py_modelmod_getdims_w_ref_re
      external f2py_modelmod_getdims_w_ref_im
      external f2py_modelmod_getdims_ind_ref_grad
      call f2pysetupfunc(manz,f2py_modelmod_getdims_mnr,f2py_modelmod_ge&
     &tdims_w_ref_re,f2py_modelmod_getdims_w_ref_im,f2py_modelmod_getdim&
     &s_ind_ref_grad)
      end subroutine f2pyinitmodelmod

      
      subroutine f2pyinitpathmod(f2pysetupfunc)
      use pathmod, only : slash
      use pathmod, only : ramd
      use pathmod, only : lnramd
      use pathmod, only : mkdir_cmd
      use pathmod, only : rmdir
      use pathmod, only : clear_string
      external f2pysetupfunc
      call f2pysetupfunc(slash,ramd,lnramd,mkdir_cmd,rmdir,clear_string)
      end subroutine f2pyinitpathmod

      subroutine f2py_randbmod_getdims_rwdnr(r,s,f2pysetdata,flag)
      use randbmod, only: d => rwdnr

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_randbmod_getdims_rwdnr
      subroutine f2py_randbmod_getdims_rwddc(r,s,f2pysetdata,flag)
      use randbmod, only: d => rwddc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_randbmod_getdims_rwddc
      subroutine f2py_randbmod_getdims_rwd(r,s,f2pysetdata,flag)
      use randbmod, only: d => rwd

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_randbmod_getdims_rwd
      subroutine f2py_randbmod_getdims_rwndc(r,s,f2pysetdata,flag)
      use randbmod, only: d => rwndc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_randbmod_getdims_rwndc
      subroutine f2py_randbmod_getdims_rwn(r,s,f2pysetdata,flag)
      use randbmod, only: d => rwn

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_randbmod_getdims_rwn
      
      subroutine f2pyinitrandbmod(f2pysetupfunc)
      use randbmod, only : rwdanz
      use randbmod, only : rwdnr
      use randbmod, only : rwddc
      use randbmod, only : rwd
      use randbmod, only : rwdbnr
      use randbmod, only : rwnanz
      use randbmod, only : rwndc
      use randbmod, only : rwn
      external f2pysetupfunc
      external f2py_randbmod_getdims_rwdnr
      external f2py_randbmod_getdims_rwddc
      external f2py_randbmod_getdims_rwd
      external f2py_randbmod_getdims_rwndc
      external f2py_randbmod_getdims_rwn
      call f2pysetupfunc(rwdanz,f2py_randbmod_getdims_rwdnr,f2py_randbmo&
     &d_getdims_rwddc,f2py_randbmod_getdims_rwd,rwdbnr,rwnanz,f2py_randb&
     &mod_getdims_rwndc,f2py_randbmod_getdims_rwn)
      end subroutine f2pyinitrandbmod

      subroutine f2py_sigmamod_getdims_sigma(r,s,f2pysetdata,flag)
      use sigmamod, only: d => sigma

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_sigmamod_getdims_sigma
      subroutine f2py_sigmamod_getdims_sigma2(r,s,f2pysetdata,flag)
      use sigmamod, only: d => sigma2

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_sigmamod_getdims_sigma2
      
      subroutine f2pyinitsigmamod(f2pysetupfunc)
      use sigmamod, only : sigma0
      use sigmamod, only : sigma
      use sigmamod, only : sigma2
      use sigmamod, only : bet0
      use sigmamod, only : pha0
      use sigmamod, only : lrho0
      use sigmamod, only : lstart
      use sigmamod, only : iseedpri
      use sigmamod, only : modl_stdn
      external f2pysetupfunc
      external f2py_sigmamod_getdims_sigma
      external f2py_sigmamod_getdims_sigma2
      call f2pysetupfunc(sigma0,f2py_sigmamod_getdims_sigma,f2py_sigmamo&
     &d_getdims_sigma2,bet0,pha0,lrho0,lstart,iseedpri,modl_stdn)
      end subroutine f2pyinitsigmamod

      subroutine f2py_wavenmod_getdims_kwn(r,s,f2pysetdata,flag)
      use wavenmod, only: d => kwn

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_wavenmod_getdims_kwn
      subroutine f2py_wavenmod_getdims_kwnwi(r,s,f2pysetdata,flag)
      use wavenmod, only: d => kwnwi

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_wavenmod_getdims_kwnwi
      
      subroutine f2pyinitwavenmod(f2pysetupfunc)
      use wavenmod, only : kwnanz
      use wavenmod, only : swrtr
      use wavenmod, only : kwn
      use wavenmod, only : kwnwi
      use wavenmod, only : amin
      use wavenmod, only : amax
      external f2pysetupfunc
      external f2py_wavenmod_getdims_kwn
      external f2py_wavenmod_getdims_kwnwi
      call f2pysetupfunc(kwnanz,swrtr,f2py_wavenmod_getdims_kwn,f2py_wav&
     &enmod_getdims_kwnwi,amin,amax)
      end subroutine f2pyinitwavenmod

      
      subroutine f2pyinitget_ver(f2pysetupfunc)
      use get_ver, only : version
      external f2pysetupfunc
      call f2pysetupfunc(version)
      end subroutine f2pyinitget_ver

      
      subroutine f2pyinitompmod(f2pysetupfunc)
      use ompmod, only : tid
      use ompmod, only : nthreads
      use ompmod, only : chunk_0
      use ompmod, only : chunk_1
      use ompmod, only : chunk_2
      use ompmod, only : chunk_3
      external f2pysetupfunc
      call f2pysetupfunc(tid,nthreads,chunk_0,chunk_1,chunk_2,chunk_3)
      end subroutine f2pyinitompmod

      
      subroutine f2pyinitmake_noise(f2pysetupfunc)
      use make_noise, only : f2py_fix
      external f2pysetupfunc
      call f2pysetupfunc(f2py_fix)
      end subroutine f2pyinitmake_noise

      
      subroutine f2pyinittic_toc(f2pysetupfunc)
      use tic_toc, only : fix_f2py
      external f2pysetupfunc
      call f2pysetupfunc(fix_f2py)
      end subroutine f2pyinittic_toc

      subroutine f2py_cjgmod_getdims_ap(r,s,f2pysetdata,flag)
      use cjgmod, only: d => ap

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_ap
      subroutine f2py_cjgmod_getdims_bvec(r,s,f2pysetdata,flag)
      use cjgmod, only: d => bvec

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_bvec
      subroutine f2py_cjgmod_getdims_rvec(r,s,f2pysetdata,flag)
      use cjgmod, only: d => rvec

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_rvec
      subroutine f2py_cjgmod_getdims_pvec(r,s,f2pysetdata,flag)
      use cjgmod, only: d => pvec

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_pvec
      subroutine f2py_cjgmod_getdims_apdc(r,s,f2pysetdata,flag)
      use cjgmod, only: d => apdc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_apdc
      subroutine f2py_cjgmod_getdims_bvecdc(r,s,f2pysetdata,flag)
      use cjgmod, only: d => bvecdc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_bvecdc
      subroutine f2py_cjgmod_getdims_rvecdc(r,s,f2pysetdata,flag)
      use cjgmod, only: d => rvecdc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_rvecdc
      subroutine f2py_cjgmod_getdims_pvecdc(r,s,f2pysetdata,flag)
      use cjgmod, only: d => pvecdc

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_pvecdc
      subroutine f2py_cjgmod_getdims_cgres(r,s,f2pysetdata,flag)
      use cjgmod, only: d => cgres

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_cgres
      subroutine f2py_cjgmod_getdims_cgres2(r,s,f2pysetdata,flag)
      use cjgmod, only: d => cgres2

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_cgres2
      subroutine f2py_cjgmod_getdims_cgfac(r,s,f2pysetdata,flag)
      use cjgmod, only: d => cgfac

      integer flag
      external f2pysetdata
      logical ns
      integer r,i
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_cjgmod_getdims_cgfac
      
      subroutine f2pyinitcjgmod(f2pysetupfunc)
      use cjgmod, only : ap
      use cjgmod, only : bvec
      use cjgmod, only : rvec
      use cjgmod, only : pvec
      use cjgmod, only : apdc
      use cjgmod, only : bvecdc
      use cjgmod, only : rvecdc
      use cjgmod, only : pvecdc
      use cjgmod, only : cgres
      use cjgmod, only : cgres2
      use cjgmod, only : cgfac
      use cjgmod, only : eps
      use cjgmod, only : ncgmax
      use cjgmod, only : ncg
      external f2pysetupfunc
      external f2py_cjgmod_getdims_ap
      external f2py_cjgmod_getdims_bvec
      external f2py_cjgmod_getdims_rvec
      external f2py_cjgmod_getdims_pvec
      external f2py_cjgmod_getdims_apdc
      external f2py_cjgmod_getdims_bvecdc
      external f2py_cjgmod_getdims_rvecdc
      external f2py_cjgmod_getdims_pvecdc
      external f2py_cjgmod_getdims_cgres
      external f2py_cjgmod_getdims_cgres2
      external f2py_cjgmod_getdims_cgfac
      call f2pysetupfunc(f2py_cjgmod_getdims_ap,f2py_cjgmod_getdims_bvec&
     &,f2py_cjgmod_getdims_rvec,f2py_cjgmod_getdims_pvec,f2py_cjgmod_get&
     &dims_apdc,f2py_cjgmod_getdims_bvecdc,f2py_cjgmod_getdims_rvecdc,f2&
     &py_cjgmod_getdims_pvecdc,f2py_cjgmod_getdims_cgres,f2py_cjgmod_get&
     &dims_cgres2,f2py_cjgmod_getdims_cgfac,eps,ncgmax,ncg)
      end subroutine f2pyinitcjgmod

      
      subroutine f2pyinitinvhpmod(f2pysetupfunc)
      use invhpmod, only : kanal
      use invhpmod, only : delem
      use invhpmod, only : delectr
      use invhpmod, only : dstrom
      use invhpmod, only : dsigma
      use invhpmod, only : dvolt
      use invhpmod, only : dsens
      use invhpmod, only : dstart
      use invhpmod, only : dd0
      use invhpmod, only : dm0
      use invhpmod, only : dfm0
      use invhpmod, only : drandb
      use invhpmod, only : lsetup
      use invhpmod, only : lsetip
      use invhpmod, only : lagain
      use invhpmod, only : j
      use invhpmod, only : k
      use invhpmod, only : l
      use invhpmod, only : izeit
      use invhpmod, only : tazeit
      use invhpmod, only : errnr2
      external f2pysetupfunc
      call f2pysetupfunc(kanal,delem,delectr,dstrom,dsigma,dvolt,dsens,d&
     &start,dd0,dm0,dfm0,drandb,lsetup,lsetip,lagain,j,k,l,izeit,tazeit,&
     &errnr2)
      end subroutine f2pyinitinvhpmod

      
      subroutine f2pyinitbsmatm_mod(f2pysetupfunc)
      use bsmatm_mod, only : p
      external f2pysetupfunc
      call f2pysetupfunc(p)
      end subroutine f2pyinitbsmatm_mod

      
      subroutine f2pyinitpyinv(f2pysetupfunc)
      use pyinv, only : invertpy
      external f2pysetupfunc
      call f2pysetupfunc(invertpy)
      end subroutine f2pyinitpyinv

subroutine kompb(nelec,b_komp,fak_komp)

!!!$     Unterprogramm zur Kompilation des Konstanten- bzw. Stromvektors 'b'
!!!$     fuer Einheitsstrom.

!!!$     Andreas Kemna                                            11-Oct-1993
!!!$     Letzte Aenderung   15-Jul-2007

!!!$.....................................................................

  USE femmod
  USE electrmod
  USE elemmod

  IMPLICIT none

!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:
!!$ Berechnete Potentialwerte (bzw. Loesungsverktor)
  COMPLEX (KIND(0D0)),DIMENSION(*):: b_komp
!!$ Skalirerungsfaktor
  REAL (KIND(0D0)),DIMENSION(*)  :: fak_komp

!!!$     Aktuelle Elektrodennummer
  INTEGER (KIND = 4) ::     nelec

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Indexvariable
  INTEGER (KIND = 4) ::     i

!!!$.....................................................................

!!!$     Konstantenvektor auf Null setzen
!!$  b_komp = 0.
  do i=1,sanz
     b_komp(i) = dcmplx(0d0)
  end do

!!!$     Aufbau des Konstanten- bzw. Stromvektors mit Skalierung
!!!$     ( A * x + b = 0 )
  b_komp(enr(nelec)) = dcmplx(-fak_komp(enr(nelec)))

!!!$     akc BAW-Tank
!!!$     ak        b_komp(211) = dcmplx(fak(211))
!!!$     akc Model EGS2003
!!!$     ak        b_komp(1683) = dcmplx(fak(1683))
!!!$     akc Lysimeter hor_elem\normal
!!!$     ak        b_komp(129) = dcmplx(fak(129))
!!!$     akc Lysimeter hor_elem\fine
!!!$     ak        b_komp(497) = dcmplx(fak(497))
!!!$     akc Simple Tucson Model
!!!$     ak        b_komp(431) = dcmplx(fak(431))
!!!$     akc TU Berlin Mesokosmos
!!!$     ak        b_komp(201) = dcmplx(fak(201))
!!!$     akc Andy
!!!$     ak        b_komp(2508) = dcmplx(fak(2508))
!!!$     akc Sandra (ele?_anom)
!!!$     ak        b_komp(497) = dcmplx(fak(497))
!!!$     akc Adrian (Tank)
!!!$     ak        b_komp(1660) = dcmplx(fak(1660))

  if (lsink) b_komp(nsink) = dcmplx(fak_komp(nsink))

  return
end subroutine kompb

!> \file electrmod.f90
!> \brief variable delarations for the <I> electrode</I> part of the inversion
!> @author Andreas Kemna
!> @date 01/22/1993

MODULE electrmod
!!$c 'electr.fin'
!!$
!!$c Andreas Kemna                                            22-Jan-1993
!!$c                                       Letzte Aenderung   24-Oct-1996
!!$             
!!$c.....................................................................
!!$c Anzahl der 
  INTEGER(KIND = 4),PUBLIC                          ::eanz
  
!!$c Knotennummern der Elektroden
  INTEGER(KIND = 4),PUBLIC,ALLOCATABLE,DIMENSION(:) :: enr
  
END MODULE electrmod

!> \file vre.f90
!> \brief perform forward and backward substitution
!> \details Perform forward and backward substitution of the linear system \f$ S\ x = b\f$ after the Cholesky decomposition, namely with \f$ S = L^*\ L .\f$  

subroutine vre(a_vre,b_vre,pot_vre)

!     Fuehrt das Vorwaerts- und Rueckwaertseinsetzen mit der Cholesky-Links-
!     dreiecksmatrix aus;
!     'b' bleibt unveraendert, 'pot' ist Loesungsvektor.

!     ( Vgl. Subroutine 'VRBNDN' in Schwarz (1991) )

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   24-Feb-1997

!.....................................................................

  USE alloci
  USE femmod
  USE elemmod

  IMPLICIT none

!.....................................................................
!!$Gesamtsteifigkeitsmatrix
  COMPLEX (KIND(0D0)), DIMENSION(*) :: a_vre
!!$ Konstanten-(bzw. Strom-) Vektor
  COMPLEX (KIND(0D0)), DIMENSION(*) :: b_vre
!!$ Berechnete Potentialwerte (bzw. Loesungsverktor)
  COMPLEX (KIND(0D0)), DIMENSION(*) :: pot_vre
!     PROGRAMMINTERNE PARAMETER:

!     Hilfsvariablen
  INTEGER (KIND=4)   :: idi,i0
  INTEGER (KIND=4)   :: m1,jlow
  COMPLEX(KIND(0D0)) ::   s

!     Indexvariablen
  INTEGER (KIND=4)   ::     i,j

!.....................................................................

  m1 = mb+1

  do i=1,sanz
     idi  = i*m1
     s    = b_vre(i)
     i0   = idi-i
     jlow = max0(1,i-mb)

     do j=jlow,i-1
        s = s - a_vre(i0+j)*pot_vre(j)
     END do

     pot_vre(i) = s / a_vre(idi)
  END do

  do i=sanz,1,-1
     pot_vre(i) = - pot_vre(i) / a_vre(idi)

     jlow = max0(1,i-mb)
     i0   = idi-i

     do j=jlow,i-1
        pot_vre(j) = pot_vre(j) + a_vre(i0+j)*pot_vre(i)
     END do

     idi = idi-m1
  END do

end subroutine vre

SUBROUTINE cholz(a,p,n,ierr,lverb)
!!$c-----------------------------------------------------------------
!!$c
!!$c                      Cholesky Decomposition
!!$c                      **********************
!!$c
!!$c This subroutine calculates the lower triangular matrix L which,
!!$c when multiplied by its own transpose, gives the symmetric 
!!$c matrix A. From Numerical recipies (Press et al 2003)
!!$c 
!!$c Changed and put into this format by R. Martin 2010
!!$c
!!$c 
!!$c**********          NOTE           ***************************
!!$c cholz In this form needs only the upper triangular part of a
!!$c and stores L in the lower part.
!!$c P contains the diagonal entries (EVs)
!!$c**************************************************************
!!$c INPUT VARIABLES:
!!$c
!!$c   a(n,n) Hermitesch positive definite nxn matrix
!!$c          to be decomposed
!!$c          Upper part still contains A and lower part is filled with L
!!$c   p(n)   Eigenvalues of a 
!!$c   ierr   Error code:  ierr=0 - no errors; ierr=1 - matrix a
!!$c          is not positive definite
!!$c NO EXTERNAL REFERENCES:
!!$c------------------------------------------------------------
  IMPLICIT none

  INTEGER,INTENT (IN)                                :: n
  COMPLEX (KIND(0D0)), DIMENSION (n,n),INTENT(INOUT) :: a
  COMPLEX (KIND(0D0)), DIMENSION (n),INTENT(OUT)     :: p
  LOGICAL,INTENT(IN)                                 :: lverb
  COMPLEX (KIND(0D0))                                :: s
  INTEGER, INTENT (OUT)                              :: ierr
  INTEGER                                            :: i,k,j,count


  ierr = 0
  count = 0

  DO i = 1 , n

     count = count + 1
     IF (lverb) WRITE (*,'(A,t25,F6.2,A)',ADVANCE='no')&
          ACHAR(13)//'Factorization ',REAL( count * (100./n)),'%'
     
     DO j = i , n ! working on upper triangle

        s = a(i,j)

        DO k = i-1,1,-1

           s = s - a(i,k)*a(j,k)

        END DO

        IF (i == j) THEN

           IF (CDABS(s) <= 0) THEN
              PRINT*,'WARNING: cholz - not positive definite'
              ierr = -i
              RETURN
           END IF

           p(i) = CDSQRT(s)

        ELSE

           a(j,i) = s / p(i)

        END IF

     END DO
  END DO


END SUBROUTINE cholz

module welectrmod
    contains
      subroutine welectr(kanal,datei)

!     Unterprogramm zum Schreiben der Elektrodenverteilung in 'datei'.

!     Andreas Kemna                                            11-Oct-1993
!     Letzte Aenderung   21-Jan-2003

! ....................................................................

      USE electrmod
      USE errmod

      IMPLICIT none

! ....................................................................

!     EIN-/AUSGABEPARAMETER:

!     Kanalnummer
      integer :: kanal

!     Datei
      character(80) :: datei

! ....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariable
      integer    ::  i

! ....................................................................

!     'datei' oeffnen
      fetxt = datei

      errnr = 1
      open(kanal,file=fetxt,status='replace',err=1000)

      errnr = 4

!     Anzahl der Elektroden schreiben
      write(kanal,*,err=1000) eanz

!     Knotennummern der Elektroden schreiben
      do i=1,eanz
         write(kanal,*,err=1000) enr(i)
      end do

!     'datei' schliessen
      close(kanal)

      errnr = 0
      return

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

 1000 return

      end subroutine welectr
end module welectrmod

MODULE konvmod
!!!$'konv.fin'
!!!$ Andreas Kemna                                          01-Mar-1995
!!!$                                      
!!!$ Last changed       RM                                  Jul-2010
!!!$
!!!$.....................................................................
!!!$Regularisierungsparameter
  REAL(KIND(0D0)), PUBLIC ::     lam

!!!$Maximaler Regularisierungsparameter
  REAL(KIND(0D0)), PUBLIC ::     lammax

!!$ >> RM
!!!$ Post CRI regularization parameter
  REAL(KIND(0D0)), PUBLIC ::     lam_cri
!!$ Starting regularization parameter (CRI)
  REAL(KIND(0D0)), PUBLIC ::     lamnull_cri
!!$ Starting regularization parameter (FPI)
  REAL(KIND(0D0)), PUBLIC ::     lamnull_fpi
!!$ << RM

!!$ >> RM
!!!$ Reference model regularization lambda (currently its a factor for lam)
  REAL(KIND(0D0)), PUBLIC ::     lam_ref
!!!$ switch if we want the absolute or just the gradient regularized
  INTEGER, PUBLIC         ::     lam_ref_sw
!!! << RM

!!!$Fester Regularisierungsparameter
  REAL(KIND(0D0)), PUBLIC ::     lamfix

!!!$Schrittweitenfaktor, maximale Anzahl der Schritte
  REAL(KIND(0D0)), PUBLIC ::     dlam,dlalt
  INTEGER(KIND = 4),PUBLIC ::     nlam

!!!$Parameter "a", "initial/final step factor"
  REAL(KIND(0D0)), PUBLIC ::     alam
  REAL(KIND(0D0)), PUBLIC ::     fstart
  REAL(KIND(0D0)), PUBLIC ::     fstop

!!!$Step-length der Modellverbesserung
  REAL(KIND(0D0)), PUBLIC ::     step

!!!$Step-length der vorherigen Iteration
  REAL(KIND(0D0)), PUBLIC ::     stpalt

!!!$Mindest-step-length
  REAL(KIND(0D0)), PUBLIC ::     stpmin

!!!$Schalter zur Steuerung der Regularisierung und der step-length-Wahl
  LOGICAL,PUBLIC  ::     llam,lstep,ldlami,ldlamf
!!!$wenn llamf >0 ist wird ein fixes Lambda gesetzt, llamf = BTEST(llamf,1) fuer lambda 
!!!$ cooling 
  INTEGER,PUBLIC  ::     llamf
!!!$Schalter ob volle step-length angebracht werden soll
  LOGICAL,PUBLIC  ::     lfstep

!!!$Daten-RMS
  REAL(KIND(0D0)), PUBLIC ::     nrmsd

!!!$Daten-RMS der vorherigen Iteration
  REAL(KIND(0D0)), PUBLIC ::     rmsalt

!!!$Daten-RMS des vorherigen "Regularisierungsschritts"
  REAL(KIND(0D0)), PUBLIC ::     rmsreg

!!!$Daten-Misfit insgesamt (in der objective function),
!!!$Misfit der Betraege, Misfit der Phasen
  REAL(KIND(0D0)), PUBLIC ::     rmssum,betrms,pharms

!!!$Roughness
  REAL(KIND(0D0)), PUBLIC ::     rough

!!!$Minimaler Daten-RMS
  REAL(KIND(0D0)), PUBLIC ::     nrmsdm

!!!$Minimaler Quotient zweier aufeinanderfolgender Daten-RMS-Werte
!!!$bzw. zwischen tatsaechlichem und minimalem Daten-RMS
  REAL(KIND(0D0)), PUBLIC ::     mqrms

!!!$Minimale "L1-ratio" (Grenze der "robust inversion")
  REAL(KIND(0D0)), PUBLIC ::     l1min

!!!$"L1-ratio"
  REAL(KIND(0D0)), PUBLIC ::     l1rat

!!!$Norm des Verbesserungsvektors (stepsize)
  REAL(KIND(0D0)), PUBLIC ::     bdpar

!!!$Minimale step size 
  REAL(KIND(0D0)), PUBLIC ::     bdmin

!!!$Felddimensionen in x- und z-Richtung
  INTEGER(KIND = 4),PUBLIC ::     nx,nz

!!!$Maximale Anzahl der Iterationen
  INTEGER(KIND = 4),PUBLIC ::     itmax

!!!$Iterationsindex
  INTEGER(KIND = 4),PUBLIC ::     it

!!!$Index des Regularisierungsschritts
  INTEGER(KIND = 4),PUBLIC ::     itr

!!!$Parameter zur Glaettung in x- und z-Richtung
!!!$(=0 bedeutet keine Glaettung in der jeweiligen Richtung)
  REAL(KIND(0D0)), PUBLIC ::     alfx,alfz
!!!$MGS beta
  REAL(KIND(0D0)), PUBLIC ::     betamgs

!!!$Schalter ob "robust inversion" durchgefuehrt werden soll
  LOGICAL,PUBLIC  ::     lrobust

!!$cdiff+<
!!!$Schalter ob "difference inversion" durchgefuehrt werden soll
  LOGICAL,PUBLIC  ::     ldiff
!!$cdiff+>
!!!$Schalter ob positive Phasen auf Null korrigiert werden sollen
  LOGICAL,PUBLIC  ::     lphi0
!!!$Schalter ob "final phase improvement" durchgefuehrt werden soll
  LOGICAL,PUBLIC  ::     lfphai
!!!$Schalter ob "final phase improvement" mit homogenem phasenwert startet
  LOGICAL,PUBLIC  ::     lffhom
!!$c	triang>
!!!$Schalter für die Triangularisierungsinversion
  INTEGER(KIND = 4),PUBLIC :: ltri
!!$c	triang<	
!!!$Schalter ob prior model vorhanden
  LOGICAL,PUBLIC  :: lprior
!!!$ >> RM ref model regu
!!!$switch is true for reference model regularization (DAMPING)
  LOGICAL,PUBLIC  :: lw_ref
!!!$ << RM ref model regu
!!!$Schalter ob prior model verrauschen
  LOGICAL,PUBLIC  :: lnsepri
!!!$Schalter ob Summe der Sensitivitaeten aller Messungen ausgegeben
!!!$werden soll
  LOGICAL,PUBLIC  :: lsens
!!!$Schalter fuer Resolution matrix
  LOGICAL,PUBLIC  :: lres
!!!$Schalter fuer posterior cov
  LOGICAL,PUBLIC  :: lcov1
!!!$Schalter fuer posterior cov
  LOGICAL,PUBLIC  :: lcov2
!!!$Mega schalter, wird binaer getestet
  INTEGER(KIND = 4),PUBLIC :: mswitch
!!!$Schalter für ols Loeser
  LOGICAL,PUBLIC  :: lgauss
!!!$Schalter ob experimentelles variogram berechnet werden soll
  LOGICAL,PUBLIC  :: lvario
!!!$ Verbose output switch
  LOGICAL,PUBLIC  :: lverb
!!!$ Verbose output of full resoultion, cm0, cm0_inv, full covariance, etc..
  LOGICAL,PUBLIC  :: lverb_dat
!!!$ lsytop = .NOT.BTEST (mswitch,8)  disables sy top check of 
!!$ no flow boundary electrodes for enhanced beta calculation (bsytop). 
!!$  This is useful for including topographical effects and should be used
  LOGICAL,PUBLIC  ::     lsytop
!!!$ switch to regard error ellipses in complex plane 
!!!$ is srt false as default if we have FPI but may be overwritten with
!!!$ mswitch + 32 setting it to true
  LOGICAL, PUBLIC ::     lelerr

END MODULE konvmod

!> \file bpot.f90
!> \brief compute the potential values in real space by applying the current strength \f$ I_i \f$
!> @author Andreas Kemna
!> @date 08/17/1994, last change 06/24/1997

subroutine bpot(kanal,datei)

!     Unterprogramm zur Berechnung der Potentialwerte
!     (beachte: Potentialwerte wurden fuer Einheitsstrom berechnet).

!     Andreas Kemna                                            17-Aug-1994
!     Letzte Aenderung   24-Jun-1997

!.....................................................................

  USE alloci
  USE femmod
  USE datmod
  USE elemmod
  USE errmod
  USE ompmod

  IMPLICIT none


!.....................................................................

!     EIN-/AUSGABEPARAMETER:

!     Kanalnummer
  INTEGER (KIND = 4)  ::     kanal

!     Datei
  CHARACTER (80)      ::    datei

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariablen
  INTEGER (KIND = 4)  ::     i,j

!     Elektrodennummern
  INTEGER (KIND = 4)  ::     elec1,elec2

  INTEGER (KIND = 4) ::  icount
!.....................................................................

  icount = 0

  !$OMP PARALLEL DEFAULT(none) &
  !$OMP SHARED (nanz,sanz,hpot,strom,strnr,datei,errnr,icount) &
  !$OMP PRIVATE(elec1,elec2,pot)
  !$OMP DO SCHEDULE (GUIDED,CHUNK_0)
  do i=1,nanz

     !$OMP ATOMIC
     icount = icount + 1

     WRITE (*,'(a,F10.2,A)',ADVANCE='no')ACHAR(13)//'Potential :',REAL(icount)/REAL(nanz)*100.,' %'
!     Stromelektroden bestimmen
     elec1 = mod(strnr(i),10000)
     elec2 = (strnr(i)-elec1)/10000

     do j=1,sanz

!     (beachte: Faktoren '.../2d0' (-> Potentialwerte fuer Einheitsstrom)
!     und '...*2d0' (-> Ruecktransformation) kuerzen sich weg !)
        if (elec1.eq.0) then
           pot(j) = hpot(j,elec2) * dcmplx(strom(i))
        else if (elec2.eq.0) then
           pot(j) = -hpot(j,elec1) * dcmplx(strom(i))
        else
           pot(j) = (hpot(j,elec2)-hpot(j,elec1)) * dcmplx(strom(i))
        end if
     end do

!     Potentialwerte ausgeben
     call wpot(datei,i,pot)
  end do
  !$OMP END DO
  !$OMP END PARALLEL

  IF (errnr /= 0) THEN
     PRINT*,'something went wrong during potential output'
     RETURN
  END IF

  errnr = 0
  return

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

!     Fehlermeldungen

1000 return

end subroutine bpot

!> \file refsig.f90
!> \brief compute reference conductivity for mixed boundaries
!> \details Compute the area-weighted conductivity average of the whole model. It is used in <I>beta</I> to determine the mixed boundary conditions. <I>Taking the overall model average is one possible option for the mixed boundary. However, it is also possible to use the adjacent model cell conductivity.</I> The area is computed with Gauss' area equation.
!> @author Andreas Kemna 
!> @date 02/29/1996

subroutine refsig()

!     Unterprogramm zum Bestimmen der Referenzleitfaehigkeit.

!     Andreas Kemna                                            29-Feb-1996
!     Letzte Aenderung   08-Nov-1997

!.....................................................................

  USE sigmamod
  USE elemmod,only:sx,sy,snr,typanz,nelanz,typ,nrel

  IMPLICIT none

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Indexvariablen
  INTEGER (KIND = 4 ) ::     i,j

!     Hilfsvariablen
  INTEGER (KIND = 4) ::      iel
  REAL (KIND(0D0))   ::     xk,yk,ax,ay,bx,by,cx,cy,dum,area

!.....................................................................
  dum    = 0D0
  iel    = 0
  area   = 0d0
  sigma0 = dcmplx(0d0)
  do i=1,typanz
     do j=1,nelanz(i)
        iel = iel + 1

        if (typ(i).gt.10) CYCLE

        xk = sx(snr(nrel(iel,1)))
        yk = sy(snr(nrel(iel,1)))
        ax = sx(snr(nrel(iel,2)))
        ay = sy(snr(nrel(iel,2)))
        bx = sx(snr(nrel(iel,3)))
        by = sy(snr(nrel(iel,3)))
        ax = ax - xk
        ay = ay - yk
        bx = bx - xk
        by = by - yk

        if (typ(i).eq.3) then
           dum = dabs(ax*by-ay*bx) / 2d0
        else if (typ(i).eq.5.or.typ(i).eq.8) then
           cx  = sx(snr(nrel(iel,4)))
           cy  = sy(snr(nrel(iel,4)))
           cx  = cx - xk
           cy  = cy - yk
           dum = (dabs(ax*by-ay*bx) + dabs(bx*cy-by*cx)) / 2d0
        end if

        sigma0 = sigma0 + dcmplx(dum)*cdlog(sigma(iel))
        area   = area   + dum

     end do
  end do

  sigma0 = cdexp(sigma0/dcmplx(area))

  return
end subroutine refsig

!> \file rtrafo.f90
!> \brief inverse Fourier transform of the modeled potentials
!> \details Kemna (2000): For the purpose of this thesis (this program) all electrodes are assumed to lie in a plane perpendicular to the strike direction \f$ y \f$. Therefore, the complex potential needs to be calculated at \f$ y=0\f$ only, and the inverse Fourier transform \f[ \phi(x,y,z) = \frac{1}{\pi} \int_0^\infty \tilde \phi (x,k,z) \cos (ky) dk \f] simplifies to a pure integration of the transformed potential values: \f[ \phi_i = \frac{1}{\pi} \int_0^\infty \tilde \phi_i(k)dk. \f]
!> The numerical evaluation of the integral in the above equation is based on a combination of Gaussian quadrature and Laguerre integration as suggested by LaBrecque et al. (1996a). The result is an expression
!> \f[ \phi_i = \sum_n w_n \tilde \phi_i (k_n) \f]
!> with different abscissa \f$ k_n \f$, for which the Helmholtz equation has to be solved, and some real weights \f$w_n\f$. Details on the procedure can be found in Kemma (2000) in Appendix C.

!> Finally, the complex voltage \f$ V_i \f$ of any arbitrary electrode configuration is obtained by appropriate superposition of calculated potential values, i.e., \f$ V_i = \sum \phi_{i_m} \f$, or with the above equation,
!> \f[ V_i = \sum_m \sum_n w_n \tilde \phi_{i_m} (k_n) \f]
!> It is obvious that the order of inverse Fourier transform and superposition can be interchanged because of the linearity of both operations.
!> @author Andreas Kemna
!> @date 10/11/1993

subroutine rtrafo()

!     Unterprogramm zur Ruecktransformation.

!     Andreas Kemna                                            20-Dec-1993
!     Letzte Aenderung   13-Nov-1997

!.....................................................................

  USE alloci
  USE femmod
  USE electrmod
  USE elemmod
  USE wavenmod

  IMPLICIT none

!.....................................................................

!     PROGRAMMINTERNE PARAMETER:

!     Pi
  REAL (KIND(0D0))  ::   pi

!     Hilfsvariablen
  COMPLEX (KIND(0D0))  ::    summe
  REAL (KIND(0D0))    ::     summdc

!     Indexvariablen
  INTEGER (KIND=4)    ::j,k,l

!.....................................................................

  pi = dacos(-1d0)

  if (ldc) then

     !$OMP PARALLEL DEFAULT (none) &
     !$OMP PRIVATE (summdc,l,j,k) &
     !$OMP SHARED (eanz,sanz,kwnanz,kwnwi,kpotdc,hpotdc,pi)
     !$OMP DO COLLAPSE (2) PRIVATE (l,j,k,summdc)
     do l=1,eanz
        do j=1,sanz
           summdc = 0d0

           do k=1,kwnanz
              summdc = summdc + kpotdc(j,l,k)*kwnwi(k)
           end do

           hpotdc(j,l) = summdc / pi
!!$           IF (summdc < EPSILON(0D0)) THEN
!!$              print*,'rtrafo::',l,j
!!$              STOP
!!$           END IF
        end do
     end do
     !$OMP END PARALLEL

  else

     !$OMP PARALLEL DEFAULT (none) &
     !$OMP PRIVATE(summe,l,j,k) &
     !$OMP SHARED (eanz,sanz,kwnanz,kwnwi,kpot,hpot,pi)
     !$OMP DO COLLAPSE (2) PRIVATE (l,j,k,summe)
     do l=1,eanz
        do j=1,sanz
           summe = dcmplx(0d0)

           do k=1,kwnanz
              summe = summe + kpot(j,l,k)*dcmplx(kwnwi(k))
           end do

           hpot(j,l) = summe / dcmplx(pi)
        end do
     end do
     !$OMP END PARALLEL

  end if

end subroutine rtrafo

subroutine chkpol(lsetup)

!!!$     Unterprogramm zum automatischen Korrigieren der Polaritaeten.

!!!$     Andreas Kemna                                            07-Dec-1996
!!!$     Letzte Aenderung   07-Nov-1997

!!!$.....................................................................

  USE invmod
  USE datmod
  USE errmod
  USE pathmod

  IMPLICIT none


!!!$.....................................................................

!!!$     EIN-/AUSGABEPARAMETER:

!!!$     Hilfsschalter
  LOGICAL ::     lsetup

!!!$.....................................................................

!!!$     PROGRAMMINTERNE PARAMETER:

!!!$     Messelektrodennummern
  INTEGER (KIND = 4)  ::  elec3,elec4

!!!$     Hilfsvariablen
  INTEGER (KIND = 4)  ::  i,idat,isig

!!!$     Real-, Imaginaerteile
  REAL (KIND(0D0))    ::  redat,imdat,resig,imsig

!!!$     Pi
  REAL (KIND(0D0))    :: pi

!!!$.....................................................................

  pi = dacos(-1d0)



  do i=1,nanz
     wdfak(i) = 1

!!!$     Messelektroden bestimmen
     elec3 = mod(vnr(i),10000)
     elec4 = (vnr(i)-elec3)/10000

!!!$     Logarithmierte Betraege in den Realteilen,
!!!$     Phasen (in rad) in den Imaginaerteilen
     redat = dble(dat(i))
     imdat = dimag(dat(i))
     resig = dble(sigmaa(i))
     imsig = dimag(sigmaa(i))

!!!$     Phasenbereich checken
     if (imdat.gt.pi/2d0) then
        idat = -1
     else if (imdat.le.-pi/2d0) then
        idat = 1
     else
        idat = 0
     end if

     if (imsig.gt.pi/2d0) then
        isig = -1
     else if (imsig.le.-pi/2d0) then
        isig = 1
     else
        isig = 0
     end if

     if (idat.eq.0.and.isig.ne.0) then

!!!$     Falls lpol=.true., angenommene Polaritaet des Messdatums falsch,
!!!$     ggf. Korrektur; auf jeden Fall Polaritaetswechsel
        vnr(i)    = elec3*10000 + elec4
        imsig     = imsig + dble(isig)*pi
        sigmaa(i) = dcmplx(resig,imsig)
        volt(i)   = cdexp(-sigmaa(i))

        if (lpol) then
           write(fprun,'(i4,a30)')i,' : correct and change polarity'
           if (.not.lsetup) wdfak(i)=0
        else
           imdat  = imdat - dsign(pi,imdat)
           dat(i) = dcmplx(redat,imdat)

           write(fprun,'(i4,a18)')i,' : change polarity'
           wdfak(i) = 0
        end if

     else if (idat.ne.0.and.isig.eq.0) then

!!!$     Falls lpol=.true., angenommene Polaritaet des Messdatums falsch,
!!!$     ggf. Korrektur
        if (lpol) then
           imdat  = imdat + dble(idat)*pi
           dat(i) = dcmplx(redat,imdat)

           write(fprun,'(i4,a19)')i,' : correct polarity'
           if (.not.lsetup) wdfak(i)=0
        else
           wdfak(i) = 0
        end if

     else if (idat.ne.0.and.isig.ne.0) then

!!!$     Polaritaetswechsel
        vnr(i)    = elec3*10000 + elec4
        imsig     = imsig + dble(isig)*pi
        sigmaa(i) = dcmplx(resig,imsig)
        volt(i)   = cdexp(-sigmaa(i))
        imdat     = imdat + dble(idat)*pi
        dat(i)    = dcmplx(redat,imdat)

        write(fprun,'(i4,a18)')i,' : change polarity'

     end if
  end do

!!!$     Ggf. Ausgabe
  do i=1,nanz
     if (wdfak(i).eq.0) write(fprun,'(i4,a11)') i,' : excluded'
  end do


  return
end subroutine chkpol

!> \file elemmod.f90
!> \brief variable delarations for the FE modelling part
!> \details Replacement of former 'elem.fin' and basically contains the FE-element related variables and two methods for allocation and deallocation of global memory.
!>
!> Latest changes:
!> - translated to F90 module
!> - added nachbar (neighbor)
!> - added esp (central point)
!> - added some variables associated with
!! grid statistics
!> - add doxy style for comments
!> - add describtion and translation
!>
!> @author Andreas Kemna, Roland Martin
!> @date 11/24/1993, last change 09/2013
MODULE elemmod
    IMPLICIT none

    !> Anzahl der Knoten (bzw. Knotenvariablen)
    INTEGER(KIND = 4),PUBLIC :: sanz

    !> Anzahl der Elementtypen
    INTEGER(KIND = 4),PUBLIC :: typanz

    !> Bandbreite der Gesamtsteifigkeitsmatrix 'a'
    INTEGER(KIND = 4),PUBLIC ::  mb

    !>Elementtypen
    !! (Randelemente (ntyp > 10) am Schluss !)
    INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: typ

    !> Anzahl der Elemente eines bestimmten Typs
    INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: nelanz

    !> Anzahl der Knoten (bzw. Knotenvariablen) in einem Elementtyp
    INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: selanz

    !> Zeiger auf Koordinaten der Knoten
    !! (Inverser Permutationsvektor der Umnumerierung)
    INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: snr

    !> x-Koordinaten der Knoten
    REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: sx

    !> y-Koordinaten der Knoten
    REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: sy

    !> Elementschwerpunktkoordinaten (ESP) der Flaechenelemente
    !! x-direction
    REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: espx

    !> Elementschwerpunktkoordinaten (ESP) der Flaechenelemente
    !! y-direction
    REAL(KIND(0D0)),PUBLIC,DIMENSION(:),ALLOCATABLE     :: espy

    !> Zeiger auf die Nachbarn der nichtentarteten Elemente
    INTEGER, DIMENSION(:,:), ALLOCATABLE, PUBLIC        :: nachbar

    !> Knotennummern der Elemente (Reihenfolge !)
    INTEGER(KIND = 4),PUBLIC,DIMENSION(:,:),ALLOCATABLE :: nrel

    !> Anzahl der Elemente (ohne Randelemente)
    INTEGER(KIND = 4),PUBLIC                            :: elanz

    !> Anzahl der Randelemente
    INTEGER(KIND = 4),PUBLIC                            :: relanz

    !> Zeiger auf Werte der Randelemente
    INTEGER(KIND = 4),PUBLIC,DIMENSION(:),ALLOCATABLE   :: rnr

    !> Groeste Anzahl der Knoten der Flaechenelemente
    INTEGER(KIND = 4),PUBLIC                            :: max_nr_element_nodes

    !> Gitter Statistiken:

    !!Minaler Abstand zwischen (Flaechen) Elementschwerpunkten
    REAL(KIND(0D0)),PUBLIC                              :: esp_min

    !> Gitter Statistiken:
    !!Maximaler Abstand zwischen (Flaechen) Elementschwerpunkten
    REAL(KIND(0D0)),PUBLIC                              :: esp_max

    !> Gitter statistiken:
    !> Mittelwert/Median und Standardabweichung der ESP
    REAL(KIND(0D0)),PUBLIC                              :: esp_mit

    !> Gitter statistiken:
    !> Median und Standardabweichung der ESP
    REAL(KIND(0D0)),PUBLIC                              :: esp_med

    !> Gitter statistiken:
    !> Standardabweichung der ESP
    REAL(KIND(0D0)),PUBLIC                              :: esp_std

    !>Minaler Gitterabstand (Betrag)
    REAL(KIND(0D0)),PUBLIC                              :: grid_min

    !>Maximaler Gitterabstand (Betrag)
    REAL(KIND(0D0)),PUBLIC                              :: grid_max

    !>Minimaler Gitterabstand in x-Richtung
    REAL(KIND(0D0)),PUBLIC                              :: grid_minx

    !>Minimaler Gitterabstand in y-Richtung
    REAL(KIND(0D0)),PUBLIC                              :: grid_miny

    !>Maximaler Gitterabstand in x-Richtung
    REAL(KIND(0D0)),PUBLIC                              :: grid_maxx

    !>Maximaler Gitterabstand in y-Richtung
    REAL(KIND(0D0)),PUBLIC                              :: grid_maxy

    !>switch/number fictitious sink node (only for 2D)
    LOGICAL,PUBLIC                                      :: lsink

    !>number of grid node for sink
    INTEGER(KIND = 4),PUBLIC                            :: nsink

    !>switch boundary values
    LOGICAL,PUBLIC                                      :: lrandb2

    !>mittlere y-Koordinate aller Randelemente vom Typ 12 ("no flow")
    REAL(KIND(0D0)),PUBLIC                              :: sytop

    !>x-Koordinaten der Eckknotenpunkte
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE,PUBLIC   :: xk

    !>y-Koordinaten der Eckknotenpunkte
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE,PUBLIC   :: yk

    !>Elementarmatrizen
    REAL(KIND(0D0)),DIMENSION(:,:),ALLOCATABLE,PUBLIC :: elmam

    !>Elementarmatrizen
    REAL(KIND(0D0)),DIMENSION(:,:),ALLOCATABLE,PUBLIC :: elmas

    !>Elementvektor
    REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE,PUBLIC   :: elve

    ! decoupling.dat exists?
    LOGICAL ::    decexi

    ! cell numbers defining decoupling interfaces
    INTEGER(KIND = 4), DIMENSION(:, :), ALLOCATABLE,PUBLIC :: edecoup

    ! decoupling values
    REAL(KIND(0D0)), DIMENSION(:),ALLOCATABLE,PUBLIC :: edecstr

    ! number of interfaces to decouple (i.e., number of lines in decouplings.dat)
    INTEGER (KIND = 4) ::  decanz

    ! number of electrode capacitances
    INTEGER (KIND = 4) :: nr_elec_capacitances;

    ! electrode_capacitances.dat exists?
    LOGICAL :: elec_caps_file_exists;

    ! electrode capacitances
    REAL(KIND(0D0)), DIMENSION(:),ALLOCATABLE,PUBLIC :: electrode_capacitances;

END MODULE elemmod

SUBROUTINE besp_elem
!!!$     
!!!$     Unterprogramm zum Bestimmen der kleinsten moeglichen 
!!!$     Skalenlaenge zur stochastischen Regularisierung
!!!$     
!!!$     Copyright by Andreas Kemna
!!!$     
!!!$     Erste Version von Roland Martin                          29-Jul-2009
!!!$     
!!!$     Letzte Aenderung                                         07-Aug-2009
!!!$     
!!!$.....................................................................
  
  USE alloci
  USE elemmod        ! fuer nachbar, nrel etc. 
  
  IMPLICIT none
  
!!!$     PROGRAMMINTERNE PARAMETER:-------------------------------------------
!!!$     Indexvariablen
  INTEGER :: i,j,ifp
!!!$     Abstaende d. Schwerpunktskoordinaten der Flaechenelemente
  REAL(KIND(0D0)) :: ax,ay,ar
!!!$     ESP Abstaende
  REAL(KIND(0D0)),DIMENSION(:),ALLOCATABLE :: abst
!!!$-----------------------------------------------------------------------

  IF (.NOT.ALLOCATED(abst)) ALLOCATE (abst(elanz))
  
  grid_min = 10.**5.; grid_max = 0.
  grid_minx = 10.**5.; grid_maxx = 0.
  grid_miny = 10.**5.; grid_maxy = 0.

  DO i=1,elanz ! only if there is a good ordering.. TODO..

     DO j=1,max_nr_element_nodes

        IF (nachbar(i,j)==0) CYCLE

        abst(i) = SQRT((espx(i) - espx(nachbar(i,j)))**2D0 + &
             (espy(i) - espy(nachbar(i,j)))**2D0)

     END DO                 ! inner loop ik=1,max_nr_element_nodes

     DO j=1,elanz

        IF (i==j) CYCLE

        ax = ABS(espx(i) - espx(j))
        ay = ABS(espy(i) - espy(j))

        ar = SQRT(ax**2D0 + ay**2D0)

        grid_min = MIN(grid_min,ar)
        grid_max = MAX(grid_max,ar)
        grid_minx = MAX(MIN(grid_minx,ax),grid_min)
        grid_maxx = MAX(grid_maxx,ax)
        grid_miny = MAX(MIN(grid_miny,ay),grid_min)
        grid_maxy = MAX(grid_maxy,ay)

     END DO

  END DO                    ! outer loop i=1,elanz

!!!$     maximaler wert aus der Menge der Nachbarmittelpunkte
  esp_max = MAXVAL(abst) 
  esp_min = MINVAL(abst)

  esp_mit = SUM(abst)/elanz

  esp_std = 0.
  DO i=1,elanz
     esp_std = esp_std + SQRT((abst(i) - esp_mit)**2D0)
  END DO
  esp_std = esp_std / MAX(1, elanz - 1)

  CALL MDIAN1(abst,elanz,esp_med)

  CALL get_unit(ifp)
  OPEN (ifp,FILE='inv.gstat',STATUS='replace')
  WRITE (ifp,'(a/)')'Grid statistics:'
  WRITE (ifp,'(20X,A,I10)')'Gridcells:'//ACHAR(9),elanz
  WRITE (ifp,'(20X,A,2F10.4)')'ESP Min/Max:'//ACHAR(9),&
       esp_min,esp_max
  WRITE (ifp,'(20X,A,2F10.4)')'GRID Min/Max:'//ACHAR(9),&
       grid_min,grid_max
  WRITE (ifp,'(20X,A,2F10.4)')'GRID-x Min/Max:'//ACHAR(9),&
       grid_minx,grid_maxx
  WRITE (ifp,'(20X,A,2F10.4)')'GRID-y Min/Max:'//ACHAR(9),&
       grid_miny,grid_maxy
  WRITE (ifp,'(20X,A,3F10.4)')'Mean/Median/Var:'//ACHAR(9),&
       esp_mit,esp_med,esp_std
  CLOSE (ifp)

  IF (ALLOCATED(abst)) DEALLOCATE (abst)

END SUBROUTINE besp_elem
      

!> \file gammln.f90
!> \brief compute Gamma function \f$ \Gamma(x) \f$
!> \details Details can be found in Press et al. <I> Numerical Resipes in Fortran 77 and 90 (second edition) </I> (2001), pp. 207
!> @author William H. Press, Saul A. Teukolsky, William T. Vetterling, Brian P. Flannery
!> @date 2001
REAL (KIND(0D0))  FUNCTION gammln(xx)
  REAL (KIND(0D0))  :: xx
  INTEGER (KIND=4)  :: j
  REAL (KIND (0D0)) :: ser,stp,tmp,x,y,cof(6)
  SAVE cof,stp
  DATA cof,stp/76.18009172947146d0,-86.50532032941677d0, &
       24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2, &
       -.5395239384953d-5,2.5066282746310005d0/
  x=xx
  y=x
  tmp=x+5.5d0
  tmp=(x+0.5d0)*dlog(tmp)-tmp
  ser=1.000000000190015d0
  do j=1,6
     y=y+1.d0
     ser=ser+cof(j)/y
  END DO
  gammln=tmp+dlog(stp*ser/x)
  return
END FUNCTION gammln
